;-------------------------------------------- TIMPETU ---------------------------------------------
;-------------------------------- Ein Schachprogramm von Klaus Helbing ----------------------------
;------------------------------- Lauffhig mit PureBasic v4.00 - Beta 11 --------------------------
;---------------------------------- Letzte Aktualisierung: 23.04.2006 -----------------------------

;--------------------------------------- Initialisierungen ----------------------------------------
 
If InitSprite() = 0 Or InitKeyboard() = 0 Or InitMouse() = 0
  MessageRequester("Error", "DirectX initialization failed", #MB_ICONSTOP)
  End
EndIf

;------------------------------- Test fr direkte WINAPI-Aufrufe ----------------------------------
!extrn _Beep@8                         ;Beeper fr "Sound"

;----------------- Konstanten und Variable, die als Parameter fr PB benutzt werden ---------------
;---------------------------- Verarbeitung in Assembler: [v_Variable] ----------------------------- 

Global ZSTM.l                          ;Zhler Stellungen pro Sekunde
Global ZSTMG1.l                        ;  "         "     gesamt Bit 0-31  Quad ist Mist! Benutzt EBX und EDI!
Global ZSTMG2.l                        ;  "         "        "   Bit 32-63 
Global ZZS.l 
Global FREEMEM.l
Global SPX.l
Global SPY.l
Global ANZAHL.l
Global MAUSOLDX.l
Global MAUSOLDY.l
Global MAUSX.l
Global MAUSY.l
Global MAUSOLDX1.l                     ;fr Men
Global MAUSOLDY1.l
Global MAUSOLDX3.l                     ;fr Men
Global MAUSOLDY3.l
Global MAUSX1.l
Global MAUSY1.l
Global MAUSX3.l
Global MAUSY3.l
Global MX.l = 296                      ;Mausposition beim Start
Global MY.l = 384
Global MZX.l
Global MZY.l
Global FIGM.l = 15                     ;Cursor
Global X1M.l                           ;beide fr Mausbegrenzung Bauernumwandlung
Global X2M.l
Global ZS.l 
Global XR.l                            ;fr aktuellen Zug rot
Global YR.l 
Global SPNRH.l
Global XSH.l
Global YSH.l 
Global PB4.l                           ;quivalent fr X4
Global PB41.l
  
;------------------------------------------ Texte, Strings -----------------------------------------
;-------------------------- sehr halbherzig! 
  TEXT1a$ ="TIMPETU"
  TEXT15$ ="GEGNER "
  OLDSEKUNDE$ = ""
    
;------------------------------------- freies RAM ermitteln ---------------------------------------
Procedure.l FreeRAM()  

   ;Eine leere Struktur erstellen 
   Info.MEMORYSTATUS 
    
   ;Die Gre der Struktur ermitteln und in ihr selbst speichern 
   Info\dwLength = SizeOf(MEMORYSTATUS) 
    
   ;Vom System Speicherinfo 
   GlobalMemoryStatus_(@Info) 
    
   ;Zuweisen der Daten 
   FREEMEM = Info\dwAvailPhys    
    
   ProcedureReturn FREEMEM 
EndProcedure 

  FREEMEM = FreeRAM()

;--------------------------------------- Grsse der Hashtabellen festlegen -------------------------
             MOV eax,[v_FREEMEM]
             CMP eax,47868c00h                 ;1.200.000.000d
             JB l_hashfest1
             MOV [HASHGROESSE],20000000h       ;jeweils 512MB
             MOV [v_FREEMEM],40000000h
             JMP l_hashfeste
                      
HASHFEST1:   CMP eax,23c34600h                 ;600.000.000d
             JB l_hashfest2
             MOV [HASHGROESSE],10000000h       ;jeweils 256MB
             MOV [v_FREEMEM],20000000h
             JMP l_hashfeste

HASHFEST2:   CMP eax,14dc9380h                 ;350.000.000d
             JB l_hashfest3
             MOV [HASHGROESSE],8000000h        ;jeweils 128MB
             MOV [v_FREEMEM],10000000h
             JMP l_hashfeste

HASHFEST3:   CMP eax,0a6e49c0h                 ;175.000.000d
             JB l_hashfest4
             MOV [HASHGROESSE],4000000h        ;jeweils 64MB
             MOV [v_FREEMEM],8000000h
             JMP l_hashfeste

HASHFEST4:   CMP eax,5500000h                  ;85.000.000d
             JB l_hashfeste
             MOV [HASHGROESSE],2000000h        ;jeweils 32MB
             MOV [v_FREEMEM],4000000h
HASHFESTE:

;-------------------------------- RAM-Speicher fr direkten Zugriff reservieren -------------------- 
       *MemoryID = AllocateMemory(FREEMEM)
    
       If *MemoryID=0 
           Debug "Konnte den angeforderten Speicher nicht reservieren!" 
       EndIf 
  
             MOV esi,*MemoryID         ;ESI wird direkter Zeiger in Hashtabelle!
      
;------------------------------------ Anfangs-Bedenkzeit setzen -----------------------------------
             XOR ebx,ebx            
             MOV cx,8h
GTZEIT:      MOV al,[STARTTIME+ebx]
             MOV [GZEIT+ebx],al
             MOV [TZEIT+ebx],al
             INC ebx
             DEC cx
             JNZ l_gtzeit

;------------------------------------ fr "Erffnungsbildschirm" ----------------------------------
             XOR eax,eax
             MOV ebx,eax
             MOV ebp,eax
             MOV edx,eax
             MOV ecx,eax
             MOV edi,eax

             MOV [COLOR],bl            ;nur bei Grundstellung!
             MOV [HZ],bx
             MOV dl,[TF]
             MOV [WERZUG],dl
       
             MOV cx,78h
GRSTELL0:    MOV al,[GSTELL+ebx]       ;Grundstellung in ASTELL kopieren
             MOV [ASTELL+ebx],al       ;fr Rechnen
             AND al,0bfh               ;Feldfarbe weg
             MOV [BSTELL+ebx],al       ;fr Bildschirmdarstellung
             INC bx
             DEC cx
             JNZ l_grstell0
            
;----------------------------------- Grafik-Daten der Sprites einlesen -----------------------------
  OpenScreen(1024,768,16,"Timpetu")            ;Vollbild-Modus
 
  UseJPEGImageDecoder()                        ;damit auch JPGs verwendet werden knnen
  LoadSprite(0,"Back.jpg",0)                   ;Ldt einen Hintergrund im platzsparenden JPEG-Format (spter evtl."richtiges" Bild)
  DisplaySprite(0,0,0)                         ;den Hintergrund setzen (ohne MaskColor, er soll ja alles abdecken)

  LoadSprite(1,"Board.jpg",0)
  TransparentSpriteColor(1,0)                  ;Setzt die transparente Farbe (schwarz fr alle Bitmaps) 

  LoadSprite(3,"KingW.bmp",0)
  TransparentSpriteColor(3,0)                  ;Setzt die transparente Farbe fr die Figuren

  LoadSprite(4,"KingS.bmp",0)
  TransparentSpriteColor(4,0)

  LoadSprite(5,"QueenW.bmp",0)
  TransparentSpriteColor(5,0)

  LoadSprite(6,"QueenS.bmp",0)
  TransparentSpriteColor(6,0)

  LoadSprite(7,"RookW.bmp",0)
  TransparentSpriteColor(7,0)

  LoadSprite(8,"RookS.bmp",0)
  TransparentSpriteColor(8,0)

  LoadSprite(9,"BishopW.bmp",0)
  TransparentSpriteColor(9,0)

  LoadSprite(10,"BishopS.bmp",0)
  TransparentSpriteColor(10,0)

  LoadSprite(11,"KnightW.bmp",0)
  TransparentSpriteColor(11,0)

  LoadSprite(12,"KnightS.bmp",0)
  TransparentSpriteColor(12,0)

  LoadSprite(13,"PawnW.bmp",0)
  TransparentSpriteColor(13,0)

  LoadSprite(14,"PawnS.bmp",0)
  TransparentSpriteColor(14,0)

  LoadSprite(15,"Cursor.bmp",0)               ;Cursor
  TransparentSpriteColor(15,0)

  LoadSprite(16,"Umwandlungw.bmp",0)          ;weisse Bauernumwandlungsmglichkeiten
  TransparentSpriteColor(16,0)

  LoadSprite(17,"Umwandlungs.bmp",0)          ;schwarze Bauernumwandlungsmglichkeiten     
  TransparentSpriteColor(17,0)

  LoadSprite(18,"CursorM.bmp",0)              ;Cursor fr Men
  TransparentSpriteColor(18,0)

  LoadSprite(19,"Menue.bmp",0)
  TransparentSpriteColor(19,0)

  LoadSprite(20,"Menueback.bmp",0)
  TransparentSpriteColor(20,0)

  LoadSprite(21,"Stellein.bmp",0)
  TransparentSpriteColor(21,0)

  LoadSprite(22,"Stback.bmp",0)
  TransparentSpriteColor(22,0)

;---------------------------------------------------------------------------------------------------
  FlipBuffers(0)
  ClearScreen($bfbfbf)
  Gosub Brettmal                               ;damit man erstmal was sieht
  
;------------------------------------------- Cursor-Sprite setzen ----------------------------------
  FlipBuffers(0)
  ClearScreen($bfbfbf)
  Gosub BRETTMAL

;------------------------------------ Beschriftungen ------------------------------------------------
       FlipBuffers(0) 
       StartDrawing(ScreenOutput())            ;Fr Schrift wird 2D Drawing bentigt 
       DrawingMode(1)                          ;Den Hintergrund der Schrift auf durchsichtig stellen
       FrontColor($8c0000)                     ;140*65536
       DrawingFont(LoadFont(1,"Arial Fett",12))
         
       DrawText(600,135,TEXT1a$)               ;"TIMPETU"
       
       DrawText(600,615,TEXT15$)               ;"GEGNER"

       FrontColor(0)       
       BackColor($bfbfbf)                      ;191*65536+192*256+192*1 = BGR
       TEXTTEST4$="Beenden mit ESC          Zum Men: Rechte Maustaste               TIMPETU - ein Schachprogramm von Klaus Helbing" 
       DrawingFont(LoadFont(1,"Arial",9))
       DrawText(40,8,TEXTTEST4$) 
       TEXTTEST4$=""

       TEXTTEST4$="Info: Ein"
       DrawingFont(LoadFont(1,"Arial Fett",10))
       DrawText(800,520,TEXTTEST4$) 
       TEXTTEST4$=""

       TEXTTEST4$="Sound: Aus"
       DrawText(800,540,TEXTTEST4$) 
       TEXTTEST4$=""

       TEXTTEST4$="Nullmove: Ein"
       DrawText(800,560,TEXTTEST4$) 
       TEXTTEST4$=""

       TEXTTEST4$="Bedenkzeit: 10s / Zug"
       DrawText(800,580,TEXTTEST4$) 
       TEXTTEST4$=""

             MOV eax,[HASHGROESSE]
             SHR eax,13h
             MOV [v_ZZS],eax
 
       TEXTTEST4$=Str(ZZS)+" MB fr Hashtabellen" 
       DrawingFont(LoadFont(1,"Arial Fett",10))
       DrawText(800,600,TEXTTEST4$) 
       TEXTTEST4$=""

       StopDrawing() 


       FlipBuffers(0) 
       StartDrawing(ScreenOutput()) 
       DrawingMode(1)
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial Fett",12))
        
       DrawText(600,135,TEXT1a$)               ;"TIMPETU"
  
       DrawText(600,615,TEXT15$)               ;"GEGNER"

       FrontColor(0)       
       BackColor(12566463)       
       TEXTTEST4$="Beenden mit ESC          Zum Men: Rechte Maustaste               TIMPETU - ein Schachprogramm von Klaus Helbing" 
       DrawingFont(LoadFont(1,"Arial",9))
       DrawText(40,8,TEXTTEST4$) 
       TEXTTEST4$=""

       TEXTTEST4$="Info: Ein"
       DrawingFont(LoadFont(1,"Arial Fett",10))
       DrawText(800,520,TEXTTEST4$) 
       TEXTTEST4$=""

       TEXTTEST4$="Sound: Aus"
       DrawText(800,540,TEXTTEST4$) 
       TEXTTEST4$=""

       TEXTTEST4$="Nullmove: Ein"
       DrawText(800,560,TEXTTEST4$) 
       TEXTTEST4$=""

       TEXTTEST4$="Bedenkzeit: 10s / Zug"
       DrawText(800,580,TEXTTEST4$) 
       TEXTTEST4$=""

       TEXTTEST4$=Str(ZZS)+" MB fr Hashtabellen" 
       DrawText(800,600,TEXTTEST4$) 
       TEXTTEST4$=""

       StopDrawing() 

;-------------------------------------- von Pure-Board; Dank an Lebostein! ------------------------- 
;************************************************************** 
;* INCLUDE FOR PUREBASIC 3.92 
;************************************************************** 
;* Titel: Tastaturabfrage bei OpenScreen (detusche Tastatur) 
;* Autor: Lebostein 
;* Datum: 21.01.2005 
;************************************************************** 

;============================================================== 
; Variablen und Konstanten der Include-Datei 
;============================================================== 

Structure KeySet 
  keycode.l 
  combine.l[3] 
EndStructure 

Global NewList KeyList.KeySet() 
Global NewList PushedKey.l() 

;============================================================== 
; Gibt einmalig 1 zurck, wenn Taste niedergedrckt wird 
;============================================================== 

Procedure KeyboardTyping(code) 

  If KeyboardPushed(code) = 0: ProcedureReturn: EndIf 
  ForEach PushedKey(): If PushedKey() = code: exist = 1: EndIf: Next 
  If exist = 0: AddElement(PushedKey()): PushedKey() = code: ProcedureReturn 1: EndIf 

EndProcedure 

;============================================================== 
; Entspricht einem Inkey-Befehl 
;============================================================== 

Procedure.s KeyboardText(eingabe$) 

  ForEach PushedKey(): If KeyboardPushed(PushedKey()) = 0: DeleteElement(PushedKey()): EndIf: Next 

  If KeyboardPushed(#PB_Key_RightShift): combi = 1: EndIf 
  If KeyboardPushed(#PB_Key_LeftShift) : combi = 1: EndIf 
  If KeyboardPushed(#PB_Key_RightAlt)  : combi = 2: EndIf 

  ForEach KeyList() 
  code = KeyList()\keycode 
  wert = KeyList()\combine[combi] 
  If KeyboardTyping(code): eingabe$ + Chr(wert): EndIf: Next 
  If KeyboardTyping(#PB_Key_Back): eingabe$ = Left(eingabe$, Len(eingabe$) - 1): EndIf 
  If KeyboardTyping(#PB_Key_Delete): eingabe$ = Space(0): EndIf 
  
  ProcedureReturn eingabe$ 

EndProcedure 

;============================================================== 
; Einen Keycode hinzufgen 
;============================================================== 

Procedure AddKey(code.l, none_combi.l, with_shift.l, with_altgr.l) 

  AddElement(KeyList()) 
  KeyList()\keycode = code 
  KeyList()\combine[0] = none_combi 
  KeyList()\combine[1] = with_shift 
  KeyList()\combine[2] = with_altgr 

EndProcedure 

;============================================================== 
; Alle Keycodes hinzufgen 
;============================================================== 

; Leertaste (Space) 
AddKey(057, 032, 032, 000)    ; [ ] [ ] [ ] ... 057 = #PB_Key_Space 

; Tasten im Hauptblock (48) 
AddKey(002, 049, 033, 000)    ; [1] [!] [ ] ... 002 = #PB_Key_1 
AddKey(003, 050, 034, 178)    ; [2] ["] [] ... 003 = #PB_Key_2 
AddKey(004, 051, 167, 179)    ; [3] [] [] ... 004 = #PB_Key_3 
AddKey(005, 052, 036, 000)    ; [4] [$] [ ] ... 005 = #PB_Key_4 
AddKey(006, 053, 037, 000)    ; [5] [%] [ ] ... 006 = #PB_Key_5 
AddKey(007, 054, 038, 000)    ; [6] [&] [ ] ... 007 = #PB_Key_6 
AddKey(008, 055, 047, 123)    ; [7] [/] [{] ... 008 = #PB_Key_7 
AddKey(009, 056, 040, 091)    ; [8] [(] [[] ... 009 = #PB_Key_8 
AddKey(010, 057, 041, 093)    ; [9] [)] []] ... 010 = #PB_Key_9 
AddKey(011, 048, 061, 125)    ; [0] [=] [}] ... 011 = #PB_Key_0 
AddKey(012, 223, 063, 092)    ; [] [?] [\] ... 012 = #PB_Key_Minus 
AddKey(013, 180, 096, 000)    ; [] [`] [ ] ... 013 = #PB_Key_Equals 
AddKey(016, 113, 081, 064)    ; [q] [Q] [@] ... 016 = #PB_Key_Q 
AddKey(017, 119, 087, 000)    ; [w] [W] [ ] ... 017 = #PB_Key_W 
AddKey(018, 101, 069, 128)    ; [e] [E] [] ... 018 = #PB_Key_E 
AddKey(019, 114, 082, 000)    ; [r] [R] [ ] ... 019 = #PB_Key_R 
AddKey(020, 116, 084, 000)    ; [t] [T] [ ] ... 020 = #PB_Key_T 
AddKey(021, 122, 090, 000)    ; [z] [Z] [ ] ... 021 = #PB_Key_Y 
AddKey(022, 117, 085, 000)    ; [u] [U] [ ] ... 022 = #PB_Key_U 
AddKey(023, 105, 073, 000)    ; [i] [I] [ ] ... 023 = #PB_Key_I 
AddKey(024, 111, 079, 000)    ; [o] [O] [ ] ... 024 = #PB_Key_O 
AddKey(025, 112, 080, 000)    ; [p] [P] [ ] ... 025 = #PB_Key_P 
AddKey(026, 252, 220, 000)    ; [] [] [ ] ... 026 = #PB_Key_LeftBracket 
AddKey(027, 043, 042, 126)    ; [+] [*] [~] ... 027 = #PB_Key_RightBracket 
AddKey(030, 097, 065, 000)    ; [a] [A] [ ] ... 030 = #PB_Key_A 
AddKey(031, 115, 083, 000)    ; [s] [S] [ ] ... 031 = #PB_Key_S 
AddKey(032, 100, 068, 000)    ; [d] [D] [ ] ... 032 = #PB_Key_D 
AddKey(033, 102, 070, 000)    ; [f] [F] [ ] ... 033 = #PB_Key_F 
AddKey(034, 103, 071, 000)    ; [g] [G] [ ] ... 034 = #PB_Key_G 
AddKey(035, 104, 072, 000)    ; [h] [H] [ ] ... 035 = #PB_Key_H 
AddKey(036, 106, 074, 000)    ; [j] [J] [ ] ... 036 = #PB_Key_J 
AddKey(037, 107, 075, 000)    ; [k] [K] [ ] ... 037 = #PB_Key_K 
AddKey(038, 108, 076, 000)    ; [l] [L] [ ] ... 038 = #PB_Key_L 
AddKey(039, 246, 214, 000)    ; [] [] [ ] ... 039 = #PB_Key_SemiColon 
AddKey(040, 228, 196, 000)    ; [] [] [ ] ... 040 = #PB_Key_Apostrophe 
AddKey(041, 094, 176, 000)    ; [^] [] [ ] ... 041 = #PB_Key_Grave 
AddKey(043, 035, 039, 000)    ; [#] ['] [ ] ... 043 = #PB_Key_BackSlash 
AddKey(044, 121, 089, 000)    ; [y] [Y] [ ] ... 044 = #PB_Key_Z 
AddKey(045, 120, 088, 000)    ; [x] [X] [ ] ... 045 = #PB_Key_X 
AddKey(046, 099, 067, 000)    ; [c] [C] [ ] ... 046 = #PB_Key_C 
AddKey(047, 118, 086, 000)    ; [v] [V] [ ] ... 047 = #PB_Key_V 
AddKey(048, 098, 066, 000)    ; [b] [B] [ ] ... 048 = #PB_Key_B 
AddKey(049, 110, 078, 000)    ; [n] [N] [ ] ... 049 = #PB_Key_N 
AddKey(050, 109, 077, 181)    ; [m] [M] [] ... 050 = #PB_Key_M 
AddKey(051, 044, 059, 000)    ; [,] [;] [ ] ... 051 = #PB_Key_Comma 
AddKey(052, 046, 058, 000)    ; [.] [:] [ ] ... 052 = #PB_Key_Period 
AddKey(053, 045, 095, 000)    ; [-] [_] [ ] ... 053 = #PB_Key_Slash 
AddKey(086, 060, 062, 124)    ; [<] [>] [|] ... 086 = keine PB-Konstante 

; Tasten auf dem Keypad (15) 
AddKey(055, 042, 000, 000)    ; [*] [ ] [ ] ... 055 = #PB_Key_Multiply 
AddKey(071, 055, 000, 000)    ; [7] [ ] [ ] ... 071 = #PB_Key_Pad7 
AddKey(072, 056, 000, 000)    ; [8] [ ] [ ] ... 072 = #PB_Key_Pad8 
AddKey(073, 057, 000, 000)    ; [9] [ ] [ ] ... 073 = #PB_Key_Pad9 
AddKey(074, 045, 000, 000)    ; [-] [ ] [ ] ... 074 = #PB_Key_Subtract 
AddKey(075, 052, 000, 000)    ; [4] [ ] [ ] ... 075 = #PB_Key_Pad4 
AddKey(076, 053, 000, 000)    ; [5] [ ] [ ] ... 076 = #PB_Key_Pad5 
AddKey(077, 054, 000, 000)    ; [6] [ ] [ ] ... 077 = #PB_Key_Pad6 
AddKey(078, 043, 000, 000)    ; [+] [ ] [ ] ... 078 = #PB_Key_Add 
AddKey(079, 049, 000, 000)    ; [1] [ ] [ ] ... 079 = #PB_Key_Pad1 
AddKey(080, 050, 000, 000)    ; [2] [ ] [ ] ... 080 = #PB_Key_Pad2 
AddKey(081, 051, 000, 000)    ; [3] [ ] [ ] ... 081 = #PB_Key_Pad3 
AddKey(082, 048, 000, 000)    ; [0] [ ] [ ] ... 082 = #PB_Key_Pad0 
AddKey(083, 044, 000, 000)    ; [,] [ ] [ ] ... 083 = #PB_Key_Decimal 
AddKey(181, 047, 000, 000)    ; [/] [ ] [ ] ... 181 = #PB_Key_Divide 

;============================================================== 
; Ende der Include-Datei 
;============================================================== 
 
;---------------------------- Anfang TANFWERT ----------------------------------
ANFWERTE:    MOV [ZUGZEIT],0ah         ;10 Sekunden pro Zug
             MOV [ZUGZEIT50],0ah

             MOV cx,13h
             XOR ebx,ebx
             MOV ax,20h
Z0NULL:      MOV word[ZEILE0+ebx],ax
             ADD bx,2h
             DEC cx
             JNZ l_z0null
        
       GZEIT$=""
       TZEIT$=""

             CALL l_aktwerte
            
             CALL l_hashbasis
           
             MOV [HASHTABANF],esi
             MOV eax,esi
             ADD eax,[HASHGROESSE]
             ADD eax,[HASHGROESSE]
             MOV [HASHTABEND],eax
             MOV eax,[HASHGROESSE]     
             SHR eax,3h                ;durch 8 , da 8 Byte pro Eintrag
             DEC eax
             MOV [ANDWERT],eax
             JMP l_neuepartie1
      
            ;CMP STELLTEST,0h
            ;JNE l_neuepartie1
            ;JMP HDHEADER
;------------------------------ Ende TANFWERT ----------------------------------
  
;---------------------------- Anfang THASH -------------------------------------
;----------------------- Zufallszahlen fr Hashtabelle erzeugen ----------------
HASHBASIS1:  XOR ebx,ebx               ;Pseudozufallsgenerator Blum-Blum-Shub
             MOV edi,[PRIM]            ;N=P*Q  s.C'T 14/97,S.223
             MOV edx,9h                ;Z0 9

             MOV cx,0c60h
ZUF:         MOV eax,edx
             MUL edx                   ;Quadrat
             XOR edx,edx
             DIV edi                   ;EDX=Modulo
             MOV [ZUFZAHLEN+ebx],edx   ;Zufallszahl eintragen
             ADD bx,4h
             DEC cx
             JNZ l_zuf
             JMP l_zuf0
;---------------------- Zufallszahlen aus Tabelle auslesen ---------------------
HASHBASIS:   
     If ReadFile(1,"zufzahl.txt")
           ReadData(1,*MemoryID,$3180)
           CloseFile(1)
             
         ;----------- kleiner Klimmzug, spter mal txt mit API auslesen -------    
             MOV ecx,0c60h
             XOR ebx,ebx
HB1:         MOV eax,[esi+ebx]
             MOV [ZUFZAHLEN+ebx],eax
             ADD ebx,4h
             DEC ecx
             JNZ l_hb1    
             
             JMP l_zuf0
     EndIf 
             CALL l_signal
               
             JMP l_hashbasis1          ;Datei nicht gefunden, selbst erstellen
             ;-------------------- Ende Erzeugung Zufallszahlen ----------------------
ZUF0:        XOR edi,edi
             MOV [HASHCODE],edi
             MOV [HASHADR],edi
             MOV ecx,62h               ;Zeiger in ASTELL, Beginn bei H1
ZUF1:        MOV bl,[ASTELL+ecx]
             MOV di,cx
             DEC cx
             CMP cx,15h                ;A8
             JB l_zufe
             AND ebx,97h               ;Figur?
             JZ l_zuf1                 ;nein
             SHL di,7h                 ;*128   Jedes Feld bentigt 128 Byte
             TEST bx,80h               ;weisse Figur?
             JZ l_zufw                 ;ja
             ADD di,40h
ZUFW:        AND ebx,7h                ;weisse Figur
             SHL bx,2h                 ;D-Word!
             ADD bx,di                 ;Zeiger in HASHWERT
             MOV eax,[ZUFZAHLEN+ebx]
             XOR [HASHADR],eax
             MOV eax,[ZUFZAHLEN+20h+ebx]
             XOR [HASHCODE],eax
             JMP l_zuf1

ZUFE:        XOR eax,eax               ;wer wei, wozu es gut ist!
             MOV ebx,eax
             MOV ebp,eax
             MOV edx,eax
             MOV ecx,eax
             MOV edi,eax
             RET
;--------------------------------- Ende THASH ----------------------------------


;----------------------------- Anfang TNEUPART ---------------------------------
;------------------------- Einsprung fr neue Partie vom Men ------------------
NEUEPARTIE:  XOR ebx,ebx               ;Grundstellung in ASTELL kopieren
             MOV [COLOR],bl            ;nur bei Grundstellung!
             MOV [HZ],bx
             MOV dl,[TF]
             MOV [WERZUG],dl
       
             MOV cx,78h
GRSTELL:     MOV al,[GSTELL+ebx]
             MOV [ASTELL+ebx],al       ;fr Rechnen
             AND al,0bfh               ;Feldfarbe weg
             MOV [BSTELL+ebx],al       ;fr Bildschirmdarstellung
             INC bx
             DEC cx
             JNZ l_grstell

         ;----------------- Einsprung von Stellungseingabe -----------------------
NEUEPARTIE1:
       TEXTTEST1$="                "   ;Matt oder Patt unterste Zeile weg
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)
       DrawText(100,750,TEXTTEST1$) 
       StopDrawing()
       
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)
       DrawText(100,750,TEXTTEST1$) 
       TEXTTEST1$=""
       StopDrawing()
         
             CALL l_zuf0               ;setzt auch E-Register auf Null   bei Grundstellung doppelt
             MOV [X1],al
             MOV [X2],ax
             MOV [X4],eax
             MOV [ZUG50],ax            ;eigentlich bei Stellungseingabe unklar!
             MOV [MATTZAHL],al

             MOV ecx,7ch
KTLOESCH:    MOV [KILLTABNPB+ecx],eax
             MOV [KILLTABSPB+ecx],eax
             MOV [KILLTABN+ecx],eax
             MOV [KILLTABS+ecx],eax
             SUB ecx,4h
             JNC l_ktloesch
            
             MOV ecx,3ch
BPBLOESCH:   MOV DWord[BESTPB+ecx],eax
             SUB ecx,4h
             JNC l_bpbloesch

             MOV ecx,880h
BLLOESCH:    MOV DWord[BESTLINE+ecx],eax
             SUB ecx,4h 
             JNC l_blloesch 
     
        ;CMP BIBART,0ff           ;war Bibliothek Aus?
        ;JE short NOBIBLAD        ;ja
        ;CALL BIBLAD

NOBIBLAD:    XOR ebx,ebx
             MOV cx,3h
             MOV ax,3030h
ZEITNULL:    MOV word[GZEIT+ebx],ax
             MOV word[TZEIT+ebx],ax
             ADD bx,3h
             DEC cx
             JNZ l_zeitnull
                
             XOR ebx,ebx
             MOV cx,8h
             MOV al,20h
TWINIT:      MOV [TEXTWERT+ebx],al
             INC bx
             DEC cx
             JNZ l_twinit
        
             CALL l_aktwerte    

             XOR ebx,ebx
             MOV cx,17bh
ZKLAR:       MOV byte[ZEILE0+ebx],20h
             INC bx
             DEC cx
             JNZ l_zklar
        
             CALL l_notkop

        ;----------------------- Bedenkzeiten auf Null -------------
             XOR ebx,ebx
       For x=0 To 7
             MOV al,[GZEIT+ebx]
             MOV [v_XSH],eax
           GZEIT$=GZEIT$+Chr(XSH) 
             INC bx
       Next
 
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)
       DrawText(600,170,GZEIT$) 
       DrawText(600,580,GZEIT$) 
       StopDrawing()
       
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)
       DrawText(600,170,GZEIT$) 
       DrawText(600,580,GZEIT$) 
       StopDrawing()
       GZEIT$=""

       FlipBuffers(0)
       Gosub BRETTMAL
       NULL=MouseLocate(MX,MY)
       MausLoch=GrabSprite(#PB_Any,MX,MY,64,55)
       DisplayTransparentSprite(15,MX,MY)
       MAUSOLDX=MX
       MAUSOLDY=MY
      
       FlipBuffers(0)
       Gosub BRETTMAL 

;------------------- Header fr HD-Notation in Feld HDP schreiben --------------

 
       ;--------------------- Hashtabelle lschen ------------------------------
             MOV edx,[HASHTABEND]      ;nur wegen Reproduzierbarkeit von Tests
             MOV ebx,[HASHTABANF]
             XOR eax,eax
HASHLOESCH0: MOV [ebx],eax             ;ersten 4 Byte=Kennung
             ADD ebx,4h                ;4 ist sicherer!
             CMP ebx,edx
             JB l_hashloesch0

             MOV ebx,eax
             MOV edx,eax

             MOV byte[GZEIT+7h],30h    ;Kosmetik, setzt Sekunden-Anzeige auf
             MOV byte[TZEIT+7h],30h    ; Null, sonst plus Hash-Lsch-Zeit

       ;------------------ Ausgangsstellung abspeichern ------------------------
             MOV ax,[HZ]
             MOV word[STELLAB],ax      ;"LASTZGE", hier Merker Anfangs-HZ
             ADD bx,2h

             MOV cx,4eh                ;78 Felder ASTELL
             MOV di,15h                ;A8
ASTCOPY:     MOV al,[ASTELL+edi]
             MOV [STELLAB+ebx],al
             INC di
             INC bx
             DEC cx
             JNZ l_astcopy
              
             XOR edi,edi
             MOV cx,26h                ;volle Zeilenlnge
COPY1:       MOV al,[ZEILE0+edi]       ;untere Zeile
             MOV [STELLAB+ebx],al
             INC di
             INC bx
             DEC cx
             JNZ l_copy1
             
             MOV eax,[HASHADR]
             MOV DWord[STELLAB+ebx],eax
             ADD bx,4h
             MOV eax,[HASHCODE]
             MOV DWord[STELLAB+ebx],eax
             ADD bx,4h

             MOV cx,8h
             XOR edi,edi
COPY2:       MOV al,[GZEIT+edi]        ;Zeit Gegner
             MOV [STELLAB+ebx],al
             MOV al,[TZEIT+edi]        ;Zeit Timpetu
             MOV [STELLAB+8h+ebx],al
             INC di
             INC bx
             DEC cx
             JNZ l_copy2
             
             ;ZUG50 hat hier sicher noch Sinn fr Zug vor/zurck
             MOV [ZASTELL],90h         ;144D mit 2 Reserve
             MOV [ZASTELLE],90h
             MOV byte[ZEILE0+2h],31h   ;1.Zug
;------------------------------- Ende TNEUPART ---------------------------------


;------------------------------ Anfang TSTEUER ---------------------------------
;----------------------- S T E U E R P R O G R A M M ---------------------------
VERTEILER:   MOV byte[ZEILE0+14h],2eh  ;Zugtrennung ...
             MOV byte[ZEILE0+15h],2eh
             MOV byte[ZEILE0+16h],2eh
             MOV byte[ZEILE0+3h],2eh   ;Punkt hinter Zugnummer
             CMP [COLOR],80h
             JE l_verteiler2
             XOR eax,eax
             MOV ax,[HZ]
             SHR ax,1h
             INC ax
             XOR edi,edi
             MOV byte[TEXTTEMP],20h
             CALL l_zahlh
             
             MOV cx,3h
             XOR ebx,ebx
VERTEILER0:  MOV al,[TEXTTEMP+1h+ebx]
             MOV [ZEILE0+ebx],al
             INC bx
             DEC cx
             JNZ l_verteiler0
              
VERTEILER2:  XOR ebx,ebx
             PUSHAD 
       For x=0 To 37
             MOV al,[ZEILE0+ebx]
             MOV [v_XSH],eax
             TEXTTEST4$=TEXTTEST4$+Chr(XSH) 
             INC bx  
       Next    
 
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,500,TEXTTEST4$) 
       StopDrawing()
   
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,500,TEXTTEST4$) 
       TEXTTEST4$=""
       StopDrawing()

             POPAD 

VERTEILERS:  CALL l_aktwerte
             JMP l_rechnen

;---------------- Zurck vom Rechenteil, Anzeige der Figurenart ----------------
NORECH:      CALL l_fa                 ;setzt X1 auf 52 ("R"), wenn Rochade
             CMP [X1],52h              ;Rochade-Notation wird von FA ausgefhrt!
             JE l_trochade
             CALL l_zugnott            ;Notation auf Bildschirm ausgeben, ruft auch ZUGSETZ auf!
             JMP l_wsamzug

       ;------------------------------------------------------------------------
TROCHADE:    CALL l_zugsetz            ;berechneten Zug in ASTELL schreiben
WSAMZUG:     PUSHAD                    ;hier Einsprung von ausgefhrtem Zug
     
       FlipBuffers(0)
       Gosub BRETTMAL0
       NULL=MouseLocate(MX,MY)
       MausLoch=GrabSprite(#PB_Any,MX,MY,64,55)
       DisplayTransparentSprite(15,MX,MY)
       MAUSOLDX=MX
       MAUSOLDY=MY
      
       FlipBuffers(0)
       Gosub BRETTMAL  
                 
             POPAD      
             
             INC [HZ]
       ;--------------- Stellung intern abspeichern ---------------------
             MOV bx,[ZASTELL]          ;aktueller Zeiger in RAM-Abspeicherung
             MOV al,[LASTZUGGA]
             MOV ah,[LASTZUGGZ]
             MOV word[STELLAB+ebx],ax
             ADD bx,2h

             MOV cx,4eh                ;78 Felder ASTELL
             MOV edi,15h               ;A8
ASTCOPY0:    MOV al,[ASTELL+edi]
             MOV [STELLAB+ebx],al
             INC di
             INC bx
             DEC cx
             JNZ l_astcopy0
                
             XOR edi,edi
             MOV cx,26h
COPY01:      MOV al,[ZEILE0+edi]       ;untere Zeile
             MOV [STELLAB+ebx],al
             INC di
             INC bx
             DEC cx
             JNZ l_copy01
                  
             MOV eax,[HASHADR]
             MOV DWord[STELLAB+ebx],eax
             ADD bx,4h
             MOV eax,[HASHCODE]
             MOV DWord[STELLAB+ebx],eax
             ADD bx,4h

             MOV cx,8h
             XOR edi,edi
COPY02:      MOV al,[GZEIT+edi]        ;Zeiten
             MOV [STELLAB+ebx],al
             MOV al,[TZEIT+edi]
             MOV [STELLAB+8h+ebx],al
             INC di
             INC bx
             DEC cx
             JNZ l_copy02
                                       ;evtl. ZUG50 fr Zug vor/zurck
             ADD [ZASTELL],90h
             MOV ax,[ZASTELL]
             CMP ax,[ZASTELLE]
             JB l_copy03
             MOV [ZASTELLE],ax         ;fr Vorspielen das Ende

       ;------Test auf mgliche 3-malige Stellungswiederholung vom Gegner ------
COPY03:      CMP [WERZUG],0h
             JE l_copy04
             CMP [HZ],5h
             JBE l_copy04
             MOV [GLEICHSTELL],1h      ;diese Stellung ist aktuell vorhanden
             MOV bx,[ZASTELL]
             SUB bx,120h               ;Anfang vorletzte Stellungsabspeicherung
             MOV di,bx
ST3TEST0G:   MOV cx,15h                ;A8
             MOV [X2],27h              ;39 Durchlufe fr 78 Felder
             MOV bx,di
ST3TEST1G:   MOV ax,word[STELLAB+2h+ebx]   ;bisherige Stellungen
             AND ax,0bfbfh             ;ohne Feldfarbe
             MOV dx,word[ASTELL+ecx]   ;aktuelle Stellung
             AND dx,0bfbfh
             ADD bx,2h
             ADD cx,2h
             CMP ax,dx
             JNE l_st3test2g
             DEC [X2]
             JNZ l_st3test1g
             INC [GLEICHSTELL]
ST3TEST2G:   SUB di,90h                ;hier nicht 120!
             JNS l_st3test0g

             CMP [GLEICHSTELL],1h
             JE l_copy04               ;keine Stellungswiederholung

       ;---- Hinweis, dass eventuelle.Reklamation des Gegners berechtigt ist ---------
       ; MOV al,GLEICHSTELL
       ; ADD al,30
       ; MOV TEXTTEMP,al        ; auch bei 2, weil Gegner Zug nicht
       ; PUSH ds         ; ausfhren muss (darf!)
       ; POP es
       ; MOV ax,1301
       ; MOV bx,7
       ; MOV dx,1d10        ;Stelle von Mattzahl
       ; MOV bp,offset TEXTTEMP
       ; MOV cx,1
       ; INT 10

       ;------------------------- Remisfaktor ----------------------------------
             CMP [GLEICHSTELL],3h
             JB l_copy04               ;keine Stellungswiederholung
             MOV ax,[REMISFAKTOR]      ;REMISFAKTOR=Remisfaktor+8000 von Vorgabe
             CMP [TIMPWERT],ax
             JA l_copy04               ;Remis wird nicht freiwillig gemacht!
             MOV ax,8000h              ;Remis wird gemacht, Partieende
             CALL l_mwertaus
             PUSHAD 
       
       TEXTTEST1$="Remis 3x            "
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)
       DrawText(100,750,TEXTTEST1$) 
       StopDrawing()
       
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)
       DrawText(100,750,TEXTTEST1$) 
       TEXTTEST1$=""
       StopDrawing()
        
       MausLoch=GrabSprite(#PB_Any,MAUSOLDX,MAUSOLDY,64,55)
       FlipBuffers(0)
       DisplayTransparentSprite(MausLoch,MAUSOLDX,MAUSOLDY)
       MausLoch=GrabSprite(#PB_Any,MAUSX,MAUSY,64,55)
       DisplayTransparentSprite(15,MAUSX,MAUSY)
       FlipBuffers(0)
             
             POPAD 
             MOV [MATTZAHL],0ffh
             JMP l_zeitlesen           ;Men-Schleife

       ;---------------------- div.Wechsel -------------------------------------
COPY04:      ADD [COLOR],80h
             ADD [WERZUG],80h
             CMP [COLOR],80h           ;Schwarz am Zug?
             JE l_verteilers           ;ja
             CALL l_notkop             ;Zugnotation nach oben kopieren
             JMP l_verteiler

       ;----------------- berprfung, ob Gegener gltigen Zug ausgefhrt hat ---------------------
ZUGEINPRUEF: MOV ah,[LASTZUGGA]
             MOV al,[LASTZUGGZ]
             MOV ebx,6h
NOTPRUEF1:   MOV dx,word[ZUGSORT+ebx]
             OR dx,dx
             JE l_notpruefe            ;Ende ZUGSORT erreicht
             CMP dx,0ffffh
             JE l_notpruefe
             CMP dl,64h
             JB l_notpruef2            ;kein Bauernumwandlungszug
             SUB dl,78h                ;120 fr Dame, reicht aus
NOTPRUEF2:   ADD bx,4h
             CMP ax,dx
             JNE l_notpruef1           ;weiter suchen
             JMP l_notpruef3           ;gltiger Zug

NOTPRUEFE:   CALL l_sound              ;ungltiger Zug
             JMP l_mausabe0 
      
NOTPRUEF3:   CALL l_ehback             ;gltiger Zug, Ausgangsstellung wieder herstellen
             
       ;---------------------- Autoplay-Sektion --------------------------------
        ;CMP [AUTOPLAY],0h
        ;JE l_notpruef4
        ;MOV bl,AUTOZUGAG
        ;XOR bh,bh
        ;MOV al,[AUTOFELD2+bx]
        ;MOV LASTZUGGA,al

        ;MOV bl,al
        ;SHL bl,1
        ;MOV dl,[NFELD+bx]
        ;ADD dl,60
        ;MOV [NOTF],dl
        ;MOV dl,[NFELD+1+bx]
        ;ADD dl,30
        ;MOV [NOTF+1],dl

        ;MOV [NOTF+2],2dh        ;"-"

        ;MOV bl,AUTOZUGZG
        ;AND bl,3f        ;Bit 6 u.7 knnten Umwandlungsfigur sein!
        ;MOV al,[AUTOFELD2+bx]
        ;MOV LASTZUGGZ,al

        ;MOV bl,al
        ;SHL bl,1
        ;MOV dl,[NFELD+bx]
        ;ADD dl,60
        ;MOV [NOTF+3],dl
        ;MOV dl,[NFELD+1+bx]
        ;ADD dl,30
        ;MOV [NOTF+4],dl

        ;MOV [NOTF+5],20        ;alte umgewandelte Figur weg

        ;MOV AUTOPLAYZ,0

       ;------------------------------------------------------------------------
NOTPRUEF4:   XOR ebx,ebx
             MOV bl,[LASTZUGGA]
             SHL bl,1h
             MOV dl,[NFELD+ebx]
             ADD dl,60h
             MOV [NOTF],dl
             MOV dl,[NFELD+1h+ebx]
             ADD dl,30h
             MOV [NOTF+1h],dl

             MOV byte[NOTF+2h],2dh     ;"-"

             MOV bl,[LASTZUGGZ]
             SHL bl,1h
             MOV dl,[NFELD+ebx]
             ADD dl,60h
             MOV [NOTF+3h],dl
             MOV dl,[NFELD+1h+ebx]
             ADD dl,30h
             MOV [NOTF+4h],dl

             MOV byte[NOTF+5h],20h     ;alte umgewandelte Figur weg
      
             PUSHAD                    
       TEXTTEST1$="                    "       ;evtl. vorhandene Anzeige "Matt in ..." weg
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)
       DrawText(100,750,TEXTTEST1$) 
       StopDrawing()
       
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)
       DrawText(100,750,TEXTTEST1$) 
       TEXTTEST1$=""
       StopDrawing() 
             POPAD 
            
             INC [ZUG50]               ;erstmal erhhen
             MOV [MATTZAHL],bh         ;wichtig!
             CALL l_fa                 ;Anzeige der Figurenart
             XOR ebx,ebx
             MOV bl,[LASTZUGGA]
             MOV [AFELDE],bl
             MOV bl,[LASTZUGGZ]
             MOV [ZFELDE],bl
             MOV al,[ASTELL+ebx]
             TEST al,7h                ;wird auf Zielfeld eine Figur geschlagen?
             JZ l_noschlag             ;nein
             MOV byte[NOTF+2h],3ah     ;":"
             MOV [ZUG50],0h
NOSCHLAG:    CALL l_zugsetz
             CMP [EP],80h              ;en passant-Zug?
             JNE l_nokg                ;nein
             XOR bx,bx
             MOV byte[NOTF+2h],3ah     ;":"
             MOV [ZUG50],0h
             JMP l_gegferte

NOKG:        MOV bl,[LASTZUGGZ]        ;Bauer 1.oder 8.Reihe erreicht?
             MOV al,[ASTELL+ebx]
             AND al,7h
             CMP al,1h                 ;Bauer?
             JNE l_gegferte            ;war kein Bauer
             MOV [ZUG50],0h
             CMP bl,1dh                ;8.Reihe?
             JB l_r18                  ;ja
             CMP bl,5bh                ;1.Reihe?
             JB l_gegferte             ;nein
       ;------------------------ Figuren darstellen fr Auswahl ----------------------------
R18:         ;CMP [AUTOPLAY],0h
             ;JE l_r18na
             ;MOV al,[AUTOZUGZG]        ;Bit 6 und 7 sind neue Figur
             ;And al,0c0h
             ;XOR dl,dl
             ;Or al,al
             ;JE l_neudame              ;msste fr TimpetuPB neu gemacht werden 
             ;CMP al,40h
             ;JE l_neuturm
             ;CMP al,80h
             ;JE l_neulaeufer
             ;JMP l_neuspringer

R18NA:       PUSHAD
            
   ExamineMouse()
 
      MAUSX=MouseX()
      MAUSY=MouseY()
       
      MausLoch3=GrabSprite(#PB_Any,MAUSX,MAUSY,64,55)
       
      MAUSXOLD=MAUSX
      MAUSYOLD=MAUSY      
      
      If MAUSX<=69
        X1M=15
        X2M=69
             JMP l_mou
      EndIf
        
      If MAUSX<=133
        X1M=79
        X2M=133
             JMP l_mou
      EndIf
      
      If MAUSX<=197
        X1M=143
        X2M=197
             JMP l_mou
      EndIf
      
      If MAUSX<=261
        X1M=207
        X2M=261
             JMP l_mou
      EndIf
      
      If MAUSX<=325
        X1M=271
        X2M=325
             JMP l_mou
      EndIf
      
      If MAUSX<=389
        X1M=335
        X2M=389
             JMP l_mou
      EndIf

      If MAUSX<=453
        X1M=399
        X2M=453
             JMP l_mou
      EndIf


      If MAUSX<=517
        X1M=463
        X2M=517
      EndIf
       
MOU:       
         If MouseY()<170         
            Goto MOBEN
         EndIf
 
    
MUNTEN:   
   ExamineMouse()
      
      MAUSX=MouseX()
      MAUSY=MouseY()
  
  
    If MouseDeltaX()<>0 Or MouseDeltaY()<>0
    
         If MouseX()>X2M          
           MAUSX=X2M                               
         EndIf
         
         If MouseX()<X1M
           MAUSX=X1M
         EndIf
       
         If MouseY()>596  
           MAUSY=596
         EndIf
        
         If MouseY()<550  
           MAUSY=550
         EndIf
       
       FlipBuffers(0)
       DisplayTransparentSprite(MausLoch3,MAUSOLDX,MAUSOLDY)
       MausLoch3=GrabSprite(#PB_Any,MAUSX,MAUSY,64,55)
       DisplayTransparentSprite(15,MAUSX,MAUSY)
          
       FlipBuffers(0)
       MAUSOLDX=MAUSX
       MAUSOLDY=MAUSY
    
   EndIf 
             
   If MouseButton(1)=1
      If MAUSY<=573 And MAUSX<=X2M-27
             MOV [X1],4h
             JMP l_ufigfert
      EndIf 
      
      If MAUSY<=573 And MAUSX>X2M-27
             MOV [X1],3h
             JMP l_ufigfert
      EndIf 
 
      If MAUSY>573 And MAUSX<=X2M-27
             MOV [X1],2h
             JMP l_ufigfert
      EndIf 
 
      If MAUSY>573 And MAUSX>X2M-27
             MOV [X1],1h
             JMP l_ufigfert
      EndIf 
   EndIf
             JMP l_munten
             

MOBEN:   
   ExamineMouse()
      
      MAUSX=MouseX()
      MAUSY=MouseY()
  
  
    If MouseDeltaX()<>0 Or MouseDeltaY()<>0
    
         If MouseX()>X2M          
           MAUSX=X2M                               
         EndIf
         
         If MouseX()<X1M
           MAUSX=X1M
         EndIf
       
         If MouseY()<120  
           MAUSY=120
         EndIf
        
         If MouseY()>166  
           MAUSY=166
         EndIf
         
       FlipBuffers(0)
       DisplayTransparentSprite(MausLoch3,MAUSOLDX,MAUSOLDY)
       MausLoch3=GrabSprite(#PB_Any,MAUSX,MAUSY,64,55)
       DisplayTransparentSprite(15,MAUSX,MAUSY)
          
       FlipBuffers(0)
       MAUSOLDX=MAUSX
       MAUSOLDY=MAUSY
    
   EndIf 
             
   If MouseButton(1)=1
      If MAUSY<=143 And MAUSX<=X2M-27
             MOV [X1],4h
             JMP l_ufigfert
      EndIf 
      
      If MAUSY<=143 And MAUSX>X2M-27
             MOV [X1],3h
             JMP l_ufigfert
      EndIf 
 
      If MAUSY>143 And MAUSX<=X2M-27
             MOV [X1],2h
             JMP l_ufigfert
      EndIf 
 
      If MAUSY>143 And MAUSX>X2M-27
             MOV [X1],1h
             JMP l_ufigfert
      EndIf 
   EndIf
             JMP l_moben


UFIGFERT:    POPAD 
             FlipBuffers(0)
             CALL l_brettmal
             FlipBuffers(0)
             CALL l_brettmal
           
             MOV dl,[X1]


             XOR ebx,ebx
             MOV bl,[LASTZUGGZ]
             ADD [ASTELL+ebx],dl       ;neue Figur in ASTELL schreiben

             CMP dl,4h
             JNE l_nixdame
             MOV dl,44h                ;D
             JMP l_neunota
NIXDAME:     CMP dl,3h
             JNE l_nixturm
             MOV dl,54h                ;T
             JMP l_neunota
NIXTURM:     CMP dl,2h
             JNE l_nixlaeu
             MOV dl,4ch                ;L
             JMP l_neunota
NIXLAEU:     MOV dl,53h                ;S

NEUNOTA:     MOV [NOTF+5h],dl          ;wird wieder bei Ausgabe Timpetu gelscht

GEGFERTE:    MOV bl,[LASTZUGGA]        ;fr Hashen
             MOV [AFELD],bl
             MOV al,[ASTELL+ebx]
             MOV [AFELDH],al
             MOV bl,[LASTZUGGZ]
             MOV [ZFELD],bl
             MOV al,[ASTELL+ebx]
             MOV [ZFELDH],al
             CMP [TF],80h
             JE l_gf
             CALL l_hashs
             JMP l_gf1
GF:          CALL l_hashw

GF1:       
            ;CMP [ZUG50],64h          ;50.Zug ohne Schlag- oder Bauernzug?
            ;JAE l_test50z2           ;Timpetu reklamiert automatisch Remis!!!
                                      ;Sprung zu RECHNEN
            
             CMP [X1],52h              ;Rochadestatus von Aufruf FA weiter oben!          
             JE l_gf4                  ;bei Rochade keine neue Zugausgabe!
             XOR ebx,ebx
             MOV edi,ebx
             MOV cx,3h
             CMP [TF],80h
             JE l_gf3
             MOV bx,13h                ;Abstand Weiss-Schwarz

GF3:         MOV ax,word[NOTF+edi]
             MOV word[ZEILE0+6h+ebx],ax
             ADD bx,2h
             ADD di,2h
             DEC cx
             JNZ l_gf3
              
             CMP [EP],0h               ;en passant?
             JE l_gf4
             MOV dword[ZEILE0+6h+ebx],2e702e65h ;"e.p." dranhngen
             MOV [EP],0h

GF4:         PUSHAD         
            
             XOR ebx,ebx
       For x=0 To 37
             MOV al,[ZEILE0+ebx]    
             MOV [v_XSH],eax
         TEXTTEST4$=TEXTTEST4$+Chr(XSH) 
             INC bx  
       Next    
    
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,500,TEXTTEST4$) 
       StopDrawing()
   
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,500,TEXTTEST4$) 
       TEXTTEST4$=""
       StopDrawing()

             POPAD 
             MOV [X2],1234h            ;nur Tag
             JMP l_mausabe1
;------------------------------- Ende TNOTGEG -----------------------------------


;-------------------------------- Anfang TAKTWERT ------------------------------
;---------------------------- Div. Werte aktualisieren -------------------------
;------------------------- Letzte Modifizierung 15.04.2006 ---------------------
AKTWERTE:    XOR eax,eax
             MOV ebx,eax
             MOV edi,eax
             MOV [ANZFIGW],ax
             MOV [ANZFIGS],ax
             MOV [ANZBAUERW],ax
             MOV [ANZBAUERS],ax
    
             MOV [MATW],ax
             MOV [MATS],ax
      
             MOV bx,14h
AKTW0:       MOV DWord[WBSTELL+ebx],eax 
             MOV DWord[SBSTELL+ebx],eax
             ADD bx,4h
             CMP bx,64h
             JB l_aktw0
  
             MOV [WKLINIE],al
             MOV [SKLINIE],al
             MOV DWord[WBLINIE+1h],eax
             MOV DWord[WBLINIE+5h],eax
             MOV DWord[SBLINIE+1h],eax
             MOV DWord[SBLINIE+5h],eax
  
             MOV bx,14h                ;A8-1
AKTW1:       INC bx
             MOV al,[ASTELL+ebx]
             CMP bx,63h                ;H1+1
             JE l_aktwe
             AND ax,97h
             JZ l_aktw1                ;keine Figur
             TEST al,80h
             JNZ l_aktws               ;schwarze Figur
  
             INC word[ANZFIGW]
             AND al,7h
             CMP al,1h
             JNE l_nobw
             INC word[ANZBAUERW]
             XOR byte[WBSTELL+ebx],10h ;nicht mov!
             INC byte[WBSTELL-9h+ebx]
             INC byte[WBSTELL-0bh+ebx]
             MOV di,bx
             SHL bx,1h
             MOV bl,[NFELD+ebx]
             INC byte[WBLINIE+ebx]
             MOV bx,di
             JMP l_nokw
NOBW:        CMP al,6h
             JNE l_nokw
             MOV [WKFELD],bl
             MOV di,bx
             SHL bx,1h
             MOV bl,[NFELD+ebx]
             MOV [WKLINIE],bl
             MOV bx,di
             JMP l_aktw1
NOKW:        SHL ax,1h
             MOV di,ax
             MOV ax,[FIGWERT+edi]
             ADD [MATW],ax
             JMP l_aktw1
  
AKTWS:       INC word[ANZFIGS]
             AND al,7h
             CMP al,1h
             JNE l_nobs
             INC word[ANZBAUERS]
             XOR byte[SBSTELL+ebx],80h
             INC byte[SBSTELL+9h+ebx]
             INC byte[SBSTELL+0bh+ebx]
             MOV di,bx
             SHL bx,1h
             MOV bl,[NFELD+ebx]
             INC byte[SBLINIE+ebx]
             MOV bx,di
             JMP l_noks
NOBS:        CMP al,6h
             JNE l_noks
             MOV [SKFELD],bl
             MOV di,bx
             SHL bx,1h
             MOV bl,[NFELD+ebx]
             MOV [SKLINIE],bl
             MOV bx,di
             JMP l_aktw1
NOKS:        SHL ax,1h
             MOV di,ax
             MOV ax,[FIGWERT+edi]
             ADD [MATS],ax
             JMP l_aktw1
AKTWE:       RET
;----------------------------- Ende TAKTWERT ---------------------------- 
  
  
;------------------------------ Anfang TEHBACK ---------------------------------
;-------------------- Ausgangsstellung wieder herstellen -----------------------
EHBACK:      PUSHAD 
             CMP [AZ],1b6h
             JNE l_ehback0
             MOV [TIEFE],1h            ;wegen Zeitabbruch bei Erweiterungstest
EHBACK0:     CMP [AZ],0h               ;nicht Tiefe!!!
             JE l_ehbacke              ;alles o.K., Timpetu kann loslegen
             CMP [COLOR],0h            ;invertiert!
             JE l_ehback2 
EHBACK1:     CALL l_whzr
             CMP [AZ],0h
             JE l_ehbacke              ;Timpetu wieder am Zug
EHBACK2:     CALL l_shzr
             CMP [AZ],0h
             JNE l_ehback1
EHBACKE:     AND [NULLMOVE],0feh       ;nur 1 lschen
             MOV [NMOVE],0h
             MOV [NMOV1],0h
             POPAD 
             RET
;----------------------------- Ende TEHBACK ------------------------------------

 
;----------------------------- Anfang TZUGFERT ---------------------------------
;------------------------- Z U G B E W E R T U N G -----------------------------
ZUGFERTIG:   XOR ebx,ebx
             CMP byte[TEXTWERT+7h],18h ;Pfeil nach oben fr Fail-High?
             JNE l_zugfertig0          ;nein
             MOV al,[AFELD+1h]         ;Fail-High-Zug nehmen
             MOV ah,[ZFELDUAKT]        ;NUR SO!
             JMP l_zugfertig01
ZUGFERTIG0:  MOV ax,Word[ZUGTAB]
ZUGFERTIG01: CALL l_sound
ZUGFERTIG1:  PUSH ax                   ;Einsprung von Bibliothek
             CMP [GRUNDTIEFE],0ffh
             JNE l_zugfertig3          ;keine Bedenkzeit-Anpassung notwendig

       ;------------------- Bedenkzeit aktualisieren ---------------------------
             XOR eax,eax
             MOV ax,[RESTZEIT]         ;Restzeit wird im Interrupt verringert
             MOV di,[HZ]
             AND di,7h
             CMP di,7h
      ;je short ZUGFERTIG2
             JNE l_zugfertigt
             ADD [NOCHZUG],2h
ZUGFERTIGT:  DEC [NOCHZUG]
             JNZ l_zugfertig2
             MOV [NOCHZUG],1h
       ;-------------------- Zeit pro Zug aktualisieren ------------------------
ZUGFERTIG2:  MOV di,[NOCHZUG]          ;Zgezahl in Hex bis zur Zeitkontrolle
             XOR dx,dx                 ;sonst Absturzgefahr!
             DIV di                    ;AX=Sekunden pro Zug in Bedenkzeit
             CMP ax,1h
             JAE l_zugfertigz
             MOV ax,1h                 ;1 Sekunde pro Zug ist Minimum!
ZUGFERTIGZ:  MOV [ZUGZEIT],ax            ;Rest in DX ist geschenkt!
             MOV byte[TEXTTEMP],20h
             XOR di,di
             CALL l_zahlzt             ;ax=ZUGZEIT
              ;MOV ax,1301
              ;MOV bx,7
              ;MOV cx,5
              ;MOV dx,1d35
              ;MOV bp,offset [TEXTTEMP+1]
              ;INT 10

             MOV ax,[ZUGZEIT]
             SHR ax,1h
             ADC ax,0h
             MOV [ZUGZEIT50],ax
             OR ax,ax
             JNE l_zugfertig3
             MOV [ZUGZEIT50],1h
       ;------------------------------------------------------------------------
ZUGFERTIG3:  POP ax
ZUGFERTIG31: MOV [LASTZUGGA],al        ;Einsprung von 1.zuflliger Zug
             MOV [AFELDE],al
             MOV [AFELD],al            ;fr ZUGTAB e.p.
             MOV [AUTOZUGAT],al
             MOV [UFIG],0h             ;Umwandlungsfigur
             CMP ah,62h                ;ZFELD
             JA l_zugfertigb           ;Bauer umgewandelt
             MOV [LASTZUGGZ],ah
             MOV [ZFELDE],ah
             MOV [ZFELD],ah            ;fr ZUGTAB e.p. und Hashen
             MOV [AUTOZUGZT],ah
             MOV bl,al
             MOV al,[ASTELL+ebx]
             MOV [AFELDH],al
             MOV bl,ah
             MOV al,[ASTELL+ebx]
             MOV [ZFELDH],al
             CMP [TF],80h
             JE l_zugfertig4
             CALL l_hashw
             JMP l_norech
ZUGFERTIG4:  CALL l_hashs
             JMP l_norech

       ;------------------ Dekodierung Bauernumwandlung ------------------------
ZUGFERTIGB:  CMP [TF],80h
             JE l_zugfertigs
             SUB ah,64h                ;ZFELD minus 100
             MOV bl,al                 ;AFELD
             SUB bl,0ah                ;1.Mglichkeit: gerade durchgezogen
             SUB ah,bl
             TEST ah,3h                ;Bit 0 oder 1 gesetzt? (n.d.4 teilbar)
             JNZ l_nichtgf             ;ja, war nicht gerade durchgezogen
             SHR ah,2h                 ;durch 4 teilen
             MOV [UFIG],ah             ;AH ist Figur, BL ist richtiges ZFELD
             MOV ah,bl
             JMP l_zugfertige
NICHTGF:     DEC ah                    ;2.Mglichkeit: nach links schlagen
             TEST ah,3h
             JNZ l_nichtlf             ;war nicht nach links
             SHR ah,2h
             MOV [UFIG],ah
             INC bl
             MOV ah,bl
             JMP l_zugfertige
NICHTLF:     ADD ah,2h                 ;bleibt nur 3.Mglichkeit: nach rechts schlagen
             SHR ah,2h
             MOV [UFIG],ah
             DEC bl
             MOV ah,bl
             JMP l_zugfertige
ZUGFERTIGS:  SUB ah,64h                ;ZFELD minus 100
             MOV bl,al                 ;AFELD
             ADD bl,0ah                ;1.Mglichkeit: gerade durchgezogen
             SUB ah,bl
             TEST ah,3h                ;Bit 0 oder 1 gesetzt? (n.d.4 teilbar)
             JNZ l_nichtgfs            ;ja, war nicht gerade durchgezogen
             SHR ah,2h                 ;durch 4 teilen
             MOV [UFIG],ah             ;AH ist Figur, BL ist richtiges ZFELD
             MOV ah,bl
             JMP l_zugfertige
NICHTGFS:    DEC ah                    ;2.Mglichkeit: nach links schlagen
             TEST ah,3h
             JNZ l_nichtlfs            ;war nicht nach links
             SHR ah,2h
             MOV [UFIG],ah
             INC bl
             MOV ah,bl
             JMP l_zugfertige
NICHTLFS:    ADD ah,2h                 ;bleibt nur 3.Mglichkeit: nach rechts schlagen
             SHR ah,2h
             MOV [UFIG],ah
             DEC bl
             MOV ah,bl
ZUGFERTIGE:  MOV [LASTZUGGZ],ah
             MOV [ZFELDE],ah
             MOV [ZFELD],ah            ;fr Hashen
             MOV [AUTOZUGZT],ah
             MOV bl,ah
             MOV al,[ASTELL+ebx]
             MOV [ZFELDH],al
             MOV bl,[AFELD]
             MOV al,[ASTELL+ebx]
             MOV [AFELDH],al
       ;--------------- Umwandlungsfigur fr Autoplay einbinden ----------------
             CMP [UFIG],4h
             JNE l_autofig1
             OR [AUTOZUGZT],40h        ;Turm
             JMP l_autofige
AUTOFIG1:    CMP [UFIG],3h
             JNE l_autofig2
             OR [AUTOZUGZT],80h        ;Lufer
             JMP l_autofige
AUTOFIG2:    CMP [UFIG],2h
             JNE l_autofige            ;Dame=00 in Bit 6 und 7
             OR [AUTOZUGZT],0c0h       ;Springer
AUTOFIGE:    CMP [TF],0h
             JE l_zugfertige1
             OR [UFIG],80h
             CALL l_hashs
             JMP l_norech
ZUGFERTIGE1: OR [UFIG],10h
             CALL l_hashw
             JMP l_norech
;------------------------------ Ende TZUGFERT ----------------------------------


;----------------------------- Anfang TRECHNEN ---------------------------------
;--------------------- Letzte Modifizierung: 15.01.2006 ------------------------
;----------------- nun versuchen wir mal,nen guten Zug zu finden --------------
RECHNEN:     CMP [AUTOPLAY],0h
             JE l_rechnenauto
             CMP [WERZUG],0h
             JE l_rechnenauto
             CMP [HZ],0h
             JE l_rechnenauto

       ;--------------- Zug von Timpetu an Autoplayer-Gegner senden ------------
             ;XOR dx,dx        ;mov dx,COM
             ;MOV bh,dh
             ;MOV ax,142        ;STX
             ;INT 14
             ;MOV al,AUTOZUGARTT
             ;MOV ah,1
             ;INT 14
             ;MOV bl,AUTOZUGAT
             ;MOV al,[AUTOFELD1+bx]
             ;MOV ah,1
             ;INT 14
             ;MOV bl,AUTOZUGZT
             ;MOV al,[AUTOFELD1+bx]
             ;MOV ah,1
             ;INT 14
             ;MOV ax,143        ;ETX
             ;INT 14

       ;-------------------- auf ACK von Fritz warten --------------------------
LAUSCH1:     ;MOV ax,200
             ;INT 14
             ;CMP al,46        ;ACK
             ;JNE LAUSCH1        ;Timeout!

       ;------------------------- weiter im Text -------------------------------
RECHNENAUTO: MOV [NMOVE],0h            ;wichtig!
             TEST [NULLMOVE],80h
             JNZ l_rechnennm
             MOV [NULLMOVE],0h         ;wegen Zeitabbruch ntig!
RECHNENNM:   MOV [TIEFE],0h
             MOV word[VARTIEFE],0h
             MOV [TICKTACK],0h         ;verbrauchte Zeit
             MOV [AZ],0h               ;Adresszhler, 438D Abstand in ZUGTAB
             MOV [NOTZ],0h             ;erspart einiges
             MOV word[ALPHA],0aceh     ;tiefster Wert
             MOV word[BETA],0f532h     ;hchster Wert
             MOV bp,8000h              ;reine Sicherheit
             CALL l_holze2             ;nur fr Remis-Untersuchung; COLOR egal
             OR bp,bp
             JNE l_rechnennr
             MOV ax,8000h
             CALL l_mwertaus
 
       TEXTTEST4$="Remis"
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(100,750,TEXTTEST4$) 
       StopDrawing()
      
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(100,750,TEXTTEST4$) 
       StopDrawing()
       TEXTTEST4$=""

             MOV [MATTZAHL],0ffh
             JMP l_zeitlesen

RECHNENNR:   MOV [v_ZSTMG1],0h         ;Zhler Gesamtanzahl bewertete Stellungen
             MOV [v_ZSTMG2],0h
             MOV al,[LASTZUGGA]        ;von Eingabe retten
             MOV ah,[LASTZUGGZ]
             
             PUSHAD 
             CALL l_rews               ;Zge sortiert nach Vorwert
             POPAD 
            
             MOV [LASTZUGGZ],ah
             MOV [LASTZUGGA],al
             MOV ebx,6h                ;weil vorn 0ffffffff und Vorwert stehen
             XOR edi,edi
             MOV [ZZZUGTAB],di
RTWS01:      MOV ax,word[ZUGSORT+ebx]
             OR ax,ax                  ;Ende ZUGSORT
             JE l_rtws02
             XCHG ah,al
             MOV word[ZUGTAB+edi],ax
             ADD bx,4h
             ADD di,2h
             INC [ZZZUGTAB]            ;immer 1 kompletter Zug
             JMP l_rtws01
RTWS02:      MOV word[ZUGTAB+edi],0ffffh   ;Ende ZUGTAB markieren
             MOV ax,[ZZZUGTAB]
                        
       ;-------------------- Bildschirminfo ------------------------------------
             PUSHAD
             CALL l_attackfeld
             POPAD 
             XOR ebx,ebx      
             CMP [COLOR],bh
             JE l_rtws04
    
             MOV bl,[SKFELD]
             TEST byte[FELDATTACK+ebx],0fh ;Bit 0-3 Weiss
             JE l_noschs               ;kein Schach
             PUSH bx                   ;wichtig!
             CALL l_schwarzschach      ;Schachgebot ausgeben; Schwarz steht im Schach
             POP bx

NOSCHS:      CMP [ZZZUGTAB],0h
             JNE l_rtws03
             TEST byte[FELDATTACK+ebx],0fh
             JE l_schwarzpatt
             JMP l_schwarzmatt
       ;---------------------------------------
RTWS04:      MOV bl,[WKFELD]
             TEST byte[FELDATTACK+ebx],0f0h
             JE l_noschw               ;kein Schach
             PUSH bx                   ;wichtig!
             CALL l_weissschach        ;Schachgebot ausgeben; Weiss steht im Schach
             POP bx
NOSCHW:      CMP [ZZZUGTAB],0h
             JNE l_rtws03
             TEST byte[FELDATTACK+ebx],0f0h
             JE l_weisspatt
             JMP l_weissmatt

RTWS03:      CALL l_bauszug            ;hier treffen sich Weiss und Schwarz; fr Partiebeginn notwendig
                   
             CMP [WERZUG],0h
             JNE l_rtws05
             CMP [ZZZUGTAB],1h
             JE l_zugfertig            ;Timpetu hat nur einen Zug
RTWS05:      ;CMP [BIBEND],80h
             ;JE l_rechnenpb0           ;Bibliothek Ende oder aus; Zufallszug beachten! 
            
             CMP [STELLTEST],0h
             JNE l_rechnenpb0
             
             CMP [WERZUG],80h
             JE l_rechnenpb

             CMP [HZ],0h
             JNE l_rechnenpb           ;in Bibliothek suchen
 
       ;-------------------- 1.weissen Zug per Zufall auswhlen ----------------
             
       ElapsedMilliseconds()           ;eax ist Rckgabewert unterste 32-Bit
            
             MOV edx,eax          
            
             CMP dl,58h                ;0-88 soll e2-e4 spielen 35%
             JAE l_d4
             MOV ax,4155h              ;e2-e4
             JMP l_zugfertig31
D4:          CMP dl,98h                ;89-152 soll d2-d4 spielen 25%
             JAE l_sf3
             MOV ax,4054h              ;d2-d4
             JMP l_zugfertig31
SF3:         CMP dl,0d8h               ;153-216 soll Sg1-f3 spielen 25%
             JAE l_c4
             MOV ax,4c61h              ;Sg1-f3
             JMP l_zugfertig31
C4:          MOV ax,3f53h              ;217-255 soll c2-c4 spielen 15%
             JMP l_zugfertig31
       ;-------------------------------------------
RECHNENPB:   ;CALL BIBSUCH             ;auch fr Gegner zur Information
            
             CMP [WERZUG],80h
             JE l_rechnenpb0
             CMP [BIBZUG],0h
             JE l_rechnenpb0           ;kein Zug gefunden oder Schreibfehler
             JMP l_zugfertig1

;------------------------------ Suche in Bibliothek ----------------------------
BIBSUCH:     ;MOV esi,100000        ;Zeiger in Bibliothek (RAM)
             ;XOR eax,eax
             ;MOV SORTE,100        ;Zeile von Gegner, Zwischenspeicher
             ;MOV ebx,eax
             ;MOV BIBZUG,ax        ;Anzahl gefundener Zge*2
             ;MOV cx,10h
BIBSUCH0:    ;MOV dword ptr[BIBZUGTAB+ebx],eax
             ;ADD bx,4h
             ;LOOP BIBSUCH0
             ;MOV dx,100h        ;Zeile von Gegner
             ;CMP WERZUG,80h
             ;JE short BIBSUCH2
             ;MOV dx,200h        ;Zeile von Timpetu
BIBSUCH2:    ;PUSH ds         ;Anzeigen lschen
             ;POP es
             ;MOV ax,1301
             ;XOR bx,bx
             ;MOV bp,offset TEXTN
             ;MOV cx,50
             ;INT 10
BIBSUCH1:    ;CMP esi,BIBENDE        ;Ende Bibliothek erreicht?
             ;JB BIBSUCH18        ;nein

             ;CMP BIBZUG,0
             ;JNE short BIBSUCH19     ;mindestens einen Zug gefunden
             ;INC BIBNOZUG
             ;CMP BIBNOZUG,4
             ;JB short BIBSUCH1B

             ;MOV bp,offset TEXT9     ;Ende
BIBSUCH111:  ;MOV BIBEND,80        ;endgltiger Abschied von Bibliothek
             ;MOV BIBNOZUG,80
             ;MOV ax,2         ;Maus weg
             ;INT 33
             ;PUSH ds
             ;POP es
             ;MOV ax,1301
             ;MOV bx,7
             ;MOV cx,8
             ;MOV dx,1447
             ;INT 10

             ;MOV ax,1301
             ;MOV cx,18
             ;MOV dx,1537
             ;MOV bp,offset TEXTN     ;Anzahl Halbzge weg
             ;INT 10

             ;MOV ax,1301
             ;MOV dx,100        ;noch evtl. angezeigte Zge weg
             ;MOV cx,50        ; doppelt hlt besser!
             ;INT 10

             ;MOV ax,1301
             ;INC dh
             ;INT 10

             ;MOV ax,1         ;Maus rein
             ;INT 33

BIBSUCH1B:   ;RET

BIBSUCH19:   ;MOV bx,BIBZUG
             ;SUB bx,2         ;direkte Adresse
             ;JZ short BIBSUCH20      ;nur einen Zug gefunden

       ;----------- mehr als ein Zug, Zug zufllig aussuchen -------------------
             ;SHR bx,1         ;BIBZUG jetzt 1,2,3,...
             ;INC bx         ;unbedingt notwendig!
             ;MOV ah,2c
             ;INT 21
             ;MOV al,dl        ;DL sind hundertstel Sekunden
             ;XOR ah,ah        ;muss sein!
             ;DIV bl
             ;MOV bl,ah        ;Modulo
             ;SHL bx,1
BIBSUCH20:   ;MOV ax,[BIBZUGTAB+bx]
             ;XOR esi,esi
       ;---------- Sicherung gegen Schreibfehler in Bibliothek -----------------
             ;XOR bx,bx
             ;CMP WERZUG,bl
             ;JE short BIBSUCH23      ;nur fr Timpetu am Zug, wegen REW/RES
             ;RET
BIBSUCH23:   ;MOV dx,word ptr[ZUGTAB+bx]
             ;CMP dx,0ffff
             ;JE short BIBSUCH24      ;Ende ZUGTAB
             ;ADD bx,2
             ;CMP ax,dx
             ;JNE BIBSUCH23        ;weiter suchen
             ;RET         ;gltiger Zug
        ;---------- Fehler in Bibliothek gefunden ---------------------
BIBSUCH24:   ;MOV bp,offset TEXT7     ;"Fehler!"
             ;MOV BIBZUG,0
             ;JMP BIBSUCH111        ;selber rechnen
        ;--------------------------------------------------------
BIBSUCH18:   ;XOR bp,bp        ;Trefferzhler
             ;MOV edi,90        ;Zeiger auf ausgefhrte Zge im RAM
             ;MOV [X4],esi        ;Anfang der Variante merken
BIBSUCH10:   ;MOV dx,gs:[7a120+edi]
             ;ADD edi,90
             ;MOV cx,HZ
BIBSUCH11:   ;MOV al,gs:[esi]        ;Bibliothek auslesen
             ;INC esi
             ;CMP al,71        ;q=Ende der Variante
             ;JE BIBSUCH1        ;nchstes Feld wieder von vorn
             ;MOV ah,gs:[esi]
             ;INC esi
             ;CMP ax,dx        ;Treffer?
             ;JE short BIBSUCH12      ;ja
             ;LOOP BIBSUCH11

BIBSUCH14:   ;CMP ah,71        ;q
             ;JE BIBSUCH1        ;Ende der Variante suchen
BIBSUCH15:   ;MOV ah,gs:[esi]
             ;INC esi
             ;JMP BIBSUCH14

BIBSUCH12:   ;INC bp         ;Treffer
             ;MOV esi,[X4]        ;wieder Anfang der Variante
             ;CMP bp,HZ
             ;JNE BIBSUCH10

             ;MOV ax,HZ        ;Hurra! Alle Neune!
             ;SHL ax,1
             ;ADD esi,eax
             ;MOV al,gs:[esi]
             ;INC esi
             ;CMP al,71        ;q
             ;JE BIBSUCH1        ;doch nicht Hurra, war Ende der Variante
             ;MOV ah,gs:[esi]        ;nchster Halbzug
             ;MOV bx,0fffe
BIBSUCH13:   ;ADD bx,2
             ;CMP ax,[BIBZUGTAB+ebx]
             ;JE BIBSUCH15        ;schon vorhanden
             ;CMP bx,BIBZUG
             ;JB BIBSUCH13
       ;---------------------- Anzeige Bibliothekzge --------------------------
             ;PUSHAD
             ;MOV bx,BIBZUG
             ;MOV [BIBZUGTAB+ebx],ax
             ;ADD BIBZUG,2
             ;XCHG al,ah
             ;XOR bh,bh
             ;MOV si,SORTE
             ;CMP WERZUG,80
             ;JE short BIBSUCH30
             ;ADD si,100        ;eine Zeile tiefer
BIBSUCH30:   ;MOV bl,ah
             ;SHL bl,1
             ;MOV dx,word ptr[NFELD+bx]
             ;ADD dl,60
             ;ADD dh,30
             ;MOV word ptr[TEXTTEMP],dx
             ;MOV bl,al
             ;SHL bl,1
             ;MOV dx,word ptr[NFELD+bx]
             ;ADD dl,60
             ;ADD dh,30
             ;MOV word ptr[TEXTTEMP+2],dx
             ;CMP SCREEN,0
             ;JNE short BIBSUCH31     ;dem Feind keine Information!
             ;MOV ax,2
             ;INT 33
             ;PUSH ds
             ;POP es
             ;MOV ax,1301
             ;MOV bx,7
             ;MOV dx,si
             ;MOV bp,offset TEXTTEMP
             ;MOV cx,4
             ;INT 10
             ;MOV ax,1
             ;INT 33
BIBSUCH31:   ;ADD SORTE,5
             ;POPAD
             ;JMP BIBSUCH15            ;q suchen

;-------------------------- Auswertung Permanent Brain -------------------------
RECHNENPB0:  XOR edi,edi
            
             CMP [HZ],di
             JE l_rechnen1
             CMP [BIBEND],0h           ;kann sonst zu Unfug fhren!
             JE l_rechnen1
             CMP [PERBRAIN],0h         ;bei Mattwert in MWERTAUS
             JE l_rechnen1
             MOV dl,[WAHLFIG]          ;Merker von Zug vor/zurck
             MOV [WAHLFIG],0h
             CMP dl,0ffh               ;nach Zug vor/zurck kein PB!
             JE l_rechnen1
             MOV dx,[BESTPB+2h]        ;besten Zug des Permanent Brain nach vorn
             OR dx,dx
             JE l_pb0
       ;---------- besten Zug mit Vorwert nach vorn sortieren ------------------
             MOV ebx,edi
RECHNENPB1:  MOV ax,word[ZUGTAB+ebx]
             CMP ax,0ffffh
             JE l_pb0                  ;Ende ZUGTAB
             ADD bx,2h
             CMP ax,dx
             JNE l_rechnenpb1
             SUB bx,2h
             MOV ax,word[ZUGTAB]
             MOV word[ZUGTAB],dx
             MOV word[ZUGTAB+ebx],ax
             SHL bx,1h                 ;Vorwerte nicht vergessen!
             MOV ax,word[ZUGSORT+4h+ebx]
             MOV dx,word[ZUGSORT+4h]
             MOV word[ZUGSORT+4h],ax
             MOV word[ZUGSORT+4h+ebx],dx

       ;------------------ Nutzung Permanent Brain -----------------------------
PB0:         CALL l_bauszug            ;sonst Anzeige nur von REW/RES!
             CMP [PERBRAIN],1h         ;PB EIN/AUS
             JE l_pb01                 ;zugeschaltet, Standard
        ;------------------- Hashtabelle lschen ------------------------------
             MOV edx,[HASHTABEND]
             MOV ebx,[HASHTABANF]
             XOR eax,eax
HASHLOESCH1: MOV [ebx],eax
             ADD ebx,4h
             CMP ebx,edx
             JB l_hashloesch1

             MOV ebx,eax
             MOV edx,eax
             JMP l_pb3

PB01:        XOR ebx,ebx
             MOV cx,1fh
             XOR edi,edi
PB1:         MOV ax,[BESTPB+2h+ebx]
             MOV [BESTLINE+ebx],ax
             OR ax,ax
             JE l_pb11
             MOV eax,[KILLTABSPB+2h+edi]
             MOV [KILLTABS+edi],eax
             MOV eax,[KILLTABNPB+2h+edi]
             MOV [KILLTABN+edi],eax
             ADD bx,2h
             ADD edi,4h
             DEC cx
             JNZ l_pb1
             
PB11:        CMP [GRUNDTIEFE],0ffh
             JNE l_pb3                 ;bei Tiefen-Abbruch bleibt VARTIEFE=0!
             CMP byte[TEXTWERT+7h],20h
             JNE l_pb3                 ;dito bei Fails
             CMP [ALPHAPB],0b00h       ;neg 0f500
             JB l_pb3                  ;dito bei erkanntem Matt

             CMP [WERZUG],80h
             JE l_pb2

             MOV al,[LASTZUGGA]        ;von Gegner-Eingabe
             MOV ah,[LASTZUGGZ]
             CMP ax,[BESTPB]
             JNE l_pb3                 ;Gegner hat nicht den erwart.Zug gezogen

       ;------------------- Test, ob Timpetu sofort ziehen kann --
             MOV ax,[BEST2ZUG]
             OR ax,ax
             JE l_pb2
             MOV dx,[BEST2TIME]
             OR dx,dx
             JE l_pb2
             MOV cx,[ZUGZEIT]
             ADD cx,2h                 ;2 Sek. drauf
             CMP dx,cx
             JB l_pb2

             MOV bl,al                 ;AFELD
             MOV dl,[ASTELL+ebx]
             AND dl,7h
             CMP dl,1h                 ;Bauer?
             JNE l_pb23                ;war kein Bauer
             CMP ah,1ch                ;ZFELD 8.Reihe?
             JBE l_pb2                 ;ja
             CMP bl,5bh                ;1.Reihe?
             JAE l_pb2                 ;ja

PB23:        MOV [SCHNELLZUG],1h
             JMP l_zugfertig01         ;"Schnellzug" von Timpetu

PB2:         CMP [SCHNELLZUG],1h
             JE l_pb3                  ;Timpetu hat vorher "Schnellzug" gemacht
             SHR bx,1h                 ;noch Zeiger in Bestline
             INC bx
             MOV ax,[PBTIEFE]          ;von ZBESTLINE
             CMP bx,ax
             JAE l_pb22
             MOV ax,bx
PB22:        DEC ax
             MOV [VARTIEFE],ax
             MOV ax,[ALPHAPB]          ;von ZBESTLINE
             NEG ax
             MOV [ALPHA],ax

             CALL l_zbestline          ;BESTLINE auf Bildschirm  vor Screen!

PB3:         MOV [BEST2ZUG],0h
             MOV [BEST2TIME],0h
             MOV [SCHNELLZUG],0h

       ;------------------------------------------
RECHNEN1:    INC word[VARTIEFE]        ;nchste Rechentiefe
             CMP word[VARTIEFE],20h
             JB l_rechnen1b
             CMP [WERZUG],0h
             JE l_zugfertig
             MOV [MATTZAHL],0ffh
             JMP l_zeitlesen
            
RECHNEN1B:   CMP [GRUNDTIEFE],0feh
             JB l_rechnen1a            ;Zeit spielt keine Rolle
             CMP [WERZUG],80h          ;Abfrage wegen Ticktack!
             JE l_rechnen1a
             MOV ax,[TICKTACK]
             CMP ax,[ZUGZEIT50]
             JAE l_zugfertig           ;weiterrechnen lohnt nicht
RECHNEN1A:   MOV dx,[VARTIEFE]
             CMP [WERZUG],80h
             JE l_rechnen0             ;Gegner am Zug, Permanent Brain
             MOV al,[GRUNDTIEFE]       ;fr Abbruch bei fester Tiefe
             INC al
             CMP al,dl
             JE l_zugfertig            ;Ende der Vorstellung   NICHT JBE

       ;--------------------- Anfangswerte -------------------------------------
RECHNEN0:    MOV word[Z+2h],0h         ;Zeiger in ZUGTAB Ausgangsstellung
             CMP dx,1h                 ;Tiefe 1?
             JNE l_rechnen01
             MOV word[ALPHA],0aceh     ;tiefster Wert
             MOV word[BETA],0f532h     ;hchster Wert
             MOV [DIVAB],0h       
             JMP l_rechnen2
RECHNEN01:   MOV ax,[ALPHA]
             MOV dx,[MATW]
             ADD dx,[MATS]
             SHR dx,0ah
             MOV cx,20h                ;= max.Tiefe
             SUB cx,[VARTIEFE]
             SHR cx,1h
             ADD dx,cx
             ADD ax,dx
             MOV [BETA],ax
             SUB ax,dx
             SUB ax,dx
             SHR cx,1h
             ADD ax,cx
             MOV [ALPHA],ax

             SUB ax,[BETA]
             JNC l_rechnen02
             NEG ax
RECHNEN02:   MOV [DIVAB],ax            ;fr Fail-High nicht 1.Zug

       ;---------------- nchster Zug der Ausgangsstellung ---------------------
RECHNEN2:    CMP [MATTZAHL],0h         ;von MWERTAUS
             JE l_rechnen21            ;kein Matt
             CMP [WERZUG],0h
             JE l_zugfertig            ;Gegner ist platt
RECHNEN21:   MOV [GLEICHSTELL],1h      ;vorhandene Stellung
             MOV [X7],1h
             CALL l_abaus
             MOV word[ERWEITERUNG],0h
             MOV ax,[ZZZUGTABGUT]
             SHL ax,1
             CMP [Z+2h],ax
             JAE l_rechnen1

             CMP [COLOR],bh            ;nchster Zug Ausgangsstellung
             JNE l_rechnen3
             CALL l_hw1
             JMP l_vorwertist
RECHNEN3:    CALL l_hs1
       ;------------------------- Vorwert von REWS holen -----------------------
VORWERTIST:  MOVZX ebx,word[Z+2h]
             SUB bx,2h
             SHL bx,1h
             MOV ax,word[ZUGSORT+4h+ebx]
             MOV [VORWERT],ax            ;wird bp in BWS
       ;----------------- Anzeige aktueller 1.Zug ------------------------------
             XOR eax,eax
             MOV [MAXSEL],ax
             MOV di,ax
             MOV byte[TEXTWERT+7h],20h ;Fails lschen
             MOV al,[ZFELDU]           ;wichtig bei Umwandlungen! Von AW/AS
             MOV [ZFELDUAKT],al        ;sonst Fehler bei Fail-High-Umwandlung, wenn nicht 1.Zug
             MOV ax,[Z+2h] 
             SHR ax,1h
                         
             PUSHAD            
             MOV [v_XSH],eax
     
             MOV ax,[ZZZUGTAB]         ;Anzahl 1.Zge
             MOV [v_YSH],eax
          
       If XSH<10
           TEXTTEST4$=TEXTTEST4$+"  "
       EndIf 
       
       TEXTTEST4$=TEXTTEST4$+Str(XSH)+" / "+Str(YSH)+"   "
  
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463) 
       DrawText(500,750,TEXTTEST4$) 
       StopDrawing()
      
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(500,750,TEXTTEST4$) 
       StopDrawing()
       TEXTTEST4$=""
            
             POPAD 
             
        ;------------------ aktuellen Zug rot markieren --------------------
             CMP [SCREEN],0h
             JNE l_anzvt
        
             CMP word[VARTIEFE],5h
             JBE l_anzvt
              
             PUSHAD
     If TEXTTESTR$<>""                 ;sonst bei Fail-High nicht erster Zug "Doppel-Anzeige" des Zuges!
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       DrawingFont(LoadFont(1,"Arial",12))
       BackColor(12566463)
       FrontColor(140*65536)           ;"alten" roten Zug erstmal wieder blau
       DrawText(XR,YR,TEXTTESTR$)
       StopDrawing()
    
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       DrawingFont(LoadFont(1,"Arial",12))
       BackColor(12566463)
       FrontColor(140*65536)           ;"alten" roten Zug erstmal wieder blau
       DrawText(XR,YR,TEXTTESTR$)      
       StopDrawing()
       TEXTTESTR$=""
     EndIf          
        ;------------------------ 1.Zug abarbeiten ----------------            
             XOR ebx,ebx
         For x=0 To 3
             MOV al,[TEXTTEMPBA+ebx]
             MOV [v_XSH],eax
             TEXTTEST1$=TEXTTEST1$+Chr(XSH)
             INC bx
         Next 
          
             CMP word[Z+2h],2h
             JNE l_notfirst            ;nicht erster Zug dran
             
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       DrawingFont(LoadFont(1,"Arial",12))
       BackColor(12566463)
       FrontColor(192)                 ;1.Zug rot darstellen
       DrawText(10,665,TEXTTEST1$)
       StopDrawing()
          
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       DrawingFont(LoadFont(1,"Arial",12))
       BackColor(12566463)
       FrontColor(192)
       DrawText(10,665,TEXTTEST1$)
       StopDrawing()
       TEXTTEST1$=""
             
             POPAD 
             JMP l_anzvt

NOTFIRST: 
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       DrawingFont(LoadFont(1,"Arial",12))
       BackColor(12566463)
       FrontColor(140*65536)   ;1.Zug blau, weil nicht dran, ntzlich fr vorgesplte Fail-High-Zge
       DrawText(10,665,TEXTTEST1$)
       StopDrawing()
                
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       DrawingFont(LoadFont(1,"Arial",12))
       BackColor(12566463)
       FrontColor(140*65536)   ;1.Zug blau, weil nicht dran, ntzlich fr vorgesplte Fail-High-Zge
       DrawText(10,665,TEXTTEST1$)
       StopDrawing()
       TEXTTEST1$="" 

      ;------------------------ 1.Zug abgehandelt -----
             XOR ebx,ebx
             MOV [v_YR],299h
             MOV ax,[Z+2h]
             SUB ax,2h
             SHR ax,1h       
             CMP ax,18h
             JBE l_u25                 ;Zug ist in der 1.Zeile
             
             ADD [v_YR],14h              ;2.Zeile
             ADD ebx,7dh
             SUB ax,19h
             
             CMP ax,18h
             JBE l_u25
             
             ADD [v_YR],14h              ;3.Zeile
             ADD ebx,7dh
             SUB ax,19h
 
U25:         MOV [v_PB4],eax
  
    For y=1 To PB4
      For x=0 To 4
             MOV al,[TEXTTEMPBA+ebx]
             MOV [v_XSH],eax
           TEXTTEST1$=TEXTTEST1$+Chr(XSH)   ;nur Lnge ermitteln
             INC bx  
      Next    
    Next     

         For x=0 To 3
             MOV al,[TEXTTEMPBA+ebx]
             MOV [v_XSH],eax
           TEXTTESTR$=TEXTTESTR$+Chr(XSH)
             INC bx
         Next 
 
 
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       DrawingFont(LoadFont(1,"Arial",12))
       BackColor(12566463)
       FrontColor(192)                 ;aktuellen Zug rot darstellen
       XR=TextWidth(TEXTTEST1$)
             ADD [v_XR],0ah            ;10 ist genereller linker Randabstand 
       DrawText(XR,YR,TEXTTESTR$)
       StopDrawing()
          
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       DrawingFont(LoadFont(1,"Arial",12))
       BackColor(12566463)
       FrontColor(192)                 ;aktuellen Zug rot darstellen
       DrawText(XR,YR,TEXTTESTR$)
       StopDrawing()
       TEXTTEST1$=""
              
             POPAD 
      
       ;--------- Test auf 3-malige Stellungswiederholung von Timpetu ----------
       ;--- wegen Feinheiten wie gezogene Figuren hier nicht mit Hashwerten! ---
ANZVT:       CMP [WERZUG],80h
             JE l_rechnen4             ;Gegner ist am Zug
             CMP [HZ],5h
             JBE l_rechnen4
            
             MOV [GLEICHSTELL],1h      ;diese Stellung ist aktuell vorhanden
             MOV bx,[ZASTELL]
             SUB bx,120h               ;Anfang vorletzte Stellungsabspeicherung
             MOV di,bx
ST3TEST0:    MOV cx,15h                ;A8
             MOV [X2],27h              ;39 Durchlufe fr 78 Felder
             MOV bx,di
ST3TEST1:    MOV ax,word[STELLAB+2h+ebx]   ;bisherige Stellungen
             AND ax,0bfbfh             ;ohne Feldfarbe
             MOV dx,word[ASTELL+ecx]
             AND dx,0bfbfh
             ADD bx,2h
             ADD cx,2h
             CMP ax,dx
             JNE l_st3test2
             DEC [X2]
             JNZ l_st3test1             
             INC [GLEICHSTELL]
ST3TEST2:    SUB di,90h                ;hier nicht 120!
             JNS l_st3test0
             CMP [GLEICHSTELL],3h      ;Test auf 2 weiter hinten!
             JB l_test50z              ;keine Stellungswiederholung
             CMP [ZZZUGTAB],1h
             JE l_st3test4             ;Timpetu hat nur einen Zug und somit keine Wahl

       ;------------------------- Remisfaktor ----------------------------------
ST3TEST31:   MOV ax,[REMISFAKTOR]      ;REMISFAKTOR=Remisfaktor+8000 von Vorgabe
             CMP [TIMPWERT],ax
             JBE l_st3test4            ;Remis wird sofort gemacht
             MOV word[TIEFENWERT+2h],8000h
             JMP l_test50z
ST3TEST4:    CALL l_ehback
ST3TEST41:   MOV ax,8000h              ;Remis wird gemacht, Partieende
             CALL l_mwertaus           ;Achtung FIDE-Regel:Zug muss notiert sein!
             PUSHAD    
       
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       TEXTTEST4$="Remis 3x   " 
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(100,750,TEXTTEST4$) 
       StopDrawing()
      
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(100,750,TEXTTEST4$) 
       StopDrawing()
       TEXTTEST4$=""
         
             POPAD             
             XOR edi,edi
             MOV al,[AFELD+1h]
             MOV ah,[ZFELD+1h]
             MOV [BESTLINE],ax
             MOV [BESTLINE+2h],di
             CALL l_zugbaus

             MOV [MATTZAHL],0ffh
             JMP l_zeitlesen           ;Men-Schleife

       ;------------------- Test auf 50-Zge-Regel -----------------------------
TEST50Z:     CMP [ZUG50],63h           ;Halbzge!   64 ist Remis!
             JB l_test1zug             ;interessant ist auch schon 62,falls der
             CMP [ZZZUGTAB],1h         ; Gegner reklamieren will!
             JE l_test50z1             ;Zugzwang, ist damit Remis
             MOV ax,[REMISFAKTOR]
             CMP [TIMPWERT],ax
             JA l_test1zug             ;Remis abgelehnt
TEST50Z1:    CALL l_ehback             ;Zug wurde schon ausgefhrt!
TEST50Z2:    ;MOV bp,offset TEXT33     ;Einsprung von NOTBUCHEIN!  "Remis 50 Z"
             JMP l_st3test41           ;Remis gemss 50-Zge-Regel

       ;---------------- Test auf mgliche Zge von Timpetu --------------------
TEST1ZUG:    CMP [ZZZUGTAB],1h
             JNE l_testremis
             CALL l_ehback             ;Zug wurde schon ausgefhrt!
             JMP l_zugfertig           ;Timpetu hat nur einen Zug
TESTREMIS:   CMP [GLEICHSTELL],2h
             JB l_rechnen4
             MOV ax,[REMISFAKTOR]
             CMP [TIMPWERT],ax
             JB l_rechnen4             ;wird sonst als Belohnung interpretiert
             MOV word[TIEFENWERT+2h],8000h ;Strafwert
             JMP l_rechnen45
       ;------------------- mehr als ein Zug ausfhrbar ------------------------
RECHNEN4:    MOV word[BESTLINE],0h     ;Anfang (alte) Hauptvariante lschen
             MOV ax,[ALPHA]
             NEG ax
             MOV [BETA+2h],ax          ;Werte fr Tiefe 2
             MOV ax,[BETA]
             NEG ax
             MOV [ALPHA+2h],ax
             MOV ax,[VARTIEFE]
             DEC ax
             MOV [VARTIEFE+2h],ax
             CALL l_alphabeta          ;Wert bestimmen
RECHNEN45:   CMP [COLOR],80h           ;Einsprung von 2x gleiche Stellung
             JE l_rechnen5
             CALL l_shzr               ;Ausgangsstellung wiederherstellen
             JMP l_rechnen6
RECHNEN5:    CALL l_whzr
       ;------------------------- Auswertung -----------------------------------
RECHNEN6:    MOV ax,[TIEFENWERT+2h]    ;Wert von Tiefe 1
             NEG ax
             MOV [TIEFENWERT],ax
             MOV [X7],1h
             MOV word[ERWEITERUNG],0h
             CMP ax,1000h              ;in Abhngigkeit VARTIEFE-WERT knnen
             JA l_rechnen63            ; auch hhere Werte probiert werden!
             CMP [ZZZUGTABGUT],1h        ;wichtig!
             JE l_rechnen63

             MOV bx,[Z+2h]
             MOV dx,[ZZZUGTABGUT]
             SHL dx,1h
             CMP dx,bx
             JE l_rechnen62            ;war letzter "guter" Zug, kein Verschieben notwendig
             SUB dx,2h                 ;sonst wird auch 0ff umsortiert (?)
             MOV [X2],dx
             SUB bx,2h                 ;zeigt auf Mistzug
             MOV dx,word[ZUGTAB+ebx]       ;Mistzug
             MOV di,bx 
             SHL di,1h
RECHNEN61:   ADD bx,2h
             ADD di,4h
             MOV cx,word[ZUGTAB+ebx]   ;nchster Zug
             MOV word[ZUGTAB-2h+ebx],cx
             MOV cx,word[ZUGSORT+4h+edi]   ;Vorwert
             MOV word[ZUGSORT+edi],cx
             CMP bx,[X2]
             JB l_rechnen61
             MOV word[ZUGTAB+ebx],dx   ;Mistzug an letzte Stelle
             CALL l_bauszug
RECHNEN62:   DEC [ZZZUGTABGUT]
             SUB word[Z+2h],2h
             JMP l_rechnen2
RECHNEN63:   CMP word[Z+2h],2h         ;war es der 1.Zug?
             JNE l_rechnen12           ;nein
       ;------------------ war 1.Zug der Ausgangsstellung ----------------------
             CMP ax,[ALPHA]        ;Test auf Fail-Low
             JAE l_rechnen9
        ;------------------ Fail Low ------------------------------------
             MOV word[ALPHA],0aceh     ;Wert ist kleiner als ALPHA
             MOV [BETA],ax
             NEG ax
             MOV [ALPHA+2h],ax
             MOV word[BETA+2h],0f532h  ;Werte fr Tiefe 1   -ALPHA
             MOV ax,[VARTIEFE]
             DEC ax
             MOV [VARTIEFE+2h],ax
             MOV word[Z+2h],0h         ;1.Zug noch einmal durchackern
             MOV byte[TEXTWERT+7h],1h  ;fr Zeit-Abbruch
             CMP [SCREEN],0h
             JNE l_rechnen131

             CMP word[VARTIEFE],7h
             JBE l_rechnen131
    
             PUSHAD   
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       TEXTTEST4$=Chr(234)             ;Runter-Pfeil
       FrontColor(220)
       DrawingFont(LoadFont(1,"Wingdings",12))
       BackColor(12566463)    
       DrawText(72,750,TEXTTEST4$) 
       StopDrawing()
       
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(220)
       DrawingFont(LoadFont(1,"Wingdings",12))
       BackColor(12566463)    
       DrawText(72,750,TEXTTEST4$) 
       StopDrawing()
       TEXTTEST4$=""
             POPAD 

RECHNEN131:  CMP [COLOR],80h
             JE l_rechnen7
             CALL l_hw1
             JMP l_rechnen8
RECHNEN7:    CALL l_hs1
RECHNEN8:    CALL l_alphabeta          ;neue Berechnung wegen Fail-Low
             MOV ax,[TIEFENWERT+2h]    ;Wert von Tiefe 1
             NEG ax
             MOV [TIEFENWERT],ax
             CMP [COLOR],0h
             JNE l_rechnen81
             CALL l_shzr
             JMP l_nullwindow
RECHNEN81:   CALL l_whzr
             JMP l_nullwindow
RECHNEN9:    CMP ax,[BETA]             ;Test auf Fail-High, AX ist noch Wert
             JB l_nullwindow           ;weder Fail-Low noch Fail-High
        ;----------------- Fail High 1.Zug ------------------------------
             MOV [ALPHA],ax            ;WERT ist grer/gleich BETA
             MOV word[BETA],0f532h
             NEG ax
             MOV [BETA+2h],ax          ;Werte fr Tiefe 1
             MOV word[ALPHA+2h],0aceh  ;-BETA
FH1:         MOV ax,[VARTIEFE]         ;Einsprung von Fail-High nicht erster Zug
             DEC ax
             MOV [VARTIEFE+2h],ax
             MOV word[Z+2h],0h         ;1.Zug noch einmal durchackern
             MOV byte[TEXTWERT+7h],18h ;fr Zugfertig
             CMP [SCREEN],0h
             JNE l_rechnen130
             
             CMP word[VARTIEFE],7h
             JBE l_rechnen130
            
             PUSHAD     
       TEXTTEST4$=Chr(233)             ;Hoch-Pfeil    
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(36864)
       DrawingFont(LoadFont(1,"Wingdings",12))
       BackColor(12566463)    
       DrawText(72,750,TEXTTEST4$) 
       StopDrawing()
       
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(36864)
       DrawingFont(LoadFont(1,"Wingdings",12))
       BackColor(12566463)    
       DrawText(72,750,TEXTTEST4$) 
       StopDrawing()
       TEXTTEST4$=""
             POPAD  
             
             CALL l_abaus
RECHNEN130:  CMP [COLOR],80h
             JE l_rechnen10
             CALL l_hw1
             JMP l_rechnen11
RECHNEN10:   CALL l_hs1
RECHNEN11:   CALL l_alphabeta          ;neue Berechnung wegen Fail-High
             CMP [COLOR],0h
             JNE l_rechnen111
             CALL l_shzr
             JMP l_nullwindow
RECHNEN111:  CALL l_whzr
NULLWINDOW:  MOV ax,[TIEFENWERT+2h]    ;Wert von Tiefe 1
             NEG ax
             MOV [TIEFENWERT],ax
             MOV [ALPHA],ax
             CALL l_mwertaus           ;AX wird als bester Wert angezeigt
             INC ax
             MOV [BETA],ax             ;Null-Fenster festlegen
             CALL l_aktbestline        ;BESTLINE aktualisieren
             CALL l_zbestline          ;Anzeige BESTLINE
  
             CMP [X7],1h
             JE l_rechnen2
             MOV ax,[X8]
             MOV [Z+2h],ax
             JMP l_rechnen2        ;nchster Zug
       ;----------------- war nicht 1.Zug der Ausgangsstellung -----------------
RECHNEN12:   MOV dx,[ALPHA]
             CMP ax,dx                 ;AX=Wert
             JBE l_rechnen2            ;Zug ist nicht besser als vorhandener
             MOV [BESTERWERT],dx       ;neuen besten 1.Zug gefunden
             MOV [ALPHA],ax            ;exakten Wert ermitteln
             MOV word[BETA],0f532h     ;hchster Wert
             NEG ax
             MOV [BETA+2h],ax
             SUB ax,[DIVAB]            ;Differenz ALPHA-BETA von 1.Zug
             MOV [ALPHA+2h],ax
             CMP ax,0b00h              ;0ace+Matt
             JAE l_rechnen124
             MOV word[ALPHA+2h],0aceh  ;-BETA	ist auch der ursprngliche Wert!

RECHNEN124:  MOV ax,[TIEFENWERT]
             MOV [ALPHA],ax
             CALL l_mwertaus           ;AX wird als bester Wert angezeigt
             CALL l_aktbestline        ;BESTLINE aktualisieren
             CALL l_zbestline          ;Anzeige BESTLINE
             MOV bx,[Z+2h]             ;ZUGTAB verschieben
             MOV [X8],bx
             SUB bx,2h                 ;ist Stelle bester Zug
             MOV dx,word[ZUGTAB+ebx]       ;bester Zug
             MOV di,bx
             SHL di,1h
             MOV cx,word[ZUGSORT+4h+edi]   ;Vorwert
RECHNEN125:  SUB bx,2h
             SUB di,4h
             MOV ax,word[ZUGTAB+ebx]   ;Zug
             MOV word[ZUGTAB+2h+ebx],ax
             MOV ax,word[ZUGSORT+4h+edi]   ;Vorwert
             MOV word[ZUGSORT+8h+edi],ax
             JNZ l_rechnen125
             MOV word[ZUGTAB],dx       ;bester Zug an 1.Stelle
             MOV word[ZUGSORT+4h],cx       ;Vorwert
             CALL l_bauszug
             MOV [X7],2h
        ;----------------------- Kosmetik -------------------------------
       TEXTTESTR$=""                   ;fr rote Anzeige 1.Zug 
             
             CMP word[VARTIEFE],7h
             JB l_fh1
           
             PUSHAD            
      
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(500,750," 1 ")         ;Zugnummer
                 
             CMP [SCREEN],0h
             JNE l_rechnen126

             XOR ebx,ebx
         For x=0 To 3
             MOV al,[TEXTTEMPBA+ebx]
             MOV [v_XSH],eax
             TEXTTEST1$=TEXTTEST1$+Chr(XSH)
             INC bx
         Next 
              
       FrontColor(192)                 ;1.Zug rot darstellen
       DrawingFont(LoadFont(1,"Arial",12))
       DrawText(10,665,TEXTTEST1$)
       StopDrawing()
                
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(500,750," 1 ")         ;Zugnummer
                        
       FrontColor(192)                 ;1.Zug rot darstellen
       DrawingFont(LoadFont(1,"Arial",12))
       DrawText(10,665,TEXTTEST1$)
RECHNEN126:
       StopDrawing()
       TEXTTEST1$=""
                             
             POPAD 
             JMP l_fh1

       ;------------------- Alpha-Beta-Ausgabe auf Bildschirm ------------------
ABAUS:       CMP [SCREEN],0h
             JE l_abaus0
             RET

ABAUS0:      PUSHAD 
             MOV [v_PB4],0h   
             XOR eax,eax
             MOV ax,[ALPHA]
             CMP ax,8000h
             JAE l_abaus1
             NEG ax
             ADD ax,8000h
             MOV [v_PB4],0ffh
             JMP l_abaus2
ABAUS1:      SUB ax,8000h
ABAUS2:      MOV [v_ZS],eax    

       TEXTTEST4$=Chr(97)+" = "+Str(ZS)+"         "  ;alpha
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(PB4)
       DrawingFont(LoadFont(1,"Symbol",14))
       BackColor(12566463)    
       DrawText(800,635,TEXTTEST4$) 
       
             MOV [v_PB41],0h 
             MOV ax,[BETA]
             CMP ax,8000h
             JAE l_abaus3
             NEG ax
             ADD ax,8000h
             MOV [v_PB41],0ffh
             JMP l_abaus4
ABAUS3:      SUB ax,8000h
ABAUS4:      MOV [v_ZS],eax  
 
       TEXTTEST5$=Chr(98)+" = "+Str(ZS)+"         "  ;beta
       FrontColor(PB41)
       DrawText(900,635,TEXTTEST5$) 
       StopDrawing()
 
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(PB4)
       DrawingFont(LoadFont(1,"Symbol",14))
       BackColor(12566463)    
       DrawText(800,635,TEXTTEST4$) 
       TEXTTEST4$=""
          
       FrontColor(PB41)
       DrawText(900,635,TEXTTEST5$) 
       TEXTTEST5$=""
       StopDrawing()

             POPAD
             RET 

;--------------------------------------- Ende TRECHNEN ----------------------------------

;------------------------------- Anfang TALPHBET -------------------------------
;------------------------ Letzte Modifizierung 09.04.2006 ----------------------
;--------------------------------- ALPHABETA -----------------------------------
ALPHABETA:   MOVZX ebx,[TIEFE]
             MOV edi,ebx
             SHL bx,6h
             SHL di,1h
             ADD bx,di
             MOV word[BESTLINE+ebx],0h ;bisherige Hauptvariante lschen
             CALL l_bws                ;Liefert Nega-Max-Wert zurck
             MOVZX ebx,[TIEFE]
             MOV edi,ebx
             MOV cx,[ATTACK]
             SHL bx,1h
             MOV [SCHACH+ebx],cx       ;fr Patterkennung
             OR bp,bp
             JNE l_abweiter
             MOV bp,8000h              ;Stellung ist z.B.technisches Remis
             JMP l_ab3
ABWEITER:    CMP bp,0f400h
             JA l_ab3                  ;Matt
             CMP di,1fh                ;0 bis 31D
             JB l_ab0                  ;Tiefe noch zulssig
             MOV edi,ebx    
             CALL l_bwsrest            ;fr bp auf letzter Tiefe
             MOVZX ebx,[TIEFE]
             SHL bx,1h
AB3:         MOV [TIEFENWERT+ebx],bp   ;Abbruch
             RET

;---------------------------- Test auf Schach ----------------------------------
AB0:         ;MOV [X5],0h               ;Merker fr Extended Futility Pruning in ZUGTAB
             CMP word[VARTIEFE+ebx],0h
             JL l_ab1y                 ;in Ruhesuche   Nicht jle!
             OR cl,cl                  ;Schachgebot?
             JE l_ab1                  ;nein
             ;MOV [X5],cl               ;s.o.
             MOV ax,900h               ;900
             CMP [ENDSPIEL],bh
             JE l_abe
             MOV ax,700h               ;700
ABE:         CMP [ERWEITERUNG+ebx],ax
             JA l_ab1z
           ;CMP ENDSPIEL,bh
           ;JNE l_abe0                ;ATTACKFELD wird dann auch nicht aufgerufen
             CMP [FATTDURCH],1h
             JE l_fad                  ;ATTACKFELD wurde schon in BWS aufgerufen

       ;------------ Ermittlung, ob sinnvolles oder sinnloses Schach -----------
             PUSH ebx
             PUSH edi  
             CALL l_attackfeld
             POP edi
             POP ebx  
                      
FAD:         MOV cx,[ATTACK]           ;Feld schachgebende Figur
             AND ecx,0ffh              ;weil High-Byte Figur!
             CMP [COLOR],bh
             JNE l_aba                 ;jne ist richtig
             TEST byte[FELDATTACK+ecx],0f0h
             JNZ l_abe0                ;Schwarz ist nochmal drauf
             CMP byte[FELDATTACK+ecx],8h
             JE l_abe0                 ;nur weisser Knig kann schlagen
             TEST byte[FELDATTACK+ecx],7h
             JNZ l_ab1                 ;Weiss kann schachgebende Figur schlagen
             MOV al,[WKFELD]
             SUB al,cl
             JNC l_kn1
             NEG al
KN1:         CMP al,28h
             JA l_ab1           
             JMP l_abe0

ABA:         TEST byte[FELDATTACK+ecx],0fh
             JNZ l_abe0                ;Weiss ist nochmal drauf
             CMP byte[FELDATTACK+ecx],80h
             JE l_abe0
             TEST byte[FELDATTACK+ecx],70h
             JNZ l_ab1                 ;Schwarz kann schachgebende Figur schlagen
             MOV al,[SKFELD]
             SUB al,cl
             JNC l_kn2
             NEG al
KN2:         CMP al,28h
             JA l_ab1           
ABE0:        CMP di,14h                ;Tiefe 20 bleibt!
             JAE l_ab1x
             ADD word[ERWEITERUNG+ebx],10h;0fh ;10h
             JMP l_ab1z

;--------------------------- Test auf Schlagen ---------------------------------
AB1:         MOV ax,word[ZFELD-1h+edi] ;DI=Tiefe
             CMP al,ah
             JNE l_ab1x                ;Zielfelder nicht identisch
             MOV ax,400h
             CMP [ENDSPIEL],bh
             JE l_abe1
             MOV ax,300h
ABE1:        CMP [ERWEITERUNG+ebx],ax
             JA l_ab1z
             MOV al,[ZFELDH+edi]
             AND al,7h
             MOV dl,[AFELDH+edi]
             AND dl,7h
             SUB al,dl
             JNC l_abe2
             NEG al
ABE2:        MOV ah,2h
             CMP dl,6h
             JB l_abe3
             INC ah
ABE3:        CMP al,ah
             JA l_ab1x
             CMP di,bx
             JAE l_ab1z
             TEST word[ZFELDH-3h+edi],707h
             JNZ l_ab1z

AB1A:        ADD word[ERWEITERUNG+ebx],8h  ;8  0c
             JMP l_ab1z
;--------------------------- weitere Erweiterungen -----------------------------
AB1X:        MOV al,[AFELDH+edi]
             MOV dl,al
             AND al,7h
             CMP al,1h
             JNE l_ab1z                ;kein Bauernzug
             TEST dl,80h
             JNZ l_ab1s
             CMP byte[ZFELD+edi],30h   ;H6
             JA l_ab1z
             JMP l_ab1w
AB1S:        CMP byte[ZFELD+edi],47h   ;A3
             JB l_ab1z
AB1W:        ADD word[ERWEITERUNG+ebx],4h  ;8
     ; CMP [ENDSPIEL],bh
     ; JE l_ab1z  	       ;kein Endspiel
     ; ADD word[ERWEITERUNG+ebx],4h  ;8
AB1Z:        CMP byte[ERWEITERUNG+ebx],10h
             JB l_ab2
             ADD word[ERWEITERUNG+ebx],0f0h  ;sub 10 und add 100
             INC word[VARTIEFE+ebx]
             JMP l_ab2x
;------------------------------ Hash-Auswertung --------------------------------
AB2:         CMP word[ERWEITERUNG+ebx],100h
             JBE l_ab2x
             CMP [VARTIEFE+ebx],di
             JBE l_ab2x
             SUB word[ERWEITERUNG+ebx],100h
AB2X:        CMP [BIBEND],bh
             JE l_ab1y
             MOV eax,[HASHCODE]
             MOV ecx,[HASHADR]
             AND ecx,[ANDWERT]
             SHL ecx,3h
             CMP [COLOR],bh
             JE l_hash1
             ADD ecx,[HASHGROESSE]
HASH1:       CMP [esi+ecx],eax
             JNE l_ab1y
             MOV dl,byte[VARTIEFE+ebx]
             MOV al,[esi+6h+ecx]
             MOV bp,[esi+4h+ecx]
             XOR ecx,ecx               ;unbedingt ntig!   
             CMP word[SCHACH+2h],0h
             JE l_hash2
             CMP word[SCHACH+ebx],0h
             JNE l_ab1y1
HASH2:       MOV ah,al                 ;Flags retten
             AND al,3fh                ;Flags ausblenden (Bits 6 und 7)
             CMP dl,al
             JA l_ab1y1
             SHR ah,6h                 ;Flags auf richtigen Wert schieben
             CMP ah,1h
             JB l_ab3                  ;0=Exakter Wert
             JE l_upperb1
             CMP [ALPHA+ebx],bp
             JAE l_ht2
             MOV [ALPHA+ebx],bp
             JMP l_ht2
UPPERB1:     CMP [BETA+ebx],bp
             JBE l_ht2
             MOV [BETA+ebx],bp
HT2:         MOV ax,[ALPHA+ebx]
             CMP ax,[BETA+ebx]
             JAE l_ab3
             JMP l_ab1y1

;------------------------- Tiefe der Ruhesuche festlegen -----------------------
AB1Y:        MOV edi,ebx    
             CALL l_bwsrest
AB1Y1:       MOVZX ebx,[TIEFE]
             MOV edi,ebx
             SHL bx,1h

             MOV ax,0fffah             ;0fffa
             MOV dx,di
             SHR dx,3h                 ;3
             ADD ax,dx
             MOV ecx,2h                ;fr AB3 und weiter unten 
             CMP [VARTIEFE+ebx],ax     ;ntig!
             JL l_ab3                  ;Abbruch, BP noch WERT

;------------------------ Test auf Vorwrts-Abschneidung -----------------------
             CMP word[SCHACH+ebx],0h
             JNE l_ab5                 ;steht im Schach, keine Abschneidung!
             CMP bp,[BETA+ebx]
             JB l_nm0
             CMP word[VARTIEFE+ebx],0h ;wenn eine Seite blanker Knig hier Null
             JLE l_ab3                 ;Vorwrts-Abschneidung

             MOV ax,[ANZFIGW+ebx]
             DEC al
             JZ l_nm0                  ;blanker weisser Knig
             MOV dx,[ANZFIGS+ebx]
             DEC dl
             JZ l_nm0                  ;blanker schwarzer Knig
                                       ;in Zeile 3452 Absturz beim editieren mit PureBasic!!!
             CMP word[VARTIEFE+ebx],1h
             JLE l_ab3

             SUB ax,[ANZBAUERW+ebx]
             CMP al,1h
             JBE l_nm0

             SUB dx,[ANZBAUERS+ebx]
             CMP dl,1h
             JBE l_nm0
        ;------- Abschneidung, wenn nicht in Schlagzugfolge -------------
             CMP [VARTIEFE+ebx],cx
             JNE l_nm0
             MOV ax,word[ZFELD-1h+edi]
             CMP al,ah
             JNE l_ab3                 ;keine Schlagfolge

;--------------------------------- NULL-MOVE -----------------------------------
NM0:         CMP [NULLMOVE],cl
             JAE l_ab5                 ;Nullmove schon eingeschaltet bzw. soll
                                       ;nicht eingeschaltet werden (Endspiel!)
             MOV dx,4h                 ;Test auf Tiefe entfllt
             CMP word[ERWEITERUNG+ebx],300h
             JB l_nm00
             DEC dl
NM00:        MOV ax,[VARTIEFE+ebx]
             CMP ax,dx
             JLE l_ab5
             MOV ax,[ANZFIGW+ebx]
             DEC al                    ;Knig weg
             SUB ax,[ANZBAUERW+ebx]
             JZ l_ab5
             MOV ax,[ANZFIGS+ebx]
             DEC al                    ;Knig weg
             SUB ax,[ANZBAUERS+ebx]
             JZ l_ab5

             MOV ax,[BETA+ebx]         ;mit ALPHA bringt nichts!
             MOV dx,[MATW+ebx]
             CMP [COLOR],bh
             JE l_nm01
             MOV dx,[MATS+ebx]
NM01:        SHR dx,4h
             SUB ax,dx                 ;150 DX
             CMP bp,ax
             JB l_ab5

       ;------------------------- 2.Null-Move ----------------------------------
             MOV ax,[VARTIEFE+ebx]
             CMP [NULLMOVE],bh
             JE l_nm1                  ;erst Nummer 1 aktivieren!
             MOV [NMOV2],ax              ;kein Vergleich NMTIEFE-TIEFE mehr!
             SUB al,cl
             CMP bl,14h                ;0eh 12h
             JBE l_nm3
             DEC al
NM3:         MOV [VARTIEFE+ebx],ax
             MOV [NMOVE],0ffh
             MOV ax,[BETA+ebx]
             MOV [NMBETA2],ax
             MOV [NULLMOVE],cl
             JMP l_ab5
       ;------------------------- 1.Null-Move ----------------------------------
NM1:         MOV [NMOV1],ax
             SUB al,cl
             CMP bl,14h                ;0eh 12h
             JBE l_nm2
             DEC al
NM2:         MOV [VARTIEFE+ebx],ax
             MOV [NULLMOVE],1h         ;einschalten
             MOV [NMOVE],0ffh          ;fr ZUGGEN
             MOV ax,[BETA+ebx]         ;kein "Korrekturwert"!
             MOV [NMBETA1],ax
             MOV ax,[TIEFE]
             MOV [NMTIEFE],ax          ;fr 2.Null-Zug

;------------------------ bei Weiss am Zug Werte aktualisieren und Men-Abfrage -------------------
AB5:         CMP [COLOR],0h
             JE l_zeitlesen            ;Zeiten aktualisieren, Men usw.

             CALL l_zuggenss
AB7:         MOVZX ebx,[TIEFE]
             SHL bl,1h
             CMP word[VARTIEFE+ebx],0h ;Ruhesuche?
             JLE l_ab8                 ;ja
             MOV word[BESTERWERT+ebx],0aceh;tiefster Wert
             JMP l_ab9
AB8:         MOV [BESTERWERT+ebx],bp   ;Wert fr Ruhesuche
AB9:         CMP [COLOR],bh
             JNE l_ab10
             CALL l_hw1
             CMP ax,0ffffh
             JE l_pattsuche            ;Ende ZUGTAB
             JMP l_ab11
AB10:        CALL l_hs1
             CMP ax,0ffffh
             JE l_pattsuche            ;Ende ZUGTAB
AB11:        MOVZX ebx,[TIEFE]
             SHL bl,1h
             MOV ax,[ALPHA-2h+ebx]
             NEG ax
             MOV [BETA+ebx],ax
             MOV ax,[BETA-2h+ebx]
             NEG ax
             MOV [ALPHA+ebx],ax
             MOV ax,[VARTIEFE-2h+ebx]
             DEC ax
             MOV [VARTIEFE+ebx],ax
             CALL l_alphabeta
             CMP [COLOR],0h
             JNE l_ab12
             CALL l_shzr
             JMP l_ab13
AB12:        CALL l_whzr
AB13:        MOVZX ebx,[TIEFE]
             SHL bl,1h
       ;-------------- Test, ob letzter zurckgenommener Zug Nullzug -----------
             CMP di,79h                ;noch von SHZR/WHZR
             JNE l_ab131               ;war kein Nullzug
             DEC [NULLMOVE]
             JZ l_ab132                ;war 1.Null-Zug
             MOV ax,[NMOV2]
             MOV [VARTIEFE+ebx],ax     ;Wert vor Ruhesuche
             MOV ax,[TIEFENWERT+2h+ebx]
             NEG ax
             CMP ax,[NMBETA2]
             JB l_ab9                  ;Nullzug nicht erfolgreich, nchster Zug
             MOV [TIEFENWERT+ebx],ax   ;Nullzug erfolgreich  ZUGZWANG!!!
             RET

       ;------------------------ Auswertung 1. Nullzug -------------------------
AB132:       MOV ax,[NMOV1]
             MOV [VARTIEFE+ebx],ax     ;Wert vor Ruhesuche
             MOV ax,[TIEFENWERT+2h+ebx]
             NEG ax
             CMP ax,[NMBETA1]
             JB l_ab9                  ;Nullzug nicht erfolgreich, nchster Zug
             MOV [TIEFENWERT+ebx],ax   ;Nullzug erfolgreich  ZUGZWANG!!!
             RET
       ;--------------------------- kein Null-Zug ------------------------------
AB131:       MOV bp,[TIEFENWERT+2h+ebx]
             NEG bp
             CMP bp,[BESTERWERT+ebx]   ;neuer bester Wert?
             JBE l_ab9                 ;nein, nchster Zug
             MOV [BESTERWERT+ebx],bp
             CMP bp,[BETA+ebx]         ;Cutoff?
             JB l_ab14                 ;nein
             CMP word[VARTIEFE+ebx],0h
             JLE l_fertig              ;in Ruhesuche
     
       ;-------------------- Hashtables fllen ---------------------------------
             CMP [BIBEND],bh
             JE l_ab133
             MOV edx,[HASHCODE]
             MOV ecx,[HASHADR]
             AND ecx,[ANDWERT]
             SHL ecx,3h                ;8 Byte Abstand
             CMP [COLOR],bh
             JE l_hashfill1
             ADD ecx,[HASHGROESSE]
HASHFILL1:   MOV [esi+ecx],edx
             MOV [esi+4h+ecx],bp
             XOR al,al                 ;Exakt=0
             CMP bp,[ALPHA+ebx]
             JBE l_hashfill2
             CMP bp,[BETA+ebx]
             JB l_hashfill3
             INC al                    ;UpperBound=1
HASHFILL2:   INC al                    ;LowerBound=2
HASHFILL3:   SHL al,6h
             OR al,byte[VARTIEFE+ebx]  ;Bit 7-6=Flag, 5-0=Distanz
             MOVZX edi,[TIEFE]
             MOV ah,[ZFELD+1h+edi]
             MOV [esi+6h+ecx],ax
            
       ;------------------------ Cutoff ----------------------------------------
AB133:       CALL l_aktbestline        ;BESTLINE aktualisieren
             JMP l_fertig
       ;---------------------- kein Cutoff -------------------------------------
AB14:        CMP bp,[ALPHA+ebx]
             JBE l_ab9                 ;nchster Zug
             CMP word[VARTIEFE+ebx],0h
             JLE l_ab15                ;in Ruhesuche
             CALL l_aktbestline        ;BESTLINE aktualisieren
AB15:        MOV [ALPHA+ebx],bp        ;neuer Wert fr ALPHA
             JMP l_ab9                 ;nchster Zug

FERTIG:      CMP bp,[BETA+ebx]
             JB l_alphabetaend         ;kein Eintrag in Killertabelle
             MOVZX edi,[TIEFE]
             MOV ch,[ZFELD+1h+edi]     ;Killerzug
             MOV cl,[AFELD+1h+edi]
             SHL di,2h                 ;TIEFE*4
             MOV bl,ch
             TEST byte[ASTELL+ebx],7h  ;steht auf Zielfeld Figur? ohne e.p.!
             JNZ l_fertigs             ;ja

             MOV dx,word[KILLTABN+edi]    ;alter 1.Killerzug an 2.Stelle
             MOV word[KILLTABN+2h+edi],dx
             MOV word[KILLTABN+edi],cx    ;neuer 1.Killerzug
             JMP l_alphabetaend

FERTIGS:     MOV dx,word[KILLTABS+edi]    ;alter 1.Killerzug an 2.Stelle
             MOV word[KILLTABS+2h+edi],dx
             MOV word[KILLTABS+edi],cx    ;neuer 1.Killerzug
             JMP l_alphabetaend

PATTSUCHE:   MOVZX ebx,[TIEFE]
             MOV ax,0acfh              ;tiefster Wert+1
             ADD ax,bx 
             SHL bx,1h
             CMP [BESTERWERT+ebx],ax
             JNE l_alphabetaend
             CMP word[SCHACH+ebx],0h
             JNE l_alphabetaend
             MOV word[TIEFENWERT+ebx],8000h    ;Patt!
             RET

ALPHABETAEND:MOVZX ebx,[TIEFE]
             SHL bl,1h
             MOV ax,[BESTERWERT+ebx]
             MOV [TIEFENWERT+ebx],ax
             RET

;----------------------------- BESTLINE aktualisieren --------------------------
;------------------------- Letzte Modifizierung 29.01.2006 ---------------------
AKTBESTLINE: PUSH eax
             PUSH ebx
             PUSH edi
                          
             MOV bx,[TIEFE]
             MOV al,[AFELD+1h+ebx]     ;ist noch der letzte Zug
             MOV di,bx
             SHL di,1h                 ;+Tiefe (dw)
             MOV ah,[ZFELD+1h+ebx]
             SHL bx,6h                 ;*64 (max.Tiefe,DW)
             ADD bx,di                 ;Adresse in BESTLINE
             MOV di,bx
             MOV [BESTLINE+ebx],ax     ;zuletzt gefundenen besten Zug notieren

             ADD bx,42h
AKTBESTLINE1:MOV ax,[BESTLINE+ebx]
             ADD di,2h
             ADD bx,2h
             MOV [BESTLINE+edi],ax
             OR ax,ax
             JNE l_aktbestline1        ;Ende BESTLINE auf Null wichtig!

             POP edi
             POP ebx
             POP eax
                          
             RET

;----------------------------- Anzeige beste Zugfolge --------------------------
ZBESTLINE:   PUSHAD 
             XOR edi,edi
             MOV ax,[BESTLINE]
             MOV ebx,edi
             MOV [X1],bl
             CMP ax,[BESTPB]
             JE l_zbestline0           ;undicht bei Bauernumwandlungen!
             MOV [X1],80h
ZBESTLINE0:  MOV cx,1fh
ZBESTLINE1:  MOV ax,[BESTLINE+ebx]
             MOV [BESTPB+ebx],ax
             MOV eax,[KILLTABS+edi]
             MOV [KILLTABSPB+edi],eax
             MOV eax,[KILLTABN+edi]
             MOV [KILLTABNPB+edi],eax
             ADD bx,2h
             ADD di,4h
             DEC cx
             JNZ l_zbestline1
             
             MOV ax,[ALPHA]
             MOV [ALPHAPB],ax
             MOV ax,[VARTIEFE]
             MOV [PBTIEFE],ax

             XOR edi,edi
             MOV ecx,edi
ZUGBAUS:     MOV ax,[BESTLINE+edi]
             OR ax,ax
             JE l_zugbaus1
             MOV bl,al                 ;AL ist AFELD
             SHL bl,1h
             MOV dx,word[NFELD+ebx]
             ADD dl,60h
             MOV [TEXTTEMP+ecx],dl
             ADD dh,30h
             MOV [TEXTTEMP+1h+ecx],dh
             MOV bl,ah                 ;AH ist ZFELD
             SHL bl,1h
             MOV dx,word[NFELD+ebx]
             ADD dl,60h
             MOV [TEXTTEMP+2h+ecx],dl
             ADD dh,30h
             MOV [TEXTTEMP+3h+ecx],dh
             ADD di,2h
             CMP di,32h                ;max. 25 Halbzge anzeigen
             JE l_zugbause
             MOV byte[TEXTTEMP+4h+ecx],20h
             ADD cx,5h
             JMP l_zugbaus
ZUGBAUS1:    CMP cx,0ffh
             JAE l_zugbause
             MOV byte[TEXTTEMP+ecx],20h;rechte alte Werte lschen
             INC cx
             JMP l_zugbaus1

ZUGBAUSE:    CMP [SCREEN],0h
             JNE l_zugbause1
                     
             XOR ebx,ebx
   For x=0 To 128
             MOV al,[TEXTTEMP+ebx]
             MOV [v_XSH],eax
       TEXTTEST1$=TEXTTEST1$+Chr(XSH) 
             INC bx  
   Next    
    
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       PB4=TextWidth(TEXTTEST1$)
             MOV eax,3ffh
             SUB eax,[v_PB4]
             MOV [v_PB4],eax
       TEXTTEST4$=LSet("",PB4) 
       TEXTTEST1$=TEXTTEST1$+TEXTTEST4$
       DrawText(10,727,TEXTTEST1$) 
       StopDrawing()
  
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(10,727,TEXTTEST1$) 
       TEXTTEST1$=""  
       TEXTTEST4$=""
       StopDrawing()

             CMP [X1],0h
             JE l_zugbause1            ;keine nderung des 1.besten Zuges
                                       ; Bauernumwandlungen!
       ;--------------- Stellungen bis letzten Hauptvariantenzug ---------------
             CMP [v_ZSTMG2],0h
             JE l_knoten3
       TEXTTEST4$=StrU(ZSTMG2,#Long)+StrU(ZSTMG1,#Long)+" Kn                "
             JMP l_knoten4
KNOTEN3:       
       TEXTTEST4$=StrU(ZSTMG1,#Long)+" Kn                "       
KNOTEN4:       
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
  
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(200,750,TEXTTEST4$) 
         
        ;---------------- Sekunden bis letzten Hauptvariantenzug ----------------
             MOV byte[TEXTTEMP],20h
             XOR edi,edi
             MOV ax,[TICKTACK]         ;Bedenkzeit in Sekunden fr diesen Zug
             CALL l_zahlht
        
             XOR ebx,ebx
   For x=0 To 5
             MOV al,[TEXTTEMP+1h+ebx]
             MOV [v_XSH],eax
       TEXTTEST5$=TEXTTEST5$+Chr(XSH) 
             INC bx  
   Next    
      
       TEXTTEST5$=TEXTTEST5$+" s    " 
       DrawText(390,750,TEXTTEST5$) 
       StopDrawing()

       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(200,750,TEXTTEST4$) 
       DrawText(390,750,TEXTTEST5$)  
       TEXTTEST4$=""
       TEXTTEST5$=""
       StopDrawing()

ZUGBAUSE1:   POPAD 
             RET

;------------------------------------- Zeiten auslesen, Men usw. ---------------------------------

ZEITLESEN:           
       ElapsedMilliseconds()           ;eax ist Rckgabewert unterste 32-Bit
                          
             MOV edx,[JIFFY]
             ADD edx,19h               ;25 Milli-Sekunden
             CMP edx,eax
             JA l_ausmenue
             MOV [JIFFY],eax
             PUSHAD 
          
;-------------------------------- Systemzeit und Wer-Am-Zug-Farbe anzeigen -------------------------
  sekunde$=Str(Second(Date()))
  If sekunde$ <> OLDSEKUNDE$
   OLDSEKUNDE$=sekunde$
                      
  stunde$=Str(Hour(Date())) 
  minute$=Str(Minute(Date())) 
    If Len(minute$)=1
      minute$="0"+minute$
    EndIf
   
    If Len(sekunde$)=1
      sekunde$="0"+sekunde$
    EndIf
        
  Systime$=stunde$+":"+minute$+":"+sekunde$ 
  
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)                          ;1= Hintergrund durchsichtig, Ziffern berschreiben sich aber
       DrawingFont(LoadFont(1,"Arial Black",12)) 
       FrontColor(16777215)                    ;weisse Schrift 255*65536+255*256+255*1
             
             TEST [HZ],1h
             JE l_wamz
     
       FrontColor(0)                           ;schwarze Schrift
WAMZ:  BackColor(12566463)                     ;Farbe vom Hintergrund, weil durchsichtig nicht richtig funzt
       DrawText(940,0,Systime$)

       ;------------------------- Bedenkzeiten ---------------------------------
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial Fett",12))
  
             INC [TICKTACK]
             XOR ebx,ebx
             CMP [WERZUG],bl
             JE l_timpamzug

             MOV ax,[BESTLINE+2h]
             OR ax,ax
             JE l_tz11                 ;kein Zug da
             CMP [BEST2ZUG],bx
             JNE l_tz10                ;schon Zug da
             MOV [BEST2ZUG],ax         ;Anfang der Zhlerei    ohne inc TIME
             JMP l_gegamzug
TZ10:        CMP ax,[BEST2ZUG]
             JNE l_tz11                ;nicht mehr derselbe
             INC [BEST2TIME]
             JMP l_gegamzug
TZ11:        MOV [BEST2ZUG],bx         ;neue Belegung
             MOV [BEST2TIME],bx
             JMP l_gegamzug

TIMPAMZUG:   DEC [RESTZEIT]            ;Bedenkzeit bis zur Zeitkontrolle
             MOV bl,8h
GEGAMZUG:    MOV al,[GZEIT+7h+ebx]     ;verbrauchte Einer-Sekunden
             INC al
             CMP al,3ah                ;schon 10?
             JNE l_tes                 ;nein
             MOV al,30h
TES:         MOV [GZEIT+7h+ebx],al     ;Einer-Sekunden
             CMP al,30h                ;0?
             JNE l_aus                 ;nein
             MOV al,[GZEIT+6h+ebx]     ;verbrauchte Zehner-Sekunden
             INC al
             CMP al,36h                ;schon 6?
             JNE l_tz5
             MOV al,30h
TZ5:         MOV [GZEIT+6h+ebx],al
             CMP al,30h
             JNE l_aus
             MOV al,[GZEIT+4h+ebx]     ;verbrauchte Einer-Minuten
             INC al
             CMP al,3ah
             JNE l_tz4
             MOV al,30h
TZ4:         MOV [GZEIT+4h+ebx],al
             CMP al,30h
             JNE l_aus
             MOV al,[GZEIT+3h+ebx]     ;verbrauchte Zehner-Minuten
             INC al
             CMP al,36h
             JNE l_tz3
             MOV al,30h
TZ3:         MOV [GZEIT+3h+ebx],al
             CMP al,30h
             JNE l_aus
             MOV al,[GZEIT+1h+ebx]     ;verbrauchte Einer-Stunden
             INC al
             CMP al,3ah
             JNE l_tz2
             MOV al,30h
TZ2:         MOV [GZEIT+1h+ebx],al
             CMP al,30h
             JNE l_aus
             MOV al,[GZEIT+ebx]        ;verbrauchte Zehner-Stunden
             INC al
             CMP al,3ah
             JNE l_tz1
             MOV al,30h
TZ1:         MOV [GZEIT+ebx],al

AUS:         MOV [v_PB4],0aah          ;oben
             CMP [WERZUG],80h
             JE l_zeitausg
             CMP [TF1],bh              ;Timpetu oben?
             JE l_zeitaust1
             ADD [v_PB4],19ah          ;unten
              
ZEITAUST1:   XOR ebx,ebx
       For x=0 To 7
             MOV al,[TZEIT+ebx]
             MOV [v_XSH],eax
           TZEIT$=TZEIT$+Chr(XSH) 
             INC bx     
       Next 
                                
   DrawText(600,PB4,TZEIT$)
               
             JMP l_knoten

ZEITAUSG:    CMP [TF1],80h             ;Gegner oben?
             JE l_zeitausg1
             ADD [v_PB4],19ah          ;unten
ZEITAUSG1:   XOR ebx,ebx
       For x=0 To 7
             MOV al,[GZEIT+ebx]
             MOV [v_XSH],eax
           GZEIT$=GZEIT$+Chr(XSH) 
             INC bx
       Next

       DrawText(600,PB4,GZEIT$)
    
KNOTEN:
       DrawingFont(LoadFont(1,"Arial",12))
       FrontColor(0) 
             CMP [v_ZSTMG2],0h
             JE l_knoten1
       TEXTTEST4$=StrU(ZSTMG2,#Long)+StrU(ZSTMG1,#Long)+" Kn                "
             JMP l_knoten2
KNOTEN1:       
       TEXTTEST4$=StrU(ZSTMG1,#Long)+" Kn                "
KNOTEN2:       
       DrawText(750,750,TEXTTEST4$)
        
       TEXTTEST5$=StrU(ZSTM,#Long)+" Kn/s              "
       DrawText(900,750,TEXTTEST5$)
             MOV ax,[VARTIEFE]
             MOV [v_XSH],eax 
  
             MOV ax,[MAXSEL]
             MOV [v_YSH],eax 
             MOV [MAXSEL],0h 
       TEXTTEST6$=TEXTTEST6$+Str(XSH)+" / "+Str(YSH)+"  " 
      
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial Fett",12))  
       DrawText(600,750,TEXTTEST6$) 
       StopDrawing()
   
     
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)                          ;1= Hintergrund durchsichtig, Ziffern berschreiben sich aber
       DrawingFont(LoadFont(1,"Arial Black",12)) 
       FrontColor(16777215)                     ;weisse Schrift
             
             TEST [HZ],1h
             JE l_wamz1
     
       FrontColor(0)                           ;schwarze Schrift
WAMZ1: BackColor(12566463)                     ;Farbe vom Hintergrund, weil durchsichtig nicht richtig funzt
       DrawText(940,0,Systime$)
    
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial Fett",12))

             CMP [WERZUG],0h
             JNE l_gegzug      
      
       DrawText(600,PB4,TZEIT$)
      
             JMP l_timpzug

GEGZUG:DrawText(600,PB4,GZEIT$)
TIMPZUG:      
       FrontColor(140*65536)
       DrawText(600,750,TEXTTEST6$) 
       TEXTTEST6$=""
      
       DrawingFont(LoadFont(1,"Arial",12))
       FrontColor(0) 
       DrawText(750,750,TEXTTEST4$)
       TEXTTEST4$=""
       DrawText(900,750,TEXTTEST5$)
       TEXTTEST5$=""

       TZEIT$=""
       GZEIT$=""

       StopDrawing()
 
            
             MOV [v_ZSTM],0h
           
             CMP [WERZUG],80h
             JE l_nosek
            
             CMP [MATTZAHL],0ffh
             JE l_nosek                ;sonst geht's im Selfplay weiter!
             CMP [GRUNDTIEFE],0feh
             JB l_nosek                ;Abbruch nicht durch Zeit
             MOV ax,[ZUGZEIT]          ;Sekunden pro Zug
             CMP [TICKTACK],ax         ;Abbruch nach AX Sekunden
             JB l_nosek
             CMP byte[TEXTWERT+7h],19h ;Fail-Low?
             JNE l_timpzieh            ;nein
             DEC [TICKTACK]
             JMP l_nosek               
TIMPZIEH:    CALL l_ehback
             POPAD     
         FakeReturn                    ;Stack-Pointer korrigieren; fhrt kein Return durch! 
                                       
             JMP l_zugfertig           ;Zeit vorbei
NOSEK:   
  EndIf

;----------------------------------------- Maus abfragen -------------------------------------------    
               
    ExamineMouse()

      If MouseButton(2)=1 And MouseButton(1)<>1
         MAUSX=MouseX()
         MAUSY=MouseY()
       
         FlipBuffers(0)                ;damit Mauszeiger weg     einfacher???
         Gosub Brettmal
         FlipBuffers(0)
         Gosub Brettmal
 
         Goto MENUE
      EndIf 

   
     If MouseDeltaX()<>0 Or MouseDeltaY()<>0
         
      MAUSX=MouseX()
      MAUSY=MouseY()
        
         If MouseX()>520               ;920    520  ;Das Mouse-Sprite darf den Bildschirmbereich nicht verlassen!!!
           MAUSX=520                                ;Hier: Brett nicht verlassen, berarbeiten
         EndIf
         
         If MouseX()<20
           MAUSX=20
         EndIf
              
         If MouseY()>590               ;627    590 
           MAUSY=590
         EndIf
       
         If MouseY()<120               ;120
           MAUSY=120
         EndIf
           

      If MouseButton(1)=1 And FIGM=15 And MouseButton(2)<>1 And MouseButton(3)<>1 ;1=linke, 2=rechte, 3=mittlere Maustaste

             CMP [WERZUG],0h           ;fr z.B. Analyse Zug ausfhren an Stelle von Timpetu doch zulassen?
             JE l_mausabe1
             ;------------------------------------ Feld in ASTELL ermitteln ------------------------------
             MOV [v_FIGM],0fh          ;15=Cursor, falls keine Figur auf "Anklick-Feld"            
             MOV [MGA],0h             
             MOV [X2],0h                        
             MOV [v_MY],90h
          
             MOV eax,0ach              ;Y-Scala
 
MPOS:        MOV edx,4dh               ;X-Scala
                
             MOV ch,[TF]
             ADD ch,[TF1]
             OR ch,ch 
             JE l_blacku1              ;Schwarz unten
             MOV ebx,15h      
             ADD bx,[X2]     
             JMP l_alle1      
                  
BLACKU1:     MOV ebx,62h
             SUB bx,[X2]          
            
ALLE1:       MOV cl,8h 
             MOV [v_MX],2bh  
XPOS:        CMP [v_MAUSX],edx
             JBE l_ypos
             ADD [v_MX],40h      
             ADD dx,40h
               
             MOV ch,[TF]
             ADD ch,[TF1]
             OR ch,ch 
             JE l_blacku2              ;Schwarz unten
             INC bl    
             JMP l_alle2                     
                
BLACKU2:     DEC bl
           
ALLE2:       DEC cl
             JNZ l_xpos

YPOS:        CMP [v_MAUSY],eax
             JBE l_posfertig
             ADD ax,3dh
             ADD [v_MY],3dh
             ADD [X2],0ah
             JMP l_mpos
                               
POSFERTIG:   MOV al,[BSTELL+ebx]
             TEST al,90h               ;berhaupt Figur?
             JZ l_figmwerte            ;n           
                 
             MOV edx,[v_MAUSX]
             MOV [v_MZX],edx    
             MOV edx,[v_MAUSY]
             MOV [v_MZY],edx   
            
             MOV [FIG_IN_MOVE],al                               
             MOV byte[BSTELL+ebx],0h
             MOV [MGA],bl
      
             TEST al,10h
             JNZ l_figmfertw
      
             MOV ecx,0eh               ;Sprite-Nr.
             MOV dl,1h                 ;Bauer
             AND al,7h
FIGMS:       CMP al,dl
             JE l_figmfert
             DEC cx 
             DEC cx
             INC dl
             JMP l_figms         
                
FIGMFERTW:   MOV ecx,0dh               ;Sprite-Nr.
             MOV dl,1h                 ;Bauer
             AND al,7h
FIGMW:       CMP al,dl
             JE l_figmfert
             DEC cx 
             DEC cx
             INC dl
             JMP l_figmw  
         
FIGMFERT:    MOV [v_FIGM],ecx
FIGMWERTE:
     
      EndIf                            ;MouseButton
      
             CMP [v_FIGM],0fh
             JE l_nofigm               ;keine Figur am "Haken"
             
       Gosub Brettmal
       FlipBuffers(0)
       Gosub Brettmal
       FlipBuffers(0)
       MausLoch=GrabSprite(#PB_Any,MAUSOLDX,MAUSOLDY,64,55)


NOFIGM:        
       FlipBuffers(0)
       DisplayTransparentSprite(MausLoch,MAUSOLDX,MAUSOLDY)
       MausLoch=GrabSprite(#PB_Any,MAUSX,MAUSY,64,55)
       DisplayTransparentSprite(FIGM,MAUSX,MAUSY)
          If FIGM<>15
            DisplayTransparentSprite(15,MAUSX,MAUSY)
          EndIf 
       FlipBuffers(0)
       MAUSOLDX=MAUSX
       MAUSOLDY=MAUSY        
     
   EndIf                               ;MouseDelta
    
             
   If FIGM<>15 And MouseButton(1)=0    ;Test, ob Figur vom Gegner gesetzt wurde
                      
             MOV [X2],0h  
             MOV [MGZ],0h  
             MOV [v_MY],90h
        
             MOV eax,0ach              ;Y-Scala

MPOS1:       MOV edx,4dh               ;X-Scala
                 
             MOV ch,[TF]
             ADD ch,[TF1]
             OR ch,ch 
             JE l_blacku3              ;Schwarz unten
             MOV ebx,15h      
             ADD bx,[X2]     
             JMP l_alle3      
               
BLACKU3:     MOV ebx,62h
             SUB bx,[X2]          
           
ALLE3:       MOV cl,8h 
             MOV [v_MX],2bh  
XPOS1:       CMP [v_MAUSX],edx
             JBE l_ypos1
             ADD [v_MX],40h      
             ADD dx,40h
           
             MOV ch,[TF]
             ADD ch,[TF1]
             OR ch,ch 
             JE l_blacku4              ;Schwarz unten
             INC bl    
             JMP l_alle4                     
                
BLACKU4:     DEC bl
          
ALLE4:       DEC cl
             JNZ l_xpos1
                
YPOS1:       CMP [v_MAUSY],eax
             JBE l_posfertig1
             ADD ax,3dh
             ADD [v_MY],3dh
             ADD [X2],0ah
             JMP l_mpos1
           
POSFERTIG1:  MOV al,[FIG_IN_MOVE]
             MOV dl,[BSTELL+ebx]     
             MOV [ZIELFELD],dl     
             MOV [BSTELL+ebx],al
             MOV [v_FIGM],0fh 
             MOV [MGZ],bl 
           
        Gosub Brettmal
              
        MausLoch=GrabSprite(#PB_Any,MAUSX,MAUSY,64,55)
       
        FlipBuffers(0)
        Gosub Brettmal
        DisplayTransparentSprite(FIGM,MAUSX,MAUSY) 
        FlipBuffers(0)
       
             MOV al,[MGZ]
             CMP [MGA],al
             JE l_mausabe1
             MOV ah,[MGA]       
             MOV [LASTZUGGA],ah        
             MOV [LASTZUGGZ],al
             MOV [X2],0h
             JMP l_zugeinpruef
              
MAUSABE0:    MOVZX ebx,[LASTZUGGA]
             MOV al,[FIG_IN_MOVE]
             MOV [BSTELL+ebx],al
             MOV al,[ZIELFELD]
             MOV bl,[LASTZUGGZ]
             MOV byte[BSTELL+ebx],al
   
        Gosub Brettmal
                  
        MausLoch=GrabSprite(#PB_Any,MAUSX,MAUSY,64,55)
     
        FlipBuffers(0)
        NULL=MouseLocate(MZX,MZY)
        Gosub Brettmal
        FlipBuffers(0)
       
     EndIf        
 
MAUSABE1:    POPAD
  
             CMP [X2],1234h
             JNE l_nowsamzug
       FakeReturn
             JMP l_wsamzug
  
NOWSAMZUG:
 
;------------------------------------------ Test auf Programm beenden ------------------------------
             PUSHAD 
  ExamineKeyboard()                            ;Tastatur-Abfrage
    If KeyboardPushed(#PB_Key_Escape)          ;Escape ?
TENDE:  CloseScreen()                          ;ja    auch Einsprung von Men! 
      FreeMemory(*MemoryID)                    ;um RAM wieder freizugeben, sollte aber auch automatisch gehen
      End                                      ;Programm beenden.
    EndIf                                      ;Ende der Abfrage
             POPAD 

             JMP l_ausmenue
;=================================================================================================

MENUE:       POPAD
             PUSHAD 
MENUE1:   
             MOV [X1],0h
             MAUSOLDX1=200             ;definierte Werte
             MAUSOLDY1=40
                                   
             NULL=MouseLocate(200,40)
             
             FlipBuffers(0)
             DisplayTransparentSprite(19,10,0)                 ;das Men selbst  
             DisplayTransparentSprite(18,200,40)               ;Cursor fr Men
            
             FlipBuffers(0)
             DisplayTransparentSprite(19,10,0) 
             DisplayTransparentSprite(18,200,40)
             DisplayTransparentSprite(19,10,0)                 ;nicht schn, aber tuts
           
             MausLoch2=GrabSprite(#PB_Any,200,40,20,32)        ;oben links Men-Raum
   Repeat 
           
          ExamineMouse()
     
     If MouseDeltaX()<>0 Or MouseDeltaY()<>0
         
           MAUSX1=MouseX()
           MAUSY1=MouseY()
        
         If MouseX()>1000
           MAUSX1=1000   
         EndIf
         
         If MouseX()<20
           MAUSX1=20
         EndIf
              
         If MouseY()>94
           MAUSY1=94
         EndIf
       
         If MouseY()<17
           MAUSY1=17
         EndIf
  
   
   ;---- Hilfsprogramm Mausposition ermitteln 
    JMP l_nom1
    PUSHAD 
    MOV eax,[v_MAUSX1]
    ADD ax,8000h
    MOV [ALPHA],ax
    MOV eax,[v_MAUSY1]
    ADD ax,8000h
    MOV [BETA],ax
    CALL l_abaus
    POPAD 
NOM1:    
    ;-------------------------------------------    
    
       FlipBuffers(0)
       DisplayTransparentSprite(MausLoch2,MAUSOLDX1,MAUSOLDY1)
       MausLoch2=GrabSprite(#PB_Any,MAUSX1,MAUSY1,20,32)
       DisplayTransparentSprite(18,MAUSX1,MAUSY1)
          
       FlipBuffers(0)
       MAUSOLDX1=MAUSX1
       MAUSOLDY1=MAUSY1

     EndIf 
   
         If MouseButton(1)=1
             
         ;--------------------------------- TIMPETU ------------------------------------------------    
             CMP [v_MAUSX1],64h            ;X-Maximalwert Timpetu
             JA l_mbrett                
             CMP [v_MAUSY1],1ah
             JBE l_menueend
             CMP [v_MAUSY1],21h
             JB l_mende
             CMP [v_MAUSY1],2ah
             JBE l_mfarbe             
             CMP [v_MAUSY1],31h
             JB l_mende
             CMP [v_MAUSY1],3ah
             JBE l_mzieh            
             CMP [v_MAUSY1],41h
             JB l_mende
             CMP [v_MAUSY1],4ah
             JBE l_tende     
           
             JMP l_mende
                 
         ;----------------------------------- Farbwahl ---------------------------------------------
MFARBE:      MOV dl,[TF]
             CMP [v_MAUSX1],27h
             JA l_mfarbe1
             XOR al,al                 ;Timpetu hat Weiss
             JMP l_mfarbe2
MFARBE1:     MOV al,80h                ;Timpetu hat Schwarz
MFARBE2:     MOV [TF],al
             CMP al,dl
             JE l_mende                ;keine nderung
             CALL l_ehback
             CMP [BIBART],0ffh
             JE l_mfarbe3
             ;CALL BIBLAD
MFARBE3:     ADD [WERZUG],80h
   
         FlipBuffers(0)
         CALL l_brettmal
         FlipBuffers(0)
         CALL l_brettmal              
 
       MausLoch=GrabSprite(#PB_Any,MAUSX,MAUSY,64,55)    ;sonst Grafikfehler nach Verlassen des Mens!
       FlipBuffers(0)
       NULL=MouseLocate(MAUSX,MAUSY)
       DisplayTransparentSprite(15,MAUSX,MAUSY)
            
              MOV [X1],3h                ;= jmp rechnen

;             MOV bx,7
;             MOV di,30
;             CMP TF,80
;             JE short NOEND3
;             MOV bx,30
;             MOV di,7
;NOEND3:      MOV cx,7
;NOEND4:      MOV al,[HDP+bx]
;             MOV [HDP+di],al
;             MOV [HDP+bx],20
;             INC bx
;             INC di
;             LOOP NOEND4

;             MOV bx,0ac
;             MOV di,0d3
;             CMP TF,80
;             JE short NOEND5
;             MOV bx,0d3
;             MOV di,0ac
;NOEND5:      MOV cx,17
;NOEND6:      MOV al,[HDP+bx]        ;Bedenkzeit
;             MOV [HDP+di],al
;             MOV [HDP+bx],20
;             MOV al,[HDP+50+bx]      ;Bibliothek, wird eigentlich schon in
;             MOV [HDP+50+di],al      ; BIBLAD gendert, aber nicht gelscht
;             MOV [HDP+50+bx],20
;             INC bx
;             INC di
;             LOOP NOEND6

             JMP l_menueend1           ; dann zu RECHNEN   direkt JMP RECHNEN



MZIEH:       CMP [WERZUG],80h
             JE l_mende
             MOV [X1],1h
             JMP l_menueend

         ;-------------------------------------- BRETT ---------------------------------------------  
MBRETT:      CMP [v_MAUSX1],0bbh       ;X-Maximalwert Brett
             JA l_mpartie                
             CMP [v_MAUSX1],7bh
             JB l_mende            
             CMP [v_MAUSY1],1ah
             JBE l_mbrettdreh
             CMP [v_MAUSY1],21h
             JB l_mende
             CMP [v_MAUSY1],2ah
             JBE l_mstellein          
          
             JMP l_mende   

         ;----------------------------------- Stellungseingabe ---------------------------------------
MSTELLEIN:   CALL l_ehback
    
             FlipBuffers(0)
             DisplayTransparentSprite(22,0,660)    ;Anzeigen lschen
             DisplayTransparentSprite(21,40,665)   ;Figurenauswahl            
            
             DisplayTransparentSprite(19,10,0)     ;das Men selbst
             MausLoch3=GrabSprite(#PB_Any,80,670,20,32)           
             DisplayTransparentSprite(18,80,670)           
        
             FlipBuffers(0)
             DisplayTransparentSprite(22,0,660)
             DisplayTransparentSprite(21,40,665) 
             DisplayTransparentSprite(19,10,0)
             MAUSOLDX3=80              ;definierte Werte
             MAUSOLDY3=670
             NULL=MouseLocate(80,670)
   
             MOV [v_FIGM],12h            
             MOV [v_MX],14h
             MOV [v_MY],20h

MSTELLEIN1:
       ExamineMouse()
     
     If MouseDeltaX()<>0 Or MouseDeltaY()<>0
         
           MAUSX3=MouseX()
           MAUSY3=MouseY()
        
         If MouseX()>520
           MAUSX3=520  
         EndIf
         
         If MouseX()<45
           MAUSX3=45
         EndIf
              
         If MouseY()>695
           MAUSY3=695
         EndIf
       
         If MouseY()<135
           MAUSY3=135
         EndIf
  
   
   ;---- Hilfsprogramm Mausposition ermitteln 
    ;JMP l_nom2
    PUSHAD 
    MOV eax,[v_MAUSX3]
    ADD ax,8000h
    MOV [ALPHA],ax
    MOV eax,[v_MAUSY3]
    ADD ax,8000h
    MOV [BETA],ax
    CALL l_abaus
    POPAD 
NOM2: 
   ;--------------------------------------- 
    
       FlipBuffers(0)
       DisplayTransparentSprite(MausLoch3,MAUSOLDX3,MAUSOLDY3)
       MausLoch3=GrabSprite(#PB_Any,MAUSX3,MAUSY3,MX,MY)
       DisplayTransparentSprite(FIGM,MAUSX3,MAUSY3)
          
       FlipBuffers(0)
       MAUSOLDX3=MAUSX3
       MAUSOLDY3=MAUSY3

     EndIf                             ;MouseDelta 
   
        If MouseButton(1)=1 And MouseButton(2)<>1 And MouseButton(3)<>1 And FIGM=18
          If MAUSY3>665 
            If MAUSX3>490
              Goto MSTELLEINE
            EndIf 
    
            If MAUSX3>425
              Goto MSTELLEINLEER
            EndIf 
    
            If MAUSX3>370 And MAUSX3<415
             MOV [v_FIGM],3h           ;wK
             MOV [FIG_IN_MOVE],16h
              Goto MSTELLEINFIG
            EndIf 
           
            If MAUSX3>305 And MAUSX3<350
             MOV [v_FIGM],5h           ;wD
             MOV [FIG_IN_MOVE],15h
              Goto MSTELLEINFIG
            EndIf 
           
            If MAUSX3>240 And MAUSX3<285
             MOV [v_FIGM],7h           ;wT
             MOV [FIG_IN_MOVE],14h
              Goto MSTELLEINFIG
            EndIf 
   
            If MAUSX3>175 And MAUSX3<220
             MOV [v_FIGM],9h           ;wL
             MOV [FIG_IN_MOVE],13h
              Goto MSTELLEINFIG
            EndIf 
   
            If MAUSX3>110 And MAUSX3<155
             MOV [v_FIGM],0bh          ;wS
             MOV [FIG_IN_MOVE],12h
              Goto MSTELLEINFIG
            EndIf 
           
            If MAUSX3<90           
             MOV [v_FIGM],0dh          ;wB
             MOV [FIG_IN_MOVE],11h
              Goto MSTELLEINFIG
            EndIf 
          EndIf                        ;MAUSY3>665 
        EndIf                          ;MouseButton


        If MouseButton(1)<>1 And MouseButton(2)=1 And MouseButton(3)<>1 And FIGM=18
          If MAUSY3>665 
            If MAUSX3>370 And MAUSX3<415
             MOV [v_FIGM],4h           ;sK
             MOV [FIG_IN_MOVE],86h
              Goto MSTELLEINFIG
            EndIf 
           
            If MAUSX3>305 And MAUSX3<350
             MOV [v_FIGM],6h           ;sD
             MOV [FIG_IN_MOVE],85h
              Goto MSTELLEINFIG
            EndIf 
           
            If MAUSX3>240 And MAUSX3<285
             MOV [v_FIGM],8h           ;sT
             MOV [FIG_IN_MOVE],84h
              Goto MSTELLEINFIG
            EndIf 
   
            If MAUSX3>175 And MAUSX3<220
             MOV [v_FIGM],0ah          ;sL
             MOV [FIG_IN_MOVE],83h
              Goto MSTELLEINFIG
            EndIf 
   
            If MAUSX3>110 And MAUSX3<155
             MOV [v_FIGM],0ch          ;sS
             MOV [FIG_IN_MOVE],82h
              Goto MSTELLEINFIG
            EndIf 
           
            If MAUSX3<90
             MOV [v_FIGM],0eh          ;sB
             MOV [FIG_IN_MOVE],81h
              Goto MSTELLEINFIG
            EndIf 
          EndIf                        ;MAUSY3>665 
        EndIf                          ;MouseButton

         ;------------------------------ Absetzfeld ermitteln ---------------------------   
       If MouseButton(1)<>1 And MouseButton(2)<>1 And MouseButton(3)<>1 And FIGM<>18 And MAUSY3<580
                     
             MOV [X2],0h  
             MOV [v_MY],90h
        
             MOV eax,0ach              ;Y-Scala

MMPOS1:      MOV edx,04dh              ;X-Scala
                 
             MOV ch,[TF]
             ADD ch,[TF1]
             OR ch,ch 
             JE l_mblacku3             ;Schwarz unten
             MOV ebx,15h      
             ADD bx,[X2]     
             JMP l_malle3      
               
MBLACKU3:    MOV ebx,62h
             SUB bx,[X2]          
           
MALLE3:      MOV cl,8h 
             MOV [v_MX],2bh  
MXPOS1:      CMP [v_MAUSX3],edx
             JBE l_mypos1
             ADD [v_MX],40h      
             ADD dx,40h
           
             MOV ch,[TF]
             ADD ch,[TF1]
             OR ch,ch 
             JE l_mblacku4             ;Schwarz unten
             INC bl    
             JMP l_malle4                     
                
MBLACKU4:    DEC bl
          
MALLE4:      DEC cl
             JNZ l_mxpos1
                
MYPOS1:      CMP [v_MAUSY3],eax
             JBE l_mposfertig1
             ADD ax,3dh
             ADD [v_MY],3dh
             ADD [X2],0ah
             JMP l_mmpos1
           
MPOSFERTIG1: MOV al,[FIG_IN_MOVE]
             MOV [BSTELL+ebx],al
             AND byte[ASTELL+ebx],40h
             OR [ASTELL+ebx],al            
      
        FlipBuffers(0)
        Gosub Brettmal
              
        MausLoch3=GrabSprite(#PB_Any,MAUSX3,MAUSY3,64,55)
       
        FlipBuffers(0)
        Gosub Brettmal
        
             MOV [v_MX],14h
             MOV [v_MY],20h
             MOV [v_FIGM],12h
     
       EndIf                           ;Absetzfeld      
 
MSTELLEINFIG:
             MOV [v_MX],40h
             MOV [v_MY],37h
             JMP l_mstellein1

MSTELLEINLEER:
             XOR ebx,ebx
             MOV cx,78h
MLSTELL:     MOV al,[LSTELL+ebx]
             MOV [ASTELL+ebx],al       ;fr Rechnen
             AND al,0bfh               ;Feldfarbe weg
             MOV [BSTELL+ebx],al       ;fr Bildschirmdarstellung
             INC bx
             DEC cx
             JNZ l_mlstell
             
       FlipBuffers(0)
       Gosub Brettmal

       FlipBuffers(0)
       Gosub Brettmal
      
             JMP l_mstellein1
 
MSTELLEINE: 
       DisplayTransparentSprite(22,0,660)      ;Anzeigen lschen
       FlipBuffers(0)
       DisplayTransparentSprite(22,0,660)

       MausLoch=GrabSprite(#PB_Any,MAUSX,MAUSY,64,55)  ;sonst Grafikfehler nach Verlassen des Mens!
       FlipBuffers(0)
       NULL=MouseLocate(296,384)
       DisplayTransparentSprite(15,296,384)

             MOV [STELLTEST],80h
             MOV [v_FIGM],0fh
             MOV [v_MX],128h
             MOV [v_MY],180h           
             MOV [X1],5h
             JMP l_menueend1



         ;----------------------------------- Brett drehen -------------------------------------------
MBRETTDREH:  CALL l_brettdreh
             
       MausLoch=GrabSprite(#PB_Any,MAUSX,MAUSY,64,55)  ;sonst Grafikfehler nach Verlassen des Mens!
       FlipBuffers(0)
       NULL=MouseLocate(MAUSX,MAUSY)
       DisplayTransparentSprite(15,MAUSX,MAUSY)
             
            ; MOV X1,3h
       Delay(5)     
             JMP l_menueend1

         ;----------------------------------- PARTIE -----------------------------------------------
MPARTIE:     CMP [v_MAUSX1],110h           ;X-Maximalwert Partie
             JA l_mdatenbank                
             CMP [v_MAUSX1],0d0h
             JB l_mende
             CMP [v_MAUSY1],1ah
             JBE l_mneuepartie
             CMP [v_MAUSY1],21h
             JB l_mende
             CMP [v_MAUSY1],2ah
             JBE l_mzugvor             
             CMP [v_MAUSY1],31h
             JB l_mende
             CMP [v_MAUSY1],3ah
             JBE l_mzugzur           
             CMP [v_MAUSY1],41h
             JB l_mende
             CMP [v_MAUSY1],4ah
             JBE l_mzugrecht
         
             JMP l_mende   

         ;-------------------------------- neue Partie ---------------------------------------------
MNEUEPARTIE: MOV [STELLTEST],0h
             MOV [X1],2h        
             JMP l_menueend 

         ;---------------------------------- Zug vor -----------------------------------------------
MZUGVOR:

             JMP l_mende

         ;--------------------------------- Zug zurck ---------------------------------------------
MZUGZUR:     CMP [ZASTELL],90h
             JE l_mende                ;ist Ausgangsstellung
             ;CMP MATTZAHL,0ffh
             ;JE l_minuszug00
             ;CMP TIEFE,3h
             ;JB l_mende

MINUSZUG00:  CALL l_ehback
MINUSZUG0:   DEC [HZ]
             SUB [ZASTELL],120h
             MOVZX ebx,[ZASTELL]       ;ist Stellung davor
             MOV [MATTZAHL],0h         ;falls Stellung Matt war
             MOV ax,word[STELLAB+ebx]
             MOV [LASTZUGGA],al
             MOV [LASTZUGGZ],ah
             ADD bx,2h

             MOV cx,4eh                ;78 Felder
             MOV edi,15h               ;A8
MINUSZUG1:   MOV al,[STELLAB+ebx]
             MOV [ASTELL+edi],al
             INC bx                    ; Idee: wird nach Zugrcknahme anderer
             INC di                    ; Zug gespielt, ZASTELLE zurcksetzen
             DEC cx        
             JNZ l_minuszug1 
       
       ;----------------------- Kopieren ---------------------------------------
          ;evtl. ZUG50 restaurieren
ZCOPY:       ADD [ZASTELL],90h         ;neuer Zeiger
             MOV [WAHLFIG],0ffh        ;um PB zu bergehen
             MOV edi,ebx               ;aktueller Zeiger ins RAM (STELLAB)
             PUSH ebx

;        MOV bp,offset ZEILE0
;        MOV dx,112a        ;unterste Zeile
            
             MOV [v_YR],1f4h           ;500 fr unterste Zeile       
             XOR ebx,ebx
             MOV [X1],0ah              ;Anzahl Zeilen
             MOV [X2],bx
             TEST [HZ],1h
             JZ l_zcopy0
             MOV [X2],90h
ZCOPY0:      MOV ecx,26h               ;Zeilenlnge
ZCOPY1:      MOV al,[STELLAB+edi]      ;abgespeicherte Zeile
             MOV byte[ZEILE0+ebx],al   ;aktuelle Zeile
             MOV byte[ZEILE1+ebx],20h
             INC di
             INC bx
             DEC cx
             JNZ l_zcopy1

             PUSHAD 
          
             SUB ebx,26h
       For x=0 To 37
             MOV al,[ZEILE0+ebx]
             MOV [v_XSH],eax
         TEXTTEST4$=TEXTTEST4$+Chr(XSH) 
             INC bx  
       Next    
    
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       PB4=TextWidth(TEXTTEST4$)
             MOV eax,3ffh
             SUB eax,[v_PB4]
             MOV [v_PB4],eax
       TEXTTEST1$=LSet("",PB4) 
       TEXTTEST4$=TEXTTEST4$+TEXTTEST1$
       DrawText(700,YR,TEXTTEST4$) 
       StopDrawing()
             
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,YR,TEXTTEST4$) 
       TEXTTEST4$=""
       TEXTTEST1$=""
       StopDrawing()
            
             POPAD 
;        ;MOV ax,1301        ;Zeile ausgeben
;        ;MOV cx,26
;        ;INT 10

             DEC [X1]                  ;Anzahl Zeilen
             JZ l_zcopyend
             SUB [v_YR],14h            ;Bildschirmposition eine Zeile hher
             ADD ebx,26h               ;nchste Zeile
 
ZCOPY2:      SUB di,146h               ;2*90+26H
             JC l_zcopyend
             CMP [X1],9h
             JNE l_zcopy0
             ADD di,[X2]               ;einmaliger Korrekturfaktor
             JMP l_zcopy0
       ;--------------------- Hashwerte zurckholen ----------------------------
ZCOPYEND:    ;CMP HZ,2h
;        JA short ZCOPYEND1
;        MOV ax,1301
;        MOV bp,offset TEXTN     ;pure Verzweiflung, "Fehler" aber wahr-
;        MOV dx,102a        ; scheinlich durch Grafikaufbau bedingt
;        INT 10

ZCOPYEND1:   POP ebx                   ;alten Zeiger zurck
             ADD bx,26h                ;Lnge ZEILE0
             MOV eax,DWord[STELLAB+ebx]
             MOV [HASHADR],eax
             ADD bx,4h
             MOV eax,DWord[STELLAB+ebx]
             MOV [HASHCODE],eax
             ADD bx,4h
       ;-------------------- Bedenkzeiten zurckholen --------------------------
             MOV cx,8h
             XOR edi,edi
COPYM2:      MOV al,[STELLAB+ebx]      ;Bedenkzeit Gegner
             MOV [GZEIT+edi],al
             MOV al,[STELLAB+8h+ebx]   ;Bedenkzeit Timpetu
             MOV [TZEIT+edi],al
             INC di
             INC bx
             DEC cx
             JNZ l_copym2

       ;-------------------- Bedenkzeiten ausgeben -----------------------------
;        MOV dx,52a        ;oben
;        MOV cx,8
;        MOV bx,7
;        MOV ax,1301
;        CMP TF1,0        ;Timpetu oben?
;        JE short TIMPO
;        ADD dx,0f00        ;unten
;TIMPO:  MOV bp,offset TZEIT     ;Bedenkzeit Timpetu
;        INT 10

;        MOV ax,1301
;        MOV dx,52a
;        CMP TF1,80        ;Gegner oben?
;        JE short GEGNO
;        ADD dx,0f00        ;unten
;GEGNO:  MOV bp,offset GZEIT     ;Bedenkzeit Gegner
;        INT 10


             ADD [WERZUG],80h
             ADD [COLOR],80h
             ;CMP [COLOR],80h
             ;JE l_zugvze
             ;CALL l_notkop
ZUGVZE: 

;        PUSH ds         ;wegen Figausneu
;        POP es
;        MOV ax,1301
;        XOR bx,bx
;        MOV dx,1d09
;        MOV bp,offset TEXTN     ;"Matt in..." und "Remis..."lschen
;        MOV cx,0a
;        INT 10

;        MOV ax,3
;        INT 33
;        CMP bx,3
;        JNE short NOSCHNELL

;        CMP ZASTELL,90
;        JE short NOSCHNELL
;        CMP cx,1f4
;        JB short NOSCHNELL      ;nicht Zug v/z
;        CMP cx,200
;        JA short NOSCHNELL
;        CMP dx,70
;        JB short NOSCHNELL
;        PUSH ds         ;wegen FIGAUSNEU
;        POP es
;        CMP dx,7c
;        JBE MINUSZUG0        ;Zug zurck

;NOSCHNELL:   ;CMP COLOR,80h
             ;JE l_verteilers
             ;JMP l_verteiler
            
    
   
       FlipBuffers(0)
       Gosub BRETTMAL0 
           
       FlipBuffers(0)
       Gosub BRETTMAL0 



                   
             MOV [X1],6h
             JMP l_menueend
            
        ;--------------------------------- Zugrecht wechseln --------------------------------------             
MZUGRECHT:   CMP [v_MAUSX1],0d0h
             JB l_mende
             CMP [v_MAUSX1],0ddh
             JBE l_mwamzug
             CMP [v_MAUSX1],0ech
             JB l_mende
             CMP [v_MAUSX1],0f5h
             JA l_mende
 
             CALL l_ehback
             MOV [X1],3h
             CMP [COLOR],80h
             JE l_menueend             ;Schwarz ist schon am Zug
             ADD [WERZUG],80h
             MOV [COLOR],80h
             OR [HZ],1h
             JMP l_menueend

MWAMZUG:     CALL l_ehback
             MOV [X1],3h
             CMP [COLOR],0h
             JE l_menueend             ;Weiss ist schon am Zug    
             ADD [WERZUG],80h
             MOV [COLOR],0h
             AND [HZ],0fffeh
             JMP l_menueend

         ;--------------------------------- DATENBANK ----------------------------------------------
MDATENBANK:  CMP [v_MAUSX1],183h           ;X-Maximalwert Datenbank
             JA l_moptionen               
             CMP [v_MAUSX1],12bh
             JB l_mende
             CMP [v_MAUSY1],1ah
             JBE l_mstladen
         
             JMP l_mende   
         
         ;---------------------------- Stellung laden ----------------------------------------------
MSTLADEN:                              ;Einsprung von Stellung laden!
       TEXTTEST1$="Bitte Namen der Teststellung eingeben [RETURN]:"
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",10))
       BackColor(12566463)
       DrawText(350,80,TEXTTEST1$) 
       StopDrawing()
      
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",10))
       BackColor(12566463)
       DrawText(350,80,TEXTTEST1$) 
       StopDrawing()
       TEXTTEST1$=""

         ;---------------------------------- Tastaturabfrage -----------------------------------------
   Repeat 
       ExamineKeyboard()
       Eingabe$ = KeyboardText(Eingabe$)         ;Procedure KeyboardText siehe Initialisierungsteil

           If KeyboardPushed(#PB_Key_Back)
             FlipBuffers(0)
             DisplayTransparentSprite(19,10,0)   ;das Men selbst  
             JMP l_mstladen
           EndIf 
     
       StartDrawing(ScreenOutput()) 
       DrawingMode(0) 
       FrontColor(0) 
       BackColor(12566463)
       DrawText(680,80,Eingabe$) 
       StopDrawing() 
       FlipBuffers() 
  Delay(5) 
   Until KeyboardPushed(#PB_Key_Return)       
       
       TEXTTEST1$="tests\"+Eingabe$+".epd"

       If ReadFile(2,TEXTTEST1$)
                
       TEXTTEST1$=""
       Eingabe$=""
               
       ANZAHL=Lof(2)        
         ;----------------- Zielspeicher erstmal subern -------
             MOV al,20h                ;wichtig! Wegen Einsprung von Stellung laden
             XOR ebx,ebx
             MOV ecx,[v_ANZAHL]
      
TEST3:       MOV [TEXTTEMP+ebx],al
             MOV [esi+ebx],al
             INC bx
             DEC cx
             JNZ l_test3

         ReadData(2,*MemoryID,ANZAHL)  ;in Hashtabelle zwischenspeichern
         CloseFile(2)
             
         JMP l_test4
      EndIf 
       TEXTTEST1$=""
       Eingabe$=""
             CALL l_signal             ;irgendwann mal Fehlermeldung
             JMP l_menueend
        
TEST4:       MOV [STELLTEST],80h

             XOR ebx,ebx               ;fr Randfelder wichtig!
             MOV cx,78h
GRUNDSTELL:  MOV al,[LSTELL+ebx]
             MOV [ASTELL+ebx],al
             INC bx
             DEC cx
             JNZ l_grundstell
       
             MOV bx,15h                ;A8, Zeiger in LSTELL
             XOR edi,edi               ;Zeiger in Teststellung
BTESTA:      MOV al,[esi+edi]
             CMP al,20h
             JE l_bteste               ;Ende bei Leerzeichen
             CMP al,2fh                ;"/"    nchste Reihe
             JE l_btrand
             CMP al,38h
             JBE l_btestl              ;Leerfelder
             MOV dl,[LSTELL+ebx]       ;Feldfarbe
             CMP al,70h                ;"p"    schwarzer Bauer
             JNE l_b1
             MOV al,81h
             JMP l_btein
B1:          CMP al,6eh                ;"n"     Springer
             JNE l_b2
             MOV al,82h
             JMP l_btein
B2:          CMP al,62h                ;"b"     Lufer
             JNE l_b3
             MOV al,83h
             JMP l_btein
B3:          CMP al,72h                ;"r"     Turm
             JNE l_b4
             MOV al,84h
             JMP l_btein
B4:          CMP al,71h                ;"q"     Dame
             JNE l_b5
             MOV al,85h
             JMP l_btein
B5:          CMP al,6bh                ;"k"     Knig
             JNE l_b6
             MOV al,86h
             JMP l_btein
B6:          CMP al,50h                ;"P"     weisser Bauer
             JNE l_b7
             MOV al,11h
             JMP l_btein
B7:          CMP al,4eh                ;"N"
             JNE l_b8
             MOV al,12h
             JMP l_btein
B8:          CMP al,42h                ;"B"
             JNE l_b9
             MOV al,13h
             JMP l_btein
B9:          CMP al,52h                ;"R"
             JNE l_b10
             MOV al,14h
             JMP l_btein
B10:         CMP al,51h                ;"Q"
             JNE l_b11
             MOV al,15h
             JMP l_btein
B11:         MOV al,16h                ;"K"

BTEIN:       OR al,dl                  ;Feldfarbe setzen
             MOV [ASTELL+ebx],al       ;hier keine Figur schon mal gezogen!
             INC bx
             INC di
             JMP l_btesta

         ;------------------- Nchste Reihe in LSTELL ----------------------------
BTRAND:      INC di
             ADD bx,2h
             JMP l_btesta
         ;------------------------- Leerfelder -----------------------------------
BTESTL:      SUB al,30h
             ADD bl,al
             INC di
             JMP l_btesta

BTESTE:      INC di                    ;geht von nur einem Leerzeichen aus!
             CMP byte[esi+edi],77h     ;"w"
             JE l_btest1
             MOV [TF],80h              ;Timpetu Schwarz
             MOV [TF1],80h             ;unten
             MOV [COLOR],80h
             MOV [HZ],1h               ;auch bei Stellungseingabe, wenn Schwarz anzieht!
             JMP l_btest2
BTEST1:      MOV [TF],bh               ;Timpetu Weiss
             MOV [TF1],80h             ;unten
             MOV [HZ],0h
             MOV [COLOR],bh
BTEST2:      MOV [WERZUG],bh           ;Timpetu am Zug
   
             ADD di,2h                 ;Rochade-Status W    Anzahl Leerzeichen!!
             MOV [ROCHSTATUSW],bl      ;Annahme: schon rochiert   ungleich Null 
             MOV [ROCHSTATUSS],bl
             CMP byte[esi+edi],2dh     ;Strich fr Rochade-Status?
             JE l_eptest
           ;Auswertung von K,k,Q,q, dann Gezogen-Bit     WM19:kq  WM25:KQ  WM26:k  BT22:KQkq

EPTEST:      ADD di,2h                 ;e.p.-Status
             CMP byte[esi+edi],2dh
             JE l_tausl0
           ;wird e.p.-Feld angegeben???

         ;------------------------- Informationstext auslesen -----------------------
TAUSL0:      XOR ebx,ebx
TAUSL:       INC di
             CMP edi,[v_ANZAHL]
             JAE l_tausle
             MOV al,[esi+edi]
             CMP al,22h                ;"
             JNE l_tausl
             MOV [X2],di               ;fr Ausgabe
             INC [X2]
TAUSL1:      INC di
             CMP edi,[v_ANZAHL]
             JAE l_tausle
             MOV al,[esi+edi]
             CMP al,22h
             JE l_tausle               ;Ende des Lesebereiches
             MOV [TEXTTEMP+ebx],al
             INC bx
             JMP l_tausl1
      
TAUSLE:      MOV [GRUNDTIEFE],20h      ;keine Zeitbegrenzung
             MOV [BIBEND],80h          ;keine Bibliothek
             MOV [BIBART],0ffh         ;Aus

             MOV ebx,15h
BRSTELL1:    MOV al,[ASTELL+ebx]
             AND al,0bfh               ;Feldfarbe weg
             MOV [BSTELL+ebx],al       ;fr Bildschirmdarstellung
             INC bx
             CMP bx,62h
             JBE l_brstell1
           
             CALL l_brettdreh1         ;fr Gegner/Timpetu-Anzeige
             
       TEXTTEST1$="Analyse  "
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",10))
       BackColor(12566463)
       DrawText(880,580,TEXTTEST1$) 
       StopDrawing()
      
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",10))
       BackColor(12566463)
       DrawText(880,580,TEXTTEST1$) 
       StopDrawing()
       TEXTTEST1$=""
             
             MOV [X1],4h        
             JMP l_menueend 

         ;----------------------------------- OPTIONEN ---------------------------------------------
MOPTIONEN:   CMP [v_MAUSX1],1f0h
             JA l_mspielstufen
             CMP [v_MAUSX1],199h
             JB l_mende   
             CMP [v_MAUSY1],1ah
             JBE l_mnmtest
             CMP [v_MAUSY1],21h
             JB l_mende
             CMP [v_MAUSY1],2ah
             JBE l_minfotest
             CMP [v_MAUSY1],31h
             JB l_mende
             CMP [v_MAUSY1],3ah
             JBE l_msoundtest
        
             JMP l_mende   

MNMTEST:     TEST [NULLMOVE],3h        ;wegen 2.Nullzug!
             JNZ l_mende               ;gerade aktiv
             CMP [v_MAUSX1],1cfh
             JB l_mende
             CMP [v_MAUSX1],1d6h
             JA l_mnmtesta
             MOV [NULLMOVE],0h
       TEXTTEST4$="Nullmove: Ein "
             JMP l_mnmtest1

MNMTESTA:    CMP [v_MAUSX1],1e7h
             JB l_mende
             CMP [v_MAUSX1],1f0h
             JA l_mende
             MOV [NULLMOVE],80h
       TEXTTEST4$="Nullmove: Aus"

MNMTEST1:
       FlipBuffers(0) 
       StartDrawing(ScreenOutput())
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",10))
       BackColor(12566463)
       DrawText(800,560,TEXTTEST4$) 
       StopDrawing() 

       FlipBuffers(0) 
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",10))
       BackColor(12566463)
       DrawText(800,560,TEXTTEST4$) 
       StopDrawing() 
       TEXTTEST4$=""
             JMP l_mende

MINFOTEST:   CMP [v_MAUSX1],1b2h
             JB l_mende
             CMP [v_MAUSX1],1b9h
             JA l_minfotesta
             MOV [SCREEN],0h
             CALL l_bauszuganz         ;ohne ZBESTLINE !
             MOV ax,[TIEFENWERT]
             CALL l_mwertaus
       TEXTTEST4$="Info: Ein "            
             JMP l_minfotest1

MINFOTESTA:  CMP [v_MAUSX1],1cah
             JB l_mende
             CMP [v_MAUSX1],1d2h
             JA l_mende
             MOV [SCREEN],80h
       TEXTTEST4$="Info: Aus"

       FlipBuffers(0)
       DisplayTransparentSprite(22,0,660)    ;Anzeigen lschen
       FlipBuffers(0)
       DisplayTransparentSprite(22,0,660)

MINFOTEST1:
       FlipBuffers(0) 
       StartDrawing(ScreenOutput())
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",10))
       BackColor(12566463)
       DrawText(800,520,TEXTTEST4$) 
       StopDrawing() 

       FlipBuffers(0) 
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",10))
       BackColor(12566463)
       DrawText(800,520,TEXTTEST4$) 
       StopDrawing() 
       TEXTTEST4$=""
             JMP l_mende

MSOUNDTEST:  CMP [v_MAUSX1],1c4h
             JB l_mende
             CMP [v_MAUSX1],1cbh
             JA l_msoundtesta
             MOV [TON],0h
       TEXTTEST4$="Sound: Ein "
             JMP l_msoundtest1
             
MSOUNDTESTA: CMP [v_MAUSX1],1dch
             JB l_mende
             CMP [v_MAUSX1],1e4h
             JA l_mende
             MOV [TON],80h
       TEXTTEST4$="Sound: Aus"

MSOUNDTEST1:
       FlipBuffers(0) 
       StartDrawing(ScreenOutput())
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",10))
       BackColor(12566463)
       DrawText(800,540,TEXTTEST4$) 
       StopDrawing() 

       FlipBuffers(0) 
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",10))
       BackColor(12566463)
       DrawText(800,540,TEXTTEST4$) 
       StopDrawing() 
       TEXTTEST4$=""
             JMP l_mende

         ;------------------------------------- SPIELSTUFEN ----------------------------------------
MSPIELSTUFEN:CMP [v_MAUSX1],254h       ;X-Maximalwert 1.Spalte
             JA l_mspsp2                
             CMP [v_MAUSX1],212h
             JB l_mende
             CMP [v_MAUSY1],1ah
             JBE l_manalyse
             CMP [v_MAUSY1],21h
             JB l_mende
             CMP [v_MAUSY1],2ah
             JBE l_mblitz5
             CMP [v_MAUSY1],31h
             JB l_mende
             CMP [v_MAUSY1],3ah
             JBE l_mpartie1h
        
             JMP l_mende   


MSPSP2:                                ;2.Spalte Spielstufen


             JMP l_mende 


     
SEK5:        MOV [ZUGZEIT],5h
             MOV [ZUGZEIT50],5h
       TEXTTEST1$="5s/Zug  "
             JMP l_zeilefertig0
SEK10:       MOV [ZUGZEIT],0ah
             MOV [ZUGZEIT50],0ah
       TEXTTEST1$="10s/Zug  "
             JMP l_zeilefertig0
SEK15:       MOV [ZUGZEIT],0fh
             MOV [ZUGZEIT50],0fh
       TEXTTEST1$="15s/Zug  "
             JMP l_zeilefertig0
SEK30:       MOV [ZUGZEIT],1eh
             MOV [ZUGZEIT50],1eh
       TEXTTEST1$="30s/Zug  "
             JMP l_zeilefertig0
MIN1:        MOV [ZUGZEIT],3ch
             MOV [ZUGZEIT50],3ch
       TEXTTEST1$="1Min./Zug  "
             JMP l_zeilefertig0
MIN3:        MOV [ZUGZEIT],0b4h
             MOV [ZUGZEIT50],0b4h
       TEXTTEST1$="3Min./Zug  "
             JMP l_zeilefertig0
MBLITZ5:     MOV [RESTZEITMEM],12ch    ;300s als Berechnungsgrundlage fr Zeitcalc
       TEXTTEST1$="5Min.Blitz    "
             JMP l_zeilefertig
BLITZ10:     MOV [RESTZEITMEM],258h
       TEXTTEST1$="10Min.Blitz  "
             JMP l_zeilefertig
PARTIE15:    MOV [RESTZEITMEM],384h
       TEXTTEST1$="15Min.Partie  "
             JMP l_zeilefertig
PARTIE30:    MOV [RESTZEITMEM],708h
       TEXTTEST1$="30Min.Partie  "
             JMP l_zeilefertig
MPARTIE1H:   MOV [RESTZEITMEM],0e10h
       TEXTTEST1$="60Min.Partie  "
             JMP l_zeilefertig
PARTIE2H:    MOV [RESTZEITMEM],1c20h
       TEXTTEST1$="120Min.Partie  "
             JMP l_zeilefertig
;PARTIE2H30M: MOV RESTZEITMEM,0ffffh
;        MOV bp,offset TEXTZ2HP30
;        JMP short ZEILEFERTIG
MANALYSE:    MOV [GRUNDTIEFE],20h           
       TEXTTEST1$="Analyse       "
             JMP l_mzeitanz
FESTTIEFE:   ;MOV bp,offset TEXTZFT
             JMP l_zeilefertig1        ;Grundtiefe schon gesetzt

ZEILEFERTIG: CALL l_zeitcalc           ;fr Zeitbegrenzungs-Partien; setzt Grundtiefe=0ff
             JMP l_mzeitanz       
ZEILEFERTIG0:MOV [GRUNDTIEFE],0feh
             JMP l_mzeitanz            ;wegen TESTZEITMEM fr neue Partie
ZEILEFERTIG1:MOV [RESTZEITMEM],0h

         ;------------------ Neue Spielstufe in HDP eintragen --------------------
MZEITANZ:    ;MOV bx,0ach               ;Weiss
             ;CMP TF,0h
             ;JE l_zeilefertig3
             ;MOV bx,0d3h               ;Schwarz
;ZEILEFERTIG3:MOV cx,17h
;ZEILEFERTIG4:MOV al,ds:[bp]
;        MOV [HDP+bx],al
;        INC bx
;        INC bp
;        LOOP ZEILEFERTIG4

        ;JMP MENUEEND
     
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",10))
       BackColor(12566463)
       DrawText(880,580,TEXTTEST1$) 
       StopDrawing()
      
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",10))
       BackColor(12566463)
       DrawText(880,580,TEXTTEST1$) 
       TEXTTEST1$=""
       StopDrawing()
     
         ;----------------------------------- Und wieder von vorn... -------------------------------           
MENDE:           
         EndIf   
             
   ForEver  
                                     
MENUEEND:           
       FlipBuffers(0)
       DisplayTransparentSprite(MausLoch2,MAUSOLDX1,MAUSOLDY1)
       NULL=MouseLocate(MAUSOLDX,MAUSOLDY)
       DisplayTransparentSprite(15,MAUSOLDX,MAUSOLDY)
      

MENUEEND1:      
       DisplayTransparentSprite(20,10,0)   

       FlipBuffers(0)
       DisplayTransparentSprite(20,10,0)             

       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(0)
       BackColor(12566463)
       TEXTTEST4$="Beenden mit ESC          Zum Men: Rechte Maustaste               TIMPETU - ein Schachprogramm von Klaus Helbing" 
       DrawingFont(LoadFont(1,"Arial",9))
       DrawText(40,8,TEXTTEST4$) 
       StopDrawing()

       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(0)
       BackColor(12566463)
       DrawingFont(LoadFont(1,"Arial",9))
       DrawText(40,8,TEXTTEST4$) 
       StopDrawing()
       TEXTTEST4$=""
             
             POPAD  

             CMP [X1],0h
             JE l_ausmenue             ;keine weiteren Aktionen ntig
             CMP [X1],1h
             JNE l_mnozieh
             CALL l_ehback             ;Timpetu soll ziehen
             JMP l_zugfertig

MNOZIEH:     CMP [X1],2h
             JNE l_mnonpartie
             JMP l_neuepartie

MNONPARTIE:  CMP [X1],3h
             JE l_rechnen

             CMP [X1],4h
             JE l_stelll
 
             CMP [X1],5h
             JE l_neuepartie1
 
             CMP [X1],6h
             JNE l_ausmenue
             CMP [COLOR],80h
             JE l_verteilers
             JMP l_verteiler
          
      ;------------------------------ Infotext von Teststellung anzeigen --------------------
STELLL:      XOR ebx,ebx
   For x=X2 To ANZAHL
             MOV al,[TEXTTEMP+ebx]
             MOV [v_XSH],eax
       TEXTTEST1$=TEXTTEST1$+Chr(XSH) 
             INC bx  
   Next    
    
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial",10))
       BackColor(12566463)    
       DrawText(10,35,TEXTTEST1$) 
       StopDrawing()
  
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial",10))
       BackColor(12566463)    
       DrawText(10,35,TEXTTEST1$) 
       TEXTTEST1$=""  
       StopDrawing()
           
          
            ;----------------- Zielspeicher wieder subern -------
             XOR ebx,ebx
             MOV al,bl
             MOV ecx,[v_ANZAHL]
TEST5:       MOV [ZUGTAB+ebx],al
             MOV [TEXTTEMP+ebx],al  
             INC bx
             DEC cx
             JNZ l_test5
             JMP l_neuepartie1    

;=============================================================================================
AUSMENUE:    CMP [MATTZAHL],0ffh
             JE l_zeitlesen
             CALL l_zuggenws
             JMP l_ab7

;---------------------------------------- Anfang TATTACKF -----------------------------------------
;--------------------------------- Letzte Modifizierung 15.01.2006 --------------------------------
;Liefert ATTACK zurck, welche weissen Figuren auf Feld BX zielen 
;Bentigt fr     - BWS, liefert dann Mattwert zurck oder ob Schachgebot
;                 - Zuggenerator fr Rochaden
;                 - Vorwerte

ATTACKFELDW: MOV di,bx
             MOV [ATTACK],0h
             ADD di,9h
             TEST byte[ASTELL+edi],10h ;weisse Figur?
             JZ l_nowf                 ;nein 
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,1h                 ;weisser Bauer?
             JE l_atfeldw9e
             CMP al,3h                 ;weisser Lufer? Vorgriff auf Test weiter unten
             JE l_atfeldw9e
             CMP al,5h                 ;weisse Dame?
             JE l_atfeldw9e

NOWF:        ADD di,2h
             TEST byte[ASTELL+edi],10h
             JZ l_atfeldw2
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,1h
             JE l_atfeldw9e
             CMP al,3h
             JE l_atfeldw9e
             CMP al,5h
             JE l_atfeldw9e

ATFELDW2:    MOV di,bx
             SUB di,15h
             TEST byte[ASTELL+edi],10h
             JZ l_atfeldw3
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,2h                 ;weisser Springer?
             JE l_atfeldw9e
ATFELDW3:    MOV di,bx
             SUB di,13h
             TEST byte[ASTELL+edi],10h
             JZ l_atfeldw4
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,2h
             JE l_atfeldw9e
ATFELDW4:    MOV di,bx
             SUB di,8h
             TEST byte[ASTELL+edi],10h
             JZ l_atfeldw5
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,2h
             JE l_atfeldw9e
ATFELDW5:    MOV di,bx
             SUB di,0ch
             TEST byte[ASTELL+edi],10h
             JZ l_atfeldw6
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,2h
             JE l_atfeldw9e
ATFELDW6:    MOV di,bx
             ADD di,8h
             TEST byte[ASTELL+edi],10h
             JZ l_atfeldw7
             MOV al,[ASTELL+edi]
             AND al,7h                 
             CMP al,2h
             JE l_atfeldw9e
ATFELDW7:    MOV di,bx
             ADD di,0ch
             TEST byte[ASTELL+edi],10h
             JZ l_atfeldw8
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,2h
             JE l_atfeldw9e
ATFELDW8:    MOV di,bx
             ADD di,13h
             TEST byte[ASTELL+edi],10h
             JZ l_atfeldw9
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,2h
             JE l_atfeldw9e
ATFELDW9:    MOV di,bx
             ADD di,15h
             TEST byte[ASTELL+edi],10h
             JZ l_atfeldw10            ;auf andere Figuren testen
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,2h
             JNE l_atfeldw10

ATFELDW9E:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             RET

ATFELDW10:   MOV di,bx
             ADD di,9h                 ;ADD di,12h ist falsch!
   
ATFELDW11:   TEST byte[ASTELL+edi],88h ;links unten - Randfeld oder schw.Figur?
             JNZ l_atfeldw14           ;ja, nchste Richtung
             MOV al,[ASTELL+edi]
             AND al,7h
             JZ l_at1                  ;Leerfeld
             CMP al,3h                 ;w.Lufer?
             JE l_atfeldw12
             CMP al,5h                 ;w.Dame?
             JNE l_atfeldw14           ;andere Figur steht im Weg

ATFELDW12:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             ;CMP al,3h
             ;JE l_atfeldw12e
             ;CMP [SEE],bh
             ;JNE l_atfeldw14           ;fr SEE nach geringerer Figur suchen
ATFELDW12E:  RET

AT1:         ADD di,9h
             JMP l_atfeldw11

ATFELDW14:   MOV di,bx
             ADD di,0bh
   
ATFELDW15:   TEST byte[ASTELL+edi],88h ;rechts unten
             JNZ l_atfeldw18
             MOV al,[ASTELL+edi]
             AND al,7h
             JZ l_at2
             CMP al,3h
             JE l_atfeldw16
             CMP al,5h
             JNE l_atfeldw18

ATFELDW16:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             ;CMP al,3h
             ;JE l_atfeldw16e
             ;CMP [SEE],bh
             ;JNE l_atfeldw18           ;fr SEE nach geringerer Figur suchen
ATFELDW16E:  RET

AT2:         ADD di,0bh
             JMP l_atfeldw15

ATFELDW18:   MOV di,bx
             SUB di,9h
ATFELDW19:   TEST byte[ASTELL+edi],88h ;rechts oben
             JNZ l_atfeldw22
             MOV al,[ASTELL+edi]
             AND al,7h
             JZ l_at3
             CMP al,3h
             JE l_atfeldw20
             CMP al,5h
             JNE l_atfeldw22

ATFELDW20:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             ;CMP al,3h
             ;JE l_atfeldw20e
             ;CMP [SEE],bh
             ;JNE l_atfeldw22           ;fr SEE nach geringerer Figur suchen
ATFELDW20E:  RET

AT3:         SUB di,9h
             JMP l_atfeldw19

ATFELDW22:   MOV di,bx
             SUB di,0bh
ATFELDW23:   TEST byte[ASTELL+edi],88h ;links oben
             JNZ l_atfeldw26
             MOV al,[ASTELL+edi]
             AND al,7h
             JZ l_at4
             CMP al,3h
             JE l_atfeldw24
             CMP al,5h
             JNE l_atfeldw26

ATFELDW24:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             ;CMP al,3h
             ;JE l_atfeldw24e
             ;CMP [SEE],bh
             ;JNE l_atfeldw26           ;fr SEE nach geringerer Figur suchen
ATFELDW24E:  RET

AT4:         SUB di,0bh
             JMP l_atfeldw23

ATFELDW26:   MOV di,bx
             ADD di,0ah
ATFELDW27:   TEST byte[ASTELL+edi],88h ;nach unten
             JNZ l_atfeldw30
             MOV al,[ASTELL+edi]
             AND al,7h
             JZ l_at5
             CMP al,4h                 ;Turm?
             JE l_atfeldw28
             CMP al,5h                 ;Dame?
             JNE l_atfeldw30

ATFELDW28:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             ;CMP al,4h
             ;JE l_atfeldw28e
             ;CMP [SEE],bh
             ;JNE l_atfeldw30           ;fr SEE nach geringerer Figur suchen
ATFELDW28E:  RET

AT5:         ADD di,0ah
             JMP l_atfeldw27

ATFELDW30:   MOV di,bx
             SUB di,0ah
ATFELDW31:   TEST byte[ASTELL+edi],88h ;nach oben
             JNZ l_atfeldw34
             MOV al,[ASTELL+edi]
             AND al,7h
             JZ l_at6
             CMP al,4h
             JE l_atfeldw32
             CMP al,5h
             JNE l_atfeldw34

ATFELDW32:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             ;CMP al,4h
             ;JE l_atfeldw32e
             ;CMP [SEE],bh
             ;JNE l_atfeldw34           ;fr SEE nach geringerer Figur suchen
ATFELDW32E:  RET

AT6:         SUB di,0ah
             JMP l_atfeldw31

ATFELDW34:   MOV di,bx
             DEC di
ATFELDW35:   TEST byte[ASTELL+edi],88h ;nach links
             JNZ l_atfeldw38
             MOV al,[ASTELL+edi]
             AND al,7h
             JZ l_at7
             CMP al,4h
             JE l_atfeldw36
             CMP al,5h
             JNE l_atfeldw38

ATFELDW36:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             ;CMP al,4h
             ;JE l_atfeldw36e
             ;CMP [SEE],bh
             ;JNE l_atfeldw38           ;fr SEE nach geringerer Figur suchen
ATFELDW36E:  RET

AT7:         DEC di
             JMP l_atfeldw35

ATFELDW38:   MOV di,bx
             INC di
ATFELDW39:   TEST byte[ASTELL+edi],88h ;nach rechts
             JNZ l_atfeldw42
             MOV al,[ASTELL+edi]
             AND al,7h
             JZ l_at8
             CMP al,4h
             JE l_atfeldw40
             CMP al,5h
             JNE l_atfeldw42

ATFELDW40:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             RET

AT8:         INC di
             JMP l_atfeldw39

ATFELDW42:   MOV al,[WKFELD]
AK0:         MOV di,ax                 ;Einsprung von ATTACKFELDS, SKFELD
             AND di,0ffh         

             SUB al,bl
             JNC l_ak1
             NEG al
AK1:         CMP al,0bh
             JA l_ak3
             CMP al,9h
             JAE l_ak2                 ;9,10 und 11
             CMP al,1h
             JNE l_ak3

AK2:         MOV [ATTACK],6h
             SHL [ATTACK],8h
             ADD [ATTACK],di 

AK3:         RET

;-------------------------------------------------------------------------------
;Liefert ATTACK zurck, welche schwarzen Figuren auf Feld BX zielen 
;Bentigt fr     - BWS, liefert dann Mattwert zurck oder ob Schachgebot
;                 - Zuggenerator fr Rochaden
;                 - Vorwerte

ATTACKFELDS: MOV di,bx
             MOV [ATTACK],0h
             SUB di,9h
             TEST byte[ASTELL+edi],80h ;schwarze Figur?
             JZ l_nosf                 ;nein
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,1h                 ;schwarzer Bauer?
             JE l_atfelds9e
             CMP al,3h
             JE l_atfelds9e
             CMP al,5h
             JE l_atfelds9e

NOSF:        SUB di,2h
             TEST byte[ASTELL+edi],80h
             JZ l_atfelds2
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,1h
             JE l_atfelds9e
             CMP al,3h
             JE l_atfelds9e
             CMP al,5h
             JE l_atfelds9e

ATFELDS2:    MOV di,bx
             SUB di,15h
             TEST byte[ASTELL+edi],80h
             JZ l_atfelds3             ;dort steht keine schwarze Figur
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,2h                 ;schwarzer Springer?
             JE l_atfelds9e
ATFELDS3:    MOV di,bx
             SUB di,13h
             TEST byte[ASTELL+edi],80h
             JZ l_atfelds4
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,2h
             JE l_atfelds9e
ATFELDS4:    MOV di,bx
             SUB di,8h
             TEST byte[ASTELL+edi],80h
             JZ l_atfelds5
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,2h
             JE l_atfelds9e
ATFELDS5:    MOV di,bx
             SUB di,0ch
             TEST byte[ASTELL+edi],80h
             JZ l_atfelds6
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,2h
             JE l_atfelds9e
ATFELDS6:    MOV di,bx
             ADD di,8h
             TEST byte[ASTELL+edi],80h
             JZ l_atfelds7
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,2h
             JE l_atfelds9e
ATFELDS7:    MOV di,bx
             ADD di,0ch
             TEST byte[ASTELL+edi],80h
             JZ l_atfelds8
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,2h
             JE l_atfelds9e
ATFELDS8:    MOV di,bx
             ADD di,13h
             TEST byte[ASTELL+edi],80h
             JZ l_atfelds9
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,2h
             JE l_atfelds9e
ATFELDS9:    MOV di,bx
             ADD di,15h
             TEST byte[ASTELL+edi],80h
             JZ l_atfelds10
             MOV al,[ASTELL+edi]
             AND al,7h
             CMP al,2h
             JNE l_atfelds10

ATFELDS9E:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             RET

ATFELDS10:   MOV di,bx
             ADD di,9h
ATFELDS11:   TEST byte[ASTELL+edi],18h ;links unten-Randfeld oder weisse Figur?
             JNZ l_atfelds14           ;ja, nchste Richtung
             MOV al,[ASTELL+edi]
             AND al,7h
             JZ l_at9
             CMP al,3h                 ;Lufer?
             JE l_atfelds12
             CMP al,5h                 ;Dame?
             JNE l_atfelds14

ATFELDS12:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             ;CMP al,3h
             ;JE l_atfelds12e
             ;CMP [SEE],bh
             ;JNE l_atfelds14           ;fr SEE nach geringerer Figur suchen
ATFELDS12E:  RET

AT9:         ADD di,9h
             JMP l_atfelds11

ATFELDS14:   MOV di,bx
             ADD di,0bh
ATFELDS15:   TEST byte[ASTELL+edi],18h ;rechts unten
             JNZ l_atfelds18
             MOV al,[ASTELL+edi]
             AND al,7h
             JZ l_at10
             CMP al,3h
             JE l_atfelds16
             CMP al,5h
             JNE l_atfelds18

ATFELDS16:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             ;CMP al,3h
             ;JE l_atfelds16e
             ;CMP [SEE],bh
             ;JNE l_atfelds18           ;fr SEE nach geringerer Figur suchen
ATFELDS16E:  RET

AT10:        ADD di,0bh
             JMP l_atfelds15

ATFELDS18:   MOV di,bx
             SUB di,9h
  
ATFELDS19:   TEST byte[ASTELL+edi],18h ;rechts oben
             JNZ l_atfelds22
             MOV al,[ASTELL+edi]
             AND al,7h
             JZ l_at11
             CMP al,3h
             JE l_atfelds20
             CMP al,5h
             JNE l_atfelds22

ATFELDS20:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             ;CMP al,3h
             ;JE l_atfelds20e
             ;CMP [SEE],bh
             ;JNE l_atfelds22           ;fr SEE nach geringerer Figur suchen
ATFELDS20E:  RET

AT11:        SUB di,9h
             JMP l_atfelds19

ATFELDS22:   MOV di,bx
             SUB di,0bh
   
ATFELDS23:   TEST byte[ASTELL+edi],18h ;links oben
             JNZ l_atfelds26
             MOV al,[ASTELL+edi]
             AND al,7h
             JZ l_at12
             CMP al,3h
             JE l_atfelds24
             CMP al,5h
             JNE l_atfelds26

ATFELDS24:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             ;CMP al,3h
             ;JE l_atfelds24e
             ;CMP [SEE],bh
             ;JNE l_atfelds26           ;fr SEE nach geringerer Figur suchen
ATFELDS24E:  RET

AT12:        SUB di,0bh
             JMP l_atfelds23

ATFELDS26:   MOV di,bx
             ADD di,0ah
ATFELDS27:   TEST byte[ASTELL+edi],18h ;nach unten
             JNZ l_atfelds30
             MOV al,[ASTELL+edi]
             AND al,7h
             JZ l_at13
             CMP al,4h                 ;Turm?
             JE l_atfelds28
             CMP al,5h                 ;Dame?
             JNE l_atfelds30

ATFELDS28:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             ;CMP al,4h
             ;JE l_atfelds28e
             ;CMP [SEE],bh
             ;JNE l_atfelds30           ;fr SEE nach geringerer Figur suchen
ATFELDS28E:  RET

AT13:        ADD di,0ah
             JMP l_atfelds27

ATFELDS30:   MOV di,bx
             SUB di,0ah
ATFELDS31:   TEST byte[ASTELL+edi],18h ;nach oben
             JNZ l_atfelds34
             MOV al,[ASTELL+edi]
             AND al,7h
             JZ l_at14
             CMP al,4h
             JE l_atfelds32
             CMP al,5h
             JNE l_atfelds34

ATFELDS32:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             ;CMP al,4h
             ;JE l_atfelds32e
             ;CMP [SEE],bh
             ;JNE l_atfelds34           ;fr SEE nach geringerer Figur suchen
ATFELDS32E:  RET

AT14:        SUB di,0ah
             JMP l_atfelds31

ATFELDS34:   MOV di,bx
             DEC di
ATFELDS35:   TEST byte[ASTELL+edi],18h ;nach links
             JNZ l_atfelds38
             MOV al,[ASTELL+edi]
             AND al,7h
             JZ l_at15
             CMP al,4h
             JE l_atfelds36
             CMP al,5h
             JNE l_atfelds38

ATFELDS36:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             ;CMP al,4h
             ;JE l_atfelds36e
             ;CMP [SEE],bh
             ;JNE l_atfelds38           ;fr SEE nach geringerer Figur suchen
ATFELDS36E:  RET

AT15:        DEC di
             JMP l_atfelds35

ATFELDS38:   MOV di,bx
             INC di
ATFELDS39:   TEST byte[ASTELL+edi],18h   ;nach rechts
             JNZ l_atfelds42
             MOV al,[ASTELL+edi]
             AND al,7h
             JZ l_at16
             CMP al,4h
             JE l_atfelds40
             CMP al,5h
             JNE l_atfelds42

ATFELDS40:   MOV [ATTACK],ax           ;Figur
             SHL [ATTACK],8h           ; wird High-Byte
             ADD [ATTACK],di           ;Feld ist Low-Byte
             RET

AT16:        INC di
             JMP l_atfelds39

ATFELDS42:   MOV al,[SKFELD]
             JMP l_ak0                 ;Knig von ATTACKFELDW

;------------------------------------- Attackierte Felder ermitteln -------------------------------
;- Alle 64 Felder, beschreibt nur FELDATTACK, Bit-Codiert
;- Bentigt fr   - Bildschirminfo ob Schachgebot
;                 - Alpha-Beta-Erweiterung ob sinnvolles Schach
;                 - BWS ob z.B. hngende Figur
;                 - Vorwerte ob Schachgebot und Matt im 1.Zug, fr Fluchtfelder der Knige
;                 - REWS ob gltiger oder ungltiger Zug
;- verndert: a,b,c,e

ATTACKFELD:  MOV ebx,61h               ;G1    wegen bX nicht H1!
             XOR eax,eax
             MOV cx,4h
ATTACKFELD1: MOV word[FELDATTACK+ebx],ax   ;WORD hier am schnellsten
             MOV word[FELDATTACK-0ah+ebx],ax
             MOV word[FELDATTACK-14h+ebx],ax
             MOV word[FELDATTACK-1eh+ebx],ax
             MOV word[FELDATTACK-28h+ebx],ax
             MOV word[FELDATTACK-32h+ebx],ax
             MOV word[FELDATTACK-3ch+ebx],ax
             MOV word[FELDATTACK-46h+ebx],ax
             SUB bx,2h
             DEC cl
             JNZ l_attackfeld1

             MOV bx,[TIEFE]
             SHL bx,1h
             MOV cx,[ANZFIGW+ebx]
             ADD cx,[ANZFIGS+ebx]
             MOV bx,15h                ;A8
ATTACKFELD2: MOV al,[ASTELL+ebx]
             TEST al,10h               ;weisse Figur?
             JNZ l_attackfeldwx        ;ja
             TEST al,80h
             JNZ l_attackfeldsx
ATTACKFELD3: INC bx
             JMP l_attackfeld2
ATTACKFELD3X:INC bx
             DEC cl
             JNZ l_attackfeld2
             RET
       ;--------------- Randfelder wieder als solche kennzeichnen --------------
    ;vorerst nicht ntig
             MOV ax,808h
             MOV bx,76h                ;118D
             MOV cx,0ah
ATTACKFELD3Y:MOV word[FELDATTACK+ebx],ax
             MOV word[FELDATTACK-64h+ebx],ax
             SUB bx,2h
             DEC cl
             JNZ l_attackfeld3y

             MOV bx,63h                ;99D
             MOV cx,9h
ATTACKFELD3Z:MOV word[FELDATTACK+ebx],ax
             SUB bx,0ah
             DEC cl
             JNZ l_attackfeld3z

             RET

       ;---------------------- Figur bestimmen ---------------------------------
ATTACKFELDWX:AND al,7h
             DEC al
             JZ l_awb
             DEC al
             JZ l_aws
             DEC al
             JZ l_awl
             DEC al
             JZ l_awt
             DEC al
             JZ l_awd
             JMP l_awk

ATTACKFELDSX:AND al,7h
             DEC al
             JZ l_asb
             DEC al
             JZ l_ass
             DEC al
             JZ l_asl
             DEC al
             JZ l_ast
             DEC al
             JZ l_asd

             OR byte[FELDATTACK+1h+ebx],80h    ;schwarzer Knig
             OR byte[FELDATTACK-1h+ebx],80h
             OR byte[FELDATTACK+0ah+ebx],80h
             OR byte[FELDATTACK-0ah+ebx],80h
             OR byte[FELDATTACK+9h+ebx],80h
             OR byte[FELDATTACK-9h+ebx],80h
             OR byte[FELDATTACK+0bh+ebx],80h
             OR byte[FELDATTACK-0bh+ebx],80h
             JMP l_attackfeld3x

AWB:         OR byte[FELDATTACK-9h+ebx],1h     ;weisser Bauer  
             OR byte[FELDATTACK-0bh+ebx],1h
             JMP l_attackfeld3x

ASB:         OR byte[FELDATTACK+9h+ebx],10h    ;schwarzer Bauer
             OR byte[FELDATTACK+0bh+ebx],10h
             JMP l_attackfeld3x

AWS:         OR byte[FELDATTACK-15h+ebx],2h    ;weisser Springer
             OR byte[FELDATTACK-13h+ebx],2h
             OR byte[FELDATTACK-8h+ebx],2h
             OR byte[FELDATTACK-0ch+ebx],2h
             OR byte[FELDATTACK+8h+ebx],2h
             OR byte[FELDATTACK+0ch+ebx],2h
             OR byte[FELDATTACK+13h+ebx],2h
             OR byte[FELDATTACK+15h+ebx],2h
             JMP l_attackfeld3x

ASS:         OR byte[FELDATTACK-15h+ebx],20h   ;schwarzer Springer
             OR byte[FELDATTACK-13h+ebx],20h
             OR byte[FELDATTACK-8h+ebx],20h
             OR byte[FELDATTACK-0ch+ebx],20h
             OR byte[FELDATTACK+8h+ebx],20h
             OR byte[FELDATTACK+0ch+ebx],20h
             OR byte[FELDATTACK+13h+ebx],20h
             OR byte[FELDATTACK+15h+ebx],20h
             JMP l_attackfeld3x

AWL:         MOV edi,ebx                       ;weisser Lufer
AWL1:        ADD di,9h
             OR byte[FELDATTACK+edi],2h
             TEST byte[ASTELL+edi],98h         ;Figur oder Randfeld?
             JZ l_awl1                         ;nein
             MOV di,bx
AWL2:        ADD di,0bh
             OR byte[FELDATTACK+edi],2h
             TEST byte[ASTELL+edi],98h
             JZ l_awl2
             MOV di,bx
AWL3:        SUB di,0bh
             OR byte[FELDATTACK+edi],2h
             TEST byte[ASTELL+edi],98h
             JZ l_awl3
             MOV di,bx
AWL4:        SUB di,9h
             OR byte[FELDATTACK+edi],2h
             TEST byte[ASTELL+edi],98h
             JZ l_awl4
             JMP l_attackfeld3x

ASL:         MOV edi,ebx                       ;schwarzer Lufer
ASL1:        ADD di,9h
             OR byte[FELDATTACK+edi],20h
             TEST byte[ASTELL+edi],98h
             JZ l_asl1
             MOV di,bx
ASL2:        ADD di,0bh
             OR byte[FELDATTACK+edi],20h
             TEST byte[ASTELL+edi],98h
             JZ l_asl2
             MOV di,bx
ASL3:        SUB di,0bh
             OR byte[FELDATTACK+edi],20h
             TEST byte[ASTELL+edi],98h
             JZ l_asl3
             MOV di,bx
ASL4:        SUB di,9h
             OR byte[FELDATTACK+edi],20h
             TEST byte[ASTELL+edi],98h
             JZ l_asl4
             JMP l_attackfeld3x

AWT:         MOV edi,ebx                       ;weisser Turm
AWT1:        INC di
             OR byte[FELDATTACK+edi],4h
             TEST byte[ASTELL+edi],98h
             JZ l_awt1
             MOV di,bx
AWT2:        DEC di
             OR byte[FELDATTACK+edi],4h
             TEST byte[ASTELL+edi],98h
             JZ l_awt2
             MOV di,bx
AWT3:        ADD di,0ah
             OR byte[FELDATTACK+edi],4h
             TEST byte[ASTELL+edi],98h
             JZ l_awt3
             MOV di,bx
AWT4:        SUB di,0ah
             OR byte[FELDATTACK+edi],4h
             TEST byte[ASTELL+edi],98h
             JZ l_awt4
             JMP l_attackfeld3x

AST:         MOV edi,ebx                       ;schwarzer Turm
AST1:        INC di
             OR byte[FELDATTACK+edi],40h
             TEST byte[ASTELL+edi],98h
             JZ l_ast1
             MOV di,bx
AST2:        DEC di
             OR byte[FELDATTACK+edi],40h
             TEST byte[ASTELL+edi],98h
             JZ l_ast2
             MOV di,bx
AST3:        ADD di,0ah
             OR byte[FELDATTACK+edi],40h
             TEST byte[ASTELL+edi],98h
             JZ l_ast3
             MOV di,bx
AST4:        SUB di,0ah
             OR byte[FELDATTACK+edi],40h
             TEST byte[ASTELL+edi],98h
             JZ l_ast4
             JMP l_attackfeld3x

AWD:         MOV edi,ebx                       ;weisse Dame
AWD1:        ADD di,9h
             OR byte[FELDATTACK+edi],4h
             TEST byte[ASTELL+edi],98h
             JZ l_awd1
             MOV di,bx
AWD2:        ADD di,0bh
             OR byte[FELDATTACK+edi],4h
             TEST byte[ASTELL+edi],98h
             JZ l_awd2
             MOV di,bx
AWD3:        SUB di,0bh
             OR byte[FELDATTACK+edi],4h
             TEST byte[ASTELL+edi],98h
             JZ l_awd3
             MOV di,bx
AWD4:        SUB di,9h
             OR byte[FELDATTACK+edi],4h
             TEST byte[ASTELL+edi],98h
             JZ l_awd4
             JMP l_awt

ASD:         MOV edi,ebx                       ;schwarze Dame
ASD1:        ADD di,9h
             OR byte[FELDATTACK+edi],40h
             TEST byte[ASTELL+edi],98h
             JZ l_asd1
             MOV di,bx
ASD2:        ADD di,0bh
             OR byte[FELDATTACK+edi],40h
             TEST byte[ASTELL+edi],98h
             JZ l_asd2
             MOV di,bx
ASD3:        SUB di,0bh
             OR byte[FELDATTACK+edi],40h
             TEST byte[ASTELL+edi],98h
             JZ l_asd3
             MOV di,bx
ASD4:        SUB di,9h
             OR byte[FELDATTACK+edi],40h
             TEST byte[ASTELL+edi],98h
             JZ l_asd4
             JMP l_ast

AWK:         OR byte[FELDATTACK+1h+ebx],8h     ;weisser Knig
             OR byte[FELDATTACK-1h+ebx],8h
             OR byte[FELDATTACK+0ah+ebx],8h
             OR byte[FELDATTACK-0ah+ebx],8h
             OR byte[FELDATTACK+9h+ebx],8h
             OR byte[FELDATTACK-9h+ebx],8h
             OR byte[FELDATTACK+0bh+ebx],8h
             OR byte[FELDATTACK-0bh+ebx],8h
             JMP l_attackfeld3x
;--------------------------------- Ende TATTACKF -------------------------------


;------------------------------ Anfang TZUGAUSF --------------------------------
;------------------------- Weissen Zug intern ausfhren ------------------------
HW1:         XOR edi,edi    
             MOV ebx,edi
             MOV di,[TIEFE]
             SHL di,1h
             MOV bx,[Z+2h+edi]         ;Zeiger in ZUGTAB    2 ist fr Tiefe!
             ADD word[Z+2h+edi],2h     ;Tiefe hier noch nicht erhht!
             ADD bx,[AZ]
             MOV ax,word[ZUGTAB+ebx]
             CMP ax,0fffeh
             JB l_hw2                  ;noch Zug vorhanden
             JA l_hw3                  ;Ende ZUGTAB
             SUB word[Z+2h+edi],2h
             CALL l_zuggenw
             JMP l_hw1                 ;neue Zge da

HW2:         INC [TIEFE]
             MOV di,[TIEFE]
             MOV [COLOR],80h
             ADD [AZ],1b6h
             CMP di,[MAXSEL]
             JBE l_hw21
             INC [MAXSEL]
HW21:        CALL l_aw                 ;weissen Zug intern ausfhren
        
HW3:         RET

;------------------------- Schwarzen Zug intern ausfhren ----------------------
HS1:         XOR edi,edi
             MOV ebx,edi
             MOV di,[TIEFE]
             SHL di,1h
             MOV bx,[Z+2h+edi]         ;Zeiger in ZUGTAB
             ADD word[Z+2h+edi],2h     ;+2, weil TIEFE hier noch nicht erhht!
             ADD bx,[AZ]
             MOV ax,word[ZUGTAB+ebx]
             CMP ax,0fffeh
             JB l_hs2                  ;noch Zug vorhanden
             JA l_hs3                  ;Ende ZUGTAB
             SUB word[Z+2h+edi],2h
             CALL l_zuggens
             JMP l_hs1                 ;neue Zge da

HS2:         INC [TIEFE]
             MOV di,[TIEFE]
             ADD [AZ],1b6h             ;COLOR wird in AS auf Null gesetzt!
             CMP di,[MAXSEL]
             JBE l_hs21
             INC [MAXSEL]
HS21:        CALL l_as
HS3:         RET

;--------------------- ausgefhrten schwarzen Halbzug zurcknehmen -------------
SHZR:        MOV [COLOR],80h
             SUB [AZ],1b6h
             MOVZX ecx,[TIEFE]
             MOV ebx,ecx               ;alte Hash-Werte zurckholen
             DEC [TIEFE]
             SHL bx,2h
             MOV eax,[HASHADRX+ebx]
             MOV [HASHADR],eax
             MOV eax,[HASHCODEX+ebx]
             MOV [HASHCODE],eax

             MOV bl,[ZFELD+ecx]
             MOV di,bx
             MOV al,[ZFELDH+ecx]
             MOV [ASTELL+ebx],al
             AND al,7h
             CMP al,1h                 ;wurde weisser Bauer geschlagen?
             JNE l_shzr1               ;nein
             XOR byte[WBSTELL+ebx],10h ;weissen Bauer wieder auf ZFELD setzen
             INC byte[WBSTELL-9h+ebx]
             INC byte[WBSTELL-0bh+ebx]
             SHL bl,1h
             MOV bl,[NFELD+ebx]
             INC byte[WBLINIE+ebx]

SHZR1:       MOV bl,[AFELD+ecx]
             MOV ah,[AFELDH+ecx]
             MOV [ASTELL+ebx],ah
             CMP bl,79h                ;Nullzug?
             JNE l_shzr10              ;nein
             RET
SHZR10:      AND ah,7h                 ;Inhalt AFELD
       ;------------------------- Test auf Bauernzug ---------------------------
             CMP ah,1h                 ;eigener Bauernzug?
             JNE l_hzsr3               ;nein
             XOR byte[SBSTELL+ebx],80h ;eigenen Bauer wieder setzen   BX=AFELD
             INC byte[SBSTELL+9h+ebx]  ;Kontrollfelder erhhen
             INC byte[SBSTELL+0bh+ebx]
             CMP di,5bh                ;A1?
             JB l_shzr11
             SHL bl,1h                 ;ja,war Umwandlung, NICHT Bauer lschen!!
             MOV bl,[NFELD+ebx]        ; Bauer nur wieder rein!
             INC byte[SBLINIE+ebx]
             RET
SHZR11:      XOR byte[SBSTELL+edi],80h ;eigenen Bauer lschen  DI=ZFELD
             DEC byte[SBSTELL+9h+edi]  ;Kontrollfeld verringern
             DEC byte[SBSTELL+0bh+edi]
       ;------------------------- Test auf en passant --------------------------
             OR al,al                  ;war Zielfeld leer?
             JNE l_shzr12              ;nein, kein e.p.
             MOV dl,bl
             SUB bx,di                 ;AFELD-ZFELD
             CMP bl,0f5h
             JE l_hzsr2
             CMP bl,0f7h
             JE l_hzsr2
             RET                       ;nicht e.p.
HZSR2:       OR byte[ASTELL-0ah+edi],11h    ;Feld unter Zielfeld  DI=ZFELD
             XOR byte[WBSTELL-0ah+edi],10h  ;gegn. weisser Bauer wieder rein
             INC byte[WBSTELL-13h+edi]
             INC byte[WBSTELL-15h+edi]
             MOV bx,di                 ;DI ist Rckgabewert!
             SHL bl,1h
             MOV bl,[NFELD+ebx]
             INC byte[WBLINIE+ebx]

             MOV bl,dl
SHZR12:      SHL bl,1h
             MOV bl,[NFELD+ebx]
             INC byte[SBLINIE+ebx]

             MOV bx,di                 ;DI ist Rckgabewert!
             SHL bl,1h
             MOV bl,[NFELD+ebx]
             DEC byte[SBLINIE+ebx]
             RET

       ;----------------- Test auf Rochaden ------------------------------------
HZSR3:       CMP ah,6h                 ;war's ein Knigszug?
             JNE l_hzsr4               ;nein
             MOV [SKFELD],bl           ;AFELD
             MOV dl,bl
             SHL bl,1h
             MOV bl,[NFELD+ebx]
             MOV [SKLINIE],bl
             CMP dl,19h                ;evtl. Rochade?
             JNE l_hzsr4               ;nein
             CMP di,1bh
             JNE l_hzsr5               ;nein
             MOV byte[ASTELL+1ah],40h
             MOV byte[ASTELL+1ch],0c4h ;Turm wieder von f8 nach h8
             MOV [ROCHSTATUSS],bh
HZSR4:       RET
HZSR5:       CMP di,17h                ;war Zielfeld c8?
             JNE l_hzsr4               ;nein
             MOV byte[ASTELL+18h],40h
             MOV byte[ASTELL+15h],84h  ;Turm wieder von d8 nach a8
             MOV [ROCHSTATUSS],bh
             RET

;---------------------- ausgefhrten weissen Halbzug zurcknehmen --------------
WHZR:        SUB [AZ],1b6h
             MOVZX ecx,[TIEFE]
             MOV ebx,ecx               ;alte Hashwerte zurckholen
             MOV [COLOR],bh
             DEC [TIEFE]
             SHL bx,2h
             MOV eax,[HASHADRX+ebx]
             MOV [HASHADR],eax
             MOV eax,[HASHCODEX+ebx]
             MOV [HASHCODE],eax
             MOV bl,[ZFELD+ecx]
             MOV edi,ebx
             MOV al,[ZFELDH+ecx]
             MOV [ASTELL+ebx],al
             AND al,7h
             CMP al,1h                 ;wurde schwarzer Bauer geschlagen?
             JNE l_whzr1               ;nein
             XOR byte[SBSTELL+ebx],80h ;schwarzen Bauer wieder auf ZFELD setzen
             INC byte[SBSTELL+9h+ebx]
             INC byte[SBSTELL+0bh+ebx]
             SHL bx,1h
             MOV bl,[NFELD+ebx]
             INC byte[SBLINIE+ebx]

WHZR1:       MOV bl,[AFELD+ecx]
             MOV ah,[AFELDH+ecx]
             MOV [ASTELL+ebx],ah
             CMP bl,79h                ;Nullzug?
             JNE l_whzr10              ;nein
             RET
WHZR10:      AND ah,7h
       ;------------------------- Test auf Bauernzug ---------------------------
             CMP ah,1h                 ;eigener Bauernzug?
             JNE l_hzwr3               ;nein, Test auf Rochade
           
             XOR byte[WBSTELL+ebx],10h ;eigenen Bauer wieder setzen   BX=AFELD
             INC byte[WBSTELL-9h+ebx]  ;Kontrollfelder erhhen
             INC byte[WBSTELL-0bh+ebx]
             CMP di,1ch                ;H8?
             JA l_whzr11
             SHL bl,1h                 ;ja,war Umwandlung, NICHT Bauer lschen!!
             MOV bl,[NFELD+ebx]       ; Bauer nur wieder rein!
             INC byte[WBLINIE+ebx]
             RET

WHZR11:      XOR byte[WBSTELL+edi],10h ;eigenen Bauer lschen  DI=ZFELD
             DEC byte[WBSTELL-9h+edi]  ;Kontrollfeld verringern
             DEC byte[WBSTELL-0bh+edi]
       ;------------------------- Test auf en passant --------------------------
WHZR2:       OR al,al                  ;war Zielfeld leer?
             JNE l_whzr12              ;nein, kein e.p.
             MOV dl,bl
             SUB bx,di                 ;AFELD-ZFELD
             CMP bl,9h
             JE l_hzwr2
             CMP bl,0bh
             JE l_hzwr2
             RET                       ;nicht e.p.
HZWR2:       OR byte[ASTELL+0ah+edi],81h    ;Feld unter Zielfeld
             XOR byte[SBSTELL+0ah+edi],80h  ;gegn. schwarzen Bauer wieder rein
             INC byte[SBSTELL+13h+edi]
             INC byte[SBSTELL+15h+edi]
             MOV bx,di                 ;DI ist Rckgabewert!
             SHL bx,1h
             MOV bl,[NFELD+ebx]
             INC byte[SBLINIE+ebx]

             MOV bl,dl
WHZR12:      SHL bl,1h
             MOV bl,[NFELD+ebx]
             INC byte[WBLINIE+ebx]

             MOV bx,di                 ;DI ist Rckgabewert!
             SHL bl,1h
             MOV bl,[NFELD+ebx]
             DEC byte[WBLINIE+ebx]
             RET

       ;---------------------- Test auf Rochaden -------------------------------
HZWR3:       CMP ah,6h                 ;Knig auf AFELD?
             JNE l_hzwr4               ;nein
             MOV [WKFELD],bl           ;AFELD
             MOV dl,bl
             SHL bl,1h
             MOV bl,[NFELD+ebx]
             MOV [WKLINIE],bl
             CMP dl,5fh                ;evtl. Rochade?
             JNE l_hzwr4               ;nein
             CMP di,61h                ;war Zielfeld g1?
             JNE l_hzwr5               ;nein
             MOV [ASTELL+60h],bh
             MOV byte[ASTELL+62h],14h  ;Turm wieder von f1 nach h1
             MOV [ROCHSTATUSW],bh
HZWR4:       RET
HZWR5:       CMP di,5dh                ;war Zielfeld c1?
             JNE l_hzwr4               ;nein
             MOV [ASTELL+5eh],bh
             MOV byte[ASTELL+5bh],54h  ;Turm wieder von d1 nach a1
             MOV [ROCHSTATUSW],bh
             RET

;---------------------------- Weissen Zug ausfhren ----------------------------
AW:          MOV [AFELD+edi],al        ;weisses AFELD retten
             MOV [LASTZUGGA],al
             MOV [ZFELDU],ah           ;Originalwert fr Bauernumwandlung retten
             CMP ah,7ah                ; nur fr REW!!!
             JBE l_aw0                 ;keine Bauernumwandlung
           ;Erweiterungen bringen hier nichts!
       ;------------- Dekodierung Bauernumwandlung ----------
             SUB ah,64h                ;ZFELD minus 100
             MOV bl,al                 ;AL=AFELD
             SUB bl,0ah                ;1.Mglichkeit: gerade durchgezogen
             SUB ah,bl
             TEST ah,3h                ;Bit 0 oder 1 gesetzt?(nicht d.4 teilbar)
             JNZ l_nichtg              ;ja, war nicht gerade durchgezogen
             SHR ah,2h                 ;durch 4 teilen
             MOV [UFIG],ah             ;AH ist Figur, BL ist richtiges ZFELD
             MOV ah,bl
             JMP l_aw0
NICHTG:      DEC ah                    ;2.Mglichkeit: nach links schlagen
             TEST ah,3h
             JNZ l_nichtl              ;war nicht nach links
             SHR ah,2h
             MOV [UFIG],ah
             INC bl
             MOV ah,bl
             JMP l_aw0
NICHTL:      ADD ah,2h                 ;bleibt nur 3.Mglichkeit: nach rechts
             SHR ah,2h                 ; schlagen
             MOV [UFIG],ah
             DEC bl
             MOV ah,bl

AW0:         MOV [ZFELD+edi],ah        ;weisses ZFELD retten
             MOV [LASTZUGGZ],ah
             XOR ebx,ebx
             MOV ecx,ebx
             MOV [X1],bl               ;Merker fr e.p.
             MOV bl,al                 ;AFELD
             MOV ch,[ASTELL+ebx]       ;Inhalt AFELD
             MOV [AFELDH+edi],ch       ;komplett retten
             AND ch,17h                ;Figurenart und-farbe
             MOV [ASTELL+ebx],bh       ;AFELD leeren
             MOV bp,bx
             MOV bl,ah                 ;ZFELD
             MOV al,[ASTELL+ebx]       ;Inhalt Zielfeld
             MOV [ZFELDH+edi],al       ;retten mit Feldfarbe
             MOV [ASTELL+ebx],ch       ;ZFELD mit Inhalt von AFELD fllen
             OR byte[ASTELL+ebx],20h   ;Bit fr Figur schon mal gezogen setzen
             SHL di,1h                 ;DI ist noch TIEFE
             MOV dx,[ERWEITERUNG-2h+edi]
             MOV [ERWEITERUNG+edi],dx
             MOV dx,[ANZFIGW-2h+edi]
             MOV [ANZFIGW+edi],dx
             MOV dx,[ANZFIGS-2h+edi]
             MOV [ANZFIGS+edi],dx
             MOV dx,[ANZBAUERW-2h+edi]
             MOV [ANZBAUERW+edi],dx
             MOV dx,[ANZBAUERS-2h+edi]
             MOV [ANZBAUERS+edi],dx
             MOV dx,[MATW-2h+edi]
             MOV [MATW+edi],dx
             MOV dx,[MATS-2h+edi]
             MOV [MATS+edi],dx

             SHL di,1h
             MOV edx,[HASHADR]         ;von Tiefe-1
             MOV [HASHADRX+edi],edx    ;alte Werte sichern
             MOV edx,[HASHCODE]
             MOV [HASHCODEX+edi],edx

             CMP bl,79h                ;Nullzug?
             JE l_hashw                ;nicht RET!
             SHR di,1h

             AND al,7h                 ;stand auf ZFELD schwarze Figur?
             JZ l_aw2                  ;nein

             DEC word[ANZFIGS+edi]     ;auf ZFELD stand schwarze Figur
             CMP al,1h                 ;schwarzen Bauer geschlagen?
             JNE l_aw12
             DEC word[ANZBAUERS+edi]
             XOR byte[SBSTELL+ebx],80h ;gegn. schwarzen Bauer lschen  BX=ZFELD
             DEC byte[SBSTELL+9h+ebx]  ;Kontrollfelder verringern
             DEC byte[SBSTELL+0bh+ebx]
             SHL bx,1h
             MOV bl,[NFELD+ebx]        ;Linie A-H
             DEC byte[SBLINIE+ebx]

AW12:        MOV bl,al                 ;Inhalt ZFELD
             SHL bl,1h
             MOV dx,[FIGWERT+ebx]
             SUB [MATS+edi],dx

       ;-------------------- Test auf Bauernzge -------------------------------
AW2:         CMP ch,11h                ;eigener Bauernzug?
             JNE l_aw3                 ;nein, weiter mit evtl. Knigszug
             MOV bl,ah                 ;AH ist immer noch ZFELD!
       
             MOVZX ecx,bp              ;BP=AFELD
             XOR byte[WBSTELL+ecx],10h ;eigenen weissen Bauern lschen
             DEC byte[WBSTELL-9h+ecx]
             DEC byte[WBSTELL-0bh+ecx]
       
         ;---------------- Test auf Bauernumwandlung -----------------------------
             CMP bl,1ch                ;8.Reihe erreicht?
             JA l_aw20                 ;nein
             MOV ah,[UFIG]             ;umgewandelte Figur
             OR ah,10h
             MOV [ASTELL+ebx],ah       ;weisse Figur setzen
             DEC word[ANZBAUERW+edi]
             SHL cx,1h
             MOV bl,[NFELD+ecx]
             DEC byte[WBLINIE+ebx]
             MOV bl,[UFIG]
             SHL bl,1h
             MOV dx,[FIGWERT+ebx]
             SUB dx,64h                ;Bauer weg
             ADD [MATW+edi],dx         ;plus neue Figur
             JMP l_hashw

AW20:        XOR byte[WBSTELL+ebx],10h ;eigenen weissen Bauer setzen  BX=ZFELD
             INC byte[WBSTELL-9h+ebx]
             INC byte[WBSTELL-0bh+ebx]
     
       ;-------------------- Test auf en passant -------------------------------
             OR al,al                  ;ZFELD leer?
             JNZ l_aw22                ;nein, kann nicht en passant gewesen sein
             MOV dl,bl
             MOV al,[LASTZUGGA]        ;=AFELD	eigener Zug!
             SUB al,bl                 ;bl=ZFELD
             CMP al,0bh                ;nach links oben?
             JE l_aw21                 ;ja
             CMP al,9h                 ;nach rechts oben?
             JNE l_hashw               ;nein, kein e.p.
AW21:        AND byte[ASTELL+0ah+ebx],40h  ;schwarzen Bauer entfernen
             DEC word[ANZFIGS+edi]
             MOV [X1],bl               ;Merker fr en passant zum Hashen
             DEC word[ANZBAUERS+edi]
             SUB word[MATS+edi],64h
             XOR byte[SBSTELL+0ah+ebx],80h ;gegn. schwarzen Bauer lschen
             DEC byte[SBSTELL+13h+ebx]
             DEC byte[SBSTELL+15h+ebx]
             SHL bx,1h                 ;BX+0a nicht ntig!
             MOV bl,[NFELD+ebx]
             DEC byte[SBLINIE+ebx]

             MOV bl,dl
AW22:        SHL bl,1h                 ;BX=ZFELD
             MOV bl,[NFELD+ebx]
             INC byte[WBLINIE+ebx]

             SHL cx,1h                 ;CX=AFELD
             MOV bl,[NFELD+ecx]
             DEC byte[WBLINIE+ebx]

             JMP l_hashw
       ;---------------------- Test auf Rochaden -------------------------------
AW3:         CMP ch,16h                ;stand auf AFELD eigener Knig?
             JNE l_hashw               ;nein
             MOV al,[LASTZUGGZ]
             MOV [WKFELD],al           ;WKFELD aktualisieren
             MOV bl,al
             SHL bl,1h
             MOV bl,[NFELD+ebx]
             MOV [WKLINIE],bl
             CMP [LASTZUGGA],5fh       ;evtl. Rochade?
             JNE l_hashw               ;nein
             CMP al,61h                ;Feld g1?
             JNE l_aw4                 ;nein
             MOV [ASTELL+62h],bh       ;es war kleine Rochade!
             MOV byte[ASTELL+60h],14h  ;Turm von h1 nach f1
             MOV bx,2f98h              ;Knig auf e1
             CALL l_hashen   
             MOV bx,3098h              ;Knig auf g1
             CALL l_hashen
             MOV bx,3110h              ;Turm auf h1
             CALL l_hashen
             MOV bx,3010h              ;Turm auf f1
             CALL l_hashen
             MOV [ROCHSTATUSW],al      ;beliebiger Wert ungleich Null
             RET

AW4:         CMP al,5dh                ;Feld c1?
             JNE l_hashw               ;nein
             MOV [ASTELL+5bh],bh       ;es war groe Rochade!
             MOV byte[ASTELL+5eh],14h  ;Turm von a1 nach d1
             MOV bx,2f98h              ;Knig auf e1
             CALL l_hashen
             MOV bx,2e98h              ;Knig auf c1
             CALL l_hashen
             MOV bx,2d90h              ;Turm auf a1
             CALL l_hashen
             MOV bx,2f10h              ;Turm auf d1
             CALL l_hashen
             MOV [ROCHSTATUSW],al
             RET
       ;------------------------------------------
HASHW:       MOVZX edi,[TIEFE]
             XOR ebx,ebx     
             MOV bl,[AFELD+edi]        ;Ausgangsfeld holen
             SHL bx,7h                 ;128 Bytes pro Feld
             MOV al,[AFELDH+edi]       ;Inhalt AFELD
             AND ax,7h                 ;Figur
             SHL al,2h                 ;*4 (DD!) jede Stelle ist 4 Byte gro
             ADD bx,ax                 ;Adresse in HASHWERT
             CALL l_hashen             ;Ausgangsfeld

             XOR ebx,ebx
             MOV bl,[ZFELD+edi]        ;Zielfeld holen
             SHL bx,7h                 ;128 Bytes pro Feld
             MOV cx,bx                 ;Adresse sichern
             ADD bx,ax                 ;Figur
             CALL l_hashen             ;Zielfeld

             CMP [X1],0h
             JE l_hashnoepw            ;war kein e.p.
             ADD cx,500h               ;10*128D
             MOV bx,cx
             ADD bx,44h                ;schwarzer Bauer
             CALL l_hashen
             RET

HASHNOEPW:   MOV al,[ZFELDH+edi]       ;Inhalt Zielfeld
             AND al,7h
             JZ l_hashwe               ;keine Figur geschlagen
             MOV bx,cx                 ;Basis-Adresse in HASHWERT von ZFELD
             ADD bx,40h                ;schwarze Figur
             SHL al,2h                 ;*4 (DD!)
             ADD bx,ax                 ;ZFELD mit geschlagener Figur
             CALL l_hashen
HASHWE:      RET

;------------------------- Schwarzen Zug ausfhren -----------------------------
As:          MOV [AFELD+edi],al        ;schwarzes AFELD retten
             MOV [LASTZUGGA],al
             MOV [ZFELDU],ah           ;Originalwert fr Bauernumwandlung retten
             CMP ah,7ah                ; nur fr RES!!!
             JBE l_as0                 ;keine Bauernumwandlung

       ;------------- Dekodierung Bauernumwandlung ----------
             SUB ah,64h                ;ZFELD minus 100
             MOV bl,al                 ;AL=AFELD
             ADD bl,0ah                ;1.Mglichkeit: gerade durchgezogen
             SUB ah,bl
             TEST ah,3h                ;Bit 0 oder 1 gesetzt?(nicht d.4 teilbar)
             JNZ l_nichtsg             ;ja, war nicht gerade durchgezogen
             SHR ah,2h                 ;durch 4 teilen
             MOV [UFIG],ah             ;AH ist Figur, BL ist richtiges ZFELD
             MOV ah,bl
             JMP l_as0
NICHTSG:     DEC ah                    ;2.Mglichkeit: nach links schlagen
             TEST ah,3h
             JNZ l_nichtsl             ;war nicht nach links
             SHR ah,2h
             MOV [UFIG],ah
             INC bl
             MOV ah,bl
             JMP l_as0
NICHTSL:     ADD ah,2h                 ;bleibt nur 3.Mglichkeit: nach rechts
             SHR ah,2h                 ; schlagen
             MOV [UFIG],ah
             DEC bl
             MOV ah,bl

AS0:         MOV [ZFELD+edi],ah        ;schwarzes ZFELD retten
             MOV [LASTZUGGZ],ah
             XOR ebx,ebx
             MOV ecx,ebx      
             MOV [X1],bl               ;Merker en passant
             MOV [COLOR],bl
             MOV bl,al                 ;AFELD
             MOV ch,[ASTELL+ebx]       ;Inhalt AFELD
             MOV [AFELDH+edi],ch       ;komplett retten
             AND ch,87h                ;schwarze Figur
             MOV [ASTELL+ebx],bh       ;AFELD leeren
             MOV bp,bx
             MOV bl,ah                 ;ZFELD
             MOV al,[ASTELL+ebx]       ;Inhalt Zielfeld
             MOV [ZFELDH+edi],al       ;retten mit Feldfarbe
             MOV [ASTELL+ebx],ch       ;ZFELD mit Inhalt von AFELD fllen
             OR byte[ASTELL+ebx],20h   ;Bit fr Figur schon mal gezogen setzen
             SHL di,1h                 ;DI ist noch Tiefe
             MOV dx,[ERWEITERUNG-2h+edi]
             MOV [ERWEITERUNG+edi],dx
             MOV dx,[ANZFIGW-2h+edi]
             MOV [ANZFIGW+edi],dx
             MOV dx,[ANZFIGS-2h+edi]
             MOV [ANZFIGS+edi],dx
             MOV dx,[ANZBAUERW-2h+edi]
             MOV [ANZBAUERW+edi],dx
             MOV dx,[ANZBAUERS-2h+edi]
             MOV [ANZBAUERS+edi],dx
             MOV dx,[MATW-2h+edi]
             MOV [MATW+edi],dx
             MOV dx,[MATS-2h+edi]
             MOV [MATS+edi],dx
             SHL di,1h
             MOV edx,[HASHADR]
             MOV [HASHADRX+edi],edx    ;alte Werte sichern!
             MOV edx,[HASHCODE]
             MOV [HASHCODEX+edi],edx

             CMP bl,79h                ;Nullzug?
             JE l_hashs                ;nicht RET!
             SHR di,1h

             AND al,7h                 ;stand auf ZFELD weisse Figur?
             JZ l_as2                  ;nein
             DEC word[ANZFIGW+edi]     ;ja
             CMP al,1h                 ;weissen Bauern geschlagen?
             JNE l_as12
             DEC word[ANZBAUERW+edi]
             XOR byte[WBSTELL+ebx],10h ;gegn. weissen Bauer lschen BX=ZFELD
             DEC byte[WBSTELL-9h+ebx]  ;Kontrollfelder verringern
             DEC byte[WBSTELL-0bh+ebx]
             SHL bx,1h
             MOV bl,[NFELD+ebx]        ;Linie A-H
             DEC byte[WBLINIE+ebx]

AS12:        MOV bl,al                 ;AL=ZFELDH
             SHL bl,1h
             MOV dx,[FIGWERT+ebx]
             SUB [MATW+edi],dx

       ;--------------------- Test auf Bauernzug -------------------------------
AS2:         CMP ch,81h                ;eigener Bauernzug?
             JNE l_as3                 ;nein
             MOV bl,ah                 ;AH ist immer noch ZFELD!
             MOV cx,bp                 ;BP=AFELD
             XOR byte[SBSTELL+ecx],80h ;eigenen schwarzen Bauern lschen
             DEC byte[SBSTELL+9h+ecx]
             DEC byte[SBSTELL+0bh+ecx]
       ;---------------- Test auf Bauernumwandlung -----------------------------
             CMP bl,5bh                ;1.Reihe erreicht?
             JB l_as20                 ;nein
             MOV ah,[UFIG]             ;umgewandelte Figur
             OR ah,80h
             MOV [ASTELL+ebx],ah       ;schwarze Figur setzen
             DEC word[ANZBAUERS+edi]
             SHL cx,1h
             MOV bl,[NFELD+ecx]
             DEC byte[SBLINIE+ebx]
             MOV bl,[UFIG]
             SHL bl,1h
             MOV dx,[FIGWERT+ebx]
             SUB dx,64h                ;Bauer weg
             ADD word[MATS+edi],dx     ;plus neue Figur
             JMP l_hashs

AS20:        XOR byte[SBSTELL+ebx],80h ;eigenen schwarzen Bauer setzen	BX=ZFELD
             INC byte[SBSTELL+9h+ebx]
             INC byte[SBSTELL+0bh+ebx]

       ;----------------------- Test auf en passant ----------------------------
             OR al,al                  ;ZFELD leer?
             JNZ l_as22                ;nein, kann nicht en passant gewesen sein
             MOV dl,bl
             MOV al,[LASTZUGGA]        ;=AFELD eigener Zug!
             SUB al,bl                 ;bl=ZFELD
             CMP al,0f7h               ;nach links unten?
             JE l_as21                 ;ja, e.p.
             CMP al,0f5h               ;nach rechts unten?
             JNE l_hashs               ;nein, kein e.p.
AS21:        AND byte[ASTELL-0ah+ebx],40h  ;weissen Bauern entfernen
             DEC word[ANZFIGW+edi]
             MOV [X1],bl               ;Merker en passant
             DEC word[ANZBAUERW+edi]
             SUB word[MATW+edi],64h
             XOR byte[WBSTELL-0ah+ebx],10h  ;gegn. weissen Bauer lschen
             DEC byte[WBSTELL-13h+ebx]
             DEC byte[WBSTELL-15h+ebx]
             SHL bx,1h
             MOV bl,[NFELD+ebx]
             DEC byte[WBLINIE+ebx]

             MOV bl,dl
AS22:        SHL bl,1h                 ;BX=ZFELD
             MOV bl,[NFELD+ebx]
             INC byte[SBLINIE+ebx]

             SHL cx,1h                 ;CX=AFELD
             MOV bl,[NFELD+ecx]
             DEC byte[SBLINIE+ebx]

             JMP l_hashs
       ;----------------------- Test auf Rochaden ------------------------------
AS3:         CMP ch,86h                ;SKFELD aktualisieren
             JNE l_hashs
             MOV al,[LASTZUGGZ]
             MOV [SKFELD],al
             MOV bl,al
             SHL bl,1h
             MOV bl,[NFELD+ebx]
             MOV [SKLINIE],bl
             CMP [LASTZUGGA],19h       ;evtl. Rochade?
             JNE l_hashs               ;nein
             CMP al,1bh                ;Feld g8?
             JNE l_as4                 ;nein
             MOV [ASTELL+1ch],bh       ;es war kleine Rochade!
             MOV byte[ASTELL+1ah],84h  ;Turm von h8 nach f8
             MOV [ROCHSTATUSS],al      ;beliebiger Wert ungleich Null
             MOV bx,0cd8h              ;Knig auf e8
             CALL l_hashen
             MOV bx,0dd8h              ;Knig auf g8
             CALL l_hashen
             MOV bx,0e50h              ;Turm auf h8
             CALL l_hashen
             MOV bx,0d50h              ;Turm auf f8
             CALL l_hashen
             RET

AS4:         CMP al,17h                ;Feld c8?
             JNE l_hashs               ;nein
             MOV [ASTELL+15h],bh       ;es war groe Rochade!
             MOV byte[ASTELL+18h],84h  ;Turm von a8 nach d8
             MOV [ROCHSTATUSS],al
             MOV bx,0cd8h              ;Knig auf e8
             CALL l_hashen
             MOV bx,0bd8h              ;Knig auf c8
             CALL l_hashen
             MOV bx,0ad0h              ;Turm auf a8
             CALL l_hashen
             MOV bx,0c50h              ;Turm auf d8
             CALL l_hashen
             RET

       ;----------------------------------
HASHS:       MOVZX edi,[TIEFE]
             XOR ebx,ebx     
             MOV bl,[AFELD+edi]        ;Ausgangsfeld holen
             SHL bx,7h                 ;128 Bytes pro Feld
             ADD bx,40h                ;schwarze Figur
             MOV al,[AFELDH+edi]       ;Inhalt AFELD
             AND ax,7h                 ;Figur
             SHL al,2h                 ;*4 (DD!) jede Stelle ist 4 Byte gro
             ADD bx,ax                 ;Adresse in HASHWERT
             CALL l_hashen             ;Ausgangsfeld

             XOR ebx,ebx
             MOV bl,[ZFELD+edi]        ;Zielfeld holen
             SHL bx,7h                 ;128 Bytes pro Feld
             MOV cx,bx                 ;Adresse sichern
             ADD bx,40h                ;schwarze Figur
             ADD bx,ax                 ;Figur
             CALL l_hashen             ;Zielfeld

             CMP [X1],0h
             JE l_hashnoeps            ;war kein e.p.
             SUB cx,500h               ;10*128D
             MOV bx,cx
             ADD bx,4h                 ;weisser Bauer
             CALL l_hashen
             RET

HASHNOEPS:   MOV al,[ZFELDH+edi]       ;Inhalt Zielfeld
             AND al,7h
             JZ l_hashse               ;keine Figur geschlagen
             MOV bx,cx                 ;Basis-Adresse in HASHWERT von ZFELD
             SHL al,2h                 ;*4 (DD!)
             ADD bx,ax                 ;ZFELD mit geschlagener Figur
             CALL l_hashen
HASHSE:      RET

       ;------------------------------------------------------------------------
HASHEN:      MOV edx,[ZUFZAHLEN+ebx]
             XOR [HASHADR],edx
             MOV edx,[ZUFZAHLEN+20h+ebx]
             XOR [HASHCODE],edx

             RET
;--------------------------------- Ende TZUGAUSF -------------------------------

;------------------------------- Anfang TEVALANF -------------------------------
;------------------------------ Stellung bewerten ------------------------------
BWS:         INC [v_ZSTM]
             ADD [v_ZSTMG1],1h
             ADC [v_ZSTMG2],0h
             MOV [FATTDURCH],0h
             MOV [X1],0ffh             ;Merker fr Knigsbewertung S+L
             XOR ebx,ebx
             MOV edi,ebx
             CMP [COLOR],bh
             JNE l_bwss                ;richtig!
             MOV bl,[SKFELD]           ;Schwarz muss Zug ausfhren
             CALL l_attackfeldw
             CMP [ATTACK],0h
             JE l_bws1
             MOV bp,0f532h             ;Schwarz steht selbst im Schach
             SUB bp,[TIEFE]            ;Mattwert
             RET
BWS1:        MOV bl,[WKFELD]           ;ob Schwarz Schach bietet
             CALL l_attackfelds
             JMP l_holze2

BWSS:        MOV bl,[WKFELD]           ;Weiss muss Zug ausfhren
             CALL l_attackfelds
             CMP [ATTACK],0h
             JE l_bws2
             MOV bp,0f532h             ;Weiss steht selbst im Schach
             SUB bp,[TIEFE]            ;Mattwert
             RET
BWS2:        MOV bl,[SKFELD]           ;ob Weiss Schach bietet
             CALL l_attackfeldw

       ;-------------------- Test auf technisches Remis ------------------------
HOLZE2:      MOVZX edi,[TIEFE]
             SHL di,1h
             MOV cx,[ANZFIGW+edi]
             MOV dx,[ANZFIGS+edi]
             MOV ax,[MATW+edi]
             ADD ax,[MATS+edi]
             CMP ax,28ch               ;KL+KL, K+KLL
             JA l_holzezw              ;mehr Holz vorhanden
             JE l_ltest                ;Test auf Luferverteilung
             CMP ax,28bh               ;KLS+K, KL+KS
             JE l_lstest
             OR ax,ax                  ;K+K ?
             JE l_holze                ;ja, remis
             CMP ax,145h               ;KS+K
             JE l_holze                ;ja, remis
             CMP ax,146h               ;KL+K
             JE l_holze                ;ja, remis
             CMP ax,28ah               ;KSS+K, KS+KS
             JE l_holze                ;ja, remis
             CMP ax,1a9h               ;KSB+K, KS+KB
             JE l_endtest2
             CMP ax,1aah               ;KLB+K, KL+KB
             JNE l_holzezw
             CMP word[ANZFIGW+edi],2h
             JNE l_holzezw             ;eine Seite hat 3 Figuren, normal weiter
             CMP word[ANZBAUERW+edi],0h
             JE l_endtest1
             MOV bp,8064h              ;Weiss hat K+B gegen K+S
             JMP l_nolw                ;zur Sicherheit
ENDTEST1:    MOV bp,7f9ch              ;Weiss hat K+S gegen K+B, Figur ist
             JMP l_nolw                ; nichts wert. RISIKO!
ENDTEST2:    CMP word[ANZFIGW+edi],2h
             JNE l_holzezw             ;eine Seite hat 3 Figuren, normal weiter
             CMP word[ANZBAUERW+edi],0h
             JE l_endtest3
             MOV bp,8064h              ;Weiss hat K+B gegen K+L
             JMP l_nolw
ENDTEST3:    MOV bp,7f9ch              ;Weiss hat K+L gegen K+B, Figur ist
             JMP l_nolw                ; nichts wert. RISIKO!
HOLZE:       XOR bp,bp                 ;remis
             RET                       ;weitere Feinheiten spter
                                       ;KSS+KS usw.
LTEST:       CMP cx,dx
             JE l_holze                ;KL+KL, remis

             MOV di,15h                ;Test auf 2 gleichfarbige Lufer = remis
LTEST1:      MOV al,[ASTELL+edi]
             AND al,7h
             INC di
             CMP al,3h                 ;Lufer?
             JNE l_ltest1              ;nein
             MOV ah,[LSTELL-1h+edi]    ;Feldfarbe von LEERBRETT, 0 oder 40
LTEST2:      MOV al,[ASTELL+edi]
             AND al,7h
             INC di
             CMP al,3h
             JNE l_ltest2
             CMP ah,[LSTELL-1h+edi]
             JE l_holze                ;Lufer sind gleichfarbig! remis
             JMP l_holzezw

LSTEST:      CMP cx,dx
             JE l_holze                ;ist KL+KS, remis
       ;------------------------- Lufersituation ------------------------------
             MOV di,15h
LSTEST1:     MOV al,[ASTELL+edi]
             AND al,7h
             INC di
             CMP al,3h                 ;Lufer?
             JNE l_ltest1              ;nein
             MOV ah,[LSTELL-1h+edi]    ;Feldfarbe von LEERBRETT, 0 oder 40
             ADD ah,cl                 ;CL=ANZFIGW
             MOV [X1],ah

       ;----------------- Test auf 2*Zugwiederholung ---------------------------
HOLZEZW:     MOV bx,[TIEFE]   
             SHL bx,2h   
             MOV eax,[HASHCODE]        ;Wert fr aktuelle Tiefe
             SUB bx,4h
HOLZE20:     CMP eax,[HASHCODEX+ebx]   ;8 Abstand
             JE l_holze
             SUB bx,8h                 ;1 Komplett-Zug Abstand! Nicht 2!
             CMP bx,4h                 ;Ausgangsstellung
             JGE l_holze20
             MOV bp,8000h              ;damit nicht Null oder Mattwert
             RET
        ;-----------------------------------------------------------------------------
BWSREST:     MOV bp,[VORWERT]	         ;8000 +-
             ;MOV bp,8000h
             XOR ecx,ecx
       ;MOV ebx,ecx     
             CMP [COLOR],cl;bh	           ;hier ist richtige Stelle
             JE l_holze22
             NEG bp
HOLZE22:     MOV ax,[MATW+edi]
         
             ADD bp,ax                 ;MATW/S von AW/AS
             MOV [X9],ax
             MOV dx,[MATS+edi]
             SUB bp,dx                 ;Materialbilanz ALLER Figuren
              
             CMP [COLOR],0h
             JE l_holze21
             MOV [X9],dx
HOLZE21:     ADD ax,dx
             MOV bx,[ANZBAUERW+edi]
             ADD bx,[ANZBAUERS+edi]
             SHL bx,1h
             SUB ax,[BAUERNWERTE+ebx]
             MOV [X2],ax               ;Materialwert ohne Knige und Bauern
       
       ;----------------------- Statische Bewertung ----------------------------
BWSPOS:      MOV ax,[ANZFIGW+edi]      ;Ende nach X-Figuren
             MOV cl,al
             MOV bx,[ANZFIGS+edi]
             ADD cl,bl                 ;Gesamtzahl Kltzchen
             DEC al                    ;Knig weg
             DEC bl
             SUB ax,[ANZBAUERW+edi]    ;Bauern weg
             CMP al,3h
             JA l_noendspiel
             SUB bx,[ANZBAUERS+edi]
             CMP bl,3h
             JA l_noendspiel
             INC ah
NOENDSPIEL:  MOV [ENDSPIEL],ah         ;Null fr kein Endspiel
             MOV ch,cl                 ;Kltzchen WICHTIG!!!
 
             CMP [X2],146h
             JBE l_holze7              ;max.1 Lufer als Figur vorhanden, immer bewerten

             MOV dx,[ALPHA+edi]
             MOV ax,[X9]                 ;X9=MATx
             SHR ax,5h
             SHR [X9],3h
             SUB [X9],ax
             SUB dx,[X9]
      ;sub dx,200h      ;150
             CMP bp,dx
             JAE l_holze4
             CMP [COLOR],0h
             JE l_holze6
             NEG bp
             RET                       ;zu starkes Materialungleichgewicht
HOLZE4:      MOV dx,[BETA+edi]
             ADD dx,[X9]
      ;add dx,200h
             CMP bp,dx
             JBE l_holze7
             CMP [COLOR],0h
             JE l_holze6
HOLZE5:      NEG bp
HOLZE6:      RET                       ;zu starkes Materialungleichgewicht

HOLZE7:      XOR eax,eax
             MOV cl,1h
             MOV [ANZLW],al            ;fr Luferpaare, Outpost-Springer
             MOV [ANZLS],al
             MOV [ANZSW],al
             MOV [ANZSS],al
             MOV [OUTPFW],al
             MOV [OUTPFS],al
             MOV [WISDAME],al
             MOV [SISDAME],al
             MOV [WFIAFELD],al
             MOV [SFIAFELD],al
             MOV DWord[WTLINIE+1h],eax
             MOV DWord[WTLINIE+5h],eax
             MOV DWord[STLINIE+1h],eax
             MOV DWord[STLINIE+5h],eax
           
       ;-------------------------- weisser Knig -------------------------------
             MOV bx,ax
             MOV bl,[WKFELD]
             CMP [X1],0ffh
             JE l_nolsew               ;kein Lufer-Springer-Endspiel
             TEST [X1],2h              ;Bit 1 nur gesetzt, wenn schwarzer Knig allein
             JNZ l_statkoenigs
             TEST [X1],40h             ;weisser Knig ist allein
             JNZ l_wksl                ;Schwarz hat schwarzfeldrigen Lufer
             MOV al,[LSE1+ebx]         ;Schwarz hat weissfeldrigen Lufer
             SHL ax,3h
             SUB bp,ax
             JMP l_nolw
WKSL:        MOV al,[LSE2+ebx]
             SHL ax,3h
             SUB bp,ax
             JMP l_nolw
NOLSEW:      CMP [ENDSPIEL],bh
             JNE l_statkoenigwe        ;Endspielbewertung
             SHL bx,cl
             ADD bp,[SBWKO+ebx]        ;weisser Knig Erffnung
             SHR bx,cl
        
       ;------------- gegnerischer Lufer oder Dame auf Diagonale? -------------
             MOV di,bx
STKW3:       SUB di,9h
             MOV al,[ASTELL+edi]
             TEST al,8h
             JE l_stkw8                ;Randfeld
             AND al,87h
             CMP al,83h                ;schwarzer Lufer?
             JNE l_stkw6
             SUB bp,20h                ;schwarzer Lufer auf Diagonale
STKW6:       CMP al,85h                ;schwarze Dame?
             JNE l_stkw3
             SUB bp,30h
             JMP l_stkw3

STKW8:       MOV di,bx
STKW4:       SUB di,0bh
             MOV al,[ASTELL+edi]
             TEST al,8h
             JE l_stkw5                ;Randfeld
             AND al,87h
             CMP al,83h
             JNE l_stkw7
             SUB bp,20h                ;schwarzer Lufer auf Diagonale
STKW7:       CMP al,85h
             JNE l_stkw4
             SUB bp,30h
             JMP l_stkw4

STKW5:       CMP [ROCHSTATUSW],bh
             JNE l_wb01                ;schon rochiert
             TEST byte[ASTELL+ebx],20h
             JNZ l_rvw                 ;Knig schon bewegt
             TEST byte[ASTELL+3h+ebx],20h   ;Turm
             JZ l_wb0
RVW:         SUB bp,20h                ;Strafe fr kleine Rochade verloren
       JMP l_wb4     
             JMP l_wb01
WB0:         TEST byte[ASTELL-4h+ebx],20h   ;Turm
             JZ l_wb01
             SUB bp,10h                ;Strafe fr groe Rochade verloren
       JMP l_wb4
WB01:        TEST byte[WBSTELL-0ah+ebx],10h
             JZ l_wb1
             ADD bp,0ch                ;Bonus fr Bauernschutz
      MOV [WFIAFELD],80h
WB1:         TEST byte[WBSTELL-9h+ebx],10h
             JZ l_wb2
             ADD bp,0ch
      INC [WFIAFELD]
WB2:         TEST byte[WBSTELL-0bh+ebx],10h
             JZ l_wb3
             ADD bp,0ch
      INC [WFIAFELD]
WB3: ;CMP [WFIAFELD],80h
     ;JAE l_wb4
             TEST byte[WBSTELL-14h+ebx],10h
             JZ l_wb4
             ADD bp,6h

WB4:         MOV bl,[WKLINIE]
             CMP [WBLINIE+ebx],bh
             JNE l_wb5
             SUB bp,25h                ;kein eigener Bauer auf Knigslinie
WB5:         DEC bl
             JZ l_wb6
             CMP [WBLINIE+ebx],bh
             JNE l_wb6
             SUB bp,20h                ;auf linke Linie auch nicht
WB6:         ADD bl,2h
             CMP bl,8h
             JA l_statkoenigs
             CMP [WBLINIE+ebx],bh
             JNE l_statkoenigs
             SUB bp,20h                ;auf rechte Linie auch nicht
             JMP l_statkoenigs

       ;--------------------- weisser Knig Endspiel ---------------------------
STATKOENIGWE:SHL di,cl
             ADD bp,[SBKEW+edi]        ;WKFELD
             SHR di,cl

        ;--------- Opposition, nur bei weissem Knig! -------------------
             MOV al,[SKFELD]
             MOV bl,[WKFELD]
             SUB al,bl
             JNS l_statk1
             NEG al
STATK1:      MOV bx,[TIEFE]
             SHL bx,cl
             MOV dx,[ANZFIGW+ebx]
             DEC dx                    ;Knig weg
             CMP dx,[ANZBAUERW+ebx]
             JNE l_statk3
             MOV dx,[ANZFIGS+ebx]
             DEC dx
             CMP dx,[ANZBAUERS+ebx]
             JNE l_statk3
             MOV dx,4h                 ;reines Bauernendspiel
             JMP l_statk4
STATK3:      MOV dx,2h
STATK4:      CMP al,2h
             JE l_opp1
             CMP al,14h                ;20
             JE l_opp1
             CMP al,4h
             JE l_opp2
             CMP al,28h                ;40
             JE l_opp2
             CMP al,6h
             JE l_opp3
             CMP al,3ch                ;60
             JE l_opp3
             JMP l_statkoenigs         ;keinerlei Opposition
OPP1:        SHL dx,cl
OPP2:        SHL dx,cl
OPP3:        SHL dx,cl
             CMP [COLOR],0h
             JNE l_opp4
             NEG dx
OPP4:        ADD bp,dx

       ;----------------------- schwarzer Knig --------------------------------
STATKOENIGS: MOV bl,[SKFELD]
             CMP [X1],0ffh
             JE l_nolses               ;kein Lufer-Springer-Endspiel
             TEST [X1],40h             ;schwarzer Knig ist Einzelkmpfer
                                       ; von STATKOENIGW
             JNZ l_sksl                ;Weiss hat schwarzfeldrigen Lufer
             MOV al,[LSE1+ebx]         ;Weiss hat weissfeldrigen Lufer
             SHL ax,3h
             ADD bp,ax
             JMP l_nolw
SKSL:        MOV al,[LSE2+ebx]
             SHL ax,3h
             ADD bp,ax
             JMP l_nolw                ;es wird nur der schwarze Knig bewertet

NOLSES:      CMP [ENDSPIEL],bh
             JNE l_statkoenigse        ;Endspielbewertung
             SHL bx,cl
             SUB bp,[SBSKO+ebx]        ;schwarzer Knig
             SHR bx,cl

       ;------------- gegnerischer Lufer oder Dame auf Diagonale? -------------
             MOV di,bx
STKS3:       ADD di,9h
             MOV al,[ASTELL+edi]
             TEST al,8h
             JE l_stks8                ;Randfeld
             AND al,17h
             CMP al,13h                ;weisser Lufer?
             JNE l_stks6
             ADD bp,20h                ;weisser Lufer auf Diagonale
STKS6:       CMP al,15h                ;weisse Dame?
             JNE l_stks3
             ADD bp,30h
             JMP l_stks3

STKS8:       MOV di,bx
STKS4:       ADD di,0bh
             MOV al,[ASTELL+edi]
             TEST al,8h
             JE l_stks5                ;Randfeld
             AND al,17h
             CMP al,13h
             JNE l_stks7
             ADD bp,20h                ;weisser Lufer auf Diagonale
STKS7:       CMP al,15h
             JNE l_stks4
             ADD bp,30h
             JMP l_stks4

STKS5:       CMP [ROCHSTATUSS],bh
             JNE l_sb01                ;schon rochiert
             TEST byte[ASTELL+ebx],20h
             JNZ l_rvs                 ;Knig schon bewegt
             TEST byte[ASTELL+3h+ebx],20h   ;Turm
             JZ l_sb0
RVS:         ADD bp,20h                ;Strafe fr kleine Rochade verloren
             JMP l_sb01
SB0:         TEST byte[ASTELL-4h+ebx],20h   ;Turm
             JZ l_sb01
             ADD bp,10h                ;Strafe fr groe Rochade verloren

SB01:        TEST byte[SBSTELL+0ah+ebx],80h ;schwarzer Bauer?
             JZ l_sb1                  ;nein
             SUB bp,0ch                ;Bonus fr Bauernschutz
SB1:         TEST byte[SBSTELL+0bh+ebx],80h
             JZ l_sb2
             SUB bp,0ch
SB2:         TEST byte[SBSTELL+9h+ebx],80h
             JZ l_sb3
             SUB bp,0ch
SB3:         TEST byte[SBSTELL+14h+ebx],80h
             JZ l_sb4
             SUB bp,6h

SB4:         MOV bl,[SKLINIE]
             CMP [SBLINIE+ebx],bh
             JNE l_sb5
             ADD bp,25h                ;kein eigener Bauer auf Knigslinie
SB5:         DEC bl
             JZ l_sb6
             CMP [SBLINIE+ebx],bh
             JNE l_sb6
             ADD bp,20h                ;auf Nebenlinie auch nicht
SB6:         ADD bl,2h
             CMP bl,8h
             JA l_brettwert
             CMP [SBLINIE+ebx],bh
             JNE l_brettwert
             ADD bp,20h
             JMP l_brettwert

       ;--------------------- schwarzer Knig Endspiel -------------------------
STATKOENIGSE:SHL di,cl
             SUB bp,[SBKES+edi]
             SHR di,cl

       ;-------------------------- Restfiguren ---------------------------------
BRETTWERT:   CMP [ENDSPIEL],bh
             JNE l_brettwert1          ;ist Endspiel   sollte so bleiben!
             MOV [FATTDURCH],1h
                
             PUSHAD 
             CALL l_attackfeld
             POPAD 
BRETTWERT1:  MOV edi,62h               ;Beginn bei H1

ABRETTWS:    MOV al,[ASTELL+edi]
             AND ax,97h                ;Figur?
             JNZ l_statbauerw          ;ja
             DEC di
             JMP l_abrettws
;----------------------------- Ende TEVALANF -----------------------------------


;------------------------------- Anfang TEVALB ---------------------------------
       ;----------------------- weisser Bauer ----------------------------------
STATBAUERW:  CMP al,11h                ;weisser Bauer?
             JNE l_statbauers          ;nein
               
             CMP [ENDSPIEL],bh
             JNE l_statwb1
             CMP [COLOR],0h
             JE l_statwb1
             TEST byte[FELDATTACK+edi],0f0h;von schwarzer Figur angegriffen?
             JZ l_statwb1              ;nein
             TEST byte[FELDATTACK+edi],0fh ;von Weiss gedeckt?
             JNZ l_statwb1             ;ja
             SUB bp,64h
             JMP l_weiterfeldws2
STATWB1:     SHL di,cl
             ADD bp,[SBWB+edi]         ;Wert aus Bewertungstabelle holen
             MOV bl,[NFELD+edi]
             SHR di,cl
 
      ;cmp di,51h	       ;A2
      ;jae short STATBW2       ;in Grundstellung ist einiges witzlos
             MOV al,[ASTELL-9h+edi]
             AND al,87h
             CMP al,82h
             JB l_statbw7
             MOV al,[ASTELL-0bh+edi]
             AND al,87h
             CMP al,82h
             JB l_statbw7
             ADD bp,50h                ;Bauerngabel
        ;JMP l_weiterfeldws2
      
      ;mov di,TIEFE
      ;shl di,cl
      ;add [ERWEITERUNG+di],8h
STATBW7:     TEST byte[WBSTELL-0ah+edi],3h  ;Bit 0 und 1 testen
             JZ l_statbw1
             ADD bp,5h                 ;Bonus fr Bauern-Duo (oder Trio!)
STATBW1:     TEST byte[WBSTELL+edi],3h ; JEDER Bauer erhlt Bonus!
             JZ l_statbw2
             ADD bp,0ah                ;Bonus fr untersttzten Bauer
STATBW2:     CMP [ENDSPIEL],bh
             JNE l_bauendw             ;zur Endspielbewertung
       
       ;-------------- rckstndiger Bauer im Mittelspiel ----------------------
             TEST byte[WBSTELL-0ah+edi],10h
             JZ l_nostraf
             SUB bp,5h                 ;Extra-Strafe fr "direkten" Doppelbauern
NOSTRAF:     MOV al,[SBSTELL-0ah+edi]  ;es geht um das Feld vor dem Bauer!
             AND al,83h
             JZ l_statbw3              ;zu Test auf Freibauer
             AND al,3h   
             MOV dl,[WBSTELL-0ah+edi]
             AND dl,3h
             CMP al,dl
             JBE l_weiterfeldws2       ;ist kein rckstndiger Bauer
             SUB bp,0ah                ;Strafe fr rckstndigen Bauer
             OR byte[WBLINIE+ebx],10h  ;Merker-Bit fr rckstndigen Bauer
             CMP bl,2h                 ;B-Linie
             JBE l_weiterfeldws2
             CMP bl,7h                 ;G-Linie
             JAE l_weiterfeldws2
             SUB bp,5h        ;0ah     ;Extra-Strafe fr C-F-Linie
             JMP l_weiterfeldws2
       ;----------------- Freibauer im Mittelspiel -----------------------------
STATBW3:     MOV bx,di                 ;FELD
STATBW4:     SUB bx,0ah
             TEST byte[SBSTELL-0ah+ebx],83h
             JNZ l_weiterfeldws2       ;kein Freibauer
             CMP bx,29h                ;A6
             JAE l_statbw4
             MOV bx,di                 ;Freibauer
             SHL bx,cl
             MOV al,[NFELD+1h+ebx]     ;Reihe
             CMP al,6h
             JB l_statbw5
             TEST byte[ASTELL-0ah+edi],7h
             JNZ l_statbw5
             ADD bp,40h                ;Bonus fr beweglichen vorderen Freibauer
STATBW5:     SHL al,3h                 ;Bonuswert in Mittelspiel (oder Tabelle!)
             ADD bp,ax
             MOV bl,[NFELD+ebx]        ;Linie
             OR byte[WBLINIE+ebx],20h  ;Bit fr Freibauer setzen
             TEST byte[WBSTELL+edi],3h
             JNZ l_statbw6             ;durch anderen Bauer gedeckt
             TEST byte[WBSTELL-0ah+edi],3h
             JZ l_weiterfeldws2
STATBW6:     SHR al,cl                 ;2*Reihe
             ADD bp,ax                 ;Bonus fr gesttzten oder beweglichen
             JMP l_weiterfeldws2       ; Freibauer
       ;----------------------- Endspielbewertung ------------------------------
BAUENDW:     SHL di,cl
             MOV al,[NFELD+1h+edi]     ;Reihe
             SHR di,cl
             MOV bx,di
BAUENDW1:    SUB bx,0ah
             TEST byte[SBSTELL+ebx],83h;offene Linie?
             JNZ l_nofreibw            ;nein, kein Freibauer
             CMP bx,29h                ;A6
             JAE l_bauendw1
             MOV [X1],al
        ;--------------- Freibauer ------------------
             MOV bx,[TIEFE]
             SHL bx,1h
             MOV dx,[ANZFIGW+ebx]
             DEC dx                    ;Knig
             CMP dx,[ANZBAUERW+ebx]
             JNE l_bauendw7
             MOV dx,[ANZFIGS+ebx]
             DEC dx
             CMP dx,[ANZBAUERS+ebx]
             JNE l_bauendw7
             SHL al,3h                 ;*8
             ADD bp,ax                 ;Freibauerbonus im reinen Bauernendspiel
      ;JMP l_weiterfeldws2 
       ;------------------------- Quadratregel ---------------------------------
             MOV bx,di
             CMP bx,4eh                ;H3
             JBE l_quadratw1
             SUB bx,0ah                ;wegen mglichem Doppelschritt
QUADRATW1:   CMP [COLOR],bh
             JE l_quadratw2
             ADD bx,0ah                ;ein Feld zurck
QUADRATW2:   SHL bx,cl
             MOV ax,word[NFELD+ebx]    ;AL=Linie, AH=Reihe
             MOV bl,[WKFELD]
             SHL bx,cl
             MOV dx,word[NFELD+ebx]
             CMP ah,dh
             JA l_quadratw4            ;Bauer ist durch
             MOV dh,9h
             SUB dh,ah
             MOV ah,dh
             SUB dl,al
             JNC l_quadratw3
             NEG dl
QUADRATW3:   CMP ah,dl
             JA l_weiterfeldws2
QUADRATW4:   ADD bp,200h               ;damit Drohung nicht hher bewertet
             MOV al,[X1]               ; als die Ausfhrung
             SHL al,4h                 ;*16
             XOR ah,ah
             ADD bp,ax
             JMP l_weiterfeldws2
       ;-------------------------------------------------------

BAUENDW7:    MOV al,[X1]               ;Reihe
             CMP al,6h
             JB l_bauendw2
             TEST byte[ASTELL-0ah+edi],7h
             JNZ l_bauendw2
             ADD bp,80h                ;Bonus fr vorgerckten Freibauer
BAUENDW2:    SHL al,4h                 ;*16
             ADD bp,ax                 ;Bonus fr Freibauer im Endspiel
             SHL di,cl
             MOV bl,[NFELD+edi]
             SHR di,cl
             SHR al,2h                 ;wieder *4
             OR byte[WBLINIE+ebx],20h  ;Bit fr Freibauer
       ;mov bx,TIEFE
       ;mov dl,[ZFELD+ebx]
       ;xor dh,dh
       ;cmp si,dx
       ;jne short BAUENDW3
       ;mov FREIBAUERZUG,1h      ;war letzter Zug
             JMP l_bauendw3

NOFREIBW:    MOV dh,[SBSTELL-0ah+edi]  ;es geht um das Feld vor dem Bauer!
             AND dh,3h
             MOV dl,[WBSTELL-0ah+edi]
             AND dl,3h
             CMP dh,dl
             JBE l_bauendw3            ;ist kein rckstndiger Bauer
             SUB bp,0ah                ;Strafe fr rckstndigen Bauer
             SHL di,cl
             MOV bl,[NFELD+edi]
             SHR di,cl
             OR byte[WBLINIE+ebx],10h  ;Bit fr rckstndigen Bauer
             JMP l_weiterfeldws2

BAUENDW3:    TEST byte[WBSTELL+edi],3h
             JZ l_bauendw4
             ADD bp,ax                 ;gesttzter Bauer
BAUENDW4:    TEST byte[WBSTELL-0ah+edi],3h
             JZ l_bauendw5
             ADD bp,ax                 ;bewegl. Bauer

BAUENDW5:    TEST byte[ASTELL-0ah+edi],80h
             JZ l_weiterfeldws2        ;Bauer nicht blockiert
             TEST byte[WBSTELL-0ah+edi],3h
             JNZ l_weiterfeldws2
             SUB bp,ax                 ;Bauer blockiert
             JMP l_weiterfeldws2

       ;----------------------- schwarzer Bauer --------------------------------
STATBAUERS:  CMP al,81h                ;schwarzer Bauer?
             JNE l_statspringer        ;nein
             CMP [ENDSPIEL],bh
             JNE l_statbs8
             CMP [COLOR],0h
             JNE l_statbs8
             TEST byte[FELDATTACK+edi],0fh  ;von weisser Figur angegriffen?
             JZ l_statbs8              ;nein
             TEST byte[FELDATTACK+edi],0f0h ;von Schwarz gedeckt?
             JNZ l_statbs8             ;ja
             ADD bp,64h
             JMP l_weiterfeldws2
STATBS8:     SHL di,cl
             SUB bp,[SBSB+edi]         ;Wert aus Bewertungstabelle holen
             MOV bl,[NFELD+edi]        ;Linie
             SHR di,cl
      ;cmp si,26h	       ;H7
      ;jbe short STATBS2
             MOV al,[ASTELL+9h+edi]
             AND al,17h
             CMP al,12h
             JB l_statbs7
             MOV al,[ASTELL+0bh+edi]
             AND al,17h
             CMP al,12h
             JB l_statbs7
             SUB bp,50h                ;Bauerngabel
         ;JMP l_weiterfeldws2
      
      ;mov di,TIEFE
      ;shl di,cl
      ;add [ERWEITERUNG+di],8
STATBS7:     TEST byte[SBSTELL+0ah+edi],3h
             JZ l_statbs1
             SUB bp,5h                 ;Bonus fr Duo
STATBS1:     TEST byte[SBSTELL+edi],3h ; JEDER Bauer erhlt Bonus!
             JZ l_statbs2
             SUB bp,0ah                ;Bonus fr untersttzten Bauer
STATBS2:     CMP [ENDSPIEL],0h
             JNE l_bauends             ;zur Endspielbewertung
       ;---------------- rckstndiger Bauer im Mittelspiel --------------------
             TEST byte[SBSTELL+0ah+edi],80h
             JZ l_nostrafs
             ADD bp,5h                 ;Extra-Strafe fr "direkten" Doppelbauern
NOSTRAFS:    MOV al,[WBSTELL+0ah+edi]
             AND al,13h
             JZ l_statbs3              ;Freibauer?
             AND al,3h    
             MOV dl,[SBSTELL+0ah+edi]
             AND dl,3h
             CMP al,dl
             JBE l_weiterfeldws2       ;ist kein rckstndiger Bauer
             ADD bp,0ah                ;Strafe fr rckstndigen Bauer
             OR byte[SBLINIE+ebx],10h  ;Merker-Bit fr rckstndigen Bauer
             CMP bl,2h                 ;B-Linie
             JBE l_weiterfeldws2
             CMP bl,7h                 ;G-Linie
             JAE l_weiterfeldws2
             ADD bp,5h        ;0a      ;Extra-Strafe fr C-F-Linie
             JMP l_weiterfeldws2
       ;---------------- Freibauer im Mittelspiel ------------------------------
STATBS3:     MOV bx,di
STATBS4:     ADD bx,0ah
             TEST byte[WBSTELL+0ah+ebx],13h
             JNZ l_weiterfeldws2       ;kein Freibauer
             CMP bx,4eh                ;H3
             JBE l_statbs4
             MOV bx,di                 ;Freibauer
             SHL bx,cl
             MOV ax,9h
             SUB al,[NFELD+1h+ebx]     ;Reihe
             CMP al,6h
             JB l_statbs5
             TEST byte[ASTELL+0ah+edi],7h
             JNZ l_statbs5
             SUB bp,40h
STATBS5:     SHL al,3h                 ;Bonuswert in Mittelspiel (oder Tabelle!)
             SUB bp,ax
             MOV bl,[NFELD+ebx]        ;Linie
             OR byte[SBLINIE+ebx],20h  ;Bit fr Freibauer setzen
             TEST byte[SBSTELL+edi],3h
             JNZ l_statbs6
             TEST byte[SBSTELL+0ah+edi],3h
             JZ l_weiterfeldws2
STATBS6:     SHR al,cl                 ;2*Reihe
             SUB bp,ax                 ;Bonus fr gesttzten oder bewegl.Bauern
             JMP l_weiterfeldws2
       
       ;------------------------- Endspiel -------------------------------------
BAUENDS:     MOV al,9h                 ;wegen Berechnung Bewertung!
             SHL di,cl
             SUB al,[NFELD+1h+edi]     ;Reihe
             SHR di,cl
             MOV bx,di
BAUENDS1:    ADD bx,0ah
             TEST byte[WBSTELL+ebx],13h;offene Linie?
             JNZ l_nofreibs            ;nein, kein Freibauer
             CMP bx,4eh                ;H3
             JBE l_bauends1
             MOV [X1],al
        ;-------------------- Freibauer ----------
             MOV bx,[TIEFE]
             SHL bx,1h
             MOV dx,[ANZFIGS+ebx]
             DEC dx                    ;Knig
             CMP dx,[ANZBAUERS+ebx]
             JNE l_bauends7
             MOV dx,[ANZFIGW+ebx]
             DEC dx
             CMP dx,[ANZBAUERW+ebx]
             JNE l_bauends7
             SHL al,3h                 ;*8
             SUB bp,ax                 ;Freibauerbonus im reinen Bauernendspiel
      ;JMP l_weiterfeldws2
       ;------------------------- Quadratregel ---------------------------------
             MOV bx,di
             CMP bx,29h                ;A6
             JAE l_quadrats1
             ADD bx,0ah                ;wegen mglichem Doppelschritt
QUADRATS1:   CMP [COLOR],bh
             JNE l_quadrats2
             SUB bx,0ah
QUADRATS2:   SHL bx,cl
             MOV ax,word[NFELD+ebx]    ;AL=Linie, AH=Reihe Bauer
             MOV bl,[WKFELD]
             SHL bx,cl
             MOV dx,word[NFELD+ebx]    ;weisser Knig
             CMP ah,dh
             JB l_quadrats4            ;Bauer ist durch
             SUB dl,al
             JNC l_quadrats3
             NEG dl
QUADRATS3:   CMP ah,dl
             JA l_weiterfeldws2        ;weisser Knig ist im Quadrat
QUADRATS4:   SUB bp,200h
             MOV al,[X1]
             SHL al,4h                 ;*16
             XOR ah,ah
             SUB bp,ax
             JMP l_weiterfeldws2
       ;-------------------------------------------------------

BAUENDS7:    MOV al,[X1]
             CMP al,6h
             JB l_bauends2
             TEST byte[ASTELL+0ah+edi],7h
             JNZ l_bauends2
             SUB bp,80h                ;Bonus fr vorgerckten Freibauer
BAUENDS2:    SHL al,4h                 ;*16
             SUB bp,ax                 ;Bonus fr Freibauer im Endspiel
             SHL di,cl
             MOV bl,[NFELD+edi]
             SHR di,cl         
             SHR al,2h                 ;wieder *4
             OR byte[SBLINIE+ebx],20h  ;Bit fr Freibauer
       ;mov bx,TIEFE
       ;mov dl,[ZFELD+ebx]
       ;xor dh,dh
       ;cmp si,dx
       ;jne short BAUENDS3
       ;mov FREIBAUERZUG,1h      ;war letzter Zug
             JMP l_bauends3

NOFREIBS:    MOV dh,[WBSTELL+0ah+edi]  ;es geht um das Feld vor dem Bauer!
             AND dh,3h
             MOV dl,[SBSTELL+0ah+edi]
             AND dl,3h
             CMP dh,dl
             JBE l_bauends3            ;ist kein rckstndiger Bauer
             ADD bp,0ah                ;Strafe fr rckstndigen Bauer 
             SHL di,cl
             MOV bl,[NFELD+edi]
             SHR di,cl
             OR byte[SBLINIE+ebx],10h  ;Bit fr rckstndigen Bauer
             JMP l_weiterfeldws2

BAUENDS3:    TEST byte[SBSTELL+edi],3h
             JZ l_bauends4
             SUB bp,ax                 ;gesttzter Bauer
BAUENDS4:    TEST byte[SBSTELL+0ah+edi],3h
             JZ l_bauends5
             SUB bp,ax                 ;bewegl. Bauer

BAUENDS5:    TEST byte[ASTELL+0ah+edi],10h
             JZ l_weiterfeldws2        ;Bauer nicht blockiert
             TEST byte[SBSTELL+0ah+edi],3h
             JNZ l_weiterfeldws2
             ADD bp,ax                 ;Bauer blockiert
             JMP l_weiterfeldws2
;-------------------------------- Ende TEVALB ----------------------------------

;------------------------------- Anfang TEVALS ---------------------------------
       ;----------------------- weisser Springer -------------------------------
STATSPRINGER:CMP al,12h                ;weisser Springer?
             JNE l_statspringers       ;nein
             SHL di,cl
             ADD bp,[SBSW+edi]         ;Wert fr Zentralisierung
             SHR di,cl
             INC [ANZSW]
        ;--------- Test auf eigene blockierte Zentrumsbauern ------------
             CMP di,4ah                ;D3?
             JE l_blockw1
             CMP di,4bh                ;E3?
             JNE l_outpw0
             CMP byte[WBSTELL+55h],10h ;weisser Bauer auf E2?
             JNE l_outpw0
             SUB bp,0ch
             JMP l_outpw0
BLOCKW1:     CMP byte[WBSTELL+54h],10h ;weisser Bauer auf D2?
             JNE l_outpw0
             SUB bp,0ch
;-------------------------------------------------------------------------------
OUTPW0:      CMP byte[OUTPW+edi],0h
             JE l_mobws1
             TEST byte[SBSTELL+edi],3h
             JNZ l_mobws1              ;schwarzer Bauer knnte sofort schlagen
        ;-------- Test auf gegnerische blockierte Zentrumsbauern --------
             CMP di,2ch                ;D6?
             JE l_blockw2
             CMP di,2dh                ;E6?
             JNE l_blockw3
             CMP byte[SBSTELL+23h],80h ;schwarzer Bauer auf E7?
             JNE l_blockw3
             ADD bp,0ch
             JMP l_blockw3
BLOCKW2:     CMP byte[SBSTELL+22h],80h ;schwarzer Bauer auf D7?
             JNE l_blockw3
             ADD bp,0ch
        ;------------------ weiter mit Outpost --------------------------
BLOCKW3:     TEST byte[WBSTELL+edi],3h
             JZ l_mobws1               ;nicht von eigenen Bauern gedeckt
             MOV bx,di
             SUB bx,9h
OUTPW1:      SUB bx,0ah
             CMP bx,1fh                ;A7
             JB l_outpw2
             TEST byte[SBSTELL+ebx],80h
             JNZ l_mobws1              ;schwarzer Bauer seitlich
             JMP l_outpw1
OUTPW2:      MOV bx,di
             SUB bx,0bh
OUTPW3:      SUB bx,0ah
             CMP bx,1fh                ;A7
             JB l_outpw4
             TEST byte[SBSTELL+ebx],80h
             JNZ l_mobws1              ;schwarzer Bauer seitlich
             JMP l_outpw3
OUTPW4:      MOV al,[OUTPW+edi]        ;ist Outpost!
             ADD bp,ax
             CMP [LSTELL+edi],bh
             JE l_outpw5
             OR [OUTPFW],2h            ;schwarzes Feld
             JMP l_outpw6
OUTPW5:      OR [OUTPFW],1h            ;weisses Feld
OUTPW6:      TEST byte[WBSTELL+edi],2h
             JZ l_weiterfeldws2
             SHR al,cl
             ADD bp,ax                 ;Outpost von 2 Bauern gedeckt
             JMP l_weiterfeldws2

        ;------------------- Mobilitt ----------------------------------
MOBWS1:       ;cmp ENDSPIEL,bh
     JMP l_weiterfeldws2       ;ist Endspiel
;       SUB bp,8h
;       MOV X2,bp
;        TEST [ASTELL-15h+si],18h  ;Randfeld oder eigene Figur?
;        JNZ short MOBWS2        ;ja
;        TEST [ASTELL-15h+si],6h
;        JNZ short P1        ;schwarze Figur auf Zielfeld
;        TEST [FELDATTACK-15h+si],0f0h
;        JNZ short MOBWS2        ;Zielfeld wird von Schwarz bedroht
;P1:    INC bp
;MOBWS2:        TEST [ASTELL-13h+si],18h
;        JNZ short MOBWS4
;        TEST [ASTELL-13h+si],6h
;        JNZ short P2
;        TEST [FELDATTACK-13h+si],0f0h
;        JNZ short MOBWS4
;P2:    INC bp
;MOBWS4:        TEST [ASTELL-8h+si],18h
;        JNZ short MOBWS6
;        TEST [ASTELL-8h+si],6h
;        JNZ short P3
;        TEST [FELDATTACK-8h+si],0f0h
;        JNZ short MOBWS6
;P3:    INC bp
;MOBWS6:        TEST [ASTELL-0ch+si],18h
;        JNZ short MOBWS8
;        TEST [ASTELL-0ch+si],6h
;        JNZ short P4
;        TEST [FELDATTACK-0ch+si],0f0h
;        JNZ short MOBWS8
;P4:    INC bp
;MOBWS8:        TEST [ASTELL+15h+si],18h
;        JNZ short MOBWS10
;        TEST [ASTELL+15h+si],6h
;        JNZ short P5
;        TEST [FELDATTACK+15h+si],0f0h
;        JNZ short MOBWS10
;P5:    INC bp
;MOBWS10:       TEST [ASTELL+13h+si],18h
;        JNZ short MOBWS12
;        TEST [ASTELL+13h+si],6h
;        JNZ short P6
;        TEST [FELDATTACK+13h+si],0f0h
;        JNZ short MOBWS12
;P6:    INC bp
;MOBWS12:       TEST [ASTELL+8h+si],18h
;        JNZ short MOBWS14
;        TEST [ASTELL+8h+si],6h
;        JNZ short P7
;        TEST [FELDATTACK+8h+si],0f0h
;        JNZ short MOBWS14
;P7:    INC bp
;MOBWS14:       TEST [ASTELL+0ch+si],18h
;        JNZ short MOBWS16
;        TEST [ASTELL+0ch+si],6h
;        JNZ short P8
;        TEST [FELDATTACK+0ch+si],0f0h
;        JNZ short MOBWS16
;P8:    INC bp
;MOBWS16:      ;sub bp,14h	       ;Strafe fr keine Beweglichkeit
;       CMP X2,bp
;       JNE short MOBWS17
;       SUB bp,14h
;       ;test [SBSTELL+si],3h     ;von schwarzen Bauer angegriffen?
;       ;jz short MOBWS17        ;nein
;       ;sub bp,150h	       ;Strafe fr kein Fluchtfeld
;       ;jmp WEITERFELDWS2
;
;MOBWS17:      ;test [FELDATTACK+si],0f0h;von schwarzer Figur angegriffen?
;       ;jz short MOBWS18        ;nein
;       ;test [FELDATTACK+si],0fh ;von Weiss gedeckt?
;       ;jnz WEITERFELDWS2       ;ja
;       ;sub bp,150h
;       ;jmp WEITERFELDWS2;
;
;        TEST [FELDATTACK+si],0f0h;von schwarzer Figur angegriffen?
;        JZ short MOBWS18        ;nein
;        SUB bp,0ah        ;Strafe
;        TEST [FELDATTACK+si],0fh ;von Weiss gedeckt?
;        JZ short MOBWS18        ;nein
;        ADD bp,8h         ;Bonus
;
;MOBWS18:       TEST [WBSTELL+si],3h     ;vom eigenen Bauern gedeckt?
;        JZ WEITERFELDWS2        ;nein
;        ADD bp,0ah        ;ja, zarter Bonus
;        JMP WEITERFELDWS2

       ;----------------------- schwarzer Springer -----------------------------
STATSPRINGERS:CMP al,82h               ;schwarzer Springer?
             JNE l_statlaeufer         ;nein
             SHL di,cl
             SUB bp,[SBSS+edi]
             SHR di,cl
             INC [ANZSS]
        ;--------- Test auf eigene blockierte Zentrumsbauern ------------
             CMP di,2ch                ;D6?
             JE l_blocks1
             CMP di,2dh                ;E6?
             JNE l_outps0
             CMP byte[SBSTELL+23h],80h ;schwarzer Bauer auf E7?
             JNE l_outps0
             ADD bp,0ch
             JMP l_outps0
BLOCKS1:     CMP byte[SBSTELL+22h],80h ;schwarzer Bauer auf D7?
             JNE l_outps0
             ADD bp,0ch
        ;----------------------- Outpost-Teil ---------------------------
OUTPS0:      CMP byte[OUTPS+edi],0h
             JE l_mobss1
             TEST byte[WBSTELL+edi],3h
             JNZ l_mobss1              ;weisser Bauer knnte sofort schlagen
        ;-------- Test auf gegnerische blockierte Zentrumsbauern --------
             CMP di,4ah                ;D3?
             JE l_blocks2
             CMP di,4bh                ;E3?
             JNE l_blocks3
             CMP byte[WBSTELL+55h],10h ;weisser Bauer auf E2?
             JNE l_blocks3
             SUB bp,0ch
             JMP l_blocks3
BLOCKS2:     CMP byte[WBSTELL+54h],10h ;weisser Bauer auf D2?
             JNE l_blocks3
             SUB bp,0ch
        ;------------------ weiter mit Outpost --------------------------
BLOCKS3:     TEST byte[SBSTELL+edi],3h
             JZ l_mobss1               ;nicht von eigenen Bauern gedeckt
             MOV bx,di
             ADD bx,9h
OUTPS1:      ADD bx,0ah
             CMP bx,58h                ;H2
             JA l_outps2
             TEST byte[WBSTELL+ebx],10h
             JNZ l_mobss1              ;weisser Bauer seitlich
             JMP l_outps1
OUTPS2:      MOV bx,di
             ADD bx,0bh
OUTPS3:      ADD bx,0ah
             CMP bx,58h                ;H2
             JA l_outps4
             TEST byte[WBSTELL+ebx],10h
             JNZ l_mobss1              ;weisser Bauer seitlich
             JMP l_outps3
OUTPS4:      MOV al,[OUTPS+edi]        ;ist Outpost!
             SUB bp,ax
             CMP [LSTELL+edi],bh
             JE l_outps5
             OR [OUTPFS],2h            ;schwarzes Feld
             JMP l_outps6
OUTPS5:      OR [OUTPFS],1h            ;weisses Feld
OUTPS6:      TEST byte[SBSTELL+edi],2h
             JZ l_weiterfeldws2
             SHR al,cl
             SUB bp,ax                 ;Outpost von 2 Bauern gedeckt
             JMP l_weiterfeldws2

        ;----------------- Mobilitt ------------------------------------
MOBSS1:       ;cmp ENDSPIEL,bh
    JMP l_weiterfeldws2
;         ADD bp,8h
;       MOV X2,bp
;        TEST [ASTELL-15h+si],88h  ;Randfeld oder eigene Figur?
;        JNZ short MOBSS2        ;ja
;        TEST [ASTELL-15h+si],6h
;        JNZ short Q1        ;weisse Figur auf Zielfeld
;        TEST [FELDATTACK-15h+si],0fh
;        JNZ short MOBSS2        ;Zielfeld wird von Weiss bedroht
;Q1:    DEC bp
;MOBSS2:        TEST [ASTELL-13h+si],88h
;        JNZ short MOBSS4
;        TEST [ASTELL-13h+si],6h
;        JNZ short Q2
;        TEST [FELDATTACK-13h+si],0fh
;        JNZ short MOBSS4
;Q2:    DEC bp
;MOBSS4:        TEST [ASTELL-8h+si],88h
;        JNZ short MOBSS6
;        TEST [ASTELL-8h+si],6h
;        JNZ short Q3
;        TEST [FELDATTACK-8h+si],0fh
;        JNZ short MOBSS6
;Q3:    DEC bp
;MOBSS6:        TEST [ASTELL-0ch+si],88h
;        JNZ short MOBSS8
;        TEST [ASTELL-0ch+si],6h
;        JNZ short Q4
;        TEST [FELDATTACK-0ch+si],0fh
;        JNZ short MOBSS8
;Q4:    DEC bp
;MOBSS8:        TEST [ASTELL+15h+si],88h
;        JNZ short MOBSS10
;        TEST [ASTELL+15h+si],6h
;        JNZ short Q5
;        TEST [FELDATTACK+15h+si],0fh
;        JNZ short MOBSS10
;Q5:    DEC bp
;MOBSS10:       TEST [ASTELL+13h+si],88h
;        JNZ short MOBSS12
;        TEST [ASTELL+13h+si],6h
;        JNZ short Q6
;        TEST [FELDATTACK+13h+si],0fh
;        JNZ short MOBSS12
;Q6:    DEC bp
;MOBSS12:       TEST [ASTELL+8h+si],88h
;        JNZ short MOBSS14
;        TEST [ASTELL+8h+si],6h
;        JNZ short Q7
;        TEST [FELDATTACK+8h+si],0fh
;        JNZ short MOBSS14
;Q7:    DEC bp
;MOBSS14:       TEST [ASTELL+0ch+si],88h
;        JNZ short MOBSS16
;        TEST [ASTELL+0ch+si],6h
;        JNZ short Q8
;        TEST [FELDATTACK+0ch+si],0fh
;        JNZ short MOBSS16
;Q8:    DEC bp
;MOBSS16:      ;add bp,14h	       ;Strafe fr keine Beweglichkeit
;       CMP X2,bp
;       JNE short MOBSS17
;       ADD bp,14h
;       ;test [WBSTELL+si],3h     ;von weissen Bauer angegriffen?
;       ;jz short MOBSS17        ;nein
;       ;add bp,150h	       ;Strafe fr kein Fluchtfeld
;       ;jmp WEITERFELDWS2;
;
;MOBSS17:      ;test [FELDATTACK+si],0fh ;von weisser Figur angegriffen?
;       ;jz short MOBSS18        ;nein
;       ;test [FELDATTACK+si],0f0h;von Schwarz gedeckt?
;       ;jnz WEITERFELDWS2       ;ja
;       ;add bp,150h
;       ;jmp WEITERFELDWS2
;
;        TEST [FELDATTACK+si],0fh ;von weisser Figur angegriffen?
;        JZ short MOBSS18        ;nein
;        ADD bp,0ah        ;Strafe
;        TEST [FELDATTACK+si],0f0h;von Schwarz gedeckt?
;        JZ short MOBSS18        ;nein
;        SUB bp,8h         ;Bonus;
;
;MOBSS18:       TEST [SBSTELL+si],3h     ;vom eigenen Bauern gedeckt?
;        JZ WEITERFELDWS2;
;        SUB bp,0ah        ;ja, zarter Bonus
;        JMP WEITERFELDWS2
;------------------------------- Ende TEVALS -----------------------------------

;------------------------------- Anfang TEVALL ---------------------------------
       ;----------------------- weisser Lufer ---------------------------------
STATLAEUFER: CMP al,13h                ;weisser Lufer?
             JNE l_statlaeufers        ;nein
             SHL di,cl
             ADD bp,[SBLW+edi]
             SHR di,cl
        ;--------- Test auf eigene blockierte Zentrumsbauern ------------
             CMP di,4ah                ;D3?
             JE l_blocklw1
             CMP di,4bh                ;E3?
             JNE l_blocklw2
             CMP byte[WBSTELL+55h],10h ;weisser Bauer auf E2?
             JNE l_paarlw
             SUB bp,0ch
             JMP l_paarlw
BLOCKLW1:    CMP byte[WBSTELL+54h],10h ;weisser Bauer auf D2?
             JNE l_paarlw
             SUB bp,0ch
             JMP l_paarlw
        ;-------- Test auf gegnerische blockierte Zentrumsbauern --------
BLOCKLW2:    TEST byte[SBSTELL+edi],3h
             JNZ l_paarlw              ;schwarzer Bauer knnte sofort schlagen
             CMP di,2ch                ;D6?
             JE l_blocklw3
             CMP di,2dh                ;E6?
             JNE l_paarlw
             CMP byte[SBSTELL+23h],80h ;schwarzer Bauer auf E7?
             JNE l_paarlw
             ADD bp,0ch
             JMP l_paarlw
BLOCKLW3:    CMP byte[SBSTELL+22h],80h ;schwarzer Bauer auf D7?
             JNE l_paarlw
             ADD bp,0ch
        ;------------- Farbe Luferfeld fr Outpost, Luferpaar und Fianchetto ---------
PAARLW:      CMP [LSTELL+edi],ah
             JE l_statlaeuferw1
             OR [ANZLW],2h             ;schwarzes Feld
             JMP l_mobwl0
STATLAEUFERW1:OR [ANZLW],1h            ;weisses Feld
       ;------------------------ Mobilitt -------------------------------------
MOBWL0: JMP l_weiterfeldws2

;             CMP ENDSPIEL,bh
;             JNE l_weiterfeldws2
        ;---------------- Test auf Fianchetto-Lufer --------------------
;             CMP di,57h                ;G2?
;             JNE l_mobwl21
;             CMP WKFELD,61h            ;G1?
;             JE l_mobwl20
;             CMP WKFELD,62h            ;H1
;             JNE l_mobwl22
;MOBWL20:     ADD bp,25h;20h                ;Bonus fr Fianchettolufer
;             JMP l_mobwl22
;MOBWL21:     CMP di,52h                ;B2
;             JNE l_mobwl22
;             CMP WKFELD,5bh            ;A1
;             JE l_mobwl23
;             CMP WKFELD,5ch            ;B1
;             JE l_mobwl23
;             CMP WKFELD,5dh            ;C1
;             JNE l_mobwl22
;MOBWL23:     ADD bp,25h;20h
;MOBWL22:     ;MOV bx,si

;   JMP l_weiterfeldws2


;MOBWL1:        SUB bl,0bh        ;nach links oben
;        MOV al,[ASTELL+bx]
;        TEST al,18        ;Randfeld oder eigene Figur?
;        JNZ short MOBWL2        ;ja, nchste Richtung
;        TEST [FELDATTACK+bx],0f0
;        JZ short MOBWL30
;        TEST al,4
;        JNZ short MOBWL3
;        TEST al,7
;        JNZ short MOBWL4
;        JMP MOBWL1
;MOBWL30:       TEST al,7
;        JNZ MOBWL19
;        INC bp
;        JMP MOBWL1
;MOBWL2:        TEST al,4
;        JZ short MOBWL4
;MOBWL3:        ADD bp,10;
;
;MOBWL4:        MOV bx,si
;MOBWL5:        SUB bl,9
;        MOV al,[ASTELL+bx]
;        TEST al,18
;        JNZ short MOBWL6
;        TEST [FELDATTACK+bx],0f0
;        JZ short MOBWL31
;        TEST al,4
;        JNZ short MOBWL7
;        TEST al,7
;        JNZ short MOBWL8
;        JMP MOBWL5
;MOBWL31:       TEST al,7
;        JNZ MOBWL19
;        INC bp
;        JMP MOBWL5
;MOBWL6:        TEST al,4
;        JZ short MOBWL8
;MOBWL7:        ADD bp,10;
;
;MOBWL8:        MOV bx,si
;MOBWL9:        ADD bl,0bh
;        MOV al,[ASTELL+bx]
;        TEST al,18
;        JNZ short MOBWL10
;        TEST [FELDATTACK+bx],0f0
;        JZ short MOBWL32
;        TEST al,4
;        JNZ short MOBWL11
;        TEST al,7
;        JNZ short MOBWL12
;        JMP MOBWL9
;MOBWL32:       TEST al,7
;        JNZ short MOBWL19
;        INC bp
;        JMP MOBWL9
;MOBWL10:       TEST al,4
;        JZ short MOBWL12
;MOBWL11:       ADD bp,10;
;
;MOBWL12:       MOV bx,si
;MOBWL13:       ADD bl,9
;        MOV al,[ASTELL+bx]
;        TEST al,18
;        JNZ short MOBWL14
;        TEST [FELDATTACK+bx],0f0
;        JZ short MOBWL33
;        TEST al,4
;        JNZ short MOBWL15
;        TEST al,7
;        JNZ short MOBWL16
;        JMP MOBWL13
;MOBWL33:       TEST al,7
;        JNZ short MOBWL19
;        INC bp
;        JMP MOBWL13
;MOBWL14:       TEST al,4
;        JZ short MOBWL16
;MOBWL15:       ADD bp,10
;        JMP short MOBWL17;
;
;MOBWL16:       SUB bp,14        ;Strafe fr keine Beweglichkeit
;       ;test [SBSTELL+si],3     ;von schwarzen Bauer angegriffen?
;       ;jz short MOBWL17        ;nein
;       ;sub bp,150	       ;Strafe fr kein Fluchtfeld
;       ;jmp WEITERFELDWS2;
;
;MOBWL17:      ;test [FELDATTACK+si],0f0;von schwarzer Figur angegriffen?
;       ;jz short MOBWL18        ;nein
;       ;test [FELDATTACK+si],0f ;von Weiss gedeckt?
;       ;jnz WEITERFELDWS2       ;ja
;       ;sub bp,150
;       ;jmp WEITERFELDWS2;
;
;        TEST [FELDATTACK+si],0f0;von schwarzer Figur angegriffen?
;        JZ short MOBWL18        ;nein
;        SUB bp,0a        ;Strafe
;        TEST [FELDATTACK+si],0f ;von Weiss gedeckt?
;        JZ short MOBWL18        ;nein
;        ADD bp,8         ;Bonus
;
;MOBWL18:       TEST [WBSTELL+si],3     ;vom eigenen Bauern gedeckt?
;        JZ WEITERFELDWS2
;        ADD bp,0a        ;ja, zarter Bonus
;        JMP WEITERFELDWS2
;
;MOBWL19:       CMP COLOR,bh
;        JNE WEITERFELDWS2
;        ADD bp,10        ;schwarzer Stein hngt
 ;       JMP WEITERFELDWS2

       ;----------------------- schwarzer Lufer -------------------------------
STATLAEUFERS:CMP al,83h        ;schwarzer Lufer?
             JNE l_statturm
             SHL di,1h
             SUB bp,[SBLS+edi]
             SHR di,1h
        ;--------- Test auf eigene blockierte Zentrumsbauern ------------
             CMP di,2ch                ;D6?
             JE l_blockls1
             CMP di,2dh                ;E6?
             JNE l_blockls2
             CMP byte[SBSTELL+23h],80h ;schwarzer Bauer auf E7?
             JNE l_paarls
             ADD bp,0ch
             JMP l_paarls
BLOCKLS1:    CMP byte[SBSTELL+22h],80h ;schwarzer Bauer auf D7?
             JNE l_paarls
             ADD bp,0ch
             JMP l_paarls
        ;-------- Test auf gegnerische blockierte Zentrumsbauern --------
BLOCKLS2:    TEST byte[WBSTELL+edi],3h
             JNZ l_paarls              ;weisser Bauer knnte sofort schlagen
             CMP di,4ah                ;D3?
             JE l_blockls3
             CMP di,4bh                ;E3?
             JNE l_paarls
             CMP byte[WBSTELL+55h],10h ;weisser Bauer auf E2?
             JNE l_paarls
             SUB bp,0ch
             JMP l_paarls
BLOCKLS3:    CMP byte[WBSTELL+54h],10h ;weisser Bauer auf D2?
             JNE l_paarls
             SUB bp,0ch
        ;------------- Farbe Luferfeld fr Outpost, Luferpaar und Fianchetto ---------------------
PAARLS:      CMP [LSTELL+edi],ah
             JE l_statlaeufers1
             OR [ANZLS],2h             ;schwarzes Feld
             JMP l_mobsl0
STATLAEUFERS1:OR [ANZLS],1h            ;weisses Feld
       ;------------------------ Mobilitt -------------------------------------
MOBSL0: JMP l_weiterfeldws2

;             CMP ENDSPIEL,bh
;             JNE l_weiterfeldws2
        ;---------------- Test auf Fianchetto-Lufer --------------------
;             CMP di,25h                ;G7?
;             JNE l_mobsl21
;             CMP SKFELD,1bh            ;G8?
;             JE l_mobsl20
;             CMP SKFELD,1ch            ;H8
;             JNE l_mobsl22
;MOBSL20:     SUB bp,25h;20h                ;Bonus fr Fianchettolufer
;             JMP l_mobsl22
;MOBSL21:     CMP di,20h                ;B7
;             JNE l_mobsl22
;             CMP SKFELD,15h            ;A8
;             JE l_mobsl23
;             CMP SKFELD,16h            ;B8
;             JE l_mobsl23
;             CMP SKFELD,17h            ;C8
;             JNE l_mobsl22
;MOBSL23:     SUB bp,25h;20h
;MOBSL22:       ;MOV bx,si
; JMP l_weiterfeldws2

;MOBSL1:        SUB bl,0bh        ;nach links oben
;        MOV al,[ASTELL+bx]
;        TEST al,88        ;Randfeld oder eigene Figur?
;        JNZ short MOBSL2        ;ja, nchste Richtung
;        TEST [FELDATTACK+bx],0f
;        JZ short MOBSL30
;        TEST al,4
;        JNZ short MOBSL3
;        TEST al,7
;        JNZ short MOBSL4
;        JMP MOBSL1
;MOBSL30:       TEST al,7
;        JNZ MOBSL19
;        DEC bp
;        JMP MOBSL1
;MOBSL2:        TEST al,4
;        JZ short MOBSL4
;MOBSL3:        SUB bp,10;
;
;MOBSL4:        MOV bx,si
;MOBSL5:        SUB bl,9
;        MOV al,[ASTELL+bx]
;        TEST al,88
;        JNZ short MOBSL6
;        TEST [FELDATTACK+bx],0f
;        JZ short MOBSL31
;        TEST al,4
;        JNZ short MOBSL7
;        TEST al,7
;        JNZ short MOBSL8
;        JMP MOBSL5
;MOBSL31:       TEST al,7
;        JNZ MOBSL19
;        DEC bp
;        JMP MOBSL5
;MOBSL6:        TEST al,4
;        JZ short MOBSL8
;MOBSL7:        SUB bp,10;
;
;MOBSL8:        MOV bx,si
;MOBSL9:        ADD bl,0bh
;        MOV al,[ASTELL+bx]
;        TEST al,88
;        JNZ short MOBSL10
;        TEST [FELDATTACK+bx],0f
;        JZ short MOBSL32
;        TEST al,4
;        JNZ short MOBSL11
;        TEST al,7
;        JNZ short MOBSL12
;        JMP MOBSL9
;MOBSL32:       TEST al,7
;        JNZ short MOBSL19
;        DEC bp
;        JMP MOBSL9
;MOBSL10:       TEST al,4
;        JZ short MOBSL12
;MOBSL11:       SUB bp,10;
;
;MOBSL12:       MOV bx,si
;MOBSL13:       ADD bl,9
;        MOV al,[ASTELL+bx]
;        TEST al,88
;        JNZ short MOBSL14
;        TEST [FELDATTACK+bx],0f
;        JZ short MOBSL33
;        TEST al,4
;        JNZ short MOBSL15
;        TEST al,7
;        JNZ short MOBSL16
;        JMP MOBSL13
;MOBSL33:       TEST al,7
;        JNZ short MOBSL19
;        DEC bp
;        JMP MOBSL13
;MOBSL14:       TEST al,4
;        JZ short MOBSL16
;MOBSL15:       SUB bp,10
;        JMP short MOBSL17
;
;MOBSL16:       ADD bp,14        ;Strafe fr keine Beweglichkeit
;       ;test [WBSTELL+si],3     ;von weissen Bauer angegriffen?
;       ;jz short MOBSL17        ;nein
;       ;add bp,150	       ;Strafe fr kein Fluchtfeld
;       ;jmp WEITERFELDWS2
;
;MOBSL17:      ;test [FELDATTACK+si],0f ;von weisser Figur angegriffen?
;       ;jz short MOBSL18        ;nein
;       ;test [FELDATTACK+si],0f0;von Schwarz gedeckt?
;       ;jnz WEITERFELDWS2       ;ja
;       ;add bp,150
;       ;jmp WEITERFELDWS2
;
;        TEST [FELDATTACK+si],0f ;von weisser Figur angegriffen?
;        JZ short MOBSL18        ;nein
;        ADD bp,0a        ;Strafe
;        TEST [FELDATTACK+si],0f0;von Schwarz gedeckt?
;        JZ short MOBSL18        ;nein
;        SUB bp,8         ;Bonus
;
;MOBSL18:       TEST [SBSTELL+si],3     ;vom eigenen Bauern gedeckt?
;        JZ WEITERFELDWS2
;        SUB bp,0a        ;ja, zarter Bonus
;        JMP WEITERFELDWS2
;
;MOBSL19:       CMP COLOR,bh
;        JE WEITERFELDWS2
 ;       SUB bp,10
 ;       JMP WEITERFELDWS2

;-------------------------------- Ende TEVALL ----------------------------------

;------------------------------- Anfang TEVALT ---------------------------------
; COLOR=80   Schwarz ist am Zug, kann also einstehende weisse Figur schlagen
; COLOR=0    Weiss ist am Zug
       ;----------------------- weisser Turm -----------------------------------
STATTURM:    CMP al,14h                ;weisser Turm?
             JNE l_statturms           ;nein
             MOV al,[SBWT+edi]
             ADD bp,ax

             SHL di,cl
             MOV bl,[NFELD+edi]        ;Linie A-H
             SHR di,cl
             INC byte[WTLINIE+ebx]
       ;cmp ENDSPIEL,bh
   JMP l_weiterfeldws2       ;ist Endspiel
       ;------------------------ Mobilitt -------------------------------------
;          MOV bx,si
;MOBWT1:        DEC bl         ;nach links
;        MOV al,[ASTELL+bx]
;        TEST al,18        ;Randfeld oder eigene Figur?
;        JNZ short MOBWT2        ;ja, nchste Richtung
;        TEST [FELDATTACK+bx],0f0
;        JZ short MOBWT20        ;Zielfeld nicht von Schwarz angegriffen
;        TEST al,4
;        JNZ short MOBWT3        ;+= gegn. Figur kann geschlagen werden
;        TEST al,7        ;berhaupt Figur?
;        JNZ short MOBWT4        ;ja
;        JMP MOBWT1
;MOBWT20:       TEST al,7        ;schwarze ungedeckte Figur?
;        JNZ MOBWT19        ;ja
;        INC bp         ;Freifeld
;        JMP MOBWT1
;MOBWT2:        TEST al,4        ;eigener Turm, Dame, Knig?
;        JZ short MOBWT4        ;nein
;MOBWT3:        ADD bp,10;
;
;MOBWT4:        MOV bx,si
;MOBWT5:        INC bl
;        MOV al,[ASTELL+bx]
;        TEST al,18
;        JNZ short MOBWT6
;        TEST [FELDATTACK+bx],0f0
;        JZ short MOBWT21
;        TEST al,4
;        JNZ short MOBWT7
;        TEST al,7
;        JNZ short MOBWT8
;        JMP MOBWT5
;MOBWT21:       TEST al,7
;        JNZ MOBWT19
;        INC bp
;        JMP MOBWT5
;MOBWT6:        TEST al,4
;        JZ short MOBWT8
;MOBWT7:        ADD bp,10
;
;MOBWT8:        MOV bx,si
;MOBWT9:        ADD bl,0a
;        MOV al,[ASTELL+bx]
;        TEST al,18
;        JNZ short MOBWT10
;        TEST [FELDATTACK+bx],0f0
;        JZ short MOBWT22
;        TEST al,4
;        JNZ short MOBWT11
;        TEST al,7
;        JNZ short MOBWT12
;        JMP MOBWT9
;MOBWT22:       TEST al,7
;        JNZ short MOBWT19
;        INC bp
;        JMP MOBWT9
;MOBWT10:       TEST al,4
;        JZ short MOBWT12
;MOBWT11:       ADD bp,10;
;
;MOBWT12:       MOV bx,si
;MOBWT13:       SUB bl,0a
;        MOV al,[ASTELL+bx]
;        TEST al,18
;        JNZ short MOBWT14
;        TEST [FELDATTACK+bx],0f0
;        JZ short MOBWT23
;        TEST al,4
;        JNZ short MOBWT15
;        TEST al,7
;        JNZ short MOBWT16
;        JMP MOBWT13
;MOBWT23:       TEST al,7
;        JNZ short MOBWT19
;        INC bp
;        JMP MOBWT13
;MOBWT14:       TEST al,4
;        JZ short MOBWT16
;MOBWT15:       ADD bp,10
;        JMP short MOBWT17
;
;MOBWT16:       SUB bp,20        ;Strafe fr keine Beweglichkeit
;       ;test [FELDATTACK+si],30 ;von schwarzen B, S o.L angegriffen?
;       ;jz short MOBWT17        ;nein
;       ;sub bp,200	       ;Strafe fr kein Fluchtfeld
;       ;jmp WEITERFELDWS2
;
;MOBWT17:      ;test [FELDATTACK+si],0f0;von schwarzer Figur angegriffen?
;       ;jz short MOBWT18        ;nein
;       ;test [FELDATTACK+si],0f ;von Weiss gedeckt?
;       ;jnz WEITERFELDWS2       ;ja
;       ;sub bp,200
;       ;jmp WEITERFELDWS2
;
;        TEST [FELDATTACK+si],0f0;von schwarzer Figur angegriffen?
;        JZ short MOBWT18        ;nein
;        SUB bp,14        ;Strafe
;MOBWT18:       TEST [FELDATTACK+si],0f ;von Weiss gedeckt?
;        JZ WEITERFELDWS2        ;nein
;        ADD bp,0a        ;Bonus
;        JMP WEITERFELDWS2
;
;MOBWT19:       CMP COLOR,bh
;        JNE WEITERFELDWS2
;        ADD bp,10        ;hngende schwarze Figur
;        JMP WEITERFELDWS2

       ;----------------------- schwarzer Turm ---------------------------------
STATTURMS:   CMP al,84h                ;schwarzer Turm?
             JNE l_statdame            ;nein

             MOV al,[SBST+edi]
             SUB bp,ax
             SHL di,cl
             MOV bl,[NFELD+edi]        ;Linie A-H
             SHR di,cl
             INC byte[STLINIE+ebx]
       ;cmp ENDSPIEL,bh
        JMP l_weiterfeldws2
       ;------------------------ Mobilitt -------------------------------------
;        MOV bx,si
;MOBST1:        DEC bl         ;nach links
;        MOV al,[ASTELL+bx]
;        TEST al,88        ;Randfeld oder eigene Figur?
;        JNZ short MOBST2        ;ja, nchste Richtung
;        TEST [FELDATTACK+bx],0f
;        JZ short MOBST20
;        TEST al,4
;        JNZ short MOBST3
;        TEST al,7
;        JNZ short MOBST4
;        JMP MOBST1
;MOBST20:       TEST al,7
;        JNZ MOBST19
;        DEC bp
;        JMP MOBST1
;MOBST2:        TEST al,4
;        JZ short MOBST4
;MOBST3:        SUB bp,10
;
;MOBST4:        MOV bx,si
;MOBST5:        INC bl
;        MOV al,[ASTELL+bx]
;        TEST al,88
;        JNZ short MOBST6
;        TEST [FELDATTACK+bx],0f
;        JZ short MOBST21
;        TEST al,4
;        JNZ short MOBST7
;        TEST al,7
;        JNZ short MOBST8
;        JMP MOBST5
;MOBST21:       TEST al,7
;        JNZ MOBST19
;        DEC bp
;        JMP MOBST5
;MOBST6:        TEST al,4
;        JZ short MOBST8
;MOBST7:        SUB bp,10;
;
;MOBST8:        MOV bx,si
;MOBST9:        ADD bl,0a
;        MOV al,[ASTELL+bx]
;        TEST al,88
;        JNZ short MOBST10
;        TEST [FELDATTACK+bx],0f
;        JZ short MOBST22
;        TEST al,4
;        JNZ short MOBST11
;        TEST al,7
;        JNZ short MOBST12
;        JMP MOBST9
;MOBST22:       TEST al,7
;        JNZ short MOBST19
;        DEC bp
;        JMP MOBST9
;MOBST10:       TEST al,4
;        JZ short MOBST12
;MOBST11:       SUB bp,10
;
;MOBST12:       MOV bx,si
;MOBST13:       SUB bl,0a
;        MOV al,[ASTELL+bx]
;        TEST al,88
;        JNZ short MOBST14
;        TEST [FELDATTACK+bx],0f
;        JZ short MOBST23
;        TEST al,4
;        JNZ short MOBST15
;        TEST al,7
;        JNZ short MOBST16
;        JMP MOBST13
;MOBST23:       TEST al,4
;        JNZ short MOBST19
;        DEC bp
;        JMP MOBST13
;MOBST14:       TEST al,4
;        JZ short MOBST16
;MOBST15:       SUB bp,10
;        JMP short MOBST17
;
;MOBST16:       ADD bp,20        ;Strafe fr keine Beweglichkeit
;       ;test [FELDATTACK+si],3  ;von weissen B, S o.L angegriffen?
;       ;jz short MOBST17        ;nein
;       ;add bp,200	       ;Strafe fr kein Fluchtfeld
;       ;jmp WEITERFELDWS2;;
;
;MOBST17:      ;test [FELDATTACK+si],0f ;von weisser Figur angegriffen?
;       ;jz short MOBST18        ;nein
;       ;test [FELDATTACK+si],0f0;von Schwarz gedeckt?
;       ;jnz WEITERFELDWS2       ;ja
;       ;add bp,200
;       ;jmp WEITERFELDWS2
;
;        TEST [FELDATTACK+si],0f ;von weisser Figur angegriffen?
;        JZ short MOBST18        ;nein
;        ADD bp,14        ;Strafe
;MOBST18:       TEST [FELDATTACK+si],0f0;von Schwarz gedeckt?
;        JZ WEITERFELDWS2        ;nein
;        SUB bp,0a        ;Bonus
;        JMP WEITERFELDWS2
;
;MOBST19:       CMP COLOR,bh
;        JE WEITERFELDWS2
;        SUB bp,10
;        JMP WEITERFELDWS2

;------------------------------- Ende TEVALT -----------------------------------

;------------------------------- Anfang TEVALD ---------------------------------
       ;----------------------- weisse Dame ------------------------------------
STATDAME:    CMP al,15h                ;weisse Dame?
             JNE l_statdames           ;nein
             SHL di,cl
             ADD bp,[SBDW+edi]
             SHR di,cl
             MOV bx,di
STDW3:       SUB bl,9h
             MOV al,[ASTELL+ebx]
             TEST al,8h
             JE l_stdw6                ;Randfeld
             AND al,87h
             CMP al,83h
             JNE l_stdw3
             SUB bp,10h                ;schwarzer Lufer auf Diagonale
             JMP l_stdw5

STDW6:       MOV bx,di
STDW4:       SUB bl,0bh
             MOV al,[ASTELL+ebx]
             TEST al,8h
             JE l_stdw5                ;Randfeld
             AND al,87h
             CMP al,83h
             JNE l_stdw4
             SUB bp,10h                ;schwarzer Lufer auf Diagonale

STDW5:       MOV bl,[SKFELD]
             SHL bx,cl
             MOV dx,word[NFELD+ebx]
             MOV bx,di
             SHL bx,cl
             MOV ax,word[NFELD+ebx]
             SUB al,dl
             JNS l_stdw1
             NEG al
STDW1:       SUB ah,dh
             JNS l_stdw2
             NEG ah
STDW2:       ADD al,ah
             SHL al,cl
             XOR ah,ah
             SUB bp,ax                 ;Strafe fr zu weit weg vom gegn.Knig
             CMP [HZ],0ch              ;Mist bei Stellungseingabe
             JA l_weiterfeldws2
             CMP di,5eh                ;Dame noch auf Ausgangsfeld?
             JE l_weiterfeldws2
             SUB bp,10h                ;Strafe fr zu frh gezogene Dame
             JMP l_weiterfeldws2

       ;----------------------- schwarze Dame ----------------------------------
STATDAMES:   CMP al,85h
             JNE l_weiterfeldws2       ;muss einer der beiden Knige sein

             SHL di,cl
             SUB bp,[SBDS+edi]
             SHR di,cl
             MOV bx,di
STDS3:       ADD bl,9h
             MOV al,[ASTELL+ebx]
             TEST al,8h
             JE l_stds6                ;Randfeld
             AND al,17h
             CMP al,13h
             JNE l_stds3
             ADD bp,10h                ;weisser Lufer auf Diagonale
             JMP l_stds5

STDS6:       MOV bx,di
STDS4:       ADD bl,0bh
             MOV al,[ASTELL+ebx]
             TEST al,8h
             JE l_stds5                ;Randfeld
             AND al,17h
             CMP al,13h
             JNE l_stds4
             ADD bp,10h                ;weisser Lufer auf Diagonale

STDS5:       MOV bl,[WKFELD]
             SHL bx,cl
             MOV dx,word[NFELD+ebx]
             MOV bx,di
             SHL bx,cl
             MOV ax,word[NFELD+ebx]
             SUB al,dl
             JNS l_stds1
             NEG al
STDS1:       SUB ah,dh
             JNS l_stds2
             NEG ah
STDS2:       ADD al,ah
             SHL al,cl
             XOR ah,ah
             ADD bp,ax                 ;Strafe fr zu weit weg vom gegn.Knig
             CMP [HZ],0ch
             JA l_weiterfeldws2
             CMP di,18h                ;Dame noch auf Ausgangsfeld?
             JE l_weiterfeldws2
             ADD bp,10h                ;Strafe fr zu frh gezogene Dame

WEITERFELDWS2:DEC di
             DEC ch
             JNZ l_abrettws
;--------------------------------- Ende TEVALD ---------------------------------

;------------------------------- Anfang TEVALAUS -------------------------------
       ;---------------- Auswertung Bauern- und Turmstellung -------------------
SOUT:        MOV ebx,8h
WT0:         CMP [WTLINIE+ebx],cl      ;CL=1
             JB l_wt4                  ;kein weisser Turm auf dieser Linie
             JE l_wt1
             ADD bp,0ah                ;Bonus fr weisse Turmverdopplung
WT1:         CMP [WBLINIE+ebx],bh
             JNE l_wt21                ;weisser Bauer auf Linie
             ADD bp,0ah                ;Bonus fr Turm auf (halb)offener Linie
             CMP bl,[SKLINIE]
             JNE l_wt2
             ADD bp,8h                 ;schw. Knig auf (halb)offener Turmlinie
WT2:         TEST byte[SBLINIE+ebx],30h
             JZ l_wt21
             ADD bp,0ah                ;rckst.o.schw. Freibauer auf Turmlinie
WT21:        TEST byte[WBLINIE+ebx],30h;eigener Freibauer o.rck.auf Turmlinie?
             JZ l_wt3
             ADD bp,0ah                ;ja
WT3:         CMP [WBLINIE+ebx],bh
             JNE l_wt4
             CMP [SBLINIE+ebx],bh
             JNE l_wt5
             ADD bp,8h                 ;Zusatzbonus fr Turm auf offener Linie
             CMP bl,[SKLINIE]
             JNE l_wt5
             ADD bp,8h                 ;Turm auf offener Knigslinie
             JMP l_wt5                 ;kein Bauer auf dieser Linie
WT4:         AND byte[WBLINIE+ebx],0cfh;Bit fr rckstndigen u.Freibauer lschen
             CMP [WBLINIE-1h+ebx],bh
             JNE l_wt41
             CMP [WBLINIE+1h+ebx],bh
             JNE l_wt41
             SUB bp,20h                ;Strafe fr weissen Isolani
WT41:        CMP [WBLINIE+ebx],cl
             JBE l_wt5
             SUB bp,14h                ;Strafe fr weissen Doppelbauer
WT5:         DEC bl
             JNZ l_wt0

             CMP [WBLINIE+1h],cl
             JBE l_wt6
             SUB bp,10h                ;Doppelbauer auf A-Linie
WT6:         CMP [WBLINIE+8h],cl
             JBE l_wt7
             SUB bp,10h                ;auf H-Linie

WT7:         MOV bl,8h
ST0:         CMP [STLINIE+ebx],cl      ;CL=1
             JB l_st4
             JE l_st1
             SUB bp,0ah                ;Bonus fr schwarze Turmverdopplung
ST1:         CMP [SBLINIE+ebx],bh
             JNE l_st21                ;schwarzer Bauer auf dieser Linie
             SUB bp,0ah                ;Bonus fr Turm auf (halb)offener Linie
             CMP bl,[WKLINIE]
             JNE l_st2
             SUB bp,8h                 ;Turm auf (halb)offener Knigslinie
ST2:         TEST byte[WBLINIE+ebx],30h;rckstndiger oder weisser Freibauer?
             JZ l_st21
             SUB bp,0ah
ST21:        TEST byte[SBLINIE+ebx],30h;eigener Freibauer o.rck.auf Turmlinie?
             JZ l_st3
             SUB bp,0ah                ;ja
ST3:         CMP [SBLINIE+ebx],bh
             JNE l_st4
             CMP [WBLINIE+ebx],bh
             JNE l_st5
             SUB bp,8h                 ;Zusatzbonus fr Turm auf offener Linie
             CMP bl,[WKLINIE]
             JNE l_st4
             SUB bp,8h                 ;Turm auf offener Knigslinie
             JMP l_st5                 ;kein Bauer auf dieser Linie
ST4:         AND byte[SBLINIE+ebx],0cfh;Bit fr rckstndigen u.Freibauer lschen
             CMP [SBLINIE-1h+ebx],bh
             JNE l_st41
             CMP [SBLINIE+1h+ebx],bh
             JNE l_st41
             ADD bp,20h                ;Strafe fr schwarzen Isolani
ST41:        CMP [SBLINIE+ebx],cl
             JBE l_st5
             ADD bp,14h                ;Strafe fr schwarzen Doppelbauer
ST5:         DEC bl
             JNZ l_st0

             CMP [SBLINIE+1h],cl
             JBE l_st6
             ADD bp,10h                ;Doppelbauer auf A-Linie
ST6:         CMP [SBLINIE+8h],cl
             JBE l_st7
             ADD bp,10h                ;auf H-Linie

ST7:         MOV bx,[TIEFE]
             SHL bx,1h
             CMP [ANZLS],3h            ;3 wegen Feldfarben
             JNE l_nols
             MOV di,[ANZBAUERS+ebx]
             SHL di,1h
             SUB bp,[LPAAR+edi]
       ;sub bp,19	       ;Bonus fr Luferpaar
NOLS:        CMP [ANZLW],3h
             JNE l_nolw
       ;add bp,19
             MOV di,[ANZBAUERW+ebx]
             SHL di,1h
             ADD bp,[LPAAR+edi]
NOLW:        CMP [OUTPFW],bh
             JE l_nooutw               ;kein weisser Outpost
             CMP [ANZSS],bh
             JNE l_nooutw              ;schwarze(r) Springer vorhanden
             TEST [OUTPFW],1h
             JZ l_outptest1
             TEST [ANZLS],1h           ;Outpost auf weissem Feld
             JNZ l_outptest1
             ADD bp,10h
OUTPTEST1:   TEST [OUTPFW],2h
             JZ l_nooutw
             TEST [ANZLS],2h           ;Outpost auf schwarzem Feld
             JNZ l_nooutw
             ADD bp,10h

NOOUTW:      CMP [OUTPFS],bh
             JE l_nooutp               ;kein schwarzer Outpost
             CMP [ANZSW],bh
             JNE l_nooutp              ;weisse(r) Springer vorhanden
             TEST [OUTPFS],1h
             JZ l_outptest2
             TEST [ANZLW],1h           ;Outpost auf weissem Feld
             JNZ l_outptest2
             SUB bp,10h
OUTPTEST2:   TEST [OUTPFS],2h
             JZ l_nooutp
             TEST [ANZLW],2h           ;Outpost auf schwarzem Feld
             JNZ l_nooutp
             SUB bp,10h

NOOUTP:      CMP [COLOR],0h
             JE l_bwse
             NEG bp
BWSE:        RET

;--------------------------------------- Zuggenerierung -------------------------------------------
;------------------------------------- Zuggenerator Weiss -----------------------------------------
;------------------------------- Letzte Modifizierung 08.03.2006 ----------------------------------
ZUGGENW:     CALL l_attackfeld
  
             MOV bx,[TIEFE]
             MOV DWord[BADZUGANF],0h
             MOV [X1],bh               ;Merker Dame-Lufer
             SHL bx,1h
   
             MOV di,[ZZUGTAB+ebx]      ;von ZUGGENWS
             MOV cx,[ANZFIGW+ebx]      ;Ende nach CX Figuren
             MOV ah,0fh
             MOV ch,7h

             MOV bx,62h                ;Beginn bei H1
ABRETT:      MOV al,[ASTELL+ebx]
             TEST al,10h               ;weisse Figur?
             JNZ l_zuggenweiss         ;ja
             DEC bx
             JMP l_abrett

       ;------------------------------------------------------------------------
ZUGGENWEISS: MOV dl,bl
             AND al,7h
             DEC al                    ;Bauer?
             JZ l_wbauer1
             DEC al                    ;Springer?
             JZ l_wspringer1
             DEC al                    ;Lufer?
             JZ l_wlaeufer1
             DEC al                    ;Turm?
             JZ l_wturm1
             DEC al                    ;Dame?
             JNZ l_weiterfeld          ;nein
             MOV [X1],bl               ;Merker Dame-Lufer ungleich Null
             JMP l_wlaeufer1
WEITERFELD:  DEC bx
             DEC cl
             JNZ l_abrett

             MOV bl,[WKFELD]
             MOV dl,bl
WKING1:      SUB bl,0bh                ;nach links oben, ist ZFELD f. SCHREIBTAB
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_wking2              ;Randfeld oder Figur
             CALL l_schreibtabw

WKING2:      ADD bl,14h                ;nach links unten
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_wking3
             CALL l_schreibtabw

WKING3:      ADD bl,2h                 ;nach rechts unten
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_wking4
             CALL l_schreibtabw

WKING4:      SUB bl,14h                ;nach rechts oben
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_wking5
             CALL l_schreibtabw

WKING5:      ADD bl,8h                 ;nach links
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_wking6
             CALL l_schreibtabw

WKING6:      ADD bl,2h                 ;nach rechts
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_wking7
             CALL l_schreibtabw

WKING7:      SUB bl,0bh                ;nach oben
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_wking8
             CALL l_schreibtabw

WKING8:      ADD bl,14h                ;nach unten
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_gkrochw
             CALL l_schreibtabw

       ;--------------------- Rochaden -----------------------------------------
GKROCHW:     CMP [WKFELD],5fh          ;E1
             JNE l_rochw
             CMP byte[ASTELL+5fh],56h  ;Pos. weier Knig (e1)
             JNE l_rochw               ;Rochaden nicht, Knig schon gezogen
             MOV bl,5fh                ;E1 bedroht?
             PUSH edi
             CALL l_attackfelds        ;verndert DI!!!
             POP edi
             CMP [ATTACK],0h
             JNZ l_rochw               ;Weiss steht im Schach
             TEST [ASTELL+60h],ch      ;Feld F1 frei? ch=7
             JNZ l_grochw              ;nein
             TEST [ASTELL+61h],ch
             JNZ l_grochw              ;nein
             CMP byte[ASTELL+62h],14h  ;Pos. rechter weier Turm
             JNE l_grochw
             MOV bl,60h                ;F1 bedroht?
             PUSH edi
             CALL l_attackfelds
             POP edi
             CMP [ATTACK],0h
             JNZ l_grochw              ;ja
             MOV bl,61h                ;G1 bedroht?
             PUSH edi
             CALL l_attackfelds
             POP edi
             CMP [ATTACK],0h
             JNZ l_grochw              ;ja
             MOV bl,61h
             CALL l_schreibtabw

GROCHW:      TEST [ASTELL+5eh],ch      ;D1 frei?
             JNZ l_rochw               ;nein
             TEST [ASTELL+5dh],ch
             JNZ l_rochw               ;nein
             TEST [ASTELL+5ch],ch
             JNZ l_rochw               ;nein
             CMP byte[ASTELL+5bh],54h  ;Pos. linker weier Turm
             JNE l_rochw               ;weg oder schon mal gezogen
             MOV bl,5eh                ;D1 bedroht?
             PUSH edi
             CALL l_attackfelds
             POP edi
             CMP [ATTACK],0h
             JNZ l_rochw               ;ja
             MOV bl,5dh                ;C1 bedroht?
             PUSH edi
             CALL l_attackfelds
             POP edi
             CMP [ATTACK],0h
             JNZ l_rochw               ;ja
             MOV bl,5dh
             CALL l_schreibtabw

ROCHW:       MOV bx,[TIEFE]
             MOV word[ZUGTAB+edi],0ffffh   ;Zeichen fr Ende ZUGTAB
             SHL bx,1h
             MOV cx,[ZZUGTAB+ebx]      ;Ende der Schlagzge+2=hier Anfang
 
HASHW1:      MOV edx,[HASHADR]
             AND edx,[ANDWERT]
             SHL edx,3h                ;8 Byte Abstand
             MOV eax,[HASHCODE]
             CMP [esi+edx],eax
             JNE l_killw1
             MOV bl,[esi+7h+edx]       ;ist nur ZFELD!
             MOV [X1],bl
             MOV bx,cx
BESTESTWS01H:CMP bx,di                 ;DI=Ende ZUGTAB
             JAE l_killw1
             MOV dx,word[ZUGTAB+ebx]
             ADD bx,2h
             CMP [X1],dh
             JNE l_bestestws01h
             MOV ax,word[ZUGTAB+ecx]
             MOV word[ZUGTAB+ecx],dx
             SUB bx,2h
             MOV word[ZUGTAB+ebx],ax
             ADD cx,2h
             ADD bx,2h
             JMP l_bestestws01h

KILLW1:      MOV bx,[TIEFE]
             SHL bx,2h                 ;dd!
             MOV ax,word[KILLTABN+ebx] ;Killerzug 1 setzen
             MOV bx,cx
BESTTESTW11: CMP bx,di
             JAE l_killw2
             MOV dx,word[ZUGTAB+ebx]
             ADD bx,2h
             CMP ax,dx
             JNE l_besttestw11
             MOV ax,word[ZUGTAB+ecx]
             MOV word[ZUGTAB+ecx],dx
             SUB bx,2h
             MOV word[ZUGTAB+ebx],ax       ;Stelle von BESTTESTW11
             ADD cx,2h

KILLW2:      MOV bx,[TIEFE]
             SHL bx,2h                 ;dd!
             ADD bx,2h
             MOV ax,word[KILLTABN+ebx] ;Killerzug 2 setzen
             MOV bx,cx
BESTTESTW21: CMP bx,di
             JAE l_bestlinew
             MOV dx,word[ZUGTAB+ebx]
             ADD bx,2h
             CMP ax,dx
             JNE l_besttestw21
             MOV ax,word[ZUGTAB+ecx]
             MOV word[ZUGTAB+ecx],dx
             SUB bx,2h
             MOV word[ZUGTAB+ebx],ax   ;Stelle von BESTTESTW21
             ADD cx,2h

BESTLINEW:   MOV bx,[TIEFE]
             SHL bx,1h
             MOV ax,[BESTLINE+ebx]     ;letzten Killerzug setzen
             MOV bx,cx
BESTTESTW01: CMP bx,di                 ;DI=Ende ZUGTAB
             JAE l_zgwe1
             MOV dx,word[ZUGTAB+ebx]
             ADD bx,2h
             CMP ax,dx
             JNE l_besttestw01
             MOV ax,word[ZUGTAB+ecx]
             MOV word[ZUGTAB+ecx],dx
             SUB bx,2h
             MOV word[ZUGTAB+ebx],ax
            
       ;------------------- Extended Futility Pruning --------------------------
ZGWE1:       RET                       ;brachte nicht die erhofften Resultate

       ;----------------------- Eigentliche Zugerzeugung -----------------------


       ;------------------------- Zge weisse Bauern ---------------------------
WBAUER1:     TEST [ASTELL-0ah+ebx],ch  ;Zielfeld frei?
             JNZ l_weiterfeld          ;nein, weiter
             CMP bl,26h                ;H7 oder kleiner?
             JBE l_weiterfeld          ;ja, Umwandlung gilt als Schlagzug
             SUB bl,0ah
             CALL l_schreibtabw

             CMP dl,51h                ;noch 2.Reihe?
             JB l_wbauer2              ;nein
             TEST [ASTELL-0ah+ebx],ch  ;noch ein Feld weiter
             JNZ l_wbauer2             ;nicht frei
             SUB bl,0ah
             CALL l_schreibtabw

WBAUER2:     MOV bl,dl
             JMP l_weiterfeld

       ;------------------------ Zge weisse Springer --------------------------
WSPRINGER1:  SUB bl,15h                ;2 Felder vorwrts, 1 Feld nach links
             TEST [ASTELL+ebx],ah      ;Randfeld oder Figur?
             JNZ l_wspringer2          ;ja
             CALL l_schreibtabwf

WSPRINGER2:  ADD bl,2h                 ;2 Felder vorwrts, 1 Feld nach rechts
             TEST [ASTELL+ebx],ah
             JNZ l_wspringer3
             CALL l_schreibtabwf

WSPRINGER3:  ADD bl,0bh                ;1 Feld vorwrts, 2 Felder nach rechts
             TEST [ASTELL+ebx],ah
             JNZ l_wspringer4
             CALL l_schreibtabwf

WSPRINGER4:  SUB bl,4h                 ;1 Feld vorwrts, 2 Felder nach links
             TEST [ASTELL+ebx],ah
             JNZ l_wspringer5
             CALL l_schreibtabwf

WSPRINGER5:  ADD bl,14h                ;1 Feld rckwrts, 2 Felder nach links
             TEST [ASTELL+ebx],ah
             JNZ l_wspringer6
             CALL l_schreibtabwf

WSPRINGER6:  ADD bl,4h                 ;1 Feld rckwrts, 2 Felder nach rechts
             TEST [ASTELL+ebx],ah
             JNZ l_wspringer7
             CALL l_schreibtabwf

WSPRINGER7:  ADD bl,7h                 ;2 Felder rckwrts, 1 Feld nach links
             TEST [ASTELL+ebx],ah
             JNZ l_wspringer8
             CALL l_schreibtabwf

WSPRINGER8:  ADD bl,2h                 ;2 Felder rckwrts, 1 Feld nach rechts
             TEST [ASTELL+ebx],ah
             JNZ l_wspringer9
             CALL l_schreibtabwf

WSPRINGER9:  MOV bl,dl
             JMP l_weiterfeld
       ;--------------------------
WLAEUFER1:   SUB bl,0bh                ;nach links oben
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_wlaeufer2
             CALL l_schreibtabwf
             JMP l_wlaeufer1

WLAEUFER2:   MOV bl,dl
WLAEUFER21:  ADD bl,9h
             TEST [ASTELL+ebx],ah
             JNZ l_wlaeufer3
             CALL l_schreibtabwf
             JMP l_wlaeufer21

WLAEUFER3:   MOV bl,dl
WLAEUFER31:  ADD bl,0bh
             TEST [ASTELL+ebx],ah
             JNZ l_wlaeufer4
             CALL l_schreibtabwf
             JMP l_wlaeufer31

WLAEUFER4:   MOV bl,dl
WLAEUFER41:  SUB bl,9h
             TEST [ASTELL+ebx],ah
             JNZ l_wlaeufer5
             CALL l_schreibtabwf
             JMP l_wlaeufer41

WLAEUFER5:   MOV bl,dl
             CMP [X1],bh               ;Dame?
             JE l_weiterfeld           ;nein

       ;-------------------------------
WTURM1:      DEC bl                    ;nach links
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_wturm2
             CALL l_schreibtabwf
             JMP l_wturm1

WTURM2:      MOV bl,dl
WTURM21:     SUB bl,0ah                ;nach oben
             TEST [ASTELL+ebx],ah
             JNZ l_wturm3
             CALL l_schreibtabwf
             JMP l_wturm21

WTURM3:      MOV bl,dl
WTURM31:     INC bl                    ;nach rechts
             TEST [ASTELL+ebx],ah
             JNZ l_wturm4
             CALL l_schreibtabwf
             JMP l_wturm31

WTURM4:      MOV bl,dl
WTURM41:     ADD bl,0ah                ;nach unten
             TEST [ASTELL+ebx],ah
             JNZ l_wturm5
             CALL l_schreibtabwf
             JMP l_wturm41

WTURM5:      MOV bl,dl
             MOV [X1],bh               ;Merker Dame-Lufer
             JMP l_weiterfeld

;------------------- Unterprogramm Zuggenerator weisse Schlagzge --------------
ZUGGENWS:    MOVZX ebx,[TIEFE]
             MOV [X1],bh               ;Merker Dame-Lufer
             SHL bx,1h
             MOV word[Z+2h+ebx],0h     ;fr DIESE Zge!
             MOVZX edi,[AZ]            ;Zeiger in ZUGTAB
             CMP [NMOVE],0ffh
             JNE l_zuggenws1
       ;--------------- Null-Zug erzeugen -------------------
             MOV word[ZUGTAB+edi],7979h;Null-Zug
             ADD di,2h
             MOV [NMOVE],0feh

ZUGGENWS1:   MOV cx,[ANZFIGW+ebx]      ;Ende nach X Figuren
             MOV ah,80h
             MOV ch,18h
               
             MOV bl,[WKFELD]
             MOV dl,bl   
             SUB bl,0bh                ;nach links oben, ist ZFELD f.SCHREIBTAB
             TEST [ASTELL+ebx],ah      ;schwarze Figur?
             JZ l_wking2s              ;nein
             CALL l_schreibtab1

WKING2S:     ADD bl,14h                ;nach links unten
             TEST [ASTELL+ebx],ah
             JZ l_wking3s
             CALL l_schreibtab1

WKING3S:     ADD bl,2h                 ;nach rechts unten
             TEST [ASTELL+ebx],ah
             JZ l_wking4s
             CALL l_schreibtab1

WKING4S:     SUB bl,14h                ;nach rechts oben
             TEST [ASTELL+ebx],ah
             JZ l_wking5s
             CALL l_schreibtab1

WKING5S:     ADD bl,8h                 ;nach links
             TEST [ASTELL+ebx],ah
             JZ l_wking6s
             CALL l_schreibtab1

WKING6S:     ADD bl,2h                 ;nach rechts
             TEST [ASTELL+ebx],ah
             JZ l_wking7s
             CALL l_schreibtab1

WKING7S:     SUB bl,0bh                ;nach oben
             TEST [ASTELL+ebx],ah
             JZ l_wking8s
             CALL l_schreibtab1

WKING8S:     ADD bl,14h                ;nach unten
             TEST [ASTELL+ebx],ah
             JZ l_wking9s
             CALL l_schreibtab1

WKING9S:     MOV bx,62h                ;Beginn bei H1
ABRETTSS:    MOV al,[ASTELL+ebx]
             TEST al,10h               ;weisse Figur?
             JNZ l_zuggenweisss        ;ja
             DEC bx
             JMP l_abrettss

       ;-----------------------------------------------------------------------
ZUGGENWEISSS:MOV dl,bl
             AND al,7h
             DEC al                    ;Bauer?
             JZ l_wbauer1s
             DEC al                    ;Springer?
             JZ l_wspringer1s
             DEC al                    ;Lufer?
             JZ l_wlaeufer1s
             DEC al                    ;Turm?
             JZ l_wturm1s
             DEC al                    ;Dame?
             JNZ l_weiterfeldss        ;nein
             MOV [X1],bl               ;Merker Dame-Lufer
             JMP l_wlaeufer1s
WEITERFELDSS:DEC bx
             DEC cl
             JNZ l_abrettss

             MOV bx,[TIEFE]
             SHL bx,1h
             MOV [ZZUGTAB+ebx],di
             CMP word[VARTIEFE+ebx],0h
             JLE l_ruhesw1             ;Ruhesuche
             MOV word[ZUGTAB+edi],0fffeh   ;Ende ZUGTAB markieren
             JMP l_ruhesw2
RUHESW1:     MOV word[ZUGTAB+edi],0ffffh
RUHESW2:     MOV cx,[AZ]
             CMP [NMOVE],0feh          ;Nullzug?
             JNE l_hashws
             ADD cx,2h
    
HASHWS:      MOV edx,[HASHADR]
             AND edx,[ANDWERT]
             SHL edx,3h                ;8 Byte Abstand
             MOV eax,[HASHCODE]
             CMP [esi+edx],eax
             JNE l_killws1
             MOV bl,[esi+7h+edx]       ;ZFELD!
             MOV [X1],bl       
             MOV bx,cx
BESTTESTWS01H:CMP bx,di                ;DI=Ende ZUGTAB
             JAE l_killws1
             MOV dx,word[ZUGTAB+ebx]
             ADD bx,2h
             CMP [X1],dh
             JNE l_besttestws01h
             MOV ax,word[ZUGTAB+ecx]
             MOV word[ZUGTAB+ecx],dx
             SUB bx,2h
             MOV word[ZUGTAB+ebx],ax
             ADD cx,2h
             ADD bx,2h
             JMP l_besttestws01h

KILLWS1:     MOV bx,[TIEFE]
             SHL bx,2h                 ;dd!
             MOV ax,word[KILLTABS+ebx] ;Killerzug 1 setzen
             MOV bx,cx
BESTTESTW61: CMP bx,di
             JAE l_killws2
             MOV dx,word[ZUGTAB+ebx]
             ADD bx,2h
             CMP ax,dx
             JNE l_besttestw61
             MOV ax,word[ZUGTAB+ecx]
             MOV word[ZUGTAB+ecx],dx
             SUB bx,2h
             MOV word[ZUGTAB+ebx],ax       ;Stelle von BESTTESTW61
             ADD cx,2h

KILLWS2:     MOV bx,[TIEFE]
             SHL bx,2h                 ;dd!
             ADD bx,2h
             MOV ax,word[KILLTABS+ebx] ;Killerzug 2 setzen
             MOV bx,cx
BESTTESTW71: CMP bx,di
             JAE l_bestlinews
             MOV dx,word[ZUGTAB+ebx]
             ADD bx,2h
             CMP ax,dx
             JNE l_besttestw71
             MOV ax,word[ZUGTAB+ecx]
             MOV word[ZUGTAB+ecx],dx
             SUB bx,2h
             MOV word[ZUGTAB+ebx],ax       ;Stelle von BESTTESTW71
             ADD cx,2h

BESTLINEWS:  MOV bx,[TIEFE]
             SHL bx,1h
             MOV ax,[BESTLINE+ebx]     ;letzten Killerzug setzen
             MOV bx,cx
BESTTESTW51: CMP bx,di
             JAE l_weiterfeldss1
             MOV dx,word[ZUGTAB+ebx]
             ADD bx,2h
             CMP ax,dx
             JNE l_besttestw51
             MOV ax,word[ZUGTAB+ecx]
             MOV word[ZUGTAB+ecx],dx
             SUB bx,2h
             MOV word[ZUGTAB+ebx],ax
         
WEITERFELDSS1:MOV [NMOVE],0h
             RET

        ;------------------------- Zge weisse Bauern ---------------------------
WBAUER1S:    CMP bl,26h                ;grer als H7?
             JA l_wbauer2s             ;ja, keine Umwandlung mglich
             TEST byte[ASTELL-0ah+ebx],7h   ;steht da was?
             JNZ l_wbauer2s            ;ja
             ADD bl,6eh                ;6eH=100D-10D+(4*5) fr Dame
             CALL l_schreibtab1        ;eigentliches ZFELD ist BL-10D
             SUB bl,4h                 ;Turm
             CALL l_schreibtab1
             SUB bl,4h                 ;Lufer
             CALL l_schreibtab1
             SUB bl,4h                 ;Springer
             CALL l_schreibtab1

WBAUER2S:    MOV bl,dl
             TEST [ASTELL-9h+ebx],ah   ;schwarze Figur?
             JZ l_wbauer3s             ;nein
             CMP bl,26h
             JA l_wbauer21s            ;keine Umwandlung
             SUB bl,9h

WBAUER20S:   ADD bl,78h                ;100D+(4*5) fr Dame
             CALL l_schreibtab1
             SUB bl,4h                 ;Turm
             CALL l_schreibtab1
             SUB bl,4h                 ;Lufer
             CALL l_schreibtab1
             SUB bl,4h                 ;Springer
             CALL l_schreibtab1
             JMP l_wbauer3s
WBAUER21S:   SUB bl,9h
             CALL l_schreibtab1

WBAUER3S:    MOV bl,dl
             TEST [ASTELL-0bh+ebx],ah  ;schwarze Figur?
             JZ l_wbauer4s             ;nein
             CMP bl,26h
             JA l_wbauer31s            ;keine Umwandlung
             SUB bl,0bh

WBAUER30S:   ADD bl,78h                ;100D+(4*5) fr Dame
             CALL l_schreibtab1
             SUB bl,4h                 ;Turm
             CALL l_schreibtab1
             SUB bl,4h                 ;Lufer
             CALL l_schreibtab1
             SUB bl,4h                 ;Springer
             CALL l_schreibtab1
             JMP l_wbauer6s
WBAUER31S:   SUB bl,0bh
             CALL l_schreibtab1

WBAUER4S:    MOV bl,dl
             INC bl                    ;rechtes Nebenfeld fr en passant
             CMP bl,[LASTZUGGZ]        ;war es Zielfeld letzter Gegnerzug?
             JNE l_wbauer5s            ;nein
             MOV al,[ASTELL+ebx]
             AND al,87h                ;schwarzer Bauer?
             CMP al,81h
             JNE l_wbauer5s            ;nein
             SUB bl,14h
             CMP bl,[LASTZUGGA]        ;Ausgangsfeld 2 Schritte zurck?
             JNE l_wbauer5s            ;nein
             ADD bl,0ah                ;Zielfeld weisser Bauer
             CALL l_schreibtab1
             JMP l_wbauer6s

WBAUER5S:    MOV bl,dl
             DEC bl                    ;linkes Nebenfeld fr en passant
             CMP bl,[LASTZUGGZ]        ;war es Zielfeld letzter Gegnerzug?
             JNE l_wbauer6s            ;nein
             MOV al,[ASTELL+ebx]
             AND al,87h
             CMP al,81h                ;Bauer?
             JNE l_wbauer6s            ;nein
             SUB bl,14h
             CMP bl,[LASTZUGGA]        ;Ausgangsfeld 2 Schritte zurck?
             JNE l_wbauer6s            ;nein
             ADD bl,0ah                ;Zielfeld weisser Bauer
             CALL l_schreibtab1

WBAUER6S:    MOV bl,dl
             JMP l_weiterfeldss

       ;------------------------ Zge weisse Springer --------------------------
WSPRINGER1S: SUB bl,15h                ;2 Felder vorwrts, 1 Feld nach links
             TEST [ASTELL+ebx],ah
             JZ l_wspringer2s
             CALL l_schreibtab1

WSPRINGER2S: ADD bl,2h                 ;2 Felder vorwrts, 1 Feld nach rechts
             TEST [ASTELL+ebx],ah
             JZ l_wspringer3s
             CALL l_schreibtab1

WSPRINGER3S: ADD bl,0bh                ;1 Feld vorwrts, 2 Felder nach rechts
             TEST [ASTELL+ebx],ah
             JZ l_wspringer4s
             CALL l_schreibtab1

WSPRINGER4S: SUB bl,4h                 ;1 Feld vorwrts, 2 Felder nach links
             TEST [ASTELL+ebx],ah
             JZ l_wspringer5s
             CALL l_schreibtab1

WSPRINGER5S: ADD bl,14h                ;1 Feld rckwrts, 2 Felder nach links
             TEST [ASTELL+ebx],ah
             JZ l_wspringer6s
             CALL l_schreibtab1

WSPRINGER6S: ADD bl,4h                 ;1 Feld rckwrts, 2 Felder nach rechts
             TEST [ASTELL+ebx],ah
             JZ l_wspringer7s
             CALL l_schreibtab1

WSPRINGER7S: ADD bl,7h                 ;2 Felder rckwrts, 1 Feld nach links
             TEST [ASTELL+ebx],ah
             JZ l_wspringer8s
             CALL l_schreibtab1

WSPRINGER8S: ADD bl,2h                 ;2 Felder rckwrts, 1 Feld nach rechts
             TEST [ASTELL+ebx],ah
             JZ l_wspringer9s
             CALL l_schreibtab1

WSPRINGER9S: MOV bl,dl
             JMP l_weiterfeldss


WLAEUFER1S:  SUB bl,0bh                ;nach links oben
             TEST [ASTELL+ebx],ch      ;Inhalt Zielfeld
             JNZ l_wlaeufer2s          ;Randfeld oder w.Figur, nchste Richtung
             TEST [ASTELL+ebx],ah      ;schwarze Figur?
             JZ l_wlaeufer1s           ;nein
             CALL l_schreibtab1
    
WLAEUFER2S:  MOV bl,dl
WLAEUFER21S: ADD bl,9h
             TEST [ASTELL+ebx],ch
             JNZ l_wlaeufer3s
             TEST [ASTELL+ebx],ah
             JZ l_wlaeufer21s
             CALL l_schreibtab1

WLAEUFER3S:  MOV bl,dl
WLAEUFER31S: ADD bl,0bh
             TEST [ASTELL+ebx],ch
             JNZ l_wlaeufer4s
             TEST [ASTELL+ebx],ah
             JZ l_wlaeufer31s
             CALL l_schreibtab1

WLAEUFER4S:  MOV bl,dl
WLAEUFER41S: SUB bl,9h
             TEST [ASTELL+ebx],ch
             JNZ l_wlaeufer5s
             TEST [ASTELL+ebx],ah
             JZ l_wlaeufer41s
             CALL l_schreibtab1

WLAEUFER5S:  MOV bl,dl
             CMP [X1],bh               ;Dame?
             JE l_weiterfeldss         ;nein

WTURM1S:     DEC bl                    ;nach links
             TEST [ASTELL+ebx],ch      ;Inhalt Zielfeld
             JNZ l_wturm2s
             TEST [ASTELL+ebx],ah
             JZ l_wturm1s
             CALL l_schreibtab1

WTURM2S:     MOV bl,dl
WTURM21S:    SUB bl,0ah                ;nach oben
             TEST [ASTELL+ebx],ch
             JNZ l_wturm3s
             TEST [ASTELL+ebx],ah
             JZ l_wturm21s
             CALL l_schreibtab1

WTURM3S:     MOV bl,dl
WTURM31S:    INC bl                    ;nach rechts
             TEST [ASTELL+ebx],ch
             JNZ l_wturm4s
             TEST [ASTELL+ebx],ah
             JZ l_wturm31s
             CALL l_schreibtab1

WTURM4S:     MOV bl,dl
WTURM41S:    ADD bl,0ah                ;nach unten
             TEST [ASTELL+ebx],ch
             JNZ l_wturm5s
             TEST [ASTELL+ebx],ah
             JZ l_wturm41s
             CALL l_schreibtab1

WTURM5S:     MOV bl,dl
             MOV [X1],bh               ;Merker Dame-Lufer
             JMP l_weiterfeldss

;----------------------------------- Zuggenerator Schwarz -----------------------------------------
ZUGGENS:     CALL l_attackfeld
   
             MOVZX ebx,[TIEFE]
             MOV DWord[BADZUGANF],0h    
             MOV [X1],bh               ;Merker Dame-Lufer
             SHL bx,1h
             MOV di,[ZZUGTAB+ebx]      ;von ZUGGENSS
             MOV cx,[ANZFIGS+ebx]      ;Ende nach X Figuren
             MOV ah,0fh                ;Randfeld oder Figur
             MOV ch,7h
          
             MOV bx,15h                ;Beginn bei A8
ABRETTSCHW:  MOV al,[ASTELL+ebx]
             TEST al,80h               ;schwarze Figur?
             JNZ l_zuggenschw          ;ja
             INC bx
             JMP l_abrettschw

       ;------------------------------------------------------------------------
ZUGGENSCHW:  MOV dl,bl
             AND al,7h
             DEC al                    ;Bauer?
             JZ l_sbauer1
             DEC al                    ;Springer?
             JZ l_sspringer1
             DEC al                    ;Lufer?
             JZ l_slaeufer1
             DEC al                    ;Turm?
             JZ l_sturm1
             DEC al                    ;Dame?
             JNZ l_weiterfelds         ;nein
             MOV [X1],bl               ;Merker Dame-Lufer
             JMP l_slaeufer1

WEITERFELDS: INC bx
             DEC cl
             JNZ l_abrettschw

             MOV bl,[SKFELD]
             MOV dl,bl 
             SUB bl,0bh                ;nach links oben
             TEST [ASTELL+ebx],ah      ;Randfeld oder Figur?
             JNZ l_sking2              ;ja
             CALL l_schreibtabs

SKING2:      ADD bl,14h                ;nach links unten
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_sking3
             CALL l_schreibtabs

SKING3:      ADD bl,2h                 ;nach rechts unten
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_sking4
             CALL l_schreibtabs

SKING4:      SUB bl,14h                ;nach rechts oben
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_sking5
             CALL l_schreibtabs

SKING5:      ADD bl,8h                 ;nach links
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_sking6
             CALL l_schreibtabs

SKING6:      ADD bl,2h                 ;nach rechts
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_sking7
             CALL l_schreibtabs

SKING7:      SUB bl,0bh                ;nach oben
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_sking8
             CALL l_schreibtabs

SKING8:      ADD bl,14h                ;nach unten
             TEST [ASTELL+ebx],ah      ;Inhalt Zielfeld
             JNZ l_gkrochs
             CALL l_schreibtabs

       ;------------------------ Rochaden --------------------------------------
GKROCHS:     CMP [SKFELD],19h          ;e8
             JNE l_rochs
             CMP byte[ASTELL+19h],86h  ;Knig schon mal gezogen?
             JNE l_rochs               ;ja, Rochaden nicht mehr mglich
             MOV bl,19h                ;E8 bedroht?
             PUSH edi
             CALL l_attackfeldw
             POP edi
             CMP [ATTACK],0h
             JNE l_rochs               ;Schwarz steht im Schach
             TEST [ASTELL+1ah],ch      ;f8 frei?
             JNZ l_grochs              ;nein
             TEST [ASTELL+1bh],ch      ;g8 frei?
             JNZ l_grochs              ;nein
             CMP byte[ASTELL+1ch],0c4h ;Pos. rechter schwarzer Turm
             JNE l_grochs              ;weg oder schon mal gezogen
             MOV bl,1ah                ;F8 bedroht?
             PUSH edi
             CALL l_attackfeldw
             POP edi
             CMP [ATTACK],0h
             JNE l_grochs              ;ja
             MOV bl,1bh                ;G8 bedroht?
             PUSH edi
             CALL l_attackfeldw
             POP edi
             CMP [ATTACK],0h
             JNE l_grochs              ;ja
             MOV bl,1bh
             CALL l_schreibtabs

GROCHS:      TEST [ASTELL+18h],ch      ;d8 frei?
             JNZ l_rochs               ;nein
             TEST [ASTELL+17h],ch      ;c8 frei?
             JNZ l_rochs               ;nein
             TEST [ASTELL+16h],ch      ;b8 frei?
             JNZ l_rochs               ;nein
             CMP byte[ASTELL+15h],84h  ;Pos. linker schwarzer Turm
             JNE l_rochs               ;weg oder schon mal gezogen
             MOV bl,18h                ;D8 bedroht?
             PUSH edi
             CALL l_attackfeldw
             POP edi
             CMP [ATTACK],0h
             JNE l_rochs               ;ja
             MOV bl,17h                ;C8 bedroht?
             PUSH edi
             CALL l_attackfeldw
             POP edi
             CMP [ATTACK],0h
             JNE l_rochs               ;ja
             MOV bl,17h
             CALL l_schreibtabs

ROCHS:       MOV bx,[TIEFE]
             MOV word[ZUGTAB+edi],0ffffh  ;Zeichen fr Ende ZUGTAB
             SHL bx,1h
             MOV cx,[ZZUGTAB+ebx]      ;von ZUGENSS, Anfang dieser Zugtabelle
    
HASHS1:      MOV edx,[HASHADR]
             AND edx,[ANDWERT]
             SHL edx,3h                ;8 Byte Abstand
             MOV eax,[HASHCODE]
             ADD edx,[HASHGROESSE]      
             CMP [esi+edx],eax
             JNE l_kills1
             MOV bl,[esi+7h+edx]       ;nur ZFELD!
             MOV [X1],bl
             MOV bx,cx
ESTESTWS01H: CMP bx,di                 ;DI=Ende ZUGTAB
             JAE l_kills1
             MOV dx,word[ZUGTAB+ebx]
             ADD bx,2h
             CMP [X1],dh
             JNE l_estestws01h
             MOV ax,word[ZUGTAB+ecx]
             MOV word[ZUGTAB+ecx],dx
             SUB bx,2h
             MOV word[ZUGTAB+ebx],ax
             ADD cx,2h
             ADD bx,2h
             JMP l_estestws01h

KILLS1:      MOV bx,[TIEFE]
             SHL bx,2h
             MOV ax,word[KILLTABN+ebx] ;Killerzug 1 setzen
             MOV bx,cx
BESTTESTS11: CMP bx,di
             JAE l_kills2
             MOV dx,word[ZUGTAB+ebx]
             ADD bx,2h
             CMP ax,dx
             JNE l_besttests11
             MOV ax,word[ZUGTAB+ecx]
             MOV word[ZUGTAB+ecx],dx
             SUB bx,2h
             MOV word[ZUGTAB+ebx],ax   ;Stelle von BESTTESTS11
             ADD cx,2h
             
KILLS2:      MOV bx,[TIEFE]
             SHL bx,2h                 ;dd!
             ADD bx,2h
             MOV ax,word[KILLTABN+ebx] ;Killerzug 2 setzen
             MOV bx,cx
BESTTESTS21: CMP bx,di
             JAE l_bestlines
             MOV dx,word[ZUGTAB+ebx]
             ADD bx,2h
             CMP ax,dx
             JNE l_besttests21
             MOV ax,word[ZUGTAB+ecx]
             MOV word[ZUGTAB+ecx],dx
             SUB bx,2h
             MOV word[ZUGTAB+ebx],ax   ;Stelle von BESTTESTS21
             ADD cx,2h

BESTLINES:   MOV bx,[TIEFE]
             SHL bx,1h
             MOV ax,[BESTLINE+ebx]     ;letzten Killerzug setzen
             MOV bx,cx
BESTTESTS01: CMP bx,di
             JAE l_zgsx
             MOV dx,word[ZUGTAB+ebx]
             ADD bx,2h
             CMP ax,dx
             JNE l_besttests01
             MOV ax,word[ZUGTAB+ecx]
             MOV word[ZUGTAB+ecx],dx
             SUB bx,2h
             MOV word[ZUGTAB+ebx],ax
                      
       ;------------------- Extended Futility Pruning --------------------------
ZGSX:        RET         ;brachte nicht die erhofften Resultate

       ;----------------------- Eigentliche Zugerzeugung -----------------------

       ;----------------------- Zge schwarze Bauern ---------------------------
SBAUER1:     TEST [ASTELL+0ah+ebx],ch  ;frei?
             JNZ l_weiterfelds         ;nein, weiter
             CMP bl,51h                ;A2 oder grer?
             JAE l_weiterfelds         ;ja, Umwandlung gilt als Schlagzug
             ADD bl,0ah
             CALL l_schreibtabs

             CMP dl,26h                ;noch 7.Reihe?
             JA l_sbauer2              ;nein
             TEST [ASTELL+0ah+ebx],ch  ;frei?
             JNZ l_sbauer2             ;nein
             ADD bl,0ah
             CALL l_schreibtabs

SBAUER2:     MOV bl,dl
             JMP l_weiterfelds

       ;---------------------- Zge schwarze Springer --------------------------
SSPRINGER1:  SUB bl,15h                ;2 Felder vorwrts, 1 Feld nach links
             TEST [ASTELL+ebx],ah      ;Randfeld oder Figur?
             JNZ l_sspringer2          ;ja
             CALL l_schreibtabsf

SSPRINGER2:  ADD bl,2h                 ;2 Felder vorwrts, 1 Feld nach rechts
             TEST [ASTELL+ebx],ah
             JNZ l_sspringer3
             CALL l_schreibtabsf

SSPRINGER3:  ADD bl,0bh                ;1 Feld vorwrts, 2 Felder nach rechts
             TEST [ASTELL+ebx],ah
             JNZ l_sspringer4
             CALL l_schreibtabsf

SSPRINGER4:  SUB bl,4h                 ;1 Feld vorwrts, 2 Felder nach links
             TEST [ASTELL+ebx],ah
             JNZ l_sspringer5
             CALL l_schreibtabsf

SSPRINGER5:  ADD bl,14h                ;1 Feld rckwrts, 2 Felder nach links
             TEST [ASTELL+ebx],ah
             JNZ l_sspringer6
             CALL l_schreibtabsf

SSPRINGER6:  ADD bl,4h                 ;1 Feld rckwrts, 2 Felder nach rechts
             TEST [ASTELL+ebx],ah
             JNZ l_sspringer7
             CALL l_schreibtabsf

SSPRINGER7:  ADD bl,7h                 ;1 Feld rckwrts, 2 Felder nach links
             TEST [ASTELL+ebx],ah
             JNZ l_sspringer8
             CALL l_schreibtabsf

SSPRINGER8:  ADD bl,2h                 ;1 Feld rckwrts, 2 Felder nach rechts
             TEST [ASTELL+ebx],ah
             JNZ l_sspringer9
             CALL l_schreibtabsf

SSPRINGER9:  MOV bl,dl
             JMP l_weiterfelds

SLAEUFER1:   SUB bl,0bh                ;nach links oben
             TEST [ASTELL+ebx],ah      ;Zielfeld Rand oder Figur?
             JNZ l_slaeufer2           ;ja
             CALL l_schreibtabsf
             JMP l_slaeufer1           ;nein, nchstes Feld

SLAEUFER2:   MOV bl,dl
SLAEUFER21:  ADD bl,9h
             TEST [ASTELL+ebx],ah
             JNZ l_slaeufer3
             CALL l_schreibtabsf
             JMP l_slaeufer21

SLAEUFER3:   MOV bl,dl
SLAEUFER31:  ADD bl,0bh
             TEST [ASTELL+ebx],ah
             JNZ l_slaeufer4
             CALL l_schreibtabsf
             JMP l_slaeufer31

SLAEUFER4:   MOV bl,dl
SLAEUFER41:  SUB bl,9h
             TEST [ASTELL+ebx],ah
             JNZ l_slaeufer5
             CALL l_schreibtabsf
             JMP l_slaeufer41

SLAEUFER5:   MOV bl,dl
             CMP [X1],bh               ;Dame?
             JE l_weiterfelds          ;nein

       ;-------------------------------
STURM1:      DEC bl                    ;nach links
             TEST [ASTELL+ebx],ah
             JNZ l_sturm2
             CALL l_schreibtabsf
             JMP l_sturm1

STURM2:      MOV bl,dl
STURM21:     SUB bl,0ah                ;nach oben
             TEST [ASTELL+ebx],ah
             JNZ l_sturm3
             CALL l_schreibtabsf
             JMP l_sturm21

STURM3:      MOV bl,dl
STURM31:     INC bl                    ;nach rechts
             TEST [ASTELL+ebx],ah
             JNZ l_sturm4
             CALL l_schreibtabsf
             JMP l_sturm31

STURM4:      MOV bl,dl
STURM41:     ADD bl,0ah                ;nach unten
             TEST [ASTELL+ebx],ah
             JNZ l_sturm5
             CALL l_schreibtabsf
             JMP l_sturm41

STURM5:      MOV bl,dl
             MOV [X1],bh               ;Merker Dame-Lufer wieder auf Null
             JMP l_weiterfelds

;----------------- Unterprogramm Zuggenerator schwarze Schlagzge --------------
ZUGGENSS:    MOVZX ebx,[TIEFE]
             MOV [X1],bh               ;Merker Dame-Lufer
             SHL bx,1h
             MOV word[Z+2h+ebx],0h
             MOVZX edi,[AZ]            ;Zeiger in ZUGTAB
             CMP [NMOVE],0ffh
             JNE l_zuggenss1
      
       ;--------------- Null-Zug erzeugen -------------------
             MOV word[ZUGTAB+edi],7979h;Null-Zug
             ADD di,2h
             MOV [NMOVE],0feh
   
ZUGGENSS1:   MOV cx,[ANZFIGS+ebx]      ;Ende nach X Figuren
             MOV ah,10h
             MOV ch,88h

             MOV bl,[SKFELD]
             MOV dl,bl
             SUB bl,0bh                ;nach links oben, ist ZFELD f. SCHREIBTAB
             TEST [ASTELL+ebx],ah      ;weisse Figur?
             JZ l_sking2s              ;nein
             CALL l_schreibtab1

SKING2S:     ADD bl,14h                ;nach links unten
             TEST [ASTELL+ebx],ah
             JZ l_sking3s
             CALL l_schreibtab1

SKING3S:     ADD bl,2h                 ;nach rechts unten
             TEST [ASTELL+ebx],ah
             JZ l_sking4s
             CALL l_schreibtab1

SKING4S:     SUB bl,14h                ;nach rechts oben
             TEST [ASTELL+ebx],ah
             JZ l_sking5s
             CALL l_schreibtab1

SKING5S:     ADD bl,8h                 ;nach links
             TEST [ASTELL+ebx],ah
             JZ l_sking6s
             CALL l_schreibtab1

SKING6S:     ADD bl,2h                 ;nach rechts
             TEST [ASTELL+ebx],ah
             JZ l_sking7s
             CALL l_schreibtab1

SKING7S:     SUB bl,0bh                ;nach oben
             TEST [ASTELL+ebx],ah
             JZ l_sking8s
             CALL l_schreibtab1

SKING8S:     ADD bl,14h                ;nach unten
             TEST [ASTELL+ebx],ah
             JZ l_sking9s
             CALL l_schreibtab1

SKING9S:     MOV bx,15h
ABRETTSSS:   MOV al,[ASTELL+ebx]
             TEST al,80h               ;schwarze Figur?
             JNZ l_zuggenschws         ;ja
             INC bx
             JMP l_abrettsss

       ;------------------------------------------------------------------------
ZUGGENSCHWS: MOV dl,bl
             AND al,7h
             DEC al                    ;Bauer?
             JZ l_sbauer1s
             DEC al                    ;Springer?
             JZ l_sspringer1s
             DEC al                    ;Lufer?
             JZ l_slaeufer1s
             DEC al                    ;Turm?
             JZ l_sturm1s
             DEC al                    ;Dame?
             JNZ l_weiterfeldsss      
             MOV [X1],bl               ;Merker Dame-Lufer
             JMP l_slaeufer1s

WEITERFELDSSS:INC bx
             DEC cl
             JNZ l_abrettsss
 
             MOV bx,[TIEFE]
             SHL bx,1h

             MOV [ZZUGTAB+ebx],di
             CMP word[VARTIEFE+ebx],0h
             JLE l_ruhess1             ;Ruhesuche
             MOV word[ZUGTAB+edi],0fffeh   ;Ende ZUGTAB markieren
             JMP l_ruhess2
RUHESS1:     MOV word[ZUGTAB+edi],0ffffh
RUHESS2:     MOV cx,[AZ]
             CMP [NMOVE],0feh          ;Nullzug?
             JNE l_hashss
             ADD cx,2h

HASHSS:      MOV edx,[HASHADR]
             AND edx,[ANDWERT]
             SHL edx,3h                ;8 Byte Abstand
             MOV eax,[HASHCODE]
             ADD edx,[HASHGROESSE]
             CMP [esi+edx],eax
             JNE l_killss1
             MOV bl,[esi+7h+edx]
             MOV [X1],bl
             MOV bx,cx
STESTWS01H:  CMP bx,di                 ;DI=Ende ZUGTAB
             JAE l_killss1
             MOV dx,word[ZUGTAB+ebx]
             ADD bx,2h
             CMP [X1],dh
             JNE l_stestws01h
             MOV ax,word[ZUGTAB+ecx]
             MOV word[ZUGTAB+ecx],dx
             SUB bx,2h
             MOV word[ZUGTAB+ebx],ax
             ADD cx,2h
             ADD bx,2h
             JMP l_stestws01h

KILLSS1:     MOV bx,[TIEFE]
             SHL bx,2h                 ;dd!
             MOV ax,word[KILLTABS+ebx] ;Killerzug 1 setzen
             MOV bx,cx
BESTTESTS61: CMP bx,di
             JAE l_killss2
             MOV dx,word[ZUGTAB+ebx]
             ADD bx,2h
             CMP ax,dx
             JNE l_besttests61
             MOV ax,word[ZUGTAB+ecx]
             MOV word[ZUGTAB+ecx],dx
             SUB bx,2h
             MOV word[ZUGTAB+ebx],ax   ;Stelle von BESTTESTS61
             ADD cx,2h

KILLSS2:     MOV bx,[TIEFE]
             SHL bx,2h                 ;dd!
             ADD bx,2h
             MOV ax,word[KILLTABS+ebx] ;Killerzug 2 setzen
             MOV bx,cx
BESTTESTS71: CMP bx,di
             JAE l_bestliness
             MOV dx,word[ZUGTAB+ebx]
             ADD bx,2h
             CMP ax,dx
             JNE l_besttests71
             MOV ax,word[ZUGTAB+ecx]
             MOV word[ZUGTAB+ecx],dx
             SUB bx,2h
             MOV word[ZUGTAB+ebx],ax   ;Stelle von BESTTESTS71
             ADD cx,2h

BESTLINESS:  MOV bx,[TIEFE]
             SHL bx,1h
             MOV ax,[BESTLINE+ebx]     ;letzten Killerzug setzen
             MOV bx,cx
BESTTESTS51: CMP bx,di
             JAE l_zugsortsse
             MOV dx,word[ZUGTAB+ebx]
             ADD bx,2h
             CMP ax,dx
             JNE l_besttests51
             MOV ax,word[ZUGTAB+ecx]
             MOV word[ZUGTAB+ecx],dx
             SUB bx,2h
             MOV word[ZUGTAB+ebx],ax
           
ZUGSORTSSE:  MOV [NMOVE],0h
             RET

         ;------------------------- Zge schw. Bauern ---------------------------
SBAUER1S:    CMP bl,51h                ;kleiner als A2?
             JB l_sbauer2s             ;ja, nach vorn keine Umwandlung mglich
             TEST byte[ASTELL+0ah+ebx],7h  ;steht da was?
             JNZ l_sbauer2s            ;ja
             ADD bl,82h                ;82H=100D+10D+(4*5) fr Dame
             CALL l_schreibtab1        ;eigentliches ZFELD ist BL+10D
             SUB bl,4h                 ;Turm
             CALL l_schreibtab1
             SUB bl,4h                 ;Lufer
             CALL l_schreibtab1
             SUB bl,4h                 ;Springer
             CALL l_schreibtab1

SBAUER2S:    MOV bl,dl
             TEST [ASTELL+9h+ebx],ah   ;weisse Figur?
             JZ l_sbauer3s             ;nein
             CMP bl,51h
             JB l_sbauer21s            ;keine Umwandlung
             ADD bl,9h
 
SBAUER20S:   ADD bl,78h                ;100D+(4*5) fr Dame
             CALL l_schreibtab1
             SUB bl,4h                 ;Turm
             CALL l_schreibtab1
             SUB bl,4h                 ;Lufer
             CALL l_schreibtab1
             SUB bl,4h                 ;Springer
             CALL l_schreibtab1
             JMP l_sbauer3s
SBAUER21S:   ADD bl,9h
             CALL l_schreibtab1

SBAUER3S:    MOV bl,dl
             TEST [ASTELL+0bh+ebx],ah  ;weisse Figur?
             JZ l_sbauer4s             ;nein
             CMP bl,51h                ;A2
             JB l_sbauer31s            ;keine Umwandlung
             ADD bl,0bh

SBAUER30S:   ADD bl,78h                ;100D+(4*5) fr Dame
             CALL l_schreibtab1
             SUB bl,4h                 ;Turm
             CALL l_schreibtab1
             SUB bl,4h                 ;Lufer
             CALL l_schreibtab1
             SUB bl,4h                 ;Springer
             CALL l_schreibtab1
             JMP l_sbauer6s
SBAUER31S:   ADD bl,0bh
             CALL l_schreibtab1

SBAUER4S:    MOV bl,dl
             DEC bl                    ;rechtes Nebenfeld fr en passant
             CMP bl,[LASTZUGGZ]        ;war es Zielfeld letzter Gegnerzug?
             JNE l_sbauer5s            ;nein
             MOV al,[ASTELL+ebx]
             AND al,7h
             CMP al,1h                 ;Bauer?
             JNE l_sbauer5s            ;nein
             ADD bl,14h
             CMP bl,[LASTZUGGA]        ;Ausgangsfeld 2 Schritte zurck?
             JNE l_sbauer5s            ;nein
             SUB bl,0ah                ;Zielfeld schwarzer Bauer
             CALL l_schreibtab1
             JMP l_sbauer6s

SBAUER5S:    MOV bl,dl
             INC bl                    ;linkes Nebenfeld fr en passant
             CMP bl,[LASTZUGGZ]        ;war es Zielfeld letzter Gegnerzug?
             JNE l_sbauer6s            ;nein
             MOV al,[ASTELL+ebx]
             AND al,7h
             CMP al,1h                 ;Bauer?
             JNE l_sbauer6s            ;nein
             ADD bl,14h
             CMP bl,[LASTZUGGA]        ;Ausgangsfeld 2 Schritte zurck?
             JNE l_sbauer6s            ;nein
             SUB bl,0ah                ;Zielfeld schwarzer Bauer
             CALL l_schreibtab1

SBAUER6S:    MOV bl,dl
             JMP l_weiterfeldsss

       ;------------------------ Zge schwarzer Springer --------------------------
SSPRINGER1S: SUB bl,15h                ;2 Felder vorwrts, 1 Feld nach links
             TEST [ASTELL+ebx],ah
             JZ l_sspringer2s
             CALL l_schreibtab1

SSPRINGER2S: ADD bl,2h                 ;2 Felder vorwrts, 1 Feld nach rechts
             TEST [ASTELL+ebx],ah
             JZ l_sspringer3s
             CALL l_schreibtab1

SSPRINGER3S: ADD bl,0bh                ;1 Feld vorwrts, 2 Felder nach rechts
             TEST [ASTELL+ebx],ah
             JZ l_sspringer4s
             CALL l_schreibtab1

SSPRINGER4S: SUB bl,4h                 ;1 Feld vorwrts, 2 Felder nach links
             TEST [ASTELL+ebx],ah
             JZ l_sspringer5s
             CALL l_schreibtab1

SSPRINGER5S: ADD bl,14h                ;1 Feld rckwrts, 2 Felder nach links
             TEST [ASTELL+ebx],ah
             JZ l_sspringer6s
             CALL l_schreibtab1

SSPRINGER6S: ADD bl,4h                 ;1 Feld rckwrts, 2 Felder nach rechts
             TEST [ASTELL+ebx],ah
             JZ l_sspringer7s
             CALL l_schreibtab1

SSPRINGER7S: ADD bl,7h                 ;2 Felder rckwrts, 1 Feld nach links
             TEST [ASTELL+ebx],ah
             JZ l_sspringer8s
             CALL l_schreibtab1

SSPRINGER8S: ADD bl,2h                 ;2 Felder rckwrts, 1 Feld nach rechts
             TEST [ASTELL+ebx],ah
             JZ l_sspringer9s
             CALL l_schreibtab1

SSPRINGER9S: MOV bl,dl
             JMP l_weiterfeldsss

SLAEUFER1S:  SUB bl,0bh                ;nach links oben
             TEST [ASTELL+ebx],ch      ;Inhalt Zielfeld
             JNZ l_slaeufer2s
             TEST [ASTELL+ebx],ah      ;weisse Figur?
             JZ l_slaeufer1s           ;nein
             CALL l_schreibtab1

SLAEUFER2S:  MOV bl,dl
SLAEUFER21S: ADD bl,9h
             TEST [ASTELL+ebx],ch
             JNZ l_slaeufer3s
             TEST [ASTELL+ebx],ah
             JZ l_slaeufer21s
             CALL l_schreibtab1

SLAEUFER3S:  MOV bl,dl
SLAEUFER31S: ADD bl,0bh
             TEST [ASTELL+ebx],ch
             JNZ l_slaeufer4s
             TEST [ASTELL+ebx],ah
             JZ l_slaeufer31s
             CALL l_schreibtab1

SLAEUFER4S:  MOV bl,dl
SLAEUFER41S: SUB bl,9h
             TEST [ASTELL+ebx],ch
             JNZ l_slaeufer5s
             TEST [ASTELL+ebx],ah
             JZ l_slaeufer41s
             CALL l_schreibtab1

SLAEUFER5S:  MOV bl,dl
             CMP [X1],bh               ;Dame?
             JE l_weiterfeldsss        ;nein

STURM1S:     DEC bl                    ;nach links
             TEST [ASTELL+ebx],ch      ;Inhalt Zielfeld
             JNZ l_sturm2s
             TEST [ASTELL+ebx],ah
             JZ l_sturm1s
             CALL l_schreibtab1

STURM2S:     MOV bl,dl
STURM21S:    SUB bl,0ah                ;nach oben
             TEST [ASTELL+ebx],ch
             JNZ l_sturm3s
             TEST [ASTELL+ebx],ah
             JZ l_sturm21s
             CALL l_schreibtab1

STURM3S:     MOV bl,dl
STURM31S:    INC bl                    ;nach rechts
             TEST [ASTELL+ebx],ch
             JNZ l_sturm4s
             TEST [ASTELL+ebx],ah
             JZ l_sturm31s
             CALL l_schreibtab1

STURM4S:     MOV bl,dl
STURM41S:    ADD bl,0ah                ;nach unten
             TEST [ASTELL+ebx],ch
             JNZ l_sturm5s
             TEST [ASTELL+ebx],ah
             JZ l_sturm41s
             CALL l_schreibtab1

STURM5S:     MOV bl,dl
             MOV [X1],bh               ;Merker Dame-Lufer
             JMP l_weiterfeldsss

;----------------------------------- Zge in Zugtabelle schreiben ---------------------------------
;------------------------------------ Versuch einer Zugsortierung ---------------------------------
SCHREIBTABWF:CMP [TIEFE],1h
             JBE l_schreibtabw3           
             
             TEST byte[FELDATTACK+ebx],10h     ;Schwarzer Bauer?
             JNZ l_schreibtabw1                ;ja, hintendran

SCHREIBTABW: TEST byte[FELDATTACK+ebx],0fh     ;Zielfeld von Weiss gedeckt?
             JNZ l_schreibtabw3                ;ja, erstmal als "normalen" Zug behandeln

             TEST byte[FELDATTACK+ebx],0f0h    ;Zielfeld von Schwarz angegriffen
             JNZ l_schreibtabw1                ;ja -> hintendran
   
             CMP word[ZUGTAB-2h+edi],7979h     ;letzter Eintrag Nullzug?
             JE l_schreibtab1          

SCHREIBTABW3:PUSH eax
             PUSH ecx
             PUSH edi
              
             MOV ecx,[BADZUGANF]
             OR ecx,ecx
             JE l_schreibtabw2

SCHREIBTABW0:MOV ax,word[ZUGTAB-2h+edi]
             MOV word[ZUGTAB+edi],ax
             SUB edi,2h
             SUB ecx,2h
             JNZ l_schreibtabw0
    
SCHREIBTABW2:MOV dh,bl                 ;BL=ZFELD, DL=AFELD
             MOV word[ZUGTAB+edi],dx
             
             POP edi
             POP ecx
             POP eax      
            
             ADD di,2h
             RET
  
SCHREIBTABW1:MOV dh,bl                 ;BL=ZFELD, DL=AFELD
             MOV word[ZUGTAB+edi],dx
             ADD DWord[BADZUGANF],2h
             ADD di,2h
             RET
 
         ;----------------------------------------------     
SCHREIBTABSF:CMP [TIEFE],1h
             JBE l_schreibtabs3           
             
             TEST byte[FELDATTACK+ebx],1h     ;Weisser Bauer?
             JNZ l_schreibtabs1                ;ja, hintendran

 SCHREIBTABS:TEST byte[FELDATTACK+ebx],0f0h
             JNZ l_schreibtabs3
  
             TEST byte[FELDATTACK+ebx],0fh
             JNZ l_schreibtabs1        ;Zielfeld von Weiss angegriffen -> hintendran
            
             CMP word[ZUGTAB-2h+edi],7979h
             JE l_schreibtab1          

SCHREIBTABS3:PUSH eax
             PUSH ecx
             PUSH edi
             
             MOV ecx,[BADZUGANF]
             OR ecx,ecx
             JE l_schreibtabs2

SCHREIBTABS0:MOV ax,word[ZUGTAB-2h+edi]
             MOV word[ZUGTAB+edi],ax
             SUB edi,2h
             SUB ecx,2h
             JNZ l_schreibtabs0
    
SCHREIBTABS2:MOV dh,bl                 ;BL=ZFELD, DL=AFELD
             MOV word[ZUGTAB+edi],dx
            
             POP edi
             POP ecx
             POP eax      
            
             ADD di,2h
             RET
  
SCHREIBTABS1:MOV dh,bl                 ;BL=ZFELD, DL=AFELD
             MOV word[ZUGTAB+edi],dx
             ADD DWord[BADZUGANF],2h
             ADD di,2h
             RET     
  
         ;------------------- fr Schlagzge -------------------
SCHREIBTAB1: MOV dh,bl                 ;BL=ZFELD, DL=AFELD
             MOV word[ZUGTAB+edi],dx
             ADD di,2h
             RET

;------------------------------------ Festlegungen der Vorwerte -----------------------------------
;--------------------------------- Letzte Modifizierung 22.01.2006 --------------------------------
;---------------------------- der jeweilige gltige 1.Zug ist ausgefhrt! -------------------------
VORWERTE:    MOV [VORWERT],8000h
             CALL l_attackfeld
             XOR ebx,ebx
             CMP [COLOR],bl
             JE l_vms0

        ;---------------------------- Bonus fr Schach geben ------------------  
             MOV bl,[SKFELD]
             TEST byte[FELDATTACK+ebx],0fh
             JZ l_see1
             ADD [VORWERT],0ah         ;Weiss gibt Schach
             JMP l_hifig
 
        ;---------------------------- Bonus fr Schach geben ------------------ 
VMS0:        MOV bl,[WKFELD]
             TEST byte[FELDATTACK+ebx],0f0h
             JZ l_hifig
             ADD [VORWERT],0ah         ;Schwarz gibt Schach
    
       ;------------ Test auf soeben gezogene Figur wieder zurck --------------

       ;------------------ Angriff auf hhere Figur ------------------------
HIFIG:      





       ;----------------- Static Exchange Evaluation (SEE) ---------------------
SEE1:        ;XOR bx,bx
;        TEST [ZFELDH+1],7
 ;       JZ NOSCHLAGZ        ;war kein Schlagzug

       ;---------------------- Vorspann
  ;      MOV di,TIEFE        ;hier=1
;        MOV bl,[ZFELDH+di]
;        MOV [ZFELDHSEE+di],bl
;        AND bl,7
;        MOV al,[SEEWERT+bx]     ;Wertzhler    Anfnger der Schlgerei
;        MOV X1,al
;        MOV bl,[ZFELD+di]
;        MOV si,bx        ;immer das selbe Feld
;        MOV SEE,1        ;Hinweis fr ATTACKFELDW/S

       ;------ ab hier Loop
;SEE4:        PUSH si
;        TEST [ZFELDHSEE+di],10
;        JNZ short SEE2        ;weisse Figur wurde geschlagen
;        CALL ATTACKFELDS
;        MOV X5,80
;        JMP short SEE3
;SEE2:        CALL ATTACKFELDW        ;Weiss will zurckschlagen
;        MOV X5,0
;SEE3:        MOV bx,ATTACK        ;BH=Figur, BL=Feld
;        POP si
;        OR bx,bx
;        JE short RESTMIES1      ;kein Rckschlagen mglich
       ;--------- Test auf Knig
;        CMP bl,0ff
;        JNE short SEE5        ;nicht der Knig
;        MOV bx,si
;        PUSH si
;        CMP X5,0
;        JE short SEE6        ;Weiss zuletzt
;        CALL ATTACKFELDW
;        JMP short SEE7
;SEE6:        CALL ATTACKFELDS
;SEE7:        POP si
;        CMP ATTACK,0
;        JNE short RESTMIES1     ;Schlagen nicht mglich
       ;-------
;SEE5:        XOR bh,bh
;        MOV bl,[ASTELL+si]
;        AND bl,7
;        MOV al,[SEEWERT+bx]
;        SUB X1,al
;        MOV bx,ATTACK
;        XOR bh,bh
;        NEG X1
;        JS short RESTMIES

;        INC di         ;"Tiefe" erhhen
;        MOV al,[ASTELL+si]      ;Schlagfeld
;        MOV [ZFELDHSEE+di],al   ;Inhalt sichern
;        MOV [AFELDSEE+di],bl    ;Feld gesichert
;        MOV al,[ASTELL+bx]
 ;       MOV [AFELDHSEE+di],al   ;Inhalt gesichert
;        MOV [ASTELL+bx],0       ;Feld leeren
;        MOV [ASTELL+si],al      ;Schlagfeld fllen
;        MOV bx,si
;        JMP SEE4

;RESTMIES:      NEG X1
;RESTMIES1:     CMP di,TIEFE
;        JE short SEEE
;       ;--- "Zge" zurck
;        MOV al,[AFELDHSEE+di]
;        MOV bl,[AFELDSEE+di]
;        MOV [ASTELL+bx],al
;        MOV al,[ZFELDHSEE+di]
;        MOV [ASTELL+si],al
;        DEC di
;        JMP RESTMIES

;SEEE:        MOV SEE,0
;        XOR eax,eax
;        MOV al,X1
;        TEST al,80
;        JZ short SEEE1
;        MOV ah,0ff
;SEEE1:        ADD VORWERT,ax
;       MOV ax,VORWERT
;       PUSHAD
;       XOR edi,edi
;       MOV TEXTTEMP,20
;       CALL ZAHLM
;       PUSH ds
;       POP es
;       MOV ax,1301
;       MOV bx,7
;       MOV dx,1d48
;       MOV bp,offset [TEXTTEMP+1]
;       MOV cx,7
;      ;int 10
;      ;call WARTE
;       POPAD
       ;----------- Test ob letzter Zug in Nhe gegnerischer Knig -------------
NOSCHLAGZ:   ;CALL l_attackfeld
             XOR bx,bx                 ;wichtig auch fr Nachfolger!
             CMP [COLOR],bl
             JE l_ab012
             MOV al,[SKFELD]
             JMP l_ab013
AB012:       MOV al,[WKFELD]
AB013:       MOV dh,al                 ;sichern fr weitere Verwendung
             SUB al,[ZFELD+1h]
             JNC l_ab014
             NEG al
AB014:       MOV dl,[AFELDH+1h]
             AND dl,7h
                
         ;--------------- Test, ob die gesetzte Figur nur der Knig schlagen kann    
             CMP al,1h
             JE l_nurking
             CMP al,9h
             JE l_nurking
             CMP al,0ah
             JE l_nurking
             CMP al,0bh
             JNE l_gaul
 
NURKING:     MOV bl,[ZFELD+1h]    
             MOV al,[FELDATTACK+ebx]   ;Aufruf oben
             CMP [COLOR],bh
             JE l_ab015a
             AND al,0f0h               ;Bit 4-7 schwarz
             JMP l_ab015b
AB015A:      SHL al,4h                 ;schiebt weiss nach schwarz
AB015B:      CMP al,80h                ;nur Bit fr Knigs-Schlagfeld
             JNE l_gaul
 
             ADD [VORWERT],10h         ;nur Knig kann schlagen
           
           ;--------------------------- Test auf Springer -------           
 GAUL:       CMP dl,2h
             JNE l_nogaul
             CMP al,12h
             JE l_gaulbonus   
             CMP al,16h
             JE l_gaulbonus            
             CMP al,1dh
             JE l_gaulbonus
             CMP al,1fh
             JNE l_nogaul
GAULBONUS:   ADD [VORWERT],5h      
             JMP l_bschlag   
 
 
          ;--------------------------- Test auf Bauer ------
NOGAUL:      CMP dl,1h
             JNE l_nobauer
             CMP al,12h
             JB l_bschlag   
             CMP al,16h
             JA l_bschlag             
BBONUS:      ADD [VORWERT],0ah             
             JMP l_bschlag
             
             
NOBAUER:    
          
          ;---------------- Test, ob Turm auf Reihe in Nhe feindlicher Knig -------
             CMP dl,4h
             JNE l_noturm
  
             MOV bl,dh                 ;dh ist entsprechendes Knigsfeld  
             SHL bl,1h
             MOV al,[NFELD+1h+ebx]
             MOV bl,[ZFELD+1h]    
             SHL bl,1h
             MOV ah,[NFELD+1h+ebx]
             SUB ah,al
             JNC l_obt63
             NEG ah
OBT63:       CMP ah,2h
             JA l_bschlag       
                         
             MOV bx,14h
             SUB bl,ah
             ADD [VORWERT],bx
             JMP l_bschlag   
NOTURM:             


       ;--------Test, ob Bauer auf feindlicher Knigslinie geschlagen wurde -------
BSCHLAG:     MOV dl,[ZFELDH+1h]
             AND dl,7h
             CMP dl,1h
             JNE l_nobauerk
             
             MOV bl,dh                 ;Knigsfeld
             SHL bl,1h
             MOV al,[NFELD+ebx]
             MOV bl,[ZFELD+1h]    
             SHL bl,1h
             MOV ah,[NFELD+ebx]
             SUB ah,al
             JZ l_bdirekt
             CMP ah,1h     
             JE l_bdirekt1
             CMP ah,0ffh
             JE l_bdirekt1
        RET
             
             
             
BDIREKT:     ADD [VORWERT],10h
BDIREKT1:    ADD [VORWERT],9h
             
             ;JMP l_ab01ee
             RET          
                        
           
NOBAUERK:             
    

       ;--------------- Test ob Angriff auf ungedeckte Figur -------------------
        ;brachte nur Verdruss! Wahrscheinlich zu simpel!
       ;-------- Test, ob gezogene Figur vorher von Bauer angegriffen war ------
        ;s.o.
 

AB01EE:      RET

;---------------------- Zge der Ausgangsstellung sortieren --------------------
REWS:        XOR ecx,ecx               ;muss!
             CMP [COLOR],cl
             JE l_rews0
           
             CALL l_zuggenss           ;schwarze Zge generieren und abspeichern
             CALL l_zuggens
             JMP l_rews01
REWS0:       CALL l_zuggenws           ;weisse Zge generieren und abspeichern
             CALL l_zuggenw

REWS01:      MOV [SORTE],1h            ;Zeiger auf Ende von ZUGSORT
             XOR edi,edi               ;unbedingt!
             MOV [SORTA],di
             MOV dword[ZUGSORT],0ffffffffh  ;obere Schranke
             MOV [ZUGSORT+4h],edi      ;untere Schranke
             MOV [ZZZUGTABGUT],0h
REWS1:       CMP [COLOR],0h
             JE l_rews10
             CALL l_hs1
             JMP l_rews11
REWS10:      CALL l_hw1                ;Zug ausfhren, erhht TIEFE
REWS11:      CMP ax,0ffffh             ;Ende ZUGTAB?
             JNE l_rews2               ;nein
                      
             RET                       ;kein Zug mehr ausfhrbar, Ende

REWS2:       XOR ebx,ebx
             PUSHAD                    ;ntig?
             CALL l_attackfeld
             POPAD 
             
             CMP [COLOR],0h
             JNE l_rews20
             MOV bl,[SKFELD]
             TEST byte[FELDATTACK+ebx],0fh
             JNZ l_uzugws              ;ungltiger Zug
             JMP l_rews21
REWS20:      MOV bl,[WKFELD]
             TEST byte[FELDATTACK+ebx],0f0h
             JNE l_uzugws              ;ungltiger Zug
       ;------------- Test ob Zug Fortsetzung von Bestline ist -----------------
REWS21:      ;MOV cl,[AFELD+1h]
             ;MOV ch,[ZFELD+1h]
             ;CMP [COLOR],0h            ;weil hier Zug noch ausgefhrt!
             ;JE l_sbz3
             ;MOV ax,WBESTZUGERW
             ;CMP cx,WBESTZUGZUG
             ;JE l_wbz4                 ;Zug bekommt Erweiterungen vom Vorgnger
             ;JMP l_wbz3
SBZ3:        ;MOV ax,SBESTZUGERW
             ;CMP cx,SBESTZUGZUG
             ;JE l_wbz4

WBZ3:        PUSHAD
             CALL l_vorwerte
             POPAD
    
WBZ4:        MOV dh,[AFELD+1h]         ;von AW/AS
             MOV dl,[ZFELDU]           ;Originalwert fr Bauernumw. von AW/AS
             SHL edx,10h               ;in E-Bereich schieben
             MOV dx,[VORWERT]          ;in EDX steht jetzt AFELD,ZFELD,VORWERT
             INC [ZZZUGTABGUT]
EINFUEG0:    PUSH [SORTE]
EINFUEG:     MOV bx,[SORTE]
             ADD bx,[SORTA]
             SHR bx,1h
             SHL bx,2h
             MOV eax,[ZUGSORT+ebx]
             CMP ax,dx
             JB l_kleiner              ;nach <--
             ADD bx,4h
             MOV eax,[ZUGSORT+ebx]
             CMP ax,dx
             JA l_groesser             ;nach -->
             POP [SORTE]
             MOV [X4],ebx
             SHR bx,2h                 ;hier ist einzufgen
             MOV cx,[SORTE]
             INC cx
             SUB cx,bx                 ;Anzahl der Verschiebungen

       ;---- Einfgestelle gefunden, Verschieberoutine -------------------------
             MOVZX ebx,[SORTE]         ;altes Ende
             SHL bx,2h
        
EINFUEG1:    MOV eax,[ZUGSORT+ebx]
             MOV [ZUGSORT+4h+ebx],eax
             SUB ebx,4h
             DEC cx
             JNZ l_einfueg1
                        
             MOV ebx,[X4]
             MOV [ZUGSORT+ebx],edx
                         
             INC [SORTE]
             MOV [SORTA],0h
UZUGWS:      CMP [COLOR],0h
             JNE l_uzugw
             CALL l_shzr
             JMP l_rews1
UZUGW:       CALL l_whzr               ;Zug zurcknehmen
             JMP l_rews1
KLEINER:     SHR bx,2h
             MOV [SORTE],bx
             JMP l_einfueg
GROESSER:    SHR bx,2h
             MOV [SORTA],bx
             JMP l_einfueg

;---------------------- Bildschirmausgabe gltige Zge -------------------------
BAUSZUG:     PUSHAD 
             CMP [SCREEN],0h
             JNE l_bauszuge1
             MOV eax,20202020h
             XOR ebx,ebx
             MOV cx,5eh
BAUSZUGL:    MOV dword[TEXTTEMPBA+ebx],eax  ;Mll lschen und Leerzeichen fr Ausgabe
             ADD bx,4h
             DEC cx
             JNZ l_bauszugl
             
             XOR ebx,ebx
             MOV ecx,ebx
             MOV [v_PB4],ebx           ;fr Zwischenraum
             MOV edi,ebx               ;Zeiger in TEXTTEMP
ZUGTABAUSL:  MOV bl,[ZUGTAB+ecx]
             CMP bl,0ffh
             JE l_bauszuge             ;Ende ZUGTAB
             CMP bl,62h                ;Bauernumwandlungszug?
             JBE l_bauszug1            ;nein
    
         ;------------------- Dekodierung Bauernumwandlung -----------------------
             MOV ah,bl
             SUB ah,64h                ;ZFELD minus 100
             MOV bl,[ZUGTAB-1h+ecx]    ;AFELD
             CMP [COLOR],80h
             JE l_bauszugs
             SUB bl,0ah                ;1.Mglichkeit: gerade durchgezogen
             SUB ah,bl
             TEST ah,3h                ;Bit 0 o.1 gesetzt? (nicht d.4 teilbar)
             JZ l_bauszug1             ;BL ist echtes ZFELD

             DEC ah                    ;2.Mglichkeit: nach links schlagen
             TEST ah,3h
             JNZ l_nichtlb             ;war nicht nach links
             INC bl
             JMP l_bauszug1
NICHTLB:     DEC bl                    ;bleibt nur 3.Mglichkeit: nach rechts
             JMP l_bauszug1

BAUSZUGS:    ADD bl,0ah                ;1.Mglichkeit: gerade durchgezogen
             SUB ah,bl
             TEST ah,3h                ;Bit 0 o.1 gesetzt? (nicht d.4 teilbar)
             JZ l_bauszug1             ;BL ist echtes ZFELD;

             DEC ah                    ;2.Mglichkeit: nach links schlagen
             TEST ah,3h
             JNZ l_nichtls             ;war nicht nach links
             INC bl
             JMP l_bauszug1
NICHTLS:     DEC bl                    ;bleibt nur 3.Mglichkeit: nach rechts

BAUSZUG1:    SHL bl,1h
             MOV dx,word[NFELD+ebx]
             ADD dx,3060h
             MOV word[TEXTTEMPBA+edi],dx
             ADD di,2h
             INC [v_PB4]
             CMP [v_PB4],2h
             JNE l_nospalt
             MOV [v_PB4],0h
             INC di
             CMP di,174h
             JAE l_bauszuge            ;Begrenzung auf 3 Zeilen

NOSPALT:     INC cx
             JMP l_zugtabausl

BAUSZUGANZ:  PUSHAD                    ;Einsprung fr Info wieder ein 

BAUSZUGE:   
             XOR ebx,ebx
             MOV ecx,7ch
BAUSZUGE0:   
             PUSH ecx
             MOV al,[TEXTTEMPBA+ebx]
             MOV [v_XSH],eax
       TEXTTEST1$=TEXTTEST1$+Chr(XSH) 
             MOV al,[TEXTTEMPBA+7dh+ebx]
             MOV [v_XSH],eax
       TEXTTEST2$=TEXTTEST2$+Chr(XSH)
             MOV al,[TEXTTEMPBA+0fah+ebx]
             MOV [v_XSH],eax
       TEXTTEST3$=TEXTTEST3$+Chr(XSH)
             INC bx  
             POP ecx   
             DEC ecx
             JNZ l_bauszuge0 
     
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial",12))
       BackColor(12566463)
       PB4=TextWidth(TEXTTEST1$)
             MOV eax,3ffh
             SUB eax,[v_PB4]
             MOV [v_PB4],eax
       TEXTTEST4$=LSet("",PB4) 
       TEXTTEST1$=TEXTTEST1$+TEXTTEST4$
       DrawText(10,665,TEXTTEST1$) 
       PB4=TextWidth(TEXTTEST2$)
             MOV eax,3ffh
             SUB eax,[v_PB4]
             MOV [v_PB4],eax
       TEXTTEST5$=LSet("",PB4) 
       TEXTTEST2$=TEXTTEST2$+TEXTTEST5$
       DrawText(10,685,TEXTTEST2$)  
       PB4=TextWidth(TEXTTEST3$)
             MOV eax,3ffh
             SUB eax,[v_PB4]
             MOV [v_PB4],eax
       TEXTTEST6$=LSet("",PB4) 
       TEXTTEST3$=TEXTTEST3$+TEXTTEST6$
       DrawText(10,705,TEXTTEST3$) 
       Line(10,725,1010,0) 
       StopDrawing()

       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(140*65536)
       DrawingFont(LoadFont(1,"Arial",12))
       BackColor(12566463)
       DrawText(10,665,TEXTTEST1$) 
       DrawText(10,685,TEXTTEST2$)  
       DrawText(10,705,TEXTTEST3$) 
       Line(10,725,1010,0) 
       TEXTTEST1$=""
       TEXTTEST2$=""
       TEXTTEST3$=""
       TEXTTEST4$=""
       TEXTTEST5$=""
       TEXTTEST6$=""
       StopDrawing()

BAUSZUGE1:   POPAD 
                       
             RET

;------------------------------- Ende TVORWERT ---------------------------------

;------------------------------------- Brettmal -----------------------------------------------------
BRETTMAL0:   MOV ebx,15h
BRSTELL0:    MOV al,[ASTELL+ebx]       ;Grundstellung in ASTELL kopieren
             AND al,0bfh               ;Feldfarbe weg
             MOV [BSTELL+ebx],al       ;fr Bildschirmdarstellung
             INC bx
             CMP bx,62h
             JBE l_brstell0
          
;------------------------------------ Unterprogramm Brett darstellen -------------------------------
BRETTMAL:
       ;--------------------------- Leeres Brett darstellen ----------------------------------------
 
       DisplayTransparentSprite(1,10,109)           ;109=gleicher oberer und unterer Rand     

       ;--------------------------- aktuelle Stellung zeichnen -----------------------------------------
             MOV al,[TF]
             ADD al,[TF1]
             OR al,al 
             JE l_blacku               ;Schwarz unten

            ;--------------------------- Weiss unten -------------
             MOV [v_SPX],2bh
             MOV [v_SPY],90h
                
             MOV ebx,15h               ;A8
SPRITETEST:  MOV al,[BSTELL+ebx]
             TEST al,80h
             JNZ l_ssprite             ;schwarze Figur
             TEST al,10h
             JNZ l_wsprite             ;weisse Figur
SPRITETEST1: INC bl
             CMP al,8h
             JE l_spritetest3          ;Randfeld
             ADD [v_SPX],40h
             CMP [v_SPX],1ebh
             JBE l_spritetest3
             MOV [v_SPX],2bh
             ADD [v_SPY],3dh
            
             CMP [v_SPY],10ah          ;Schnheitskorrekturen
             JNE l_spritetest2
             INC [v_SPY]
SPRITETEST2: CMP [v_SPY],1c2h
             JNE l_spritetest3
             INC [v_SPY]

SPRITETEST3: CMP bx,62h                ;H1
             JBE l_spritetest
   
         ;------------------------ Brettbeschriftung Weiss unten  ----------------------------------
       StartDrawing(ScreenOutput())
       DrawingMode(1)
      ;DrawingFont(LoadFont(1,"Arial",16))          ;Arial sollte auf jeder Kiste verfgbar sein
       DrawingFont(LoadFont(1,"Palatino Linotype Fett Kursiv",16))    
       FrontColor(657930)                         ;(fast) schwarze Schrift, fast wegen Cursor            
                        
      a=65 : b=49                              ;Buchstabe A und Ziffer 1      
      y=585 : x=65                             ;Positionen
      
      For zv=0 To 7
       a$=Chr(a)     
       b$=Chr(b)
         DrawText(x,633,a$)                    ;Brett-Buchstaben
         DrawText(19,y,b$)                     ;Brett-Ziffern
        a=a+1 : b=b+1
        y=y-61 : x=x+64
      Next
       StopDrawing() 

    Return 

            ;--------------------------- Schwarz unten -------------
BLACKU:      MOV [v_SPX],2bh
             MOV [v_SPY],90h
                
             MOV ebx,62h               ;A8
SPRITETESTU: MOV al,[BSTELL+ebx]
             TEST al,80h
             JNZ l_ssprite             ;schwarze Figur
             TEST al,10h
             JNZ l_wsprite             ;weisse Figur
SPRITETEST1U:DEC bl
             CMP al,8h
             JE l_spritetest3u         ;Randfeld
             ADD [v_SPX],40h
             CMP [v_SPX],1ebh
             JBE l_spritetest3u
             MOV [v_SPX],2bh
             ADD [v_SPY],3dh
              
             CMP [v_SPY],10ah          ;Schnheitskorrekturen
             JNE l_spritetest2u
             INC [v_SPY]
SPRITETEST2U:CMP [v_SPY],1c2h
             JNE l_spritetest3u
             INC [v_SPY]

SPRITETEST3U:CMP bx,15h                ;H1
             JAE l_spritetestu
   
         ;------------------------ Brettbeschriftung Schwarz unten  --------------------------------
       StartDrawing(ScreenOutput())
       DrawingMode(1)
      ;DrawingFont(LoadFont(1,"Arial",16))          ;Arial sollte auf jeder Kiste verfgbar sein
       DrawingFont(LoadFont(1,"Palatino Linotype Fett Kursiv",16))
       FrontColor(657930)                         ;(fast) schwarze Schrift, fast wegen Cursor 
 
      a=72 : b=56                              ;Buchstabe A und Ziffer 1      
      y=585 : x=65                             ;Positionen
      
      For zv=0 To 7
       a$=Chr(a)     
       b$=Chr(b)
         DrawText(x,633,a$)                    ;Brett-Buchstaben
         DrawText(19,y,b$)                     ;Brett-Ziffern
        a=a-1 : b=b-1
        y=y-61 : x=x+64
      Next
       StopDrawing() 
   
   Return
   
   ;-----------------------------------------------------------------------------------------------------

SSPRITE:     AND al,7h                 ;schwarze Figur
             CMP al,1h
             JNE l_ssprite1
             CMP bx,5bh
             JB l_ssprite0      
             MOV [v_SPNRH],11h         ;Bauernumwandlung   
             JMP l_spritemal       
SSPRITE0:    MOV [v_SPNRH],0eh         ;Bauer                
             JMP l_spritemal
SSPRITE1:    CMP al,2h                          
             JNE l_ssprite2
             MOV [v_SPNRH],0ch         ;Springer  
             JMP l_spritemal
SSPRITE2:    CMP al,3h
             JNE l_ssprite3
             MOV [v_SPNRH],0ah         ;Lufer
             JMP l_spritemal          
SSPRITE3:    CMP al,4h
             JNE l_ssprite4
             MOV [v_SPNRH],8h          ;Turm
             JMP l_spritemal            
SSPRITE4:    CMP al,5h
             JNE l_ssprite5
             MOV [v_SPNRH],6h          ;Dame
             JMP l_spritemal
SSPRITE5:    MOV [v_SPNRH],4h          ;Knig
             JMP l_spritemal
              
WSPRITE:     AND al,7h                 ;weisse Figur
             CMP al,1h
             JNE l_wsprite1
             CMP bx,1ch
             JA l_wsprite0      
             MOV [v_SPNRH],10h         ;Bauernumwandlung     
             JMP l_spritemal     
WSPRITE0:    MOV [v_SPNRH],0dh         ;Bauer                
             JMP l_spritemal
WSPRITE1:    CMP al,2h                          
             JNE l_wsprite2
             MOV [v_SPNRH],0bh         ;Springer  
             JMP l_spritemal
WSPRITE2:    CMP al,3h
             JNE l_wsprite3
             MOV [v_SPNRH],9h          ;Lufer
             JMP l_spritemal          
WSPRITE3:    CMP al,4h
             JNE l_wsprite4
             MOV [v_SPNRH],7h          ;Turm
             JMP l_spritemal            
WSPRITE4:    CMP al,5h
             JNE l_wsprite5
             MOV [v_SPNRH],5h          ;Dame
             JMP l_spritemal
WSPRITE5:    MOV [v_SPNRH],3h          ;Knig
                     
SPRITEMAL: 
            DisplayTransparentSprite(SPNRH,SPX,SPY)        ;Sprite darstellen
             
             MOV al,[TF]
             ADD al,[TF1]
             OR al,al 
             JE l_spritetest1u         ;Schwarz unten
             JMP l_spritetest1 
               
;--------------------------------------------------------------------------------------------------

;----------------------- Diverse Zahlenanzeigen --------------------------------
ZAHLGIGA:    XOR ebx,ebx
             MOV ecx,3b9aca00h         ;1.000.000.000 dez.
HEXDEZIG:    CMP eax,ecx
             JB l_ziffertg
             SUB eax,ecx
             INC bx
             JMP l_hexdezig
ZIFFERTG:    OR bx,bx
             JNE l_zig
             SUB bx,10h                ;gibt Leerzeichen aus bei Null
ZIG:         ADD bx,30h
             MOV [TEXTTEMP+edi],bl

ZAHLHM:      XOR bx,bx
             MOV ecx,5f5e100h          ;100.000.000 dez.
HEXDEZIC:    CMP eax,ecx
             JB l_ziffertc
             SUB eax,ecx
             INC bx
             JMP l_hexdezic
ZIFFERTC:    CMP byte[TEXTTEMP+edi],20h;Leerzeichen Vorstelle?
             JNE l_zic                 ;nein
             OR bx,bx
             JNE l_zic
             SUB bx,10h
ZIC:         ADD bx,30h
             INC di
             MOV [TEXTTEMP+edi],bl

             XOR bx,bx
             MOV ecx,989680h           ;10.000.000 dez.
HEXDEZIB:    CMP eax,ecx
             JB l_ziffertb
             SUB eax,ecx
             INC bx
             JMP l_hexdezib
ZIFFERTB:    CMP byte[TEXTTEMP+edi],20h;Leerzeichen Vorstelle?
             JNE l_zib                 ;nein
             OR bx,bx
             JNE l_zib
             SUB bx,10h
ZIB:         ADD bx,30h
             INC di
             MOV [TEXTTEMP+edi],bl

ZAHLM:       XOR bx,bx
             MOV ecx,0f4240h           ;1.000.000 dez.
HEXDEZIA:    CMP eax,ecx
             JB l_zifferta
             SUB eax,ecx
             INC bx
             JMP l_hexdezia
ZIFFERTA:    CMP byte[TEXTTEMP+edi],20h;Leerzeichen Vorstelle?
             JNE l_zia                 ;nein
             OR bx,bx
             JNE l_zia
             SUB bx,10h
ZIA:         INC di
             ADD bx,30h
             MOV [TEXTTEMP+edi],bl

ZAHLHT:      XOR bx,bx
             MOV ecx,186a0h            ;100.000 dez.
HEXDEZI5:    CMP eax,ecx
             JB l_ziffert5
             SUB eax,ecx
             INC bx
             JMP l_hexdezi5
ZIFFERT5:    CMP byte[TEXTTEMP+edi],20h;Leerzeichen Vorstelle?
             JNE l_zi5                 ;nein
             OR bx,bx
             JNE l_zi5
             SUB bx,10h
ZI5:         INC di
             ADD bx,30h
             MOV [TEXTTEMP+edi],bl

ZAHLZT:      XOR bx,bx
             MOV ecx,2710h             ;10.000 dez.
HEXDEZI6:    CMP eax,ecx
             JB l_ziffert6
             SUB eax,ecx
             INC bx
             JMP l_hexdezi6
ZIFFERT6:    CMP byte[TEXTTEMP+edi],20h;Leerzeichen Vorstelle?
             JNE l_zi6                 ;nein
             OR bx,bx
             JNE l_zi6
             SUB bx,10h
ZI6:         INC di
             ADD bx,30h
             MOV [TEXTTEMP+edi],bl

ZAHLT:       XOR bx,bx
             MOV ecx,3e8h              ;1.000 dez.
HEXDEZI7:    CMP eax,ecx
             JB l_ziffert7
             SUB eax,ecx
             INC bx
             JMP l_hexdezi7
ZIFFERT7:    CMP byte[TEXTTEMP+edi],20h;Leerzeichen Vorstelle?
             JNE l_zi7                 ;nein
             OR bx,bx
             JNE l_zi7
             SUB bx,10h
ZI7:         INC di
             ADD bx,30h
             MOV [TEXTTEMP+edi],bl

ZAHLH:       XOR bx,bx
             MOV ecx,64h               ;100 dez.
HEXDEZI8:    CMP eax,ecx
             JB l_ziffert8
             SUB eax,ecx
             INC bx
             JMP l_hexdezi8
ZIFFERT8:    CMP byte[TEXTTEMP+edi],20h;Leerzeichen Vorstelle?
             JNE l_zi8                 ;nein
             OR bx,bx
             JNE l_zi8
             SUB bx,10h
ZI8:         INC di
             ADD bx,30h
             MOV [TEXTTEMP+edi],bl

ZAHLZ:       XOR bx,bx
             MOV ecx,0ah               ;10 dez.
HEXDEZI9:    CMP eax,ecx
             JB l_ziffert9
             SUB eax,ecx
             INC bx
             JMP l_hexdezi9
ZIFFERT9:    CMP byte[TEXTTEMP+edi],20h;Leerzeichen Vorstelle?
             JNE l_zi9                 ;nein
             OR bx,bx
             JNE l_zi9
             SUB bx,10h
ZI9:         INC di
             ADD bx,30h
             MOV [TEXTTEMP+edi],bl
             INC di
             ADD al,30h
             MOV [TEXTTEMP+edi],al     ;Anzeige Einer
             RET

;------------------ Unterroutine Notation der Zge kopieren --------------------
NOTKOP:      XOR ebx,ebx
             MOV cx,13h                ;38 Bytes Zeilenlnge
NK1:         MOV ax,word[ZEILE8+ebx]       ;Schleife !?
             MOV word[ZEILE9+ebx],ax
             MOV ax,word[ZEILE7+ebx]
             MOV word[ZEILE8+ebx],ax
             MOV ax,word[ZEILE6+ebx]
             MOV word[ZEILE7+ebx],ax
             MOV ax,word[ZEILE5+ebx]
             MOV word[ZEILE6+ebx],ax
             MOV ax,word[ZEILE4+ebx]
             MOV word[ZEILE5+ebx],ax
             MOV ax,word[ZEILE3+ebx]
             MOV word[ZEILE4+ebx],ax
             MOV ax,word[ZEILE2+ebx]
             MOV word[ZEILE3+ebx],ax
             MOV ax,word[ZEILE1+ebx]
             MOV word[ZEILE2+ebx],ax
             MOV ax,word[ZEILE0+ebx]
             MOV word[ZEILE1+ebx],ax

             MOV word[ZEILE0+ebx],2020h  ;untere Zeile lschen
             ADD bx,2h
             DEC cx
             JNZ l_nk1
            
             MOV cx,0ah                ;Anzahl der Zeilen
             MOV [v_PB4],1f4h          ;500d
             XOR ebx,ebx
              
NK2:         PUSHAD
       For x=0 To 37
             MOV al,[ZEILE0+ebx]
             MOV [v_XSH],eax
         TEXTTEST4$=TEXTTEST4$+Chr(XSH) 
             INC bx  
       Next    

       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       PB41=TextWidth(TEXTTEST4$)
             MOV eax,3ffh
             SUB eax,[v_PB41]
             MOV [v_PB41],eax
       TEXTTEST1$=LSet("",PB41) 
       TEXTTEST4$=TEXTTEST4$+TEXTTEST1$
       DrawText(700,PB4,TEXTTEST4$) 
       StopDrawing()
             
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,PB4,TEXTTEST4$) 
       TEXTTEST4$=""
       TEXTTEST1$=""
       StopDrawing()
             
             POPAD
             ADD bx,26h                ;nchste Zeile
             SUB [v_PB4],14h
             DEC cx
             JNZ l_nk2
                        
             RET

;---------------------- Unterroutine Bewertungswert ausgeben ---------------------
MWERTAUS:    CMP word[ALPHA],0f500h
             JB l_mwertaus2            ;kein Matt fr den Anziehenden
             MOV [PERBRAIN],0h         ;wichtig!
             MOV dx,0f532h             ;MATTWERT
             SUB dx,[ALPHA]
             SHR dl,1h
             MOV [MATTZAHL],dl         ;fr Zugfertig und Schleife
MWERTAUS2:   CMP [SCREEN],0h
             JE l_mwertaus01
             RET
MWERTAUS01:  PUSHA
             CMP [WERZUG],0h
             JE l_mwertaus0
             NEG ax                    ;fr Remis
             MOV [TIMPWERT],ax           ;ist Wert von Permanent Brain!
             NEG ax
MWERTAUS0:   MOV dl,2bh                ;"+"
             MOV [v_PB4],0h
       ;CMP [COLOR],0h            ;falls Bewertung IMMER aus weisser Sicht angezeigt werden soll!
       ;JE l_mwertw 
       ;NEG ax
MWERTW:      CMP ax,8000h
             JA l_plus
             JB l_mwertaus1
             MOV dl,20h                ;Leerzeichen fr Null
             JMP l_plus
MWERTAUS1:   NEG ax
             MOV dl,2dh                ;"-"
             MOV [v_PB4],0ffh
PLUS:        MOV [TEXTWERT],dl         ;Vorzeichen
             MOV byte[TEXTWERT+4h],2eh ;Punkt  
             MOV di,1h
             SUB ax,8000h
             MOV cx,2710h              ;10.000 dez
             XOR bx,bx
             CALL l_mhexdezi
             MOV cx,3e8h               ;1.000 dez
             CALL l_mhexdezi
             MOV cx,64h                ;100 dez
             CALL l_mhexdezi
             MOV cx,0ah                ;10 dez
             CALL l_mhexdezi
             ADD al,30h
             MOV [TEXTWERT+6h],al      ;Einer

             XOR ebx,ebx
   For x=0 To 6
             MOV al,[TEXTWERT+ebx]
             MOV [v_XSH],eax
       TEXTTEST1$=TEXTTEST1$+Chr(XSH)
             INC bx  
   Next    

       TEXTTEST1$=TEXTTEST1$+"      "           ;eventuelle Reste weg von Pfeilen
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(PB4)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)
       DrawText(10,750,TEXTTEST1$) 
       StopDrawing()
       
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(PB4)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)
       DrawText(10,750,TEXTTEST1$) 
       TEXTTEST1$=""
       StopDrawing()

       ;---------------- Ausgabe Zgeanzahl bis zum Matt -----------------------
             CMP [MATTZAHL],1h         ;wegen DEC unten!
             JBE l_mwertaus02
             CMP [WERZUG],bh
             JNE l_mwertaus02
              
             MOV al,[MATTZAHL]
             DEC al
             MOV [v_XSH],eax
                  
       TEXTTEST1$="Matt in "+Str(XSH)+"   "
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)
       DrawText(100,750,TEXTTEST1$) 
       StopDrawing()
       
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)  
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)
       DrawText(100,750,TEXTTEST1$) 
       TEXTTEST1$=""
       StopDrawing()

MWERTAUS02:  POPA
             RET                       ;Ende von MWERTAUS

MHEXDEZI:    CMP ax,cx
             JB l_mziffert
             SUB ax,cx
             INC bx
             JMP l_mhexdezi

MZIFFERT:    ADD bx,30h
             MOV [TEXTWERT+edi],bl
             INC di
             CMP di,4h                 ;Punkt berspringen
             JNE l_mziffert1
             INC di

MZIFFERT1:   XOR bx,bx
             RET

;-------------- Unterprogramm ausgefhrten Zug von Timpetu anzeigen ------------
ZUGNOTT:     INC [ZUG50]
             MOV [AUTOZUGARTT],1h      ;erstmal normaler Zug
             XOR bh,bh
             MOV bl,[AFELDE]
             SHL bl,1h
             MOV dl,[NFELD+ebx]
             ADD dl,60h
             MOV [NOTF],dl
             MOV dl,[NFELD+1h+ebx]
             ADD dl,30h
             MOV [NOTF+1h],dl
             MOV bl,[ZFELDE]
             SHL bl,1h
             MOV dl,[NFELD+ebx]
             ADD dl,60h
             MOV byte[NOTF+2h],2dh     ;"-"
             MOV [NOTF+3h],dl
             MOV dl,[NFELD+1h+ebx]
             ADD dl,30h
             MOV [NOTF+4h],dl
             MOV byte[NOTF+5h],20h     ;alte umgewandelte Figur weg
       ;--------------------- Zielfeld unter die Lupe nehmen -------------------
             SHR bl,1h                 ;wieder ZFELDE
             MOV al,[ASTELL+ebx]
             TEST al,7h
             JNZ l_schlt
             CALL l_zugsetz            ;keine Figur auf Zielfeld
             CMP [EP],80h              ;en passant? EP von ZUGSETZ
             JNE l_znbu                ;nein, Test auf Bauernumwandlung
             JMP l_schlt1
SCHLT:       CALL l_zugsetz            ;Figur auf Zielfeld
SCHLT1:      MOV byte[NOTF+2h],3ah         ;":"
             MOV [AUTOZUGARTT],2h
             MOV [ZUG50],0h            ;Bauernzug wird in ZUGSETZ getestet
             CMP [EP],80h              ;en passant?
             JNE l_znbu                ;nein, auf Bauernumwandlung testen
             MOV [ZUG50],0h

ZNBU:        CMP [UFIG],0h             ;hat Timpetu einen Bauern in eine Figur
             JE l_zna                  ;umgewandelt?  nein
             MOV al,[UFIG]             ;neue Figur bei Notation ausgeben
TEGWF:       AND al,7h
             CMP al,5h
             JNE l_tixdame
             MOV dl,44h
             JZ l_teunota
TIXDAME:     CMP al,4h
             JNE l_tixturm
             MOV dl,54h
             JZ l_teunota
TIXTURM:     CMP al,3h
             JNE l_tixlaeu
             MOV dl,4ch
             JZ l_teunota
TIXLAEU:     MOV dl,53h

TEUNOTA:     MOV [NOTF+5h],dl          ;Figurenart
ZNA:         MOV [X2],0h     
             CMP [COLOR],0h
             JE l_zna1
             MOV [X2],13h
ZNA1:        MOV bx,[X2]   
             MOV cx,3h
             XOR edi,edi
ZNA2:        MOV ax,word[NOTF+edi]
             MOV word[ZEILE0+6h+ebx],ax
             ADD bx,2h
             ADD di,2h
             DEC cx
             JNZ l_zna2
        
             CMP [EP],0h
             JE l_zna3
             MOV [EP],0h
             MOV dword[ZEILE0+6h+ebx],2e702e65h ;"e.p." dranhngen

ZNA3:        PUSHAD        
             XOR ebx,ebx
  
   For x=0 To 37
             MOV al,[ZEILE0+ebx]    
             MOV [v_XSH],eax
     TEXTTEST4$=TEXTTEST4$+Chr(XSH) 
             INC bx  
   Next    
    
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,500,TEXTTEST4$) 
       StopDrawing()
 
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,500,TEXTTEST4$) 
       TEXTTEST4$=""
       StopDrawing()
            
             POPAD 

             MOV byte[NOTF+5h],20h     ;umgewandelte Figur weg

             RET

;------------------------ Unterprogramm errechneten Zug in ASTELL schreiben -----------------------
ZUGSETZ:     XOR ebx,ebx
             MOV bl,[AFELDE]
             MOV dl,[ASTELL+ebx]       ;Inhalt Ausgangsfeld holen
             MOV dh,dl                 ;wegen e.p.
             AND dl,97h                ;Figurentyp und -farbe retten
             AND byte[ASTELL+ebx],40h  ;Ausgangsfeld leeren u.Feldfarbe behalten
             MOV bl,[ZFELDE]
             MOV al,[ASTELL+ebx]       ;Inhalt Zielfeld holen
             AND dh,7h                 ;Beginn Untersuchung auf e.p. und Umwandwandlung
             CMP dh,1h                 ;Bauer?
             JNE l_keinbauer
       ;--------------------- Bauernumwandlung von Timpetu ---------------------
             CMP [WERZUG],bh           ;Timpetu am Zug?
             JNE l_bauum2              ;nein, wird fr Gegner separat behandelt
             MOV [ZUG50],0h
             CMP [UFIG],bh
             JE l_bauum2               ;war keine Bauernumwandlung

             MOV bl,[LASTZUGGZ]        ;Zielfeld
             MOV ah,[UFIG]             ;neue Figur
             MOV al,[ASTELL+ebx]
             AND al,40h                ;Feldfarbe
             OR ah,al
             MOV [ASTELL+ebx],ah       ;neue Figur setzen
             RET
       ;---------------------
BAUUM2:      MOV ah,al                 ;Inhalt ZFELD
             AND ah,7h
             JNZ l_keinbauer           ;Zielfeld nicht leer

             PUSH bx                   ;ZFELD retten
             PUSH bx
             SUB bl,[AFELDE]           ;bl=ZFELD
             CMP bl,9h
             JE l_diffza1
             CMP bl,0bh
             JNE l_diffaz
DIFFZA1:     SUB [ZFELDE],0ah
             MOV bl,[ZFELDE]
             AND byte[ASTELL+ebx],40h
             MOV [EP],80h              ;Merker fr en passant setzen
             MOV [AUTOZUGARTT],3h
             POP bx
             JMP l_epend
DIFFAZ:      POP bx
             SUB [AFELDE],bl           ;bl=ZFELD
             CMP [AFELDE],9h
             JE l_diffaz1
             CMP [AFELDE],0bh
             JNE l_epend
DIFFAZ1:     ADD [ZFELDE],0ah
             MOV bl,[ZFELDE]
             AND byte[ASTELL+ebx],40h
             MOV [EP],80h
             MOV [AUTOZUGARTT],3h
EPEND:       POP bx

KEINBAUER:   AND al,40h                ;Zielfeld leeren
             OR al,20h                 ;Bit fr Figur schon mal gezogen setzen
             OR al,dl                  ;Inhalt von Ausgangsfeld in
             MOV [ASTELL+ebx],al       ; Zielfeld schreiben
       ;---------------------- Turmzge bei Rochaden ---------------------------
             MOV al,[ASTELL+ebx]
             AND al,7h
             CMP al,6h
             JNE l_zugsetze            ;kein Knig
             CMP bl,17h                ;Zielfeld c8? Groe schwarze Rochade
             JE l_zuggrs               ;ja
             CMP bl,1bh                ;Zielfeld g8?
             JE l_zugkrs
             CMP bl,5dh                ;Zielfeld c1?
             JE l_zuggrw
             CMP bl,61h                ;Zielfeld g1?
             JE l_zugkrw
             RET
ZUGGRS:      CMP dl,86h                ;schwarzer Knig?
             JNE l_zugsetze            ;nein
             CMP [AFELDE],19h          ;Ausgangsfeld e8?
             JNE l_zugsetze            ;nein
             MOV [AFELDE],15h          ;Turm a8
             MOV [ZFELDE],18h          ;groe Rochade
             MOV [ROCHSTATUSS],bl      ;beliebiger Wert ungleich Null
             JMP l_zugsetz
ZUGKRS:      CMP dl,86h                ;schwarzer Knig?
             JNE l_zugsetze            ;nein
             CMP [AFELDE],19h          ;Ausgangsfeld e8?
             JNE l_zugsetze            ;nein
             MOV [AFELDE],1ch          ;Turm h8
             MOV [ZFELDE],1ah          ;kleine Rochade
             MOV [ROCHSTATUSS],bl
             JMP l_zugsetz
ZUGGRW:      CMP dl,16h                ;weisser Knig?
             JNE l_zugsetze            ;nein
             CMP [AFELDE],5fh          ;Ausgangsfeld e1?
             JNE l_zugsetze            ;nein
             MOV [AFELDE],5bh          ;Turm a1
             MOV [ZFELDE],5eh          ;groe Rochade
             MOV [ROCHSTATUSW],bl
             JMP l_zugsetz
ZUGKRW:      CMP dl,16h                ;weisser Knig?
             JNE l_zugsetze            ;nein
             CMP [AFELDE],5fh          ;Ausgangsfeld e1?
             JNE l_zugsetze            ;nein
             MOV [AFELDE],62h          ;Turm h1
             MOV [ZFELDE],60h          ;kleine Rochade
             MOV [ROCHSTATUSW],bl
             JMP l_zugsetz
ZUGSETZE:    RET

;------------------- Unterprogramm Ermittlung der Figurenart, Anzeige Rochade  ---------------------
FA:          XOR dx,dx
             CMP [COLOR],dl            ;test HZ,1
             JE l_fa1
             MOV dx,13h                ;Abstand Weiss-Schwarz
FA1:         MOV cl,20h                ;Leerzeichen fr Bauer
             XOR ebx,ebx
             MOV bl,[LASTZUGGA]        ;von AW/AS
             MOV al,[ASTELL+ebx]
             AND al,7h
             CMP al,1h
             JE l_fart
             MOV cl,53h                ;S
             CMP al,2h
             JE l_fart
             MOV cl,4ch                ;L
             CMP al,3h
             JE l_fart
             MOV cl,54h                ;T
             CMP al,4h
             JE l_fart
             MOV cl,44h                ;D
             CMP al,5h
             JE l_fart
KOENIG:      MOV al,[LASTZUGGA]        ;auf Rochade testen
             CMP al,5fh                ;Feld e1?
             JE l_rochas
             CMP al,19h                ;Feld e8?
             JNE l_koeniga
ROCHAS:      MOV al,[LASTZUGGZ]
             CMP al,61h                ;Feld g1?
             JE l_klrochas
             CMP al,1bh                ;Feld g8?
             JNE l_groro
KLROCHAS:    MOV [AUTOZUGARTT],4h
             MOV bx,dx
             MOV byte[ZEILE0+5h+ebx],20h
             MOV byte[ZEILE0+6h+ebx],20h
             MOV byte[ZEILE0+7h+ebx],30h
             MOV byte[ZEILE0+8h+ebx],2dh
             MOV byte[ZEILE0+9h+ebx],30h
             MOV byte[ZEILE0+0ah+ebx],20h
             MOV byte[ZEILE0+0bh+ebx],20h
 
             PUSHAD        
             XOR ebx,ebx
  
   For x=0 To 37
             MOV al,[ZEILE0+ebx]    
             MOV [v_XSH],eax
     TEXTTEST4$=TEXTTEST4$+Chr(XSH) 
             INC bx  
   Next    
    
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,500,TEXTTEST4$) 
       StopDrawing()
 
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,500,TEXTTEST4$) 
       TEXTTEST4$=""
       StopDrawing()
            
             POPAD 
        
             MOV [X1],52h              ;R wie Rochade
             RET

GRORO:       CMP al,5dh                ;Feld c1?
             JE l_grrochas
             CMP al,17h                ;Feld c8?
             JNE l_koeniga
GRROCHAS:    MOV [AUTOZUGARTT],5h
             MOV bx,dx
             MOV byte[ZEILE0+5h+ebx],20h
             MOV byte[ZEILE0+6h+ebx],30h
             MOV byte[ZEILE0+7h+ebx],2dh
             MOV byte[ZEILE0+8h+ebx],30h
             MOV byte[ZEILE0+9h+ebx],2dh
             MOV byte[ZEILE0+0ah+ebx],30h
             MOV byte[ZEILE0+0bh+ebx],20h
       
             PUSHAD        
             XOR ebx,ebx
  
   For x=0 To 37
             MOV al,[ZEILE0+ebx]    
             MOV [v_XSH],eax
     TEXTTEST4$=TEXTTEST4$+Chr(XSH) 
             INC bx  
   Next    
    
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,500,TEXTTEST4$) 
       StopDrawing()
 
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,500,TEXTTEST4$) 
       TEXTTEST4$=""
       StopDrawing()
            
             POPAD 

             MOV [X1],52h              ;R wie Rochade
             RET

KOENIGA:     MOV cl,4bh                ;K
FART:        OR dx,dx
             JE l_fart1
             MOV [ZEILE0+18h],cl
             RET 
FART1:       MOV [ZEILE0+5h],cl
FART2:       RET

;----------------- Unterprogramm Bildschirmausgabe Weiss ist Matt --------------
WEISSMATT:   XOR ebx,ebx
             MOV ecx,ebx
             MOV cx,[HZ]
             CMP [STELLAB],bl
             JE l_weim1
             DEC cx
WEIM1:       MOV eax,90h
             MUL ecx
             MOV edi,eax
             ADD edi,70h               ;nach Zugnotation
             MOV eax,7474614dh         ;"ttaM"
             MOV DWord[ZEILE1+20h+ebx],eax  ;hier Zeile 1, bei Schw. Zeile 0!
             MOV DWord[STELLAB+edi],eax
             MOV ax,20h                ;zur Sicherheit hier Leerzeichen
             MOV word[ZEILE1+24h+ebx],ax
             MOV word[STELLAB+4h+edi],ax
             
             XOR ebx,ebx
       For x=0 To 37
             MOV al,[ZEILE1+ebx]
             MOV [v_XSH],eax
         TEXTTEST4$=TEXTTEST4$+Chr(XSH) 
             INC bx  
       Next    
   
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       PB41=TextWidth(TEXTTEST4$)
             MOV eax,3ffh
             SUB eax,[v_PB41]
             MOV [v_PB41],eax
       TEXTTEST1$=LSet("",PB41) 
       TEXTTEST4$=TEXTTEST4$+TEXTTEST1$
       DrawText(700,480,TEXTTEST4$)    ;Zeile1
       StopDrawing()
             
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,480,TEXTTEST4$) 
       TEXTTEST4$=""
       TEXTTEST1$=""
       StopDrawing()
            
             MOV ax,0f530h             ;300.00
             CALL l_mwertaus
           
             MOV [MATTZAHL],0ffh
             JMP l_zeitlesen           ;Menschleife

;----------------- Unterprogramm Bildschirmausgabe Weiss ist Patt --------------
WEISSPATT:   XOR ebx,ebx
             MOV ecx,ebx
             MOV cx,[HZ]
             CMP [STELLAB],bl
             JE l_weip1
             DEC cx
WEIP1:       MOV eax,90h
             MUL ecx
             MOV edi,eax
             ADD edi,70h               ;nach Zugnotation
             MOV eax,74746150h         ;"ttaP"
             MOV DWord[ZEILE1+20h+ebx],eax  ;hier Zeile 1, bei Schw. Zeile 0!
             MOV DWord[STELLAB+edi],eax
             MOV ax,20h                ;zur Sicherheit hier Leerzeichen
             MOV word[ZEILE1+24h+ebx],ax
             MOV word[STELLAB+4h+edi],ax
             
             XOR ebx,ebx
       For x=0 To 37
             MOV al,[ZEILE1+ebx]
             MOV [v_XSH],eax
         TEXTTEST4$=TEXTTEST4$+Chr(XSH) 
             INC bx  
       Next    
   
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       PB41=TextWidth(TEXTTEST4$)
             MOV eax,3ffh
             SUB eax,[v_PB41]
             MOV [v_PB41],eax
       TEXTTEST1$=LSet("",PB41) 
       TEXTTEST4$=TEXTTEST4$+TEXTTEST1$
       DrawText(700,480,TEXTTEST4$) 
       StopDrawing()
             
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,480,TEXTTEST4$) 
       TEXTTEST4$=""
       TEXTTEST1$=""
       StopDrawing()
             
             MOV [MATTZAHL],0ffh
             JMP l_zeitlesen

;-------------- Unterprogramm Bildschirmausgabe Weiss steht im Schach ----------
WEISSSCHACH: PUSHAD  
             XOR ebx,ebx
             MOV ecx,ebx
             MOV cx,[HZ]
             CMP [STELLAB],bl
             JE l_weis1
             DEC cx
WEIS1:       MOV eax,90h
             MUL ecx
             MOV edi,eax
             ADD edi,70h               ;nach Zugnotation
             MOV eax,61686353h         ;"ahcS"
             MOV DWord[ZEILE1+20h+ebx],eax  ;hier Zeile 1, bei Schw. Zeile 0!
             MOV DWord[STELLAB+edi],eax
             MOV ax,6863h              ;"hc"
             MOV word[ZEILE1+24h+ebx],ax
             MOV word[STELLAB+4h+edi],ax
             
             XOR ebx,ebx
       For x=0 To 37
             MOV al,[ZEILE1+ebx]
             MOV [v_XSH],eax
         TEXTTEST4$=TEXTTEST4$+Chr(XSH) 
             INC bx  
       Next    
   
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       PB41=TextWidth(TEXTTEST4$)
             MOV eax,3ffh
             SUB eax,[v_PB41]
             MOV [v_PB41],eax
       TEXTTEST1$=LSet("",PB41) 
       TEXTTEST4$=TEXTTEST4$+TEXTTEST1$
       DrawText(700,480,TEXTTEST4$) 
       StopDrawing()
             
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,480,TEXTTEST4$) 
       TEXTTEST4$=""
       TEXTTEST1$=""
       StopDrawing()

             POPAD 
             RET
 
;--------------- Unterprogramm Bildschirmausgabe Schwarz ist Matt --------------
SCHWARZMATT: XOR ebx,ebx
             MOV ecx,ebx
             MOV cx,[HZ]
             CMP [STELLAB],bl
             JE l_seim1
             DEC cx
SEIM1:       MOV eax,90h
             MUL ecx
             MOV edi,eax
             ADD edi,5dh               ;nach Zugnotation
             MOV eax,7474614dh         ;"ttaM"
             MOV DWord[ZEILE0+0dh+ebx],eax  ;hier Zeile 0, bei W. Zeile 1!
             MOV DWord[STELLAB+edi],eax
             MOV ax,20h                ;zur Sicherheit hier Leerzeichen
             MOV word[ZEILE0+11h+ebx],ax
             MOV word[STELLAB+4h+edi],ax
             
             XOR ebx,ebx
       For x=0 To 37
             MOV al,[ZEILE0+ebx]
             MOV [v_XSH],eax
         TEXTTEST4$=TEXTTEST4$+Chr(XSH) 
             INC bx  
       Next    
   
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       PB41=TextWidth(TEXTTEST4$)
             MOV eax,3ffh
             SUB eax,[v_PB41]
             MOV [v_PB41],eax
       TEXTTEST1$=LSet("",PB41) 
       TEXTTEST4$=TEXTTEST4$+TEXTTEST1$
       DrawText(700,500,TEXTTEST4$) 
       StopDrawing()
             
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,500,TEXTTEST4$) 
       TEXTTEST4$=""
       TEXTTEST1$=""
       StopDrawing()
            
             MOV ax,0f530h             ;300.00
             CALL l_mwertaus
           
             MOV [MATTZAHL],0ffh
             JMP l_zeitlesen           ;Menschleife

;--------------- Unterprogramm Bildschirmausgabe Schwarz ist Patt --------------
SCHWARZPATT: XOR ebx,ebx
             MOV ecx,ebx
             MOV cx,[HZ]
             CMP [STELLAB],bl
             JE l_seip1
             DEC cx
SEIP1:       MOV eax,90h
             MUL ecx
             MOV edi,eax
             ADD edi,5dh               ;nach Zugnotation
             MOV eax,74746150h         ;"ttaP"
             MOV DWord[ZEILE0+0dh+ebx],eax  ;hier Zeile 0, bei W. Zeile 1!
             MOV DWord[STELLAB+edi],eax
             MOV ax,20h                ;zur Sicherheit hier Leerzeichen
             MOV word[ZEILE0+11h+ebx],ax
             MOV word[STELLAB+4h+edi],ax
             
             XOR ebx,ebx
       For x=0 To 37
             MOV al,[ZEILE0+ebx]
             MOV [v_XSH],eax
         TEXTTEST4$=TEXTTEST4$+Chr(XSH) 
             INC bx  
       Next    
   
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       PB41=TextWidth(TEXTTEST4$)
             MOV eax,3ffh
             SUB eax,[v_PB41]
             MOV [v_PB41],eax
       TEXTTEST1$=LSet("",PB41) 
       TEXTTEST4$=TEXTTEST4$+TEXTTEST1$
       DrawText(700,500,TEXTTEST4$)    ;Zeile0
       StopDrawing()
             
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,500,TEXTTEST4$) 
       TEXTTEST4$=""
       TEXTTEST1$=""
       StopDrawing()
           
             MOV [MATTZAHL],0ffh
             JMP l_zeitlesen

;------------ Unterprogramm Bildschirmausgabe Schwarz steht im Schach ----------
SCHWARZSCHACH:PUSHAD 
             XOR ebx,ebx 
             MOV ecx,ebx
             MOV cx,[HZ]
             CMP [STELLAB],bl
             JE l_seis1
             DEC cx
SEIS1:       MOV eax,90h
             MUL ecx
             MOV edi,eax
             ADD edi,5dh               ;nach Zugnotation
             MOV eax,61686353h         ;"ahcS"
             MOV DWord[ZEILE0+0dh+ebx],eax  ;hier Zeile 0, bei W. Zeile 1!
             MOV DWord[STELLAB+edi],eax
             MOV ax,6863h              ;"hc"
             MOV word[ZEILE0+11h+ebx],ax
             MOV word[STELLAB+4h+edi],ax
             
             XOR ebx,ebx
       For x=0 To 37
             MOV al,[ZEILE0+ebx]
             MOV [v_XSH],eax
         TEXTTEST4$=TEXTTEST4$+Chr(XSH) 
             INC bx  
       Next    
   
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       PB41=TextWidth(TEXTTEST4$)
             MOV eax,3ffh
             SUB eax,[v_PB41]
             MOV [v_PB41],eax
       TEXTTEST1$=LSet("",PB41) 
       TEXTTEST4$=TEXTTEST4$+TEXTTEST1$
       DrawText(700,500,TEXTTEST4$) 
       StopDrawing()
             
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(0)
       FrontColor(0)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       BackColor(12566463)    
       DrawText(700,500,TEXTTEST4$) 
       TEXTTEST4$=""
       TEXTTEST1$=""
       StopDrawing()
             
             POPAD 
             RET

;-------------------------------- Brett drehen ---------------------------------
BRETTDREH:   ADD [TF1],80h
             ;CALL l_ehback
             
         FlipBuffers(0)
             CALL l_brettmal
         FlipBuffers(0)
             CALL l_brettmal              
 
BRETTDREH1:  CMP [TF1],0h
             JNE l_brettdreh2

         FlipBuffers(0) 
         StartDrawing(ScreenOutput()) 
         DrawingMode(0)
         FrontColor(140*65536)
         DrawingFont(LoadFont(1,"Arial Fett",12))
         BackColor(12566463)
         DrawText(600,135,TEXT1a$)             ;"TIMPETU" oben
         DrawText(600,615,TEXT15$)             ;"GEGNER" unten
             
             XOR ebx,ebx
       For x=0 To 7
             MOV al,[GZEIT+ebx]
             MOV [v_XSH],eax
           GZEIT$=GZEIT$+Chr(XSH) 
             INC bx
       Next

         DrawText(600,580,GZEIT$)
             
             XOR ebx,ebx
       For x=0 To 7
             MOV al,[TZEIT+ebx]
             MOV [v_XSH],eax
           TZEIT$=TZEIT$+Chr(XSH) 
             INC bx
       Next

         DrawText(600,170,TZEIT$)
         StopDrawing()
  
         FlipBuffers(0) 
         StartDrawing(ScreenOutput()) 
         DrawingMode(0)
         FrontColor(140*65536)
         DrawingFont(LoadFont(1,"Arial Fett",12))
         BackColor(12566463)
         DrawText(600,135,TEXT1a$)                        ;"TIMPETU" oben
         DrawText(600,615,TEXT15$)                        ;"GEGNER" unten
         DrawText(600,580,GZEIT$)
         DrawText(600,170,TZEIT$)
         StopDrawing()
 
         GZEIT$=""
         TZEIT$="" 
            
             RET

BRETTDREH2:
         FlipBuffers(0) 
         StartDrawing(ScreenOutput()) 
         DrawingMode(0)
         FrontColor(140*65536)
         DrawingFont(LoadFont(1,"Arial Fett",12))
         BackColor(12566463)
         DrawText(600,615,TEXT1a$)                        ;"TIMPETU" unten
         DrawText(600,135,TEXT15$)                        ;"GEGNER" oben
             XOR ebx,ebx
       For x=0 To 7
             MOV al,[GZEIT+ebx]
             MOV [v_XSH],eax
           GZEIT$=GZEIT$+Chr(XSH) 
             INC bx
       Next
 
         DrawText(600,170,GZEIT$)
             XOR ebx,ebx
       For x=0 To 7
             MOV al,[TZEIT+ebx]
             MOV [v_XSH],eax
           TZEIT$=TZEIT$+Chr(XSH) 
             INC bx
       Next

         DrawText(600,580,TZEIT$)
         StopDrawing()

         FlipBuffers(0) 
         StartDrawing(ScreenOutput()) 
         DrawingMode(0)
         FrontColor(140*65536)
         DrawingFont(LoadFont(1,"Arial Fett",12))
         BackColor(12566463)
         DrawText(600,615,TEXT1a$)                        ;"TIMPETU" unten
         DrawText(600,135,TEXT15$)                        ;"GEGNER" oben
         DrawText(600,170,GZEIT$)
         DrawText(600,580,TZEIT$)
         StopDrawing()
  
         GZEIT$=""
         TZEIT$="" 
             RET

;-------------------------- Startwerte fr Bedenkzeiten berechnen ---------------------
ZEITCALC:    MOV [GRUNDTIEFE],0ffh
             CMP [RESTZEITMEM],0ffffh
             JE l_zeitcalc1
             MOV [NOCHZUG],46h         ;70 Zge fr Gesamtzeit
             MOV ax,[RESTZEITMEM]      ;z.B. 300s fr 5-Min.-Blitz
             MOV [RESTZEIT],ax
             XOR dx,dx
             MOV bx,46h                ;NOCHZUG
             DIV bx
             MOV [ZUGZEIT],ax          ;ergibt Zeit fr 1 Zug
             SHR ax,1h
             ADC ax,0h
             MOV [ZUGZEIT50],ax
             RET

ZEITCALC1:   MOV [NOCHZUG],28h         ;40 Zge fr 2h
             MOV [RESTZEIT],1c20h      ;volle 2 Stunden
       ;mov RESTZEIT1,708       ;volle 30 Minuten
             MOV [ZUGZEIT],0b4h        ;3 Minuten
             MOV [ZUGZEIT50],5ah       ;90 Sekunden
       ;mov GRUNDTIEFE,0ff
             RET

;-------------------------------- Signal ------------------------------------
SIGNAL:      PUSHAD 
       FlipBuffers(0)
       StartDrawing(ScreenOutput()) 
       DrawingMode(1)
       TEXTTESTT$="Hallo!"
       FrontColor(8388608)
       DrawingFont(LoadFont(1,"Arial Fett",12))
       DrawText(10,705,TEXTTESTT$) 
       StopDrawing()
       FlipBuffers(0)
             POPAD 
             RET

;------------------------------------- "Sound" ----------------------------------------------              
SOUND:       CMP [TON],0h
             JNE l_sounda
             PUSHAD 
       
             PUSH dword 0fah           ;Tondauer
             PUSH dword 5dch           ;Tonhhe
             CALL _Beep@8          
                  
             POPAD
SOUNDA:      RET

;--------------------------------------------------------------------------------------------------
!section '.data' Data readable writeable

!BADZUGANF   DD (0h)                   ;Zeiger in Zugtabelle Zuggenerierung
!HASHADR     DD (0h)                   ;Hash-Adresse
!HASHCODE    DD (0h)                   ;Hash-Code
!PRIM        DD (3BE975h)              ;dd (3be975h)	Primzahl als Basis fr eigene Erstellung
!HASHTABANF  DD (0h)                   ;Anfang der Hashtabelle
!HASHTABEND  DD (0h)                   ;Ende der Hashtabelle
!HASHGROESSE DD (0h)
!ANDWERT     DD (0h)                   ;fr Adressierung
!JIFFY       DD (0h)
!X4          DD (0h)

!FIGWERT     DW 0h,64h,145h,146h,1f4h,3cfh     ;100,325,326,500,975
!BAUERNWERTE DW 0h,64h,0c8h,12ch,190h,1f4h,258h,2bch
            !DW 320h,384h,3e8h,44ch,4b0h,514h,578h,5dch,640h
!LPAAR       DW 18h,18h,18h,18h,18h,18h,18h,18h,18h  
!SBKEW       DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
            !DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h  ;Stat.Bew.w.K.im Endspiel
            !DW 0h,0FFCEh,0FFE2h,0FFE2h,0FFE2h,0FFE2h,0FFE2h,0FFE2h,0FFCEh,0h    ;Bauern auf Damen-
            !DW 0h,0FFE2h,0FFE2h,0h,0h,0h,0h,0FFE2h,0FFE2h,0h                    ; UND Knigsflgel
            !DW 0h,0FFE2h,0FFF6h,1Eh,28h,28h,1Eh,0FFF6h,0FFE2h,0h
            !DW 0h,0FFE2h,0FFF6h,1Eh,28h,28h,1Eh,0FFF6h,0FFE2h,0h
            !DW 0h,0FFE2h,0FFF6h,14h,1Eh,1Eh,14h,0FFF6h,0FFE2h,0h
            !DW 0h,0FFE2h,0FFF6h,0h,1Ah,1Ah,0h,0FFF6h,0FFE2h,0h
            !DW 0h,0ffe2h,0ffech,0fff6h,0h,0h,0fff6h,0ffech,0ffe2h,0h
            !DW 0h,0ffceh,0ffd8h,0ffe2h,0ffech,0ffech,0ffe2h,0ffd8h,0ffceh,0h
!SBKES       DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
            !DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h      ;Stat.Bew.s.K.im Endspiel
            !DW 0h,0ffceh,0ffd8h,0ffe2h,0ffech,0ffech,0ffe2h,0ffd8h,0ffceh,0h    ;Bauern auf Damen-
            !DW 0h,0ffe2h,0ffech,0fff6h,0h,0h,0fff6h,0ffech,0ffe2h,0h            ; UND Knigsflgel
            !DW 0h,0ffe2h,0fff6h,0h,1ah,1ah,0h,0fff6h,0ffe2h,0h
            !DW 0h,0ffe2h,0fff6h,14h,1eh,1eh,14h,0fff6h,0ffe2h,0h
            !DW 0h,0ffe2h,0fff6h,1eh,28h,28h,1eh,0fff6h,0ffe2h,0h
            !DW 0h,0ffe2h,0fff6h,1eh,28h,28h,1eh,0fff6h,0ffe2h,0h
            !DW 0h,0ffe2h,0ffe2h,0h,0h,0h,0h,0ffe2h,0ffe2h,0h
            !DW 0h,0ffceh,0ffe2h,0ffe2h,0ffe2h,0ffe2h,0ffe2h,0ffe2h,0ffceh,0h
!SBKEDW      DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h      ;Stat.Bew.w.K.im Endspiel
            !DW 0h,0ffe2h,0ffe2h,0ffe2h,0ffe2h,0ffe2h,0ffceh,0ffbah,0ffa6h,0h    ;Bauern NUR auf Damenflgel
            !DW 0h,0fff6h,0h,0h,0h,0ffech,0ffe2h,0ffceh,0ffbah,0h
            !DW 0h,0h,1eh,1eh,1eh,0fff6h,0ffe2h,0ffceh,0ffbah,0h
            !DW 0h,0h,1Eh,1Eh,1Eh,0FFF6h,0FFE2h,0FFCEh,0FFBAh,0h
            !DW 0h,0h,1Eh,1Eh,1Eh,0FFF6h,0FFE2h,0FFCEh,0FFBAh,0h
            !DW 0h,0h,14h,14h,14h,0FFF6h,0FFE2h,0FFCEh,0FFBAh,0h
            !DW 0h,0FFF6h,0FFF6h,0FFF6h,0FFF6h,0FFECh,0FFE2h,0FFCEh,0FFBAh,0h
            !DW 0h,0FFE2h,0FFECh,0FFECh,0FFE2h,0FFD8h,0FFCEh,0FFBAh,0FFA6h,0h
!SBKEDS      DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h      ;Stat.Bew.s.K.im Endspiel
            !DW 0h,0FFE2h,0FFECh,0FFECh,0FFE2h,0FFD8h,0FFCEh,0FFBAh,0FFA6h,0h    ;Bauern NUR auf
            !DW 0h,0FFF6h,0FFF6h,0FFF6h,0FFF6h,0FFECh,0FFE2h,0FFCEh,0FFBAh,0h    ; Damenflgel
            !DW 0h,0h,14h,14h,14h,0FFF6h,0FFE2h,0FFCEh,0FFBAh,0h
            !DW 0h,0h,1Eh,1Eh,1Eh,0FFF6h,0FFE2h,0FFCEh,0FFBAh,0h
            !DW 0h,0h,1Eh,1Eh,1Eh,0FFF6h,0FFE2h,0FFCEh,0FFBAh,0h
            !DW 0h,0h,1Eh,1Eh,1Eh,0FFF6h,0FFE2h,0FFCEh,0FFBAh,0h
            !DW 0h,0FFF6h,0h,0h,0h,0FFECh,0FFE2h,0FFCEh,0FFBAh,0h
            !DW 0h,0FFE2h,0FFE2h,0FFE2h,0FFE2h,0FFE2h,0FFCEh,0FFBAh,0FFA6h,0h
!SBKEKW      DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h      ;Stat.Bew.w.K.im Endspiel
            !DW 0h,0FFA6h,0FFBAh,0FFCEh,0FFE2h,0FFE2h,0FFE2h,0FFE2h,0FFE2h,0h    ;Bauern NUR auf
            !DW 0h,0FFBAh,0FFCEh,0FFE2h,0FFE2h,0h,0h,0h,0FFF6h,0h                ; Knigsflgel
            !DW 0h,0FFBAh,0FFCEh,0FFE2h,0FFF6h,1Eh,1Eh,1Eh,0h,0h
            !DW 0h,0FFBAh,0FFCEh,0FFE2h,0FFF6h,1Eh,1Eh,1Eh,0h,0h
            !DW 0h,0FFBAh,0FFCEh,0FFE2h,0FFF6h,1Eh,1Eh,1Eh,0h,0h
            !DW 0h,0FFBAh,0FFCEh,0FFE2h,0FFF6h,14h,14h,14h,0h,0h
            !DW 0h,0FFBAh,0FFCEh,0FFE2h,0FFECh,0FFF6h,0FFF6h,0FFF6h,0FFF6h,0h
            !DW 0h,0FFA6h,0FFBAh,0FFCEh,0FFD8h,0FFE2h,0FFECh,0FFECh,0FFE2h,0h
!SBKEKS      DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h      ;Stat.Bew.s.K.im Endspiel
            !DW 0h,0FFA6h,0FFBAh,0FFCEh,0FFD8h,0FFE2h,0FFECh,0FFECh,0FFE2h,0h    ;Bauern NUR auf
            !DW 0h,0FFBAh,0FFCEh,0FFE2h,0FFECh,0FFF6h,0FFF6h,0FFF6h,0FFF6h,0h    ; Knigsflgel
            !DW 0h,0FFBAh,0FFCEh,0FFE2h,0FFF6h,14h,14h,14h,0h,0h
            !DW 0h,0FFBAh,0FFCEh,0FFE2h,0FFF6h,1Eh,1Eh,1Eh,0h,0h
            !DW 0h,0FFBAh,0FFCEh,0FFE2h,0FFF6h,1Eh,1Eh,1Eh,0h,0h
            !DW 0h,0FFBAh,0FFCEh,0FFE2h,0FFF6h,1Eh,1Eh,1Eh,0h,0h
            !DW 0h,0FFBAh,0FFCEh,0FFE2h,0FFE2h,0h,0h,0h,0FFF6h,0h
            !DW 0h,0FFA6h,0FFBAh,0FFCEh,0FFE2h,0FFE2h,0FFE2h,0FFE2h,0FFE2h,0h
!SBWKO       DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h      ;Stat. Bewertung w.Knig Erffnung
            !DW 0h,0ffd7h,0ffd7h,0ffd7h,0ffd7h,0ffd7h,0ffd7h,0ffd7h,0ffd7h,0h
            !DW 0h,0ffdeh,0ffdeh,0ffdeh,0ffdeh,0ffdeh,0ffdeh,0ffdeh,0ffdeh,0h
            !DW 0h,0ffe4h,0ffe4h,0ffe4h,0ffe4h,0ffe4h,0ffe4h,0ffe4h,0ffe4h,0h
            !DW 0h,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0h
            !DW 0h,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0h
!SBSKO       DW 0h,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0h
            !DW 0h,0fff7h,0fff7h,0fff7h,0fff7h,0fff7h,0fff7h,0fff7h,0fff7h,0h
            !DW 0h,0h,0ah,9h,0fff7h,0fff7h,5h,0ah,0h,0h                          ;Stat. Bewertung s.Knig Erffn.
            !DW 0h,0fff7h,0fff7h,0fff7h,0fff7h,0fff7h,0fff7h,0fff7h,0fff7h,0h
            !DW 0h,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0h
            !DW 0h,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0h
            !DW 0h,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0ffeah,0h
            !DW 0h,0ffe4h,0ffe4h,0ffe4h,0ffe4h,0ffe4h,0ffe4h,0ffe4h,0ffe4h,0h
            !DW 0h,0ffdeh,0ffdeh,0ffdeh,0ffdeh,0ffdeh,0ffdeh,0ffdeh,0ffdeh,0h
            !DW 0h,0ffd7h,0ffd7h,0ffd7h,0ffd7h,0ffd7h,0ffd7h,0ffd7h,0ffd7h,0h
!SBSW        DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h      ;stat.Bew.weisser Springer
            !DW 0h,0fff0h,0fff0h,0fff8h,0fff8h,0fff8h,0fff8h,0fff0h,0fff0h,0h
            !DW 0h,0fff0h,0fff0h,4h,4h,4h,4h,0fff0h,0fff0h,0h
            !DW 0h,0fff8h,2h,6h,6h,6h,6h,2h,0fff8h,0h
            !DW 0h,0fff8h,2h,6h,6h,6h,6h,2h,0fff8h,0h
            !DW 0h,0fff8h,2h,4h,4h,4h,4h,2h,0fff8h,0h
            !DW 0h,0fff8h,2h,2h,2h,2h,2h,2h,0fff8h,0h
            !DW 0h,0fff8h,0fff8h,0h,0h,0h,0h,0fff8h,0fff8h,0h
            !DW 0h,0fff8h,0fff8h,0fff8h,0fff8h,0fff8h,0fff8h,0fff8h,0fff8h,0h
!SBSS        DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h      ;stat.Bew.schw.Springer0
            !DW 0h,0fff8h,0fff8h,0fff8h,0fff8h,0fff8h,0fff8h,0fff8h,0fff8h,0h
            !DW 0h,0fff8h,0fff8h,0h,0h,0h,0h,0fff8h,0fff8h,0h
            !DW 0h,0fff8h,2h,2h,2h,2h,2h,2h,0fff8h,0h
            !DW 0h,0fff8h,2h,4h,4h,4h,4h,2h,0fff8h,0h
            !DW 0h,0fff8h,2h,6h,6h,6h,6h,2h,0fff8h,0h
            !DW 0h,0fff8h,2h,6h,6h,6h,6h,2h,0fff8h,0h
            !DW 0h,0fff0h,0fff0h,4h,4h,4h,4h,0fff0h,0fff0h,0h
            !DW 0h,0fff0h,0fff0h,0fff8h,0fff8h,0fff8h,0fff8h,0fff0h,0fff0h,0h
!SBLW        DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h      ;stat.Bew.weisser Lufer
            !DW 0h,0fff0h,0fff0h,0h,0h,0h,0h,0fff0h,0fff0h,0h
            !DW 0h,0fff0h,2h,4h,4h,4h,4h,2h,0fff0h,0h
            !DW 0h,0fffch,2h,6h,6h,6h,6h,2h,0fffch,0h
            !DW 0h,0fffch,2h,6h,6h,6h,6h,2h,0fffch,0h
            !DW 0h,0fffch,2h,4h,4h,4h,4h,2h,0fffch,0h
            !DW 0h,0fffch,2h,2h,2h,2h,2h,2h,0fffch,0h
            !DW 0h,0fff0h,2h,0h,0h,0h,0h,2h,0fff0h,0h
            !DW 0h,0fff0h,0fff0h,0fff8h,0fff8h,0fff8h,0fff8h,0fff0h,0fff0h,0h
!SBLS        DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h      ;stat.Bew.schw.Lufer
            !DW 0h,0fff0h,0fff0h,0fff8h,0fff8h,0fff8h,0fff8h,0fff0h,0fff0h,0h
            !DW 0h,0fff0h,2h,0h,0h,0h,0h,2h,0fff0h,0h
            !DW 0h,0FFFCh,2h,2h,2h,2h,2h,2h,0FFFCh,0h
            !DW 0h,0FFFCh,2h,4h,4h,4h,4h,2h,0FFFCh,0h
            !DW 0h,0FFFCh,2h,6h,6h,6h,6h,2h,0FFFCh,0h
            !DW 0h,0FFFCh,2h,6h,6h,6h,6h,2h,0FFFCh,0h
            !DW 0h,0FFF0h,2h,4h,4h,4h,4h,2h,0FFF0h,0h
            !DW 0h,0FFF0h,0FFF0h,0h,0h,0h,0h,0FFF0h,0FFF0h,0h
!SBDW        DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h      ;stat.Bew.weisse Dame
            !DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
            !DW 0h,0FFF1h,0h,4h,5h,5h,4h,0h,0FFF1h,0h
            !DW 0h,0h,2h,4h,0Ah,0Ah,4h,2h,0h,0h
            !DW 0h,0h,2h,0Ah,0Ch,0Ch,0Ah,2h,0h,0h
            !DW 0h,0FFF6h,2h,0Ah,0Ch,0Ch,0Ah,2h,0FFF6h,0h
            !DW 0h,0FFF6h,0FFF6h,4h,0Ah,0Ah,4h,0FFF6h,0FFF6h,0h
            !DW 0h,0FFF6h,2h,8h,8h,8h,8h,2h,0FFF6h,0h
            !DW 0h,0FFF6h,0FFF8h,0h,0h,0h,0h,0FFF8h,0FFF6h,0h
!SBDS        DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h      ;stat.Bew.schwarze Dame
            !DW 0h,0FFF6h,0FFF8h,0h,0h,0h,0h,0FFF8h,0FFF6h,0h
            !DW 0h,0FFF6h,2h,8h,8h,8h,8h,2h,0FFF6h,0h
            !DW 0h,0FFF6h,0FFF6h,4h,0Ah,0Ah,4h,0FFF6h,0FFF6h,0h
            !DW 0h,0fff6h,2h,0ah,0ch,0ch,0ah,2h,0fff6h,0h
            !DW 0h,0h,2h,0ah,0ch,0ch,0ah,2h,0h,0h
            !DW 0h,0h,2h,4h,0ah,0ah,4h,2h,0h,0h
            !DW 0h,0fff1h,0h,4h,5h,5h,4h,0h,0fff1h,0h
            !DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
!SBSB        DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h          ;Statische Bewertung Bauer Schwarz
            !DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
            !DW 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
            !DW 0h,6h,6h,6h,0fff7h,0fff7h,9h,0dh,0dh,0h
            !DW 0h,6h,6h,6h,0h,0h,6h,6h,9h,0h
!SBWB        DW 0h,0h,0h,0Dh,13h,13h,0Dh,0h,0h,0h
            !DW 0h,0h,0h,10h,16h,16h,10h,0h,0h,0h
            !DW 0h,0h,0h,13h,19h,19h,13h,0h,0h,0h
            !DW 0h,10h,13h,16h,1ch,1ch,16h,13h,10h,0h  ;Statische Bewertung Bauer Weiss
            !DW 0h,0h,0h,13h,19h,19h,13h,0h,0h,0h
            !DW 0h,0h,0h,10h,16h,16h,10h,0h,0h,0h
            !DW 0h,0h,0h,0dh,13h,13h,0dh,0h,0h,0h
            !DW 0h,6h,6h,6h,0h,0h,6h,6h,9h,0h
            !DW 0h,6h,6h,6h,0fff7h,0fff7h,9h,0dh,0dh,0h

!AUFMACH     DW (0h)
!TICKTACK    DW (0h)
!BEST2ZUG    DW (0h)
!BEST2TIME   DW (0h)
!X8          DW (0h)                        
!X9          DW (0h)
!DIVAB       DW (0h)                   ;Differenz Alpha-Beta 1.Zug
!X2          DW (0h)                   ;universelle Zwischenspeicher
!NMOV1       DW (0h)
!NMOV2       DW (0h)
!MAXSEL      DW (0h)                   ;Merker hchste selektive Tiefe 1.Zug
!AZ          DW (0h)                   ;Adresszhler, Abstand 1B6=2*219D
!ZASTELL     DW (0h)                   ;Zeiger fr ASTELL usw.abspeichern
!ZASTELLE    DW (0h)                   ;Ende bisher gespielter Zge
!HZ          DW (0h)                   ;Zhler Halbzug
!ATTACK      DW (0h)                   ;Merker fr attackiertes Feld + Figur
!REMISFAKTOR DW (8000h)                ;(8000)  eigentlicher Remisfaktor wird zuaddiert
!ZUG50       DW (0h)                   ;Figur schlagen oder Bauer ziehen
!BIBZUG      DW (0h)                   ;Anzahl gefundener Zge in Bibliothek
!NOTZ        DW (0h)                   ;Zhler fr Notationseingabe
!VORWERT     DW (8000h)                ;(8000)	fr Ausgangszge, Bewertung
!ALPHAPB     DW (0h)
!TIMPWERT    DW (0h)                   ;wahrscheinlicher Wert fr Timetu  
!TIEFE       DW (0h)                   ;Rechnentiefe incl. Ruhesuche
!PBTIEFE     DW (1h)                   ;(1)
!NMBETA1     DW (0h)                   ;Beta-Wert fr Nullmove
!NMBETA2     DW (0h)
!NMTIEFE     DW (0h)
!ZZZUGTAB    DW (0h)                   ;Anzahl gltiger 1.Zge
!ZZZUGTABGUT DW (0h)                   ;wie oben ohne aussortierte Zge
!SORTA       DW (0h)                   ;Zeiger SORTANFANG
!SORTE       DW (0h)                   ;Zeiger SORTENDE
!NOCHZUG     DW (0h)                   ;verbleibende Zgezahl in Bedenkzeit
!ZUGZEIT     DW (0h)                   ;Durchschnittszeit fr 1 Zug
!ZUGZEIT50   DW (0h)                   ;50% von ZUGZEIT
!RESTZEIT    DW (0h)                   ;aktuelle Restzeit
!RESTZEITMEM DW (0h)                   ;Abspeicherung Restzeit fr neue Partie

!GSTELL     DB 8h,8h,8h,8h,8h,8h,8h,8h,8h,8h                               ;Grundstellung
           !DB 8h,8h,8h,8h,8h,8h,8h,8h,8h,8h
           !DB 8h,84h,0c2h,83h,0c5h,86h,0c3h,82h,0c4h,8h
           !DB 8h,0c1h,81h,0c1h,81h,0c1h,81h,0c1h,81h,8h
           !DB 8h,0h,40h,0h,40h,0h,40h,0h,40h,8h
           !DB 8h,40h,0h,40h,0h,40h,0h,40h,0h,8h
           !DB 8h,0h,40h,0h,40h,0h,40h,0h,40h,8h
           !DB 8h,40h,0h,40h,0h,40h,0h,40h,0h,8h
           !DB 8h,11h,51h,11h,51h,11h,51h,11h,51h,8h
           !DB 8h,54h,12h,53h,15h,56h,13h,52h,14h,8h
!LSTELL     DB 8h,8h,8h,8h,8h,8h,8h,8h,8h,8h                                ;leeres Brett
           !DB 8h,8h,8h,8h,8h,8h,8h,8h,8h,8h                                ;Ende GSTELL
           !DB 8h,0h,40h,0h,40h,0h,40h,0h,40h,8h
           !DB 8h,40h,0h,40h,0h,40h,0h,40h,0h,8h
           !DB 8h,0h,40h,0h,40h,0h,40h,0h,40h,8h
           !DB 8h,40h,0h,40h,0h,40h,0h,40h,0h,8h
           !DB 8h,0h,40h,0h,40h,0h,40h,0h,40h,8h
           !DB 8h,40h,0h,40h,0h,40h,0h,40h,0h,8h
!NFELD      DB 8h,0h,40h,0h,40h,0h,40h,0h,40h,8h                            ;Notationsfeld
           !DB 8h,40h,0h,40h,0h,40h,0h,40h,0h,8h                            ;auch fr Distanz K-D/T!
           !DB 8h,8h,8h,8h,8h,8h,8h,8h,8h,8h
           !DB 8h,8h,8h,8h,8h,8h,8h,8h,8h,8h                                ;Ende LSTELL
           !DB 0h,0h,1h,8h,2h,8h,3h,8h,4h,8h,5h,8h,6h,8h,7h,8h,8h,8h,0h,0h
           !DB 0h,0h,1h,7h,2h,7h,3h,7h,4h,7h,5h,7h,6h,7h,7h,7h,8h,7h,0h,0h
           !DB 0h,0h,1h,6h,2h,6h,3h,6h,4h,6h,5h,6h,6h,6h,7h,6h,8h,6h,0h,0h
           !DB 0h,0h,1h,5h,2h,5h,3h,5h,4h,5h,5h,5h,6h,5h,7h,5h,8h,5h,0h,0h
           !DB 0h,0h,1h,4h,2h,4h,3h,4h,4h,4h,5h,4h,6h,4h,7h,4h,8h,4h,0h,0h
           !DB 0h,0h,1h,3h,2h,3h,3h,3h,4h,3h,5h,3h,6h,3h,7h,3h,8h,3h,0h,0h
           !DB 0h,0h,1h,2h,2h,2h,3h,2h,4h,2h,5h,2h,6h,2h,7h,2h,8h,2h,0h,0h
           !DB 0h,0h,1h,1h,2h,1h,3h,1h,4h,1h,5h,1h,6h,1h,7h,1h,8h,1h,0h,0h
!SBWT       DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h  ;Stat.Bew.weisser Turm
           !DB 0h,20h,20h,20h,20h,20h,20h,20h,20h,0h
           !DB 0h,20h,20h,20h,20h,20h,20h,20h,20h,0h
           !DB 0h,0ch,0ch,0ch,0ch,0ch,0ch,0ch,0ch,0h
           !DB 0h,0h,1h,2h,3h,3h,3h,2h,1h,0h
           !DB 0h,0h,1h,2h,3h,3h,3h,2h,1h,0h
           !DB 0h,0h,1h,2h,3h,3h,3h,2h,1h,0h
!SBST       DB 0h,0h,1h,2h,3h,3h,3h,2h,1h,0h                                ;Statische Bewertung schwarzer Turm
           !DB 0h,5h,9h,0ch,14h,14h,0ch,9h,5h,0h
           !DB 0h,5h,9h,0ch,14h,14h,0ch,9h,5h,0h
           !DB 0h,0h,1h,2h,3h,3h,3h,2h,1h,0h
           !DB 0h,0h,1h,2h,3h,3h,3h,2h,1h,0h
           !DB 0h,0h,1h,2h,3h,3h,3h,2h,1h,0h
           !DB 0h,0h,1h,2h,3h,3h,3h,2h,1h,0h
           !DB 0h,0ch,0ch,0ch,0ch,0ch,0ch,0ch,0ch,0h
           !DB 0h,20h,20h,20h,20h,20h,20h,20h,20h,0h
           !DB 0h,20h,20h,20h,20h,20h,20h,20h,20h,0h
!LSE1       DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h                                ;Endspiel KLS-K
           !DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
           !DB 0h,0ffh,0cch,80h,40h,10h,8h,0h,0h,0h
           !DB 0h,0cch,0cch,80h,20h,8h,4h,0h,0h,0h
           !DB 0h,80h,80h,40h,10h,0h,0h,4h,8h,0h
           !DB 0h,40h,20h,10h,0h,0h,0h,8h,10h,0h
           !DB 0h,10h,8h,0h,0h,0h,10h,20h,40h,0h
           !DB 0h,8h,4h,0h,0h,10h,40h,80h,80h,0h
           !DB 0h,0h,0h,4h,8h,20h,80h,0cch,0cch,0h
           !DB 0h,0h,0h,8h,10h,40h,80h,0cch,0ffh,0h
!LSE2       DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
           !DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
           !DB 0h,0h,0h,8h,10h,40h,80h,0cch,0ffh,0h
           !DB 0h,0h,0h,4h,8h,20h,80h,0cch,0cch,0h
           !DB 0h,8h,4h,0h,0h,10h,40h,80h,80h,0h
           !DB 0h,10h,8h,0h,0h,0h,10h,20h,40h,0h
           !DB 0h,40h,20h,10h,0h,0h,0h,8h,10h,0h
           !DB 0h,80h,80h,40h,10h,0h,0h,4h,8h,0h
           !DB 0h,0cch,0cch,80h,20h,8h,4h,0h,0h,0h
           !DB 0h,0ffh,0cch,80h,40h,10h,8h,0h,0h,0h
!OUTPW      DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h   ;weisser Outpost-Springer
           !DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
           !DB 0h,0h,0h,4h,8h,8h,4h,0h,0h,0h
           !DB 0h,0h,0h,0ch,14h,14h,0ch,0h,0h,0h
           !DB 0h,0h,0h,0ch,10h,10h,0ch,0h,0h,0h
           !DB 0h,0h,0h,0h,6h,6h,0h,0h,0h,0h
           !DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
           !DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
           !DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
!OUTPS      DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h   ;schw.Outpost-Springer
           !DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
           !DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
           !DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
           !DB 0h,0h,0h,0h,6h,6h,0h,0h,0h,0h
           !DB 0h,0h,0h,0ch,10h,10h,0ch,0h,0h,0h
           !DB 0h,0h,0h,0ch,14h,14h,0ch,0h,0h,0h
           !DB 0h,0h,0h,4h,8h,8h,4h,0h,0h,0h
           !DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
!ZUGWS      DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
           !DB 0h,0h,0ah,14h,14h,14h,0ah,0ah,0h,0h
           !DB 0h,0ah,18h,1ah,1ah,1ah,18h,18h,0ah,0h
           !DB 0h,0ah,1ch,28h,32h,32h,1ch,1ch,0ah,0h
           !DB 0h,0ah,17h,24h,28h,28h,17h,17h,0ah,0h
           !DB 0h,0ah,16h,1ch,1eh,1eh,16h,16h,0ah,0h
           !DB 0h,0h,1ah,1ah,1eh,1eh,1ah,1ah,0h,0h
           !DB 0h,5h,14h,14h,17h,1ah,14h,1ah,5h,0h
           !DB 0h,0h,5h,0fh,0fh,0fh,0fh,0h,0h,0h
!ZUGSS      DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h
           !DB 0h,0h,5h,0fh,0fh,0fh,0fh,0h,0h,0h
           !DB 0h,5h,14h,14h,17h,1ah,14h,1ah,5h,0h
           !DB 0h,0h,1ah,1ah,1eh,1eh,1ah,1ah,0h,0h
           !DB 0h,0ah,16h,1ch,1eh,1eh,16h,16h,0ah,0h
           !DB 0h,0ah,17h,24h,28h,28h,17h,17h,0ah,0h
           !DB 0h,0ah,1ch,28h,32h,32h,1ch,1ch,0ah,0h
           !DB 0h,0ah,18h,1ah,1ah,1ah,18h,18h,0ah,0h
           !DB 0h,0h,0ah,14h,14h,14h,0ah,0ah,0h,0h
!BFELD      DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,5bh,51h,47h,3dh,33h,29h,1fh,15h    ;A1-A8	fr Bibliothek
           !DB 5ch,52h,48h,3eh,34h,2ah,20h,16h                               ;B1-B8
           !DB 5dh,53h,49h,3fh,35h,2bh,21h,17h                               ;C1-C8
           !DB 5eh,54h,4ah,40h,36h,2ch,22h,18h                               ;D1-D8
           !DB 5fh,55h,4bh,41h,37h,2dh,23h,19h                               ;E1-E8
           !DB 60h,56h,4ch,42h,38h,2eh,24h,1ah                               ;F1-F8
           !DB 61h,57h,4dh,43h,39h,2fh,25h,1bh                               ;G1-G8
           !DB 62h,58h,4eh,44h,3ah,30h,26h,1ch                               ;H1-H8
!AUTOFELD1  DB 0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h,0h   ;fr AUTO232-
           !DB 0h,38h,39h,3ah,3bh,3ch,3dh,3eh,3fh,0h                         ; Protokoll,
           !DB 0h,30h,31h,32h,33h,34h,35h,36h,37h,0h                         ; Timpetu in
           !DB 0h,28h,29h,2ah,2bh,2ch,2dh,2eh,2fh,0h                         ; AUTO232-Format
           !DB 0h,20h,21h,22h,23h,24h,25h,26h,27h,0h
           !DB 0h,18h,19h,1ah,1bh,1ch,1dh,1eh,1fh,0h
           !DB 0h,10h,11h,12h,13h,14h,15h,16h,17h,0h
           !DB 0h,8h,9h,0ah,0bh,0ch,0dh,0eh,0fh,0h
           !DB 0h,0h,1h,2h,3h,4h,5h,6h,7h,0h
!AUTOFELD2  DB 5bh,5ch,5dh,5eh,5fh,60h,61h,62h                                ;A1-A8	AUTO232 in
           !DB 51h,52h,53h,54h,55h,56h,57h,58h                                ; Timpetu-Format
           !DB 47h,48h,49h,4ah,4bh,4ch,4dh,4eh
           !DB 3dh,3eh,3fh,40h,41h,42h,43h,44h
           !DB 33h,34h,35h,36h,37h,38h,39h,3ah
           !DB 29h,2ah,2bh,2ch,2dh,2eh,2fh,30h
           !DB 1fh,20h,21h,22h,23h,24h,25h,26h
           !DB 15h,16h,17h,18h,19h,1ah,1bh,1ch
!KZEIGER    DB 0h,1h,9h,0ah,0bh,0ffh,0f7h,0f6h,0f5h                            ;Zugrichtungen des Knigs
!SEEWERT    DB 0h,1h,3h,3h,5h,0ah                                              ;B,S,L,T,D
!STARTTIME  DB 30h,30h,3ah,30h,30h,3ah,30h,30h

!AFELDE      DB 0h
!TF          DB 80h                    ;db (80) Merker fr Farbe von Timpetu,80=Schwarz
!TF1         DB 0h                     ;fr Brettdrehung  0=Timpetu oben, 80 unten
!ZFELDE      DB 0h
!WERZUG      DB 80h                    ;Wer ist am Zug? 0=Timpetu; 80=Gegner
!COLOR       DB 0h                     ;Welche Farbe am Zug, 0=Weiss
!GLEICHSTELL DB 0h                     ;fr 3-malige Zugwiederholung
!ENDSPIEL    DB 0h
!FARBE       DB 0h
!LASTZUGGA   DB 0h                     ;Letzter Zug Gegner Ausgangsfeld
!LASTZUGGZ   DB 0h                     ;   "     "    "    Zielfeld
!WKFELD      DB 0h                     ;Zeiger auf weissen Knig
!SKFELD      DB 0h                     ;Zeiger auf schwarzen Knig
!ANZLW       DB 0h                     ;fr Luferpaar, Fianchetto und Outpost
!ANZLS       DB 0h
!ANZSW       DB 0h
!ANZSS       DB 0h
!OUTPFW      DB 0h                     ;Feldfarbe weisse Outpost-Springer
!OUTPFS      DB 0h
!WISDAME     DB 0h                     ;ob weisse Dame da fr schwarzes Fianchetto
!SISDAME     DB 0h
!WFIAFELD    DB 0h                     ;G2 bzw.B2
!SFIAFELD    DB 0h                     ;G7 bzw.B7 
!WKLINIE     DB 0h                     ;Linie weisser Knig
!SKLINIE     DB 0h
!GRUNDTIEFE  DB 0feh                   ;(0fe)	fr Rechenabbruch  je nach Vorgabe!!!
!BIBART      DB 0ffh                   ;(0ff)	Merker Turnier/Komplett-Bibl. 0=Komplett 
!NULLMOVE    DB 0h                     ;Merker
!TON         DB 80h                    ;(80) Merker fr Beeper Ein/Aus  0=An 80=Aus
!BIBEND      DB 80h                    ;(80)  Merker Bibliothek   Ende=80
!SCREEN      DB 0h                     ;Bildschirmanzeige E/A	     0=an
!AUTOPLAY    DB 0h                     ;Merker fr AUTO232
!AUTOPLAYZ   DB 0h                     ;Zhler vom Datenpaket 1-5
!AUTOZUGARTT DB 0h                     ;Zugart 1=normal usw. Timpetu
!AUTOZUGAT   DB 0h                     ;AFELD
!AUTOZUGZT   DB 0h                     ;ZFELD
!AUTOZUGARTG DB 0h                     ;Zugart 1=normal usw. Gegner
!AUTOZUGAG   DB 0h                     ;AFELD
!AUTOZUGZG   DB 0h                     ;ZFELD
!BIBNOZUG    DB 0h                     ;Zhler wie oft nichts gefunden
!EP          DB 0h                     ;Merker en passant
!ROCHSTATUSW DB 0h
!ROCHSTATUSS DB 0h
!ZFELDU      DB 0h                     ;Originalwert fr Bauernumwandlung
!ZFELDUAKT   DB 0h                     ;fr Tiefe 1 (Bauernumwandlung Fail High)
!UFIG        DB 0h                     ;umgewandelte Figur
!NMOVE       DB 0h                     ;Merker Nullzug
!SCHNELLZUG  DB 0h                     ;aus PB heraus
!STELLTEST   DB 0h                     ;Merker, ob Stellungstest geladen
!WAHLFIG     DB 0h                     ;gewhlte Figur in Stellungseingabe
!MAUSSTATUS  DB 0h
!MATTZAHL    DB 0h                     ;Matt in ...
!PERBRAIN    DB 1h                     ;(1) Merker Permanent Brain	1=Ein
!X1          DB 0h
;!X5          DB 0h
!X7          DB 0h                     ;beide fr TRECHNEN Fail-High nicht erster Zug
!MGA         DB 0h                     ;Mausabfrage LASTZUGGA
!MGZ         DB 0h                     ;      "     LASTZGGGZ
!FATTDURCH   DB 0h                     ;Merker, ob ATTACKFELD aufgerufen wurde 
!MAUS_KNOPF  DB 0h
!FIG_IN_MOVE DB 0h
!ZIELFELD    DB 0h

!ASTELL      RB 7ah                    ;db 7a  120 Byte fr aktuelle Stellung + Nullzug
!WBSTELL     RB 78h                    ;db 78  weisse Bauernstruktur
!SBSTELL     RB 78h                    ;db 78
!AFELD       RB 20h                    ;db 20  Speicher Ausgangsfeld fr 32 HZ
!AFELDH      RB 20h                    ;db 20  Hilfsspeicher Ausgangsfeld fr 32 HZ
!ZFELD       RB 20h                    ;db 20  Speicher Zielfeld fr 32 HZ
!ZFELDH      RB 20h                    ;db 20  Hilfsspeicher Zielfeld fr 32 HZ
!WBLINIE     RB 0ah                    ;db 0a  Linienbelegung weisse Bauern
!SBLINIE     RB 0ah                    ;db 0a
!WTLINIE     RB 0ah                    ;db 0a  Linienbelegung weisse Trme
!STLINIE     RB 0ah                    ;db 0a
!ZUGTAB      RB 3834h                  ;db 3834 Zugtabelle fr 32*218 Zge +je 1*0ffff
!GZEIT       RB 8h                     ;db 8
!TZEIT       RB 8h
!TI1         RB 5h                     ;db  5  Merker fr 1.Bedenkzeit
!NOTF        RB 6h                     ;db  6  Feld fr Notationseingabe
!FELDATTACK  RB 78h                    ;db 78 
!BSTELL      RB 7ah                    ;db 7a wie ASTELL, nur fr Bildschirmdarstellung
!TEXTWERT    RB 8h                     ;db 8  
!TEXTTEMP    RB 174h                   ;db 174
  
!ZEILE0      RB 26h                    ;db 26  DUP (20)      ;Zuganzeige auf Bildschirm
!ZEILE1      RB 26h                    ;db 26  DUP (20)      ; auch fr Festplatte !
!ZEILE2      RB 26h                    ;db 26  DUP (20)
!ZEILE3      RB 26h                    ;db 26  DUP (20)
!ZEILE4      RB 26h                    ;db 26  DUP (20)
!ZEILE5      RB 26h                    ;db 26  DUP (20)
!ZEILE6      RB 26h                    ;db 26  DUP (20)
!ZEILE7      RB 26h                    ;db 26  DUP (20)
!ZEILE8      RB 26h                    ;db 26  DUP (20)
!ZEILE9      RB 26h                    ;db 26  DUP (20) 
!TEXTTEMPBA  RB 174h                   ;db 174   neu fr 1.Zge Bildschirmausgabe

!PUFFER      RD 100h

!ZUFZAHLEN   RD 0c60h                  ;fr Hashwerte (Zufallszahlen) 12.672 Byte=3180h
!STELLAB     RB 11940h                 ;fr Stellungsabspeicherung 144 Byte pro Halbzug
                                       ; 500 Halbzge=11940h ergibt insges. +1bac0h
!BESTLINE    RW 441h                   ;dw 441 beste Linie 33D*33D  
!BESTPB      RW 20h                    ;dw 20  bester Zug aus Permanent Brain
!KILLTABS    RD 20h                    ;dd 20  Killertabelle fr 2 Schlagzge
!KILLTABN    RD 20h                    ;dd 20        "        "  2 Normalzge
!KILLTABSPB  RD 20h                    ;dd 20        "       von Permanent Brain
!KILLTABNPB  RD 20h                    ;dd 20  von hier bis oben BESTLINE zusammenlassen! KILLWEG!
!ALPHA       RW 20h                    ;dw 20  untere Schranke
!BETA        RW 20h                    ;dw 20  obere Schranke
!Z           RW 20h                    ;dw 20  Zeiger in ZUGTAB ohne AZ
!ZUGSORT     RD 0ffh                   ;dd 0ff Sortierte Zugtabelle fr 256 Zge
!ZZUGTAB     RW 20h                    ;dw 20  Zhler Zugtabelle
!ANZFIGW     RW 20h                    ;dw 20  Anzahl weisse Figuren
!ANZFIGS     RW 20h                    ;dw 20  Anzahl schwarze Figuren
!ANZBAUERW   RW 20h                    ;dw 20  Anzahl weisse Bauern
!ANZBAUERS   RW 20h                    ;dw 20  Anzahl schwarze Bauern
!TIEFENWERT  RW 20h                    ;dw 20  Alpha-Beta-Wert
!BESTERWERT  RW 20h                    ;dw 20
!SCHACH      RW 20h                    ;dw 20	 Schach-Merker
!ERWEITERUNG RW 20h                    ;dw 20  Begrenzung fr Tiefen-Erweiterung
!VARTIEFE    RW 20h                    ;dw 20  variable Tiefe
!BIBZUGTAB   RW 20h                    ;dw 20  gefundene Zge
!MATW        RW 21h                    ;dw 21  Materialwert Weiss
!MATS        RW 21h                    ;dw 21
!HASHADRX    RD 20h                    ;dd 20  Zwischenspeicher Adr. wegen Zugriff hochgerundet
!HASHCODEX   RD 20h                    ;dd 20  

; IDE Options = PureBasic v4.00 - Beta 11 (Windows - x86)
; CursorPosition = 53
; FirstLine = 33
; Folding = -
; EnableAsm
; Executable = TimpetuPB.exe
; DisableDebugger